/* -*- Mode: C -*- */
#ifndef NSP_INC_Nspcairo_t
#define NSP_INC_Nspcairo_t

/*
 * Copyright (C) 1998-2015 Jean-Philippe Chancelier Enpc/Cermics
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/* Nspcairo_t */

#include <nsp/gtk/gboxed.h>

/*
 * Nspcairo_t inherits from GBoxed
 * just change some type attributes 
 */

typedef NspGBoxed Nspcairo_t ;
typedef NspTypeGBoxed NspTypeCairo_t ;

extern int nsp_type_cairo_t_id;
extern NspTypeCairo_t *nsp_type_cairo_t;

/* type instances for gboxed */

NspTypeCairo_t *new_type_cairo_t(type_mode mode);

/* instance for Nspcairo_t */

Nspcairo_t *new_cairo_t();

/*
 * Object methods redefined for cairo_t 
 */

#define NULLCAIRO_T (Nspcairo_t*) 0


/* from Nspcairo_tObj.c */

extern Nspcairo_t *nsp_cairo_t_object (NspObject *O);
extern int IsCairo_tObj (Stack stack, int i);
extern int IsCairo_t(NspObject *O);
extern Nspcairo_t *GetCairo_tCopy (Stack stack, int i);
extern Nspcairo_t *GetCairo_t (Stack stack, int i);

#endif /* NSP_INC_Nspcairo_t */ 

#ifdef Nspcairo_t_Private 
static int init_cairo_t(Nspcairo_t *o,NspTypeCairo_t *type);
static char *nsp_cairo_t_type_as_string(void);
static char *nsp_cairo_t_type_short_string(NspObject *v);
static AttrTab cairo_t_attrs[];
static NspMethods *cairo_t_get_methods(void);
/* static int int_cairo_t_create(Stack stack, int rhs, int opt, int lhs);*/ 
#endif /* Nspcairo_t_Private */
