/* -*- Mode: C -*- */
#ifndef NSP_INC_NspGtkSeparator
#define NSP_INC_NspGtkSeparator

/*
 * Copyright (C) 1998-2015 Jean-Philippe Chancelier Enpc/Cermics
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/* NspGtkSeparator */

#include <nsp/gtk/gtkwidget.h>

/*
 * NspGtkSeparator inherits from GtkWidget
 * just change some type attributes 
 */

typedef NspGtkWidget NspGtkSeparator ;
typedef NspTypeGtkWidget NspTypeGtkSeparator ;

extern int nsp_type_gtkseparator_id;
extern NspTypeGtkSeparator *nsp_type_gtkseparator;

/* type instances for gtkwidget */

NspTypeGtkSeparator *new_type_gtkseparator(type_mode mode);

/* instance for NspGtkSeparator */

NspGtkSeparator *new_gtkseparator();

/*
 * Object methods redefined for gtkseparator 
 */

#define NULLGTKSEPARATOR (NspGtkSeparator*) 0


/* from NspGtkSeparatorObj.c */

extern NspGtkSeparator *nsp_gtkseparator_object (NspObject *O);
extern int IsGtkSeparatorObj (Stack stack, int i);
extern int IsGtkSeparator(NspObject *O);
extern NspGtkSeparator *GetGtkSeparatorCopy (Stack stack, int i);
extern NspGtkSeparator *GetGtkSeparator (Stack stack, int i);

#endif /* NSP_INC_NspGtkSeparator */ 

#ifdef NspGtkSeparator_Private 
static int init_gtkseparator(NspGtkSeparator *o,NspTypeGtkSeparator *type);
static char *nsp_gtkseparator_type_as_string(void);
static char *nsp_gtkseparator_type_short_string(NspObject *v);
static AttrTab gtkseparator_attrs[];
static NspMethods *gtkseparator_get_methods(void);
/* static int int_gtkseparator_create(Stack stack, int rhs, int opt, int lhs);*/ 
#endif /* NspGtkSeparator_Private */
