#include "fftpack.h"

static int fftpack_passf2 (int *ido, int *l1, double *cc, double *ch,
			   double *wa1);
static int fftpack_passf3 (int *ido, int *l1, double *cc, double *ch,
			   double *wa1, double *wa2);
static int fftpack_passf4 (int *ido, int *l1, double *cc, double *ch,
			   double *wa1, double *wa2, double *wa3);
static int fftpack_passf5 (int *ido, int *l1, double *cc, double *ch,
			   double *wa1, double *wa2, double *wa3,
			   double *wa4);
static int fftpack_passf (int *nac, int *ido, int *ip, int *l1, int *idl1,
			  double *cc, double *c1, double *c2, double *ch,
			  double *ch2, double *wa);


/* Subroutine */ int
fftpack_cfftf1 (int *n, double *c__, double *ch, double *wa, int *ifac)
{
  /* System generated locals */
  int i__1;

  /* Local variables */
  int idot, i__;
  int k1, l1, l2, n2;
  int na, nf, ip, iw, ix2, ix3, ix4, nac, ido, idl1;

  /* Parameter adjustments */
  --ifac;
  --wa;
  --ch;
  --c__;

  /* Function Body */
  nf = ifac[2];
  na = 0;
  l1 = 1;
  iw = 1;
  i__1 = nf;
  for (k1 = 1; k1 <= i__1; ++k1)
    {
      ip = ifac[k1 + 2];
      l2 = ip * l1;
      ido = *n / l2;
      idot = ido + ido;
      idl1 = idot * l1;
      if (ip != 4)
	{
	  goto L103;
	}
      ix2 = iw + idot;
      ix3 = ix2 + idot;
      if (na != 0)
	{
	  goto L101;
	}
      fftpack_passf4 (&idot, &l1, &c__[1], &ch[1], &wa[iw], &wa[ix2],
		      &wa[ix3]);
      goto L102;
    L101:
      fftpack_passf4 (&idot, &l1, &ch[1], &c__[1], &wa[iw], &wa[ix2],
		      &wa[ix3]);
    L102:
      na = 1 - na;
      goto L115;
    L103:
      if (ip != 2)
	{
	  goto L106;
	}
      if (na != 0)
	{
	  goto L104;
	}
      fftpack_passf2 (&idot, &l1, &c__[1], &ch[1], &wa[iw]);
      goto L105;
    L104:
      fftpack_passf2 (&idot, &l1, &ch[1], &c__[1], &wa[iw]);
    L105:
      na = 1 - na;
      goto L115;
    L106:
      if (ip != 3)
	{
	  goto L109;
	}
      ix2 = iw + idot;
      if (na != 0)
	{
	  goto L107;
	}
      fftpack_passf3 (&idot, &l1, &c__[1], &ch[1], &wa[iw], &wa[ix2]);
      goto L108;
    L107:
      fftpack_passf3 (&idot, &l1, &ch[1], &c__[1], &wa[iw], &wa[ix2]);
    L108:
      na = 1 - na;
      goto L115;
    L109:
      if (ip != 5)
	{
	  goto L112;
	}
      ix2 = iw + idot;
      ix3 = ix2 + idot;
      ix4 = ix3 + idot;
      if (na != 0)
	{
	  goto L110;
	}
      fftpack_passf5 (&idot, &l1, &c__[1], &ch[1], &wa[iw], &wa[ix2],
		      &wa[ix3], &wa[ix4]);
      goto L111;
    L110:
      fftpack_passf5 (&idot, &l1, &ch[1], &c__[1], &wa[iw], &wa[ix2],
		      &wa[ix3], &wa[ix4]);
    L111:
      na = 1 - na;
      goto L115;
    L112:
      if (na != 0)
	{
	  goto L113;
	}
      fftpack_passf (&nac, &idot, &ip, &l1, &idl1, &c__[1], &c__[1], &c__[1],
		     &ch[1], &ch[1], &wa[iw]);
      goto L114;
    L113:
      fftpack_passf (&nac, &idot, &ip, &l1, &idl1, &ch[1], &ch[1], &ch[1],
		     &c__[1], &c__[1], &wa[iw]);
    L114:
      if (nac != 0)
	{
	  na = 1 - na;
	}
    L115:
      l1 = l2;
      iw += (ip - 1) * idot;
      /* L116: */
    }
  if (na == 0)
    {
      return 0;
    }
  n2 = *n + *n;
  i__1 = n2;
  for (i__ = 1; i__ <= i__1; ++i__)
    {
      c__[i__] = ch[i__];
      /* L117: */
    }
  return 0;
}				/* cfftf1_ */
/* passf.f -- translated by f2c (version 19961017). */

/* Subroutine */ int
fftpack_passf (int *nac, int *ido, int *ip, int *l1, int *idl1, double *cc,
	       double *c1, double *c2, double *ch, double *ch2, double *wa)
{
  /* System generated locals */
  int ch_dim1, ch_dim2, ch_offset, cc_dim1, cc_dim2, cc_offset, c1_dim1,
    c1_dim2, c1_offset, c2_dim1, c2_offset, ch2_dim1, ch2_offset, i__1, i__2,
    i__3;

  /* Local variables */
  int idij, idlj, idot, ipph, i__, j, k, l, jc, lc, ik, idj, idl, inc, idp;
  double wai, war;
  int ipp2;

  /* Parameter adjustments */
  ch_dim1 = *ido;
  ch_dim2 = *l1;
  ch_offset = ch_dim1 * (ch_dim2 + 1) + 1;
  ch -= ch_offset;
  c1_dim1 = *ido;
  c1_dim2 = *l1;
  c1_offset = c1_dim1 * (c1_dim2 + 1) + 1;
  c1 -= c1_offset;
  cc_dim1 = *ido;
  cc_dim2 = *ip;
  cc_offset = cc_dim1 * (cc_dim2 + 1) + 1;
  cc -= cc_offset;
  ch2_dim1 = *idl1;
  ch2_offset = ch2_dim1 + 1;
  ch2 -= ch2_offset;
  c2_dim1 = *idl1;
  c2_offset = c2_dim1 + 1;
  c2 -= c2_offset;
  --wa;

  /* Function Body */
  idot = *ido / 2;
  /* nt = *ip * *idl1; */
  ipp2 = *ip + 2;
  ipph = (*ip + 1) / 2;
  idp = *ip * *ido;
  /* 
   */
  if (*ido < *l1)
    {
      goto L106;
    }
  i__1 = ipph;
  for (j = 2; j <= i__1; ++j)
    {
      jc = ipp2 - j;
      i__2 = *l1;
      for (k = 1; k <= i__2; ++k)
	{
	  i__3 = *ido;
	  for (i__ = 1; i__ <= i__3; ++i__)
	    {
	      ch[i__ + (k + j * ch_dim2) * ch_dim1] =
		cc[i__ + (j + k * cc_dim2) * cc_dim1] + cc[i__ +
							   (jc +
							    k * cc_dim2) *
							   cc_dim1];
	      ch[i__ + (k + jc * ch_dim2) * ch_dim1] =
		cc[i__ + (j + k * cc_dim2) * cc_dim1] - cc[i__ +
							   (jc +
							    k * cc_dim2) *
							   cc_dim1];
	      /* L101: */
	    }
	  /* L102: */
	}
      /* L103: */
    }
  i__1 = *l1;
  for (k = 1; k <= i__1; ++k)
    {
      i__2 = *ido;
      for (i__ = 1; i__ <= i__2; ++i__)
	{
	  ch[i__ + (k + ch_dim2) * ch_dim1] =
	    cc[i__ + (k * cc_dim2 + 1) * cc_dim1];
	  /* L104: */
	}
      /* L105: */
    }
  goto L112;
 L106:
  i__1 = ipph;
  for (j = 2; j <= i__1; ++j)
    {
      jc = ipp2 - j;
      i__2 = *ido;
      for (i__ = 1; i__ <= i__2; ++i__)
	{
	  i__3 = *l1;
	  for (k = 1; k <= i__3; ++k)
	    {
	      ch[i__ + (k + j * ch_dim2) * ch_dim1] =
		cc[i__ + (j + k * cc_dim2) * cc_dim1] + cc[i__ +
							   (jc +
							    k * cc_dim2) *
							   cc_dim1];
	      ch[i__ + (k + jc * ch_dim2) * ch_dim1] =
		cc[i__ + (j + k * cc_dim2) * cc_dim1] - cc[i__ +
							   (jc +
							    k * cc_dim2) *
							   cc_dim1];
	      /* L107: */
	    }
	  /* L108: */
	}
      /* L109: */
    }
  i__1 = *ido;
  for (i__ = 1; i__ <= i__1; ++i__)
    {
      i__2 = *l1;
      for (k = 1; k <= i__2; ++k)
	{
	  ch[i__ + (k + ch_dim2) * ch_dim1] =
	    cc[i__ + (k * cc_dim2 + 1) * cc_dim1];
	  /* L110: */
	}
      /* L111: */
    }
 L112:
  idl = 2 - *ido;
  inc = 0;
  i__1 = ipph;
  for (l = 2; l <= i__1; ++l)
    {
      lc = ipp2 - l;
      idl += *ido;
      i__2 = *idl1;
      for (ik = 1; ik <= i__2; ++ik)
	{
	  c2[ik + l * c2_dim1] =
	    ch2[ik + ch2_dim1] + wa[idl - 1] * ch2[ik + (ch2_dim1 << 1)];
	  c2[ik + lc * c2_dim1] = -wa[idl] * ch2[ik + *ip * ch2_dim1];
	  /* L113: */
	}
      idlj = idl;
      inc += *ido;
      i__2 = ipph;
      for (j = 3; j <= i__2; ++j)
	{
	  jc = ipp2 - j;
	  idlj += inc;
	  if (idlj > idp)
	    {
	      idlj -= idp;
	    }
	  war = wa[idlj - 1];
	  wai = wa[idlj];
	  i__3 = *idl1;
	  for (ik = 1; ik <= i__3; ++ik)
	    {
	      c2[ik + l * c2_dim1] += war * ch2[ik + j * ch2_dim1];
	      c2[ik + lc * c2_dim1] -= wai * ch2[ik + jc * ch2_dim1];
	      /* L114: */
	    }
	  /* L115: */
	}
      /* L116: */
    }
  i__1 = ipph;
  for (j = 2; j <= i__1; ++j)
    {
      i__2 = *idl1;
      for (ik = 1; ik <= i__2; ++ik)
	{
	  ch2[ik + ch2_dim1] += ch2[ik + j * ch2_dim1];
	  /* L117: */
	}
      /* L118: */
    }
  i__1 = ipph;
  for (j = 2; j <= i__1; ++j)
    {
      jc = ipp2 - j;
      i__2 = *idl1;
      for (ik = 2; ik <= i__2; ik += 2)
	{
	  ch2[ik - 1 + j * ch2_dim1] =
	    c2[ik - 1 + j * c2_dim1] - c2[ik + jc * c2_dim1];
	  ch2[ik - 1 + jc * ch2_dim1] =
	    c2[ik - 1 + j * c2_dim1] + c2[ik + jc * c2_dim1];
	  ch2[ik + j * ch2_dim1] =
	    c2[ik + j * c2_dim1] + c2[ik - 1 + jc * c2_dim1];
	  ch2[ik + jc * ch2_dim1] =
	    c2[ik + j * c2_dim1] - c2[ik - 1 + jc * c2_dim1];
	  /* L119: */
	}
      /* L120: */
    }
  *nac = 1;
  if (*ido == 2)
    {
      return 0;
    }
  *nac = 0;
  i__1 = *idl1;
  for (ik = 1; ik <= i__1; ++ik)
    {
      c2[ik + c2_dim1] = ch2[ik + ch2_dim1];
      /* L121: */
    }
  i__1 = *ip;
  for (j = 2; j <= i__1; ++j)
    {
      i__2 = *l1;
      for (k = 1; k <= i__2; ++k)
	{
	  c1[(k + j * c1_dim2) * c1_dim1 + 1] =
	    ch[(k + j * ch_dim2) * ch_dim1 + 1];
	  c1[(k + j * c1_dim2) * c1_dim1 + 2] =
	    ch[(k + j * ch_dim2) * ch_dim1 + 2];
	  /* L122: */
	}
      /* L123: */
    }
  if (idot > *l1)
    {
      goto L127;
    }
  idij = 0;
  i__1 = *ip;
  for (j = 2; j <= i__1; ++j)
    {
      idij += 2;
      i__2 = *ido;
      for (i__ = 4; i__ <= i__2; i__ += 2)
	{
	  idij += 2;
	  i__3 = *l1;
	  for (k = 1; k <= i__3; ++k)
	    {
	      c1[i__ - 1 + (k + j * c1_dim2) * c1_dim1] =
		wa[idij - 1] * ch[i__ - 1 + (k + j * ch_dim2) * ch_dim1] +
		wa[idij] * ch[i__ + (k + j * ch_dim2) * ch_dim1];
	      c1[i__ + (k + j * c1_dim2) * c1_dim1] =
		wa[idij - 1] * ch[i__ + (k + j * ch_dim2) * ch_dim1] -
		wa[idij] * ch[i__ - 1 + (k + j * ch_dim2) * ch_dim1];
	      /* L124: */
	    }
	  /* L125: */
	}
      /* L126: */
    }
  return 0;
 L127:
  idj = 2 - *ido;
  i__1 = *ip;
  for (j = 2; j <= i__1; ++j)
    {
      idj += *ido;
      i__2 = *l1;
      for (k = 1; k <= i__2; ++k)
	{
	  idij = idj;
	  i__3 = *ido;
	  for (i__ = 4; i__ <= i__3; i__ += 2)
	    {
	      idij += 2;
	      c1[i__ - 1 + (k + j * c1_dim2) * c1_dim1] =
		wa[idij - 1] * ch[i__ - 1 + (k + j * ch_dim2) * ch_dim1] +
		wa[idij] * ch[i__ + (k + j * ch_dim2) * ch_dim1];
	      c1[i__ + (k + j * c1_dim2) * c1_dim1] =
		wa[idij - 1] * ch[i__ + (k + j * ch_dim2) * ch_dim1] -
		wa[idij] * ch[i__ - 1 + (k + j * ch_dim2) * ch_dim1];
	      /* L128: */
	    }
	  /* L129: */
	}
      /* L130: */
    }
  return 0;
}				/* passf_ */
/* passf2.f -- translated by f2c (version 19961017). */

/* Subroutine */ int
fftpack_passf2 (int *ido, int *l1, double *cc, double *ch, double *wa1)
{
  /* System generated locals */
  int cc_dim1, cc_offset, ch_dim1, ch_dim2, ch_offset, i__1, i__2;

  /* Local variables */
  int i__, k;
  double ti2, tr2;

  /* Parameter adjustments */
  ch_dim1 = *ido;
  ch_dim2 = *l1;
  ch_offset = ch_dim1 * (ch_dim2 + 1) + 1;
  ch -= ch_offset;
  cc_dim1 = *ido;
  cc_offset = cc_dim1 * 3 + 1;
  cc -= cc_offset;
  --wa1;

  /* Function Body */
  if (*ido > 2)
    {
      goto L102;
    }
  i__1 = *l1;
  for (k = 1; k <= i__1; ++k)
    {
      ch[(k + ch_dim2) * ch_dim1 + 1] =
	cc[((k << 1) + 1) * cc_dim1 + 1] + cc[((k << 1) + 2) * cc_dim1 + 1];
      ch[(k + (ch_dim2 << 1)) * ch_dim1 + 1] =
	cc[((k << 1) + 1) * cc_dim1 + 1] - cc[((k << 1) + 2) * cc_dim1 + 1];
      ch[(k + ch_dim2) * ch_dim1 + 2] =
	cc[((k << 1) + 1) * cc_dim1 + 2] + cc[((k << 1) + 2) * cc_dim1 + 2];
      ch[(k + (ch_dim2 << 1)) * ch_dim1 + 2] =
	cc[((k << 1) + 1) * cc_dim1 + 2] - cc[((k << 1) + 2) * cc_dim1 + 2];
      /* L101: */
    }
  return 0;
 L102:
  i__1 = *l1;
  for (k = 1; k <= i__1; ++k)
    {
      i__2 = *ido;
      for (i__ = 2; i__ <= i__2; i__ += 2)
	{
	  ch[i__ - 1 + (k + ch_dim2) * ch_dim1] =
	    cc[i__ - 1 + ((k << 1) + 1) * cc_dim1] + cc[i__ - 1 +
							((k << 1) +
							 2) * cc_dim1];
	  tr2 =
	    cc[i__ - 1 + ((k << 1) + 1) * cc_dim1] - cc[i__ - 1 +
							((k << 1) +
							 2) * cc_dim1];
	  ch[i__ + (k + ch_dim2) * ch_dim1] =
	    cc[i__ + ((k << 1) + 1) * cc_dim1] + cc[i__ +
						    ((k << 1) + 2) * cc_dim1];
	  ti2 =
	    cc[i__ + ((k << 1) + 1) * cc_dim1] - cc[i__ +
						    ((k << 1) + 2) * cc_dim1];
	  ch[i__ + (k + (ch_dim2 << 1)) * ch_dim1] =
	    wa1[i__ - 1] * ti2 - wa1[i__] * tr2;
	  ch[i__ - 1 + (k + (ch_dim2 << 1)) * ch_dim1] =
	    wa1[i__ - 1] * tr2 + wa1[i__] * ti2;
	  /* L103: */
	}
      /* L104: */
    }
  return 0;
}				/* passf2_ */
/* passf3.f -- translated by f2c (version 19961017). */

/* Subroutine */ int
fftpack_passf3 (int *ido, int *l1, double *cc, double *ch, double *wa1,
		double *wa2)
{
  /* Initialized data */

  static double taur = -.5;
  static double taui = -.86602540378443864676;

  /* System generated locals */
  int cc_dim1, cc_offset, ch_dim1, ch_dim2, ch_offset, i__1, i__2;

  /* Local variables */
  int i__, k;
  double ci2, ci3, di2, di3, cr2, cr3, dr2, dr3, ti2, tr2;

  /*    *** TAUI IS -SQRT(3)/2 *** 
   */
  /* Parameter adjustments */
  ch_dim1 = *ido;
  ch_dim2 = *l1;
  ch_offset = ch_dim1 * (ch_dim2 + 1) + 1;
  ch -= ch_offset;
  cc_dim1 = *ido;
  cc_offset = (cc_dim1 << 2) + 1;
  cc -= cc_offset;
  --wa1;
  --wa2;

  /* Function Body */
  if (*ido != 2)
    {
      goto L102;
    }
  i__1 = *l1;
  for (k = 1; k <= i__1; ++k)
    {
      tr2 = cc[(k * 3 + 2) * cc_dim1 + 1] + cc[(k * 3 + 3) * cc_dim1 + 1];
      cr2 = cc[(k * 3 + 1) * cc_dim1 + 1] + taur * tr2;
      ch[(k + ch_dim2) * ch_dim1 + 1] = cc[(k * 3 + 1) * cc_dim1 + 1] + tr2;
      ti2 = cc[(k * 3 + 2) * cc_dim1 + 2] + cc[(k * 3 + 3) * cc_dim1 + 2];
      ci2 = cc[(k * 3 + 1) * cc_dim1 + 2] + taur * ti2;
      ch[(k + ch_dim2) * ch_dim1 + 2] = cc[(k * 3 + 1) * cc_dim1 + 2] + ti2;
      cr3 =
	taui * (cc[(k * 3 + 2) * cc_dim1 + 1] -
		cc[(k * 3 + 3) * cc_dim1 + 1]);
      ci3 =
	taui * (cc[(k * 3 + 2) * cc_dim1 + 2] -
		cc[(k * 3 + 3) * cc_dim1 + 2]);
      ch[(k + (ch_dim2 << 1)) * ch_dim1 + 1] = cr2 - ci3;
      ch[(k + ch_dim2 * 3) * ch_dim1 + 1] = cr2 + ci3;
      ch[(k + (ch_dim2 << 1)) * ch_dim1 + 2] = ci2 + cr3;
      ch[(k + ch_dim2 * 3) * ch_dim1 + 2] = ci2 - cr3;
      /* L101: */
    }
  return 0;
 L102:
  i__1 = *l1;
  for (k = 1; k <= i__1; ++k)
    {
      i__2 = *ido;
      for (i__ = 2; i__ <= i__2; i__ += 2)
	{
	  tr2 =
	    cc[i__ - 1 + (k * 3 + 2) * cc_dim1] + cc[i__ - 1 +
						     (k * 3 + 3) * cc_dim1];
	  cr2 = cc[i__ - 1 + (k * 3 + 1) * cc_dim1] + taur * tr2;
	  ch[i__ - 1 + (k + ch_dim2) * ch_dim1] =
	    cc[i__ - 1 + (k * 3 + 1) * cc_dim1] + tr2;
	  ti2 =
	    cc[i__ + (k * 3 + 2) * cc_dim1] + cc[i__ + (k * 3 + 3) * cc_dim1];
	  ci2 = cc[i__ + (k * 3 + 1) * cc_dim1] + taur * ti2;
	  ch[i__ + (k + ch_dim2) * ch_dim1] =
	    cc[i__ + (k * 3 + 1) * cc_dim1] + ti2;
	  cr3 =
	    taui * (cc[i__ - 1 + (k * 3 + 2) * cc_dim1] -
		    cc[i__ - 1 + (k * 3 + 3) * cc_dim1]);
	  ci3 =
	    taui * (cc[i__ + (k * 3 + 2) * cc_dim1] -
		    cc[i__ + (k * 3 + 3) * cc_dim1]);
	  dr2 = cr2 - ci3;
	  dr3 = cr2 + ci3;
	  di2 = ci2 + cr3;
	  di3 = ci2 - cr3;
	  ch[i__ + (k + (ch_dim2 << 1)) * ch_dim1] =
	    wa1[i__ - 1] * di2 - wa1[i__] * dr2;
	  ch[i__ - 1 + (k + (ch_dim2 << 1)) * ch_dim1] =
	    wa1[i__ - 1] * dr2 + wa1[i__] * di2;
	  ch[i__ + (k + ch_dim2 * 3) * ch_dim1] =
	    wa2[i__ - 1] * di3 - wa2[i__] * dr3;
	  ch[i__ - 1 + (k + ch_dim2 * 3) * ch_dim1] =
	    wa2[i__ - 1] * dr3 + wa2[i__] * di3;
	  /* L103: */
	}
      /* L104: */
    }
  return 0;
}				/* passf3_ */
/* passf4.f -- translated by f2c (version 19961017). */

/* Subroutine */ int
fftpack_passf4 (int *ido, int *l1, double *cc, double *ch, double *wa1,
		double *wa2, double *wa3)
{
  /* System generated locals */
  int cc_dim1, cc_offset, ch_dim1, ch_dim2, ch_offset, i__1, i__2;

  /* Local variables */
  int i__, k;
  double ci2, ci3, ci4, cr2, cr3, cr4, ti1, ti2, ti3, ti4, tr1, tr2, tr3, tr4;

  /* Parameter adjustments */
  ch_dim1 = *ido;
  ch_dim2 = *l1;
  ch_offset = ch_dim1 * (ch_dim2 + 1) + 1;
  ch -= ch_offset;
  cc_dim1 = *ido;
  cc_offset = cc_dim1 * 5 + 1;
  cc -= cc_offset;
  --wa1;
  --wa2;
  --wa3;

  /* Function Body */
  if (*ido != 2)
    {
      goto L102;
    }
  i__1 = *l1;
  for (k = 1; k <= i__1; ++k)
    {
      ti1 =
	cc[((k << 2) + 1) * cc_dim1 + 2] - cc[((k << 2) + 3) * cc_dim1 + 2];
      ti2 =
	cc[((k << 2) + 1) * cc_dim1 + 2] + cc[((k << 2) + 3) * cc_dim1 + 2];
      tr4 =
	cc[((k << 2) + 2) * cc_dim1 + 2] - cc[((k << 2) + 4) * cc_dim1 + 2];
      ti3 =
	cc[((k << 2) + 2) * cc_dim1 + 2] + cc[((k << 2) + 4) * cc_dim1 + 2];
      tr1 =
	cc[((k << 2) + 1) * cc_dim1 + 1] - cc[((k << 2) + 3) * cc_dim1 + 1];
      tr2 =
	cc[((k << 2) + 1) * cc_dim1 + 1] + cc[((k << 2) + 3) * cc_dim1 + 1];
      ti4 =
	cc[((k << 2) + 4) * cc_dim1 + 1] - cc[((k << 2) + 2) * cc_dim1 + 1];
      tr3 =
	cc[((k << 2) + 2) * cc_dim1 + 1] + cc[((k << 2) + 4) * cc_dim1 + 1];
      ch[(k + ch_dim2) * ch_dim1 + 1] = tr2 + tr3;
      ch[(k + ch_dim2 * 3) * ch_dim1 + 1] = tr2 - tr3;
      ch[(k + ch_dim2) * ch_dim1 + 2] = ti2 + ti3;
      ch[(k + ch_dim2 * 3) * ch_dim1 + 2] = ti2 - ti3;
      ch[(k + (ch_dim2 << 1)) * ch_dim1 + 1] = tr1 + tr4;
      ch[(k + (ch_dim2 << 2)) * ch_dim1 + 1] = tr1 - tr4;
      ch[(k + (ch_dim2 << 1)) * ch_dim1 + 2] = ti1 + ti4;
      ch[(k + (ch_dim2 << 2)) * ch_dim1 + 2] = ti1 - ti4;
      /* L101: */
    }
  return 0;
 L102:
  i__1 = *l1;
  for (k = 1; k <= i__1; ++k)
    {
      i__2 = *ido;
      for (i__ = 2; i__ <= i__2; i__ += 2)
	{
	  ti1 =
	    cc[i__ + ((k << 2) + 1) * cc_dim1] - cc[i__ +
						    ((k << 2) + 3) * cc_dim1];
	  ti2 =
	    cc[i__ + ((k << 2) + 1) * cc_dim1] + cc[i__ +
						    ((k << 2) + 3) * cc_dim1];
	  ti3 =
	    cc[i__ + ((k << 2) + 2) * cc_dim1] + cc[i__ +
						    ((k << 2) + 4) * cc_dim1];
	  tr4 =
	    cc[i__ + ((k << 2) + 2) * cc_dim1] - cc[i__ +
						    ((k << 2) + 4) * cc_dim1];
	  tr1 =
	    cc[i__ - 1 + ((k << 2) + 1) * cc_dim1] - cc[i__ - 1 +
							((k << 2) +
							 3) * cc_dim1];
	  tr2 =
	    cc[i__ - 1 + ((k << 2) + 1) * cc_dim1] + cc[i__ - 1 +
							((k << 2) +
							 3) * cc_dim1];
	  ti4 =
	    cc[i__ - 1 + ((k << 2) + 4) * cc_dim1] - cc[i__ - 1 +
							((k << 2) +
							 2) * cc_dim1];
	  tr3 =
	    cc[i__ - 1 + ((k << 2) + 2) * cc_dim1] + cc[i__ - 1 +
							((k << 2) +
							 4) * cc_dim1];
	  ch[i__ - 1 + (k + ch_dim2) * ch_dim1] = tr2 + tr3;
	  cr3 = tr2 - tr3;
	  ch[i__ + (k + ch_dim2) * ch_dim1] = ti2 + ti3;
	  ci3 = ti2 - ti3;
	  cr2 = tr1 + tr4;
	  cr4 = tr1 - tr4;
	  ci2 = ti1 + ti4;
	  ci4 = ti1 - ti4;
	  ch[i__ - 1 + (k + (ch_dim2 << 1)) * ch_dim1] =
	    wa1[i__ - 1] * cr2 + wa1[i__] * ci2;
	  ch[i__ + (k + (ch_dim2 << 1)) * ch_dim1] =
	    wa1[i__ - 1] * ci2 - wa1[i__] * cr2;
	  ch[i__ - 1 + (k + ch_dim2 * 3) * ch_dim1] =
	    wa2[i__ - 1] * cr3 + wa2[i__] * ci3;
	  ch[i__ + (k + ch_dim2 * 3) * ch_dim1] =
	    wa2[i__ - 1] * ci3 - wa2[i__] * cr3;
	  ch[i__ - 1 + (k + (ch_dim2 << 2)) * ch_dim1] =
	    wa3[i__ - 1] * cr4 + wa3[i__] * ci4;
	  ch[i__ + (k + (ch_dim2 << 2)) * ch_dim1] =
	    wa3[i__ - 1] * ci4 - wa3[i__] * cr4;
	  /* L103: */
	}
      /* L104: */
    }
  return 0;
}				/* passf4_ */

/* passf5.f -- translated by f2c (version 19961017).
 */

/* Subroutine */ int
fftpack_passf5 (int *ido, int *l1, double *cc, double *ch, double *wa1,
		double *wa2, double *wa3, double *wa4)
{
  /* Initialized data */

  static double tr11 = .3090169943749474241;
  static double ti11 = -.95105651629515357212;
  static double tr12 = -.8090169943749474241;
  static double ti12 = -.58778525229247312917;

  /* System generated locals */
  int cc_dim1, cc_offset, ch_dim1, ch_dim2, ch_offset, i__1, i__2;

  /* Local variables */
  int i__, k;
  double ci2, ci3, ci4, ci5, di3, di4, di5, di2, cr2, cr3, cr5, cr4, ti2, ti3,
    ti4, ti5, dr3, dr4, dr5, dr2, tr2, tr3, tr4, tr5;

  /*    *** TR11=COS(2*PI/5), TI11=-SIN(2*PI/5) 
   *    *** TR12=-COS(4*PI/5), TI12=-SIN(4*PI/5) 
   */
  /* Parameter adjustments */
  ch_dim1 = *ido;
  ch_dim2 = *l1;
  ch_offset = ch_dim1 * (ch_dim2 + 1) + 1;
  ch -= ch_offset;
  cc_dim1 = *ido;
  cc_offset = cc_dim1 * 6 + 1;
  cc -= cc_offset;
  --wa1;
  --wa2;
  --wa3;
  --wa4;

  /* Function Body */
  if (*ido != 2)
    {
      goto L102;
    }
  i__1 = *l1;
  for (k = 1; k <= i__1; ++k)
    {
      ti5 = cc[(k * 5 + 2) * cc_dim1 + 2] - cc[(k * 5 + 5) * cc_dim1 + 2];
      ti2 = cc[(k * 5 + 2) * cc_dim1 + 2] + cc[(k * 5 + 5) * cc_dim1 + 2];
      ti4 = cc[(k * 5 + 3) * cc_dim1 + 2] - cc[(k * 5 + 4) * cc_dim1 + 2];
      ti3 = cc[(k * 5 + 3) * cc_dim1 + 2] + cc[(k * 5 + 4) * cc_dim1 + 2];
      tr5 = cc[(k * 5 + 2) * cc_dim1 + 1] - cc[(k * 5 + 5) * cc_dim1 + 1];
      tr2 = cc[(k * 5 + 2) * cc_dim1 + 1] + cc[(k * 5 + 5) * cc_dim1 + 1];
      tr4 = cc[(k * 5 + 3) * cc_dim1 + 1] - cc[(k * 5 + 4) * cc_dim1 + 1];
      tr3 = cc[(k * 5 + 3) * cc_dim1 + 1] + cc[(k * 5 + 4) * cc_dim1 + 1];
      ch[(k + ch_dim2) * ch_dim1 + 1] =
	cc[(k * 5 + 1) * cc_dim1 + 1] + tr2 + tr3;
      ch[(k + ch_dim2) * ch_dim1 + 2] =
	cc[(k * 5 + 1) * cc_dim1 + 2] + ti2 + ti3;
      cr2 = cc[(k * 5 + 1) * cc_dim1 + 1] + tr11 * tr2 + tr12 * tr3;
      ci2 = cc[(k * 5 + 1) * cc_dim1 + 2] + tr11 * ti2 + tr12 * ti3;
      cr3 = cc[(k * 5 + 1) * cc_dim1 + 1] + tr12 * tr2 + tr11 * tr3;
      ci3 = cc[(k * 5 + 1) * cc_dim1 + 2] + tr12 * ti2 + tr11 * ti3;
      cr5 = ti11 * tr5 + ti12 * tr4;
      ci5 = ti11 * ti5 + ti12 * ti4;
      cr4 = ti12 * tr5 - ti11 * tr4;
      ci4 = ti12 * ti5 - ti11 * ti4;
      ch[(k + (ch_dim2 << 1)) * ch_dim1 + 1] = cr2 - ci5;
      ch[(k + ch_dim2 * 5) * ch_dim1 + 1] = cr2 + ci5;
      ch[(k + (ch_dim2 << 1)) * ch_dim1 + 2] = ci2 + cr5;
      ch[(k + ch_dim2 * 3) * ch_dim1 + 2] = ci3 + cr4;
      ch[(k + ch_dim2 * 3) * ch_dim1 + 1] = cr3 - ci4;
      ch[(k + (ch_dim2 << 2)) * ch_dim1 + 1] = cr3 + ci4;
      ch[(k + (ch_dim2 << 2)) * ch_dim1 + 2] = ci3 - cr4;
      ch[(k + ch_dim2 * 5) * ch_dim1 + 2] = ci2 - cr5;
      /* L101: */
    }
  return 0;
 L102:
  i__1 = *l1;
  for (k = 1; k <= i__1; ++k)
    {
      i__2 = *ido;
      for (i__ = 2; i__ <= i__2; i__ += 2)
	{
	  ti5 =
	    cc[i__ + (k * 5 + 2) * cc_dim1] - cc[i__ + (k * 5 + 5) * cc_dim1];
	  ti2 =
	    cc[i__ + (k * 5 + 2) * cc_dim1] + cc[i__ + (k * 5 + 5) * cc_dim1];
	  ti4 =
	    cc[i__ + (k * 5 + 3) * cc_dim1] - cc[i__ + (k * 5 + 4) * cc_dim1];
	  ti3 =
	    cc[i__ + (k * 5 + 3) * cc_dim1] + cc[i__ + (k * 5 + 4) * cc_dim1];
	  tr5 =
	    cc[i__ - 1 + (k * 5 + 2) * cc_dim1] - cc[i__ - 1 +
						     (k * 5 + 5) * cc_dim1];
	  tr2 =
	    cc[i__ - 1 + (k * 5 + 2) * cc_dim1] + cc[i__ - 1 +
						     (k * 5 + 5) * cc_dim1];
	  tr4 =
	    cc[i__ - 1 + (k * 5 + 3) * cc_dim1] - cc[i__ - 1 +
						     (k * 5 + 4) * cc_dim1];
	  tr3 =
	    cc[i__ - 1 + (k * 5 + 3) * cc_dim1] + cc[i__ - 1 +
						     (k * 5 + 4) * cc_dim1];
	  ch[i__ - 1 + (k + ch_dim2) * ch_dim1] =
	    cc[i__ - 1 + (k * 5 + 1) * cc_dim1] + tr2 + tr3;
	  ch[i__ + (k + ch_dim2) * ch_dim1] =
	    cc[i__ + (k * 5 + 1) * cc_dim1] + ti2 + ti3;
	  cr2 = cc[i__ - 1 + (k * 5 + 1) * cc_dim1] + tr11 * tr2 + tr12 * tr3;
	  ci2 = cc[i__ + (k * 5 + 1) * cc_dim1] + tr11 * ti2 + tr12 * ti3;
	  cr3 = cc[i__ - 1 + (k * 5 + 1) * cc_dim1] + tr12 * tr2 + tr11 * tr3;
	  ci3 = cc[i__ + (k * 5 + 1) * cc_dim1] + tr12 * ti2 + tr11 * ti3;
	  cr5 = ti11 * tr5 + ti12 * tr4;
	  ci5 = ti11 * ti5 + ti12 * ti4;
	  cr4 = ti12 * tr5 - ti11 * tr4;
	  ci4 = ti12 * ti5 - ti11 * ti4;
	  dr3 = cr3 - ci4;
	  dr4 = cr3 + ci4;
	  di3 = ci3 + cr4;
	  di4 = ci3 - cr4;
	  dr5 = cr2 + ci5;
	  dr2 = cr2 - ci5;
	  di5 = ci2 - cr5;
	  di2 = ci2 + cr5;
	  ch[i__ - 1 + (k + (ch_dim2 << 1)) * ch_dim1] =
	    wa1[i__ - 1] * dr2 + wa1[i__] * di2;
	  ch[i__ + (k + (ch_dim2 << 1)) * ch_dim1] =
	    wa1[i__ - 1] * di2 - wa1[i__] * dr2;
	  ch[i__ - 1 + (k + ch_dim2 * 3) * ch_dim1] =
	    wa2[i__ - 1] * dr3 + wa2[i__] * di3;
	  ch[i__ + (k + ch_dim2 * 3) * ch_dim1] =
	    wa2[i__ - 1] * di3 - wa2[i__] * dr3;
	  ch[i__ - 1 + (k + (ch_dim2 << 2)) * ch_dim1] =
	    wa3[i__ - 1] * dr4 + wa3[i__] * di4;
	  ch[i__ + (k + (ch_dim2 << 2)) * ch_dim1] =
	    wa3[i__ - 1] * di4 - wa3[i__] * dr4;
	  ch[i__ - 1 + (k + ch_dim2 * 5) * ch_dim1] =
	    wa4[i__ - 1] * dr5 + wa4[i__] * di5;
	  ch[i__ + (k + ch_dim2 * 5) * ch_dim1] =
	    wa4[i__ - 1] * di5 - wa4[i__] * dr5;
	  /* L103: */
	}
      /* L104: */
    }
  return 0;
}				/* passf5_ */
