#include "fftpack.h"

static int fftpack_radb2 (int *ido, int *l1, double *cc, double *ch,
			  double *wa1);
static int fftpack_radb3 (int *ido, int *l1, double *cc, double *ch,
			  double *wa1, double *wa2);
static int fftpack_radb4 (int *ido, int *l1, double *cc, double *ch,
			  double *wa1, double *wa2, double *wa3);
static int fftpack_radb5 (int *ido, int *l1, double *cc, double *ch,
			  double *wa1, double *wa2, double *wa3, double *wa4);

static int fftpack_radbg (int *ido, int *ip, int *l1, int *idl1, double *cc,
			  double *c1, double *c2, double *ch, double *ch2,
			  double *wa);

/* Subroutine */ int
fftpack_rfftb1 (int *n, double *c__, double *ch, double *wa, int *ifac)
{
  /* System generated locals */
  int i__1;

  /* Local variables */
  int i__;
  int k1, l1, l2, na, nf, ip, iw, ix2, ix3, ix4, ido, idl1;

  /* Parameter adjustments */
  --ifac;
  --wa;
  --ch;
  --c__;

  /* Function Body */
  nf = ifac[2];
  na = 0;
  l1 = 1;
  iw = 1;
  i__1 = nf;
  for (k1 = 1; k1 <= i__1; ++k1)
    {
      ip = ifac[k1 + 2];
      l2 = ip * l1;
      ido = *n / l2;
      idl1 = ido * l1;
      if (ip != 4)
	{
	  goto L103;
	}
      ix2 = iw + ido;
      ix3 = ix2 + ido;
      if (na != 0)
	{
	  goto L101;
	}
      fftpack_radb4 (&ido, &l1, &c__[1], &ch[1], &wa[iw], &wa[ix2], &wa[ix3]);
      goto L102;
    L101:
      fftpack_radb4 (&ido, &l1, &ch[1], &c__[1], &wa[iw], &wa[ix2], &wa[ix3]);
    L102:
      na = 1 - na;
      goto L115;
    L103:
      if (ip != 2)
	{
	  goto L106;
	}
      if (na != 0)
	{
	  goto L104;
	}
      fftpack_radb2 (&ido, &l1, &c__[1], &ch[1], &wa[iw]);
      goto L105;
    L104:
      fftpack_radb2 (&ido, &l1, &ch[1], &c__[1], &wa[iw]);
    L105:
      na = 1 - na;
      goto L115;
    L106:
      if (ip != 3)
	{
	  goto L109;
	}
      ix2 = iw + ido;
      if (na != 0)
	{
	  goto L107;
	}
      fftpack_radb3 (&ido, &l1, &c__[1], &ch[1], &wa[iw], &wa[ix2]);
      goto L108;
    L107:
      fftpack_radb3 (&ido, &l1, &ch[1], &c__[1], &wa[iw], &wa[ix2]);
    L108:
      na = 1 - na;
      goto L115;
    L109:
      if (ip != 5)
	{
	  goto L112;
	}
      ix2 = iw + ido;
      ix3 = ix2 + ido;
      ix4 = ix3 + ido;
      if (na != 0)
	{
	  goto L110;
	}
      fftpack_radb5 (&ido, &l1, &c__[1], &ch[1], &wa[iw], &wa[ix2], &wa[ix3],
		     &wa[ix4]);
      goto L111;
    L110:
      fftpack_radb5 (&ido, &l1, &ch[1], &c__[1], &wa[iw], &wa[ix2], &wa[ix3],
		     &wa[ix4]);
    L111:
      na = 1 - na;
      goto L115;
    L112:
      if (na != 0)
	{
	  goto L113;
	}
      fftpack_radbg (&ido, &ip, &l1, &idl1, &c__[1], &c__[1], &c__[1], &ch[1],
		     &ch[1], &wa[iw]);
      goto L114;
    L113:
      fftpack_radbg (&ido, &ip, &l1, &idl1, &ch[1], &ch[1], &ch[1], &c__[1],
		     &c__[1], &wa[iw]);
    L114:
      if (ido == 1)
	{
	  na = 1 - na;
	}
    L115:
      l1 = l2;
      iw += (ip - 1) * ido;
      /* L116: */
    }
  if (na == 0)
    {
      return 0;
    }
  i__1 = *n;
  for (i__ = 1; i__ <= i__1; ++i__)
    {
      c__[i__] = ch[i__];
      /* L117: */
    }
  return 0;
}				/* rfftb1_ */
/* radb2.f -- translated by f2c (version 19961017).
 *   
 *   -lf2c -lm (in that order)
 */

#include "fftpack.h"

/* Subroutine */ int
fftpack_radb2 (int *ido, int *l1, double *cc, double *ch, double *wa1)
{
  /* System generated locals */
  int cc_dim1, cc_offset, ch_dim1, ch_dim2, ch_offset, i__1, i__2;

  /* Local variables */
  int i__, k, ic;
  double ti2, tr2;
  int idp2;

  /* Parameter adjustments */
  ch_dim1 = *ido;
  ch_dim2 = *l1;
  ch_offset = ch_dim1 * (ch_dim2 + 1) + 1;
  ch -= ch_offset;
  cc_dim1 = *ido;
  cc_offset = cc_dim1 * 3 + 1;
  cc -= cc_offset;
  --wa1;

  /* Function Body */
  i__1 = *l1;
  for (k = 1; k <= i__1; ++k)
    {
      ch[(k + ch_dim2) * ch_dim1 + 1] =
	cc[((k << 1) + 1) * cc_dim1 + 1] + cc[*ido +
					      ((k << 1) + 2) * cc_dim1];
      ch[(k + (ch_dim2 << 1)) * ch_dim1 + 1] =
	cc[((k << 1) + 1) * cc_dim1 + 1] - cc[*ido +
					      ((k << 1) + 2) * cc_dim1];
      /* L101: */
    }
  if ((i__1 = *ido - 2) < 0)
    {
      goto L107;
    }
  else if (i__1 == 0)
    {
      goto L105;
    }
  else
    {
      goto L102;
    }
 L102:
  idp2 = *ido + 2;
  i__1 = *l1;
  for (k = 1; k <= i__1; ++k)
    {
      i__2 = *ido;
      for (i__ = 3; i__ <= i__2; i__ += 2)
	{
	  ic = idp2 - i__;
	  ch[i__ - 1 + (k + ch_dim2) * ch_dim1] =
	    cc[i__ - 1 + ((k << 1) + 1) * cc_dim1] + cc[ic - 1 +
							((k << 1) +
							 2) * cc_dim1];
	  tr2 =
	    cc[i__ - 1 + ((k << 1) + 1) * cc_dim1] - cc[ic - 1 +
							((k << 1) +
							 2) * cc_dim1];
	  ch[i__ + (k + ch_dim2) * ch_dim1] =
	    cc[i__ + ((k << 1) + 1) * cc_dim1] - cc[ic +
						    ((k << 1) + 2) * cc_dim1];
	  ti2 =
	    cc[i__ + ((k << 1) + 1) * cc_dim1] + cc[ic +
						    ((k << 1) + 2) * cc_dim1];
	  ch[i__ - 1 + (k + (ch_dim2 << 1)) * ch_dim1] =
	    wa1[i__ - 2] * tr2 - wa1[i__ - 1] * ti2;
	  ch[i__ + (k + (ch_dim2 << 1)) * ch_dim1] =
	    wa1[i__ - 2] * ti2 + wa1[i__ - 1] * tr2;
	  /* L103: */
	}
      /* L104: */
    }
  if (*ido % 2 == 1)
    {
      return 0;
    }
 L105:
  i__1 = *l1;
  for (k = 1; k <= i__1; ++k)
    {
      ch[*ido + (k + ch_dim2) * ch_dim1] =
	cc[*ido + ((k << 1) + 1) * cc_dim1] + cc[*ido +
						 ((k << 1) + 1) * cc_dim1];
      ch[*ido + (k + (ch_dim2 << 1)) * ch_dim1] =
	-(cc[((k << 1) + 2) * cc_dim1 + 1] +
	  cc[((k << 1) + 2) * cc_dim1 + 1]);
      /* L106: */
    }
 L107:
  return 0;
}				/* radb2_ */
/* radb3.f -- translated by f2c (version 19961017).
 *   
 *   -lf2c -lm (in that order)
 */

#include "fftpack.h"

/* Subroutine */ int
fftpack_radb3 (int *ido, int *l1, double *cc, double *ch, double *wa1,
	       double *wa2)
{
  /* Initialized data */

  static double taur = -.5;
  static double taui = .86602540378443864676;

  /* System generated locals */
  int cc_dim1, cc_offset, ch_dim1, ch_dim2, ch_offset, i__1, i__2;

  /* Local variables */
  int i__, k, ic;
  double ci2, ci3, di2, di3, cr2, cr3, dr2, dr3, ti2, tr2;
  int idp2;

  /*    *** TAUI IS SQRT(3)/2 *** 
   */
  /* Parameter adjustments */
  ch_dim1 = *ido;
  ch_dim2 = *l1;
  ch_offset = ch_dim1 * (ch_dim2 + 1) + 1;
  ch -= ch_offset;
  cc_dim1 = *ido;
  cc_offset = (cc_dim1 << 2) + 1;
  cc -= cc_offset;
  --wa1;
  --wa2;

  /* Function Body */
  i__1 = *l1;
  for (k = 1; k <= i__1; ++k)
    {
      tr2 =
	cc[*ido + (k * 3 + 2) * cc_dim1] + cc[*ido + (k * 3 + 2) * cc_dim1];
      cr2 = cc[(k * 3 + 1) * cc_dim1 + 1] + taur * tr2;
      ch[(k + ch_dim2) * ch_dim1 + 1] = cc[(k * 3 + 1) * cc_dim1 + 1] + tr2;
      ci3 =
	taui * (cc[(k * 3 + 3) * cc_dim1 + 1] +
		cc[(k * 3 + 3) * cc_dim1 + 1]);
      ch[(k + (ch_dim2 << 1)) * ch_dim1 + 1] = cr2 - ci3;
      ch[(k + ch_dim2 * 3) * ch_dim1 + 1] = cr2 + ci3;
      /* L101: */
    }
  if (*ido == 1)
    {
      return 0;
    }
  idp2 = *ido + 2;
  i__1 = *l1;
  for (k = 1; k <= i__1; ++k)
    {
      i__2 = *ido;
      for (i__ = 3; i__ <= i__2; i__ += 2)
	{
	  ic = idp2 - i__;
	  tr2 =
	    cc[i__ - 1 + (k * 3 + 3) * cc_dim1] + cc[ic - 1 +
						     (k * 3 + 2) * cc_dim1];
	  cr2 = cc[i__ - 1 + (k * 3 + 1) * cc_dim1] + taur * tr2;
	  ch[i__ - 1 + (k + ch_dim2) * ch_dim1] =
	    cc[i__ - 1 + (k * 3 + 1) * cc_dim1] + tr2;
	  ti2 =
	    cc[i__ + (k * 3 + 3) * cc_dim1] - cc[ic + (k * 3 + 2) * cc_dim1];
	  ci2 = cc[i__ + (k * 3 + 1) * cc_dim1] + taur * ti2;
	  ch[i__ + (k + ch_dim2) * ch_dim1] =
	    cc[i__ + (k * 3 + 1) * cc_dim1] + ti2;
	  cr3 =
	    taui * (cc[i__ - 1 + (k * 3 + 3) * cc_dim1] -
		    cc[ic - 1 + (k * 3 + 2) * cc_dim1]);
	  ci3 =
	    taui * (cc[i__ + (k * 3 + 3) * cc_dim1] +
		    cc[ic + (k * 3 + 2) * cc_dim1]);
	  dr2 = cr2 - ci3;
	  dr3 = cr2 + ci3;
	  di2 = ci2 + cr3;
	  di3 = ci2 - cr3;
	  ch[i__ - 1 + (k + (ch_dim2 << 1)) * ch_dim1] =
	    wa1[i__ - 2] * dr2 - wa1[i__ - 1] * di2;
	  ch[i__ + (k + (ch_dim2 << 1)) * ch_dim1] =
	    wa1[i__ - 2] * di2 + wa1[i__ - 1] * dr2;
	  ch[i__ - 1 + (k + ch_dim2 * 3) * ch_dim1] =
	    wa2[i__ - 2] * dr3 - wa2[i__ - 1] * di3;
	  ch[i__ + (k + ch_dim2 * 3) * ch_dim1] =
	    wa2[i__ - 2] * di3 + wa2[i__ - 1] * dr3;
	  /* L102: */
	}
      /* L103: */
    }
  return 0;
}				/* radb3_ */
/* radb4.f -- translated by f2c (version 19961017).
 *   
 *   -lf2c -lm (in that order)
 */

#include "fftpack.h"

/* Subroutine */ int
fftpack_radb4 (int *ido, int *l1, double *cc, double *ch, double *wa1,
	       double *wa2, double *wa3)
{
  /* Initialized data */

  static double sqrt2 = 1.4142135623730950488;

  /* System generated locals */
  int cc_dim1, cc_offset, ch_dim1, ch_dim2, ch_offset, i__1, i__2;

  /* Local variables */
  int i__, k, ic;
  double ci2, ci3, ci4, cr2, cr3, cr4, ti1, ti2, ti3, ti4, tr1, tr2, tr3, tr4;
  int idp2;

  /* Parameter adjustments */
  ch_dim1 = *ido;
  ch_dim2 = *l1;
  ch_offset = ch_dim1 * (ch_dim2 + 1) + 1;
  ch -= ch_offset;
  cc_dim1 = *ido;
  cc_offset = cc_dim1 * 5 + 1;
  cc -= cc_offset;
  --wa1;
  --wa2;
  --wa3;

  /* Function Body */
  i__1 = *l1;
  for (k = 1; k <= i__1; ++k)
    {
      tr1 =
	cc[((k << 2) + 1) * cc_dim1 + 1] - cc[*ido +
					      ((k << 2) + 4) * cc_dim1];
      tr2 =
	cc[((k << 2) + 1) * cc_dim1 + 1] + cc[*ido +
					      ((k << 2) + 4) * cc_dim1];
      tr3 =
	cc[*ido + ((k << 2) + 2) * cc_dim1] + cc[*ido +
						 ((k << 2) + 2) * cc_dim1];
      tr4 =
	cc[((k << 2) + 3) * cc_dim1 + 1] + cc[((k << 2) + 3) * cc_dim1 + 1];
      ch[(k + ch_dim2) * ch_dim1 + 1] = tr2 + tr3;
      ch[(k + (ch_dim2 << 1)) * ch_dim1 + 1] = tr1 - tr4;
      ch[(k + ch_dim2 * 3) * ch_dim1 + 1] = tr2 - tr3;
      ch[(k + (ch_dim2 << 2)) * ch_dim1 + 1] = tr1 + tr4;
      /* L101: */
    }
  if ((i__1 = *ido - 2) < 0)
    {
      goto L107;
    }
  else if (i__1 == 0)
    {
      goto L105;
    }
  else
    {
      goto L102;
    }
 L102:
  idp2 = *ido + 2;
  i__1 = *l1;
  for (k = 1; k <= i__1; ++k)
    {
      i__2 = *ido;
      for (i__ = 3; i__ <= i__2; i__ += 2)
	{
	  ic = idp2 - i__;
	  ti1 =
	    cc[i__ + ((k << 2) + 1) * cc_dim1] + cc[ic +
						    ((k << 2) + 4) * cc_dim1];
	  ti2 =
	    cc[i__ + ((k << 2) + 1) * cc_dim1] - cc[ic +
						    ((k << 2) + 4) * cc_dim1];
	  ti3 =
	    cc[i__ + ((k << 2) + 3) * cc_dim1] - cc[ic +
						    ((k << 2) + 2) * cc_dim1];
	  tr4 =
	    cc[i__ + ((k << 2) + 3) * cc_dim1] + cc[ic +
						    ((k << 2) + 2) * cc_dim1];
	  tr1 =
	    cc[i__ - 1 + ((k << 2) + 1) * cc_dim1] - cc[ic - 1 +
							((k << 2) +
							 4) * cc_dim1];
	  tr2 =
	    cc[i__ - 1 + ((k << 2) + 1) * cc_dim1] + cc[ic - 1 +
							((k << 2) +
							 4) * cc_dim1];
	  ti4 =
	    cc[i__ - 1 + ((k << 2) + 3) * cc_dim1] - cc[ic - 1 +
							((k << 2) +
							 2) * cc_dim1];
	  tr3 =
	    cc[i__ - 1 + ((k << 2) + 3) * cc_dim1] + cc[ic - 1 +
							((k << 2) +
							 2) * cc_dim1];
	  ch[i__ - 1 + (k + ch_dim2) * ch_dim1] = tr2 + tr3;
	  cr3 = tr2 - tr3;
	  ch[i__ + (k + ch_dim2) * ch_dim1] = ti2 + ti3;
	  ci3 = ti2 - ti3;
	  cr2 = tr1 - tr4;
	  cr4 = tr1 + tr4;
	  ci2 = ti1 + ti4;
	  ci4 = ti1 - ti4;
	  ch[i__ - 1 + (k + (ch_dim2 << 1)) * ch_dim1] =
	    wa1[i__ - 2] * cr2 - wa1[i__ - 1] * ci2;
	  ch[i__ + (k + (ch_dim2 << 1)) * ch_dim1] =
	    wa1[i__ - 2] * ci2 + wa1[i__ - 1] * cr2;
	  ch[i__ - 1 + (k + ch_dim2 * 3) * ch_dim1] =
	    wa2[i__ - 2] * cr3 - wa2[i__ - 1] * ci3;
	  ch[i__ + (k + ch_dim2 * 3) * ch_dim1] =
	    wa2[i__ - 2] * ci3 + wa2[i__ - 1] * cr3;
	  ch[i__ - 1 + (k + (ch_dim2 << 2)) * ch_dim1] =
	    wa3[i__ - 2] * cr4 - wa3[i__ - 1] * ci4;
	  ch[i__ + (k + (ch_dim2 << 2)) * ch_dim1] =
	    wa3[i__ - 2] * ci4 + wa3[i__ - 1] * cr4;
	  /* L103: */
	}
      /* L104: */
    }
  if (*ido % 2 == 1)
    {
      return 0;
    }
 L105:
  i__1 = *l1;
  for (k = 1; k <= i__1; ++k)
    {
      ti1 =
	cc[((k << 2) + 2) * cc_dim1 + 1] + cc[((k << 2) + 4) * cc_dim1 + 1];
      ti2 =
	cc[((k << 2) + 4) * cc_dim1 + 1] - cc[((k << 2) + 2) * cc_dim1 + 1];
      tr1 =
	cc[*ido + ((k << 2) + 1) * cc_dim1] - cc[*ido +
						 ((k << 2) + 3) * cc_dim1];
      tr2 =
	cc[*ido + ((k << 2) + 1) * cc_dim1] + cc[*ido +
						 ((k << 2) + 3) * cc_dim1];
      ch[*ido + (k + ch_dim2) * ch_dim1] = tr2 + tr2;
      ch[*ido + (k + (ch_dim2 << 1)) * ch_dim1] = sqrt2 * (tr1 - ti1);
      ch[*ido + (k + ch_dim2 * 3) * ch_dim1] = ti2 + ti2;
      ch[*ido + (k + (ch_dim2 << 2)) * ch_dim1] = -sqrt2 * (tr1 + ti1);
      /* L106: */
    }
 L107:
  return 0;
}				/* radb4_ */
/* radb5.f -- translated by f2c (version 19961017).
 *   
 *   -lf2c -lm (in that order)
 */

#include "fftpack.h"

/* Subroutine */ int
fftpack_radb5 (int *ido, int *l1, double *cc, double *ch, double *wa1,
	       double *wa2, double *wa3, double *wa4)
{
  /* Initialized data */

  static double tr11 = .3090169943749474241;
  static double ti11 = .95105651629515357212;
  static double tr12 = -.8090169943749474241;
  static double ti12 = .58778525229247312917;

  /* System generated locals */
  int cc_dim1, cc_offset, ch_dim1, ch_dim2, ch_offset, i__1, i__2;

  /* Local variables */
  int i__, k, ic;
  double ci2, ci3, ci4, ci5, di3, di4, di5, di2, cr2, cr3, cr5, cr4, ti2, ti3,
    ti4, ti5, dr3, dr4, dr5, dr2, tr2, tr3, tr4, tr5;
  int idp2;

  /*    *** TR11=COS(2*PI/5), TI11=SIN(2*PI/5) 
   *    *** TR12=COS(4*PI/5), TI12=SIN(4*PI/5) 
   */
  /* Parameter adjustments */
  ch_dim1 = *ido;
  ch_dim2 = *l1;
  ch_offset = ch_dim1 * (ch_dim2 + 1) + 1;
  ch -= ch_offset;
  cc_dim1 = *ido;
  cc_offset = cc_dim1 * 6 + 1;
  cc -= cc_offset;
  --wa1;
  --wa2;
  --wa3;
  --wa4;

  /* Function Body */
  i__1 = *l1;
  for (k = 1; k <= i__1; ++k)
    {
      ti5 = cc[(k * 5 + 3) * cc_dim1 + 1] + cc[(k * 5 + 3) * cc_dim1 + 1];
      ti4 = cc[(k * 5 + 5) * cc_dim1 + 1] + cc[(k * 5 + 5) * cc_dim1 + 1];
      tr2 =
	cc[*ido + (k * 5 + 2) * cc_dim1] + cc[*ido + (k * 5 + 2) * cc_dim1];
      tr3 =
	cc[*ido + (k * 5 + 4) * cc_dim1] + cc[*ido + (k * 5 + 4) * cc_dim1];
      ch[(k + ch_dim2) * ch_dim1 + 1] =
	cc[(k * 5 + 1) * cc_dim1 + 1] + tr2 + tr3;
      cr2 = cc[(k * 5 + 1) * cc_dim1 + 1] + tr11 * tr2 + tr12 * tr3;
      cr3 = cc[(k * 5 + 1) * cc_dim1 + 1] + tr12 * tr2 + tr11 * tr3;
      ci5 = ti11 * ti5 + ti12 * ti4;
      ci4 = ti12 * ti5 - ti11 * ti4;
      ch[(k + (ch_dim2 << 1)) * ch_dim1 + 1] = cr2 - ci5;
      ch[(k + ch_dim2 * 3) * ch_dim1 + 1] = cr3 - ci4;
      ch[(k + (ch_dim2 << 2)) * ch_dim1 + 1] = cr3 + ci4;
      ch[(k + ch_dim2 * 5) * ch_dim1 + 1] = cr2 + ci5;
      /* L101: */
    }
  if (*ido == 1)
    {
      return 0;
    }
  idp2 = *ido + 2;
  i__1 = *l1;
  for (k = 1; k <= i__1; ++k)
    {
      i__2 = *ido;
      for (i__ = 3; i__ <= i__2; i__ += 2)
	{
	  ic = idp2 - i__;
	  ti5 =
	    cc[i__ + (k * 5 + 3) * cc_dim1] + cc[ic + (k * 5 + 2) * cc_dim1];
	  ti2 =
	    cc[i__ + (k * 5 + 3) * cc_dim1] - cc[ic + (k * 5 + 2) * cc_dim1];
	  ti4 =
	    cc[i__ + (k * 5 + 5) * cc_dim1] + cc[ic + (k * 5 + 4) * cc_dim1];
	  ti3 =
	    cc[i__ + (k * 5 + 5) * cc_dim1] - cc[ic + (k * 5 + 4) * cc_dim1];
	  tr5 =
	    cc[i__ - 1 + (k * 5 + 3) * cc_dim1] - cc[ic - 1 +
						     (k * 5 + 2) * cc_dim1];
	  tr2 =
	    cc[i__ - 1 + (k * 5 + 3) * cc_dim1] + cc[ic - 1 +
						     (k * 5 + 2) * cc_dim1];
	  tr4 =
	    cc[i__ - 1 + (k * 5 + 5) * cc_dim1] - cc[ic - 1 +
						     (k * 5 + 4) * cc_dim1];
	  tr3 =
	    cc[i__ - 1 + (k * 5 + 5) * cc_dim1] + cc[ic - 1 +
						     (k * 5 + 4) * cc_dim1];
	  ch[i__ - 1 + (k + ch_dim2) * ch_dim1] =
	    cc[i__ - 1 + (k * 5 + 1) * cc_dim1] + tr2 + tr3;
	  ch[i__ + (k + ch_dim2) * ch_dim1] =
	    cc[i__ + (k * 5 + 1) * cc_dim1] + ti2 + ti3;
	  cr2 = cc[i__ - 1 + (k * 5 + 1) * cc_dim1] + tr11 * tr2 + tr12 * tr3;
	  ci2 = cc[i__ + (k * 5 + 1) * cc_dim1] + tr11 * ti2 + tr12 * ti3;
	  cr3 = cc[i__ - 1 + (k * 5 + 1) * cc_dim1] + tr12 * tr2 + tr11 * tr3;
	  ci3 = cc[i__ + (k * 5 + 1) * cc_dim1] + tr12 * ti2 + tr11 * ti3;
	  cr5 = ti11 * tr5 + ti12 * tr4;
	  ci5 = ti11 * ti5 + ti12 * ti4;
	  cr4 = ti12 * tr5 - ti11 * tr4;
	  ci4 = ti12 * ti5 - ti11 * ti4;
	  dr3 = cr3 - ci4;
	  dr4 = cr3 + ci4;
	  di3 = ci3 + cr4;
	  di4 = ci3 - cr4;
	  dr5 = cr2 + ci5;
	  dr2 = cr2 - ci5;
	  di5 = ci2 - cr5;
	  di2 = ci2 + cr5;
	  ch[i__ - 1 + (k + (ch_dim2 << 1)) * ch_dim1] =
	    wa1[i__ - 2] * dr2 - wa1[i__ - 1] * di2;
	  ch[i__ + (k + (ch_dim2 << 1)) * ch_dim1] =
	    wa1[i__ - 2] * di2 + wa1[i__ - 1] * dr2;
	  ch[i__ - 1 + (k + ch_dim2 * 3) * ch_dim1] =
	    wa2[i__ - 2] * dr3 - wa2[i__ - 1] * di3;
	  ch[i__ + (k + ch_dim2 * 3) * ch_dim1] =
	    wa2[i__ - 2] * di3 + wa2[i__ - 1] * dr3;
	  ch[i__ - 1 + (k + (ch_dim2 << 2)) * ch_dim1] =
	    wa3[i__ - 2] * dr4 - wa3[i__ - 1] * di4;
	  ch[i__ + (k + (ch_dim2 << 2)) * ch_dim1] =
	    wa3[i__ - 2] * di4 + wa3[i__ - 1] * dr4;
	  ch[i__ - 1 + (k + ch_dim2 * 5) * ch_dim1] =
	    wa4[i__ - 2] * dr5 - wa4[i__ - 1] * di5;
	  ch[i__ + (k + ch_dim2 * 5) * ch_dim1] =
	    wa4[i__ - 2] * di5 + wa4[i__ - 1] * dr5;
	  /* L102: */
	}
      /* L103: */
    }
  return 0;
}				/* radb5_ */
/* radbg.f -- translated by f2c (version 19961017).
 *   
 *   -lf2c -lm (in that order)
 */

#include "fftpack.h"

/* Subroutine */ int
fftpack_radbg (int *ido, int *ip, int *l1, int *idl1, double *cc, double *c1,
	       double *c2, double *ch, double *ch2, double *wa)
{
  /* Initialized data */

  static double tpi = 6.28318530717958647692;

  /* System generated locals */
  int ch_dim1, ch_dim2, ch_offset, cc_dim1, cc_dim2, cc_offset, c1_dim1,
    c1_dim2, c1_offset, c2_dim1, c2_offset, ch2_dim1, ch2_offset, i__1, i__2,
    i__3;

  /* Builtin functions */
  double cos (double), sin (double);

  /* Local variables */
  int idij, ipph, i__, j, k, l, j2, ic, jc, lc, ik, is;
  double dc2, ai1, ai2, ar1, ar2, ds2;
  int nbd;
  double dcp, arg, dsp, ar1h, ar2h;
  int idp2, ipp2;

  /* Parameter adjustments */
  ch_dim1 = *ido;
  ch_dim2 = *l1;
  ch_offset = ch_dim1 * (ch_dim2 + 1) + 1;
  ch -= ch_offset;
  c1_dim1 = *ido;
  c1_dim2 = *l1;
  c1_offset = c1_dim1 * (c1_dim2 + 1) + 1;
  c1 -= c1_offset;
  cc_dim1 = *ido;
  cc_dim2 = *ip;
  cc_offset = cc_dim1 * (cc_dim2 + 1) + 1;
  cc -= cc_offset;
  ch2_dim1 = *idl1;
  ch2_offset = ch2_dim1 + 1;
  ch2 -= ch2_offset;
  c2_dim1 = *idl1;
  c2_offset = c2_dim1 + 1;
  c2 -= c2_offset;
  --wa;

  /* Function Body */
  arg = tpi / (double) (*ip);
  dcp = cos (arg);
  dsp = sin (arg);
  idp2 = *ido + 2;
  nbd = (*ido - 1) / 2;
  ipp2 = *ip + 2;
  ipph = (*ip + 1) / 2;
  if (*ido < *l1)
    {
      goto L103;
    }
  i__1 = *l1;
  for (k = 1; k <= i__1; ++k)
    {
      i__2 = *ido;
      for (i__ = 1; i__ <= i__2; ++i__)
	{
	  ch[i__ + (k + ch_dim2) * ch_dim1] =
	    cc[i__ + (k * cc_dim2 + 1) * cc_dim1];
	  /* L101: */
	}
      /* L102: */
    }
  goto L106;
 L103:
  i__1 = *ido;
  for (i__ = 1; i__ <= i__1; ++i__)
    {
      i__2 = *l1;
      for (k = 1; k <= i__2; ++k)
	{
	  ch[i__ + (k + ch_dim2) * ch_dim1] =
	    cc[i__ + (k * cc_dim2 + 1) * cc_dim1];
	  /* L104: */
	}
      /* L105: */
    }
 L106:
  i__1 = ipph;
  for (j = 2; j <= i__1; ++j)
    {
      jc = ipp2 - j;
      j2 = j + j;
      i__2 = *l1;
      for (k = 1; k <= i__2; ++k)
	{
	  ch[(k + j * ch_dim2) * ch_dim1 + 1] =
	    cc[*ido + (j2 - 2 + k * cc_dim2) * cc_dim1] + cc[*ido +
							     (j2 - 2 +
							      k * cc_dim2) *
							     cc_dim1];
	  ch[(k + jc * ch_dim2) * ch_dim1 + 1] =
	    cc[(j2 - 1 + k * cc_dim2) * cc_dim1 + 1] +
	    cc[(j2 - 1 + k * cc_dim2) * cc_dim1 + 1];
	  /* L107: */
	}
      /* L108: */
    }
  if (*ido == 1)
    {
      goto L116;
    }
  if (nbd < *l1)
    {
      goto L112;
    }
  i__1 = ipph;
  for (j = 2; j <= i__1; ++j)
    {
      jc = ipp2 - j;
      i__2 = *l1;
      for (k = 1; k <= i__2; ++k)
	{
	  i__3 = *ido;
	  for (i__ = 3; i__ <= i__3; i__ += 2)
	    {
	      ic = idp2 - i__;
	      ch[i__ - 1 + (k + j * ch_dim2) * ch_dim1] =
		cc[i__ - 1 + ((j << 1) - 1 + k * cc_dim2) * cc_dim1] + cc[ic -
									  1 +
									  ((j
									    <<
									    1)
									   -
									   2 +
									   k *
									   cc_dim2)
									  *
									  cc_dim1];
	      ch[i__ - 1 + (k + jc * ch_dim2) * ch_dim1] =
		cc[i__ - 1 + ((j << 1) - 1 + k * cc_dim2) * cc_dim1] - cc[ic -
									  1 +
									  ((j
									    <<
									    1)
									   -
									   2 +
									   k *
									   cc_dim2)
									  *
									  cc_dim1];
	      ch[i__ + (k + j * ch_dim2) * ch_dim1] =
		cc[i__ + ((j << 1) - 1 + k * cc_dim2) * cc_dim1] - cc[ic +
								      ((j <<
									1) -
								       2 +
								       k *
								       cc_dim2)
								      *
								      cc_dim1];
	      ch[i__ + (k + jc * ch_dim2) * ch_dim1] =
		cc[i__ + ((j << 1) - 1 + k * cc_dim2) * cc_dim1] + cc[ic +
								      ((j <<
									1) -
								       2 +
								       k *
								       cc_dim2)
								      *
								      cc_dim1];
	      /* L109: */
	    }
	  /* L110: */
	}
      /* L111: */
    }
  goto L116;
 L112:
  i__1 = ipph;
  for (j = 2; j <= i__1; ++j)
    {
      jc = ipp2 - j;
      i__2 = *ido;
      for (i__ = 3; i__ <= i__2; i__ += 2)
	{
	  ic = idp2 - i__;
	  i__3 = *l1;
	  for (k = 1; k <= i__3; ++k)
	    {
	      ch[i__ - 1 + (k + j * ch_dim2) * ch_dim1] =
		cc[i__ - 1 + ((j << 1) - 1 + k * cc_dim2) * cc_dim1] + cc[ic -
									  1 +
									  ((j
									    <<
									    1)
									   -
									   2 +
									   k *
									   cc_dim2)
									  *
									  cc_dim1];
	      ch[i__ - 1 + (k + jc * ch_dim2) * ch_dim1] =
		cc[i__ - 1 + ((j << 1) - 1 + k * cc_dim2) * cc_dim1] - cc[ic -
									  1 +
									  ((j
									    <<
									    1)
									   -
									   2 +
									   k *
									   cc_dim2)
									  *
									  cc_dim1];
	      ch[i__ + (k + j * ch_dim2) * ch_dim1] =
		cc[i__ + ((j << 1) - 1 + k * cc_dim2) * cc_dim1] - cc[ic +
								      ((j <<
									1) -
								       2 +
								       k *
								       cc_dim2)
								      *
								      cc_dim1];
	      ch[i__ + (k + jc * ch_dim2) * ch_dim1] =
		cc[i__ + ((j << 1) - 1 + k * cc_dim2) * cc_dim1] + cc[ic +
								      ((j <<
									1) -
								       2 +
								       k *
								       cc_dim2)
								      *
								      cc_dim1];
	      /* L113: */
	    }
	  /* L114: */
	}
      /* L115: */
    }
 L116:
  ar1 = 1.;
  ai1 = 0.;
  i__1 = ipph;
  for (l = 2; l <= i__1; ++l)
    {
      lc = ipp2 - l;
      ar1h = dcp * ar1 - dsp * ai1;
      ai1 = dcp * ai1 + dsp * ar1;
      ar1 = ar1h;
      i__2 = *idl1;
      for (ik = 1; ik <= i__2; ++ik)
	{
	  c2[ik + l * c2_dim1] =
	    ch2[ik + ch2_dim1] + ar1 * ch2[ik + (ch2_dim1 << 1)];
	  c2[ik + lc * c2_dim1] = ai1 * ch2[ik + *ip * ch2_dim1];
	  /* L117: */
	}
      dc2 = ar1;
      ds2 = ai1;
      ar2 = ar1;
      ai2 = ai1;
      i__2 = ipph;
      for (j = 3; j <= i__2; ++j)
	{
	  jc = ipp2 - j;
	  ar2h = dc2 * ar2 - ds2 * ai2;
	  ai2 = dc2 * ai2 + ds2 * ar2;
	  ar2 = ar2h;
	  i__3 = *idl1;
	  for (ik = 1; ik <= i__3; ++ik)
	    {
	      c2[ik + l * c2_dim1] += ar2 * ch2[ik + j * ch2_dim1];
	      c2[ik + lc * c2_dim1] += ai2 * ch2[ik + jc * ch2_dim1];
	      /* L118: */
	    }
	  /* L119: */
	}
      /* L120: */
    }
  i__1 = ipph;
  for (j = 2; j <= i__1; ++j)
    {
      i__2 = *idl1;
      for (ik = 1; ik <= i__2; ++ik)
	{
	  ch2[ik + ch2_dim1] += ch2[ik + j * ch2_dim1];
	  /* L121: */
	}
      /* L122: */
    }
  i__1 = ipph;
  for (j = 2; j <= i__1; ++j)
    {
      jc = ipp2 - j;
      i__2 = *l1;
      for (k = 1; k <= i__2; ++k)
	{
	  ch[(k + j * ch_dim2) * ch_dim1 + 1] =
	    c1[(k + j * c1_dim2) * c1_dim1 + 1] -
	    c1[(k + jc * c1_dim2) * c1_dim1 + 1];
	  ch[(k + jc * ch_dim2) * ch_dim1 + 1] =
	    c1[(k + j * c1_dim2) * c1_dim1 + 1] +
	    c1[(k + jc * c1_dim2) * c1_dim1 + 1];
	  /* L123: */
	}
      /* L124: */
    }
  if (*ido == 1)
    {
      goto L132;
    }
  if (nbd < *l1)
    {
      goto L128;
    }
  i__1 = ipph;
  for (j = 2; j <= i__1; ++j)
    {
      jc = ipp2 - j;
      i__2 = *l1;
      for (k = 1; k <= i__2; ++k)
	{
	  i__3 = *ido;
	  for (i__ = 3; i__ <= i__3; i__ += 2)
	    {
	      ch[i__ - 1 + (k + j * ch_dim2) * ch_dim1] =
		c1[i__ - 1 + (k + j * c1_dim2) * c1_dim1] - c1[i__ +
							       (k +
								jc *
								c1_dim2) *
							       c1_dim1];
	      ch[i__ - 1 + (k + jc * ch_dim2) * ch_dim1] =
		c1[i__ - 1 + (k + j * c1_dim2) * c1_dim1] + c1[i__ +
							       (k +
								jc *
								c1_dim2) *
							       c1_dim1];
	      ch[i__ + (k + j * ch_dim2) * ch_dim1] =
		c1[i__ + (k + j * c1_dim2) * c1_dim1] + c1[i__ - 1 +
							   (k +
							    jc * c1_dim2) *
							   c1_dim1];
	      ch[i__ + (k + jc * ch_dim2) * ch_dim1] =
		c1[i__ + (k + j * c1_dim2) * c1_dim1] - c1[i__ - 1 +
							   (k +
							    jc * c1_dim2) *
							   c1_dim1];
	      /* L125: */
	    }
	  /* L126: */
	}
      /* L127: */
    }
  goto L132;
 L128:
  i__1 = ipph;
  for (j = 2; j <= i__1; ++j)
    {
      jc = ipp2 - j;
      i__2 = *ido;
      for (i__ = 3; i__ <= i__2; i__ += 2)
	{
	  i__3 = *l1;
	  for (k = 1; k <= i__3; ++k)
	    {
	      ch[i__ - 1 + (k + j * ch_dim2) * ch_dim1] =
		c1[i__ - 1 + (k + j * c1_dim2) * c1_dim1] - c1[i__ +
							       (k +
								jc *
								c1_dim2) *
							       c1_dim1];
	      ch[i__ - 1 + (k + jc * ch_dim2) * ch_dim1] =
		c1[i__ - 1 + (k + j * c1_dim2) * c1_dim1] + c1[i__ +
							       (k +
								jc *
								c1_dim2) *
							       c1_dim1];
	      ch[i__ + (k + j * ch_dim2) * ch_dim1] =
		c1[i__ + (k + j * c1_dim2) * c1_dim1] + c1[i__ - 1 +
							   (k +
							    jc * c1_dim2) *
							   c1_dim1];
	      ch[i__ + (k + jc * ch_dim2) * ch_dim1] =
		c1[i__ + (k + j * c1_dim2) * c1_dim1] - c1[i__ - 1 +
							   (k +
							    jc * c1_dim2) *
							   c1_dim1];
	      /* L129: */
	    }
	  /* L130: */
	}
      /* L131: */
    }
 L132:
  if (*ido == 1)
    {
      return 0;
    }
  i__1 = *idl1;
  for (ik = 1; ik <= i__1; ++ik)
    {
      c2[ik + c2_dim1] = ch2[ik + ch2_dim1];
      /* L133: */
    }
  i__1 = *ip;
  for (j = 2; j <= i__1; ++j)
    {
      i__2 = *l1;
      for (k = 1; k <= i__2; ++k)
	{
	  c1[(k + j * c1_dim2) * c1_dim1 + 1] =
	    ch[(k + j * ch_dim2) * ch_dim1 + 1];
	  /* L134: */
	}
      /* L135: */
    }
  if (nbd > *l1)
    {
      goto L139;
    }
  is = -(*ido);
  i__1 = *ip;
  for (j = 2; j <= i__1; ++j)
    {
      is += *ido;
      idij = is;
      i__2 = *ido;
      for (i__ = 3; i__ <= i__2; i__ += 2)
	{
	  idij += 2;
	  i__3 = *l1;
	  for (k = 1; k <= i__3; ++k)
	    {
	      c1[i__ - 1 + (k + j * c1_dim2) * c1_dim1] =
		wa[idij - 1] * ch[i__ - 1 + (k + j * ch_dim2) * ch_dim1] -
		wa[idij] * ch[i__ + (k + j * ch_dim2) * ch_dim1];
	      c1[i__ + (k + j * c1_dim2) * c1_dim1] =
		wa[idij - 1] * ch[i__ + (k + j * ch_dim2) * ch_dim1] +
		wa[idij] * ch[i__ - 1 + (k + j * ch_dim2) * ch_dim1];
	      /* L136: */
	    }
	  /* L137: */
	}
      /* L138: */
    }
  goto L143;
 L139:
  is = -(*ido);
  i__1 = *ip;
  for (j = 2; j <= i__1; ++j)
    {
      is += *ido;
      i__2 = *l1;
      for (k = 1; k <= i__2; ++k)
	{
	  idij = is;
	  i__3 = *ido;
	  for (i__ = 3; i__ <= i__3; i__ += 2)
	    {
	      idij += 2;
	      c1[i__ - 1 + (k + j * c1_dim2) * c1_dim1] =
		wa[idij - 1] * ch[i__ - 1 + (k + j * ch_dim2) * ch_dim1] -
		wa[idij] * ch[i__ + (k + j * ch_dim2) * ch_dim1];
	      c1[i__ + (k + j * c1_dim2) * c1_dim1] =
		wa[idij - 1] * ch[i__ + (k + j * ch_dim2) * ch_dim1] +
		wa[idij] * ch[i__ - 1 + (k + j * ch_dim2) * ch_dim1];
	      /* L140: */
	    }
	  /* L141: */
	}
      /* L142: */
    }
 L143:
  return 0;
}				/* radbg_ */
