// Coselica Toolbox for Scicoslab
// Copyright (C) 2009-2011  Dirk Reusch, Kybernetik Dr. Reusch
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

function [x,y,typ]=MBM_Gain(job,arg1,arg2)
  
  
  function blk_draw(sz,orig,orient,label)
    blue=xget('color','blue');
    white=xget('color','white');
    black=xget('color','black');
    gray=xget('color','gray');
    red = xget('color','red');

    if orient then
      xx=orig(1);yy=orig(2);
      ww=sz(1);hh=sz(2);
    else
      xx=orig(1)+sz(1);yy=orig(2);
      ww=-sz(1);hh=sz(2);
    end
    xfpoly(xx+ww*[0;0;1;0],yy+hh*[0;1;0.5;0],color=blue,fill_color=white);
    if %t then
      // draw the gain inside the icon 
      w=sz(1)*(4/5);
      hf=(1/3);
      if length(arg1.graphics.exprs(1))>6 then
	gain=part(arg1.graphics.exprs(1),1:4)+'..'
      else
	gain=arg1.graphics.exprs(1);
      end
      xstringb(orig(1),orig(2)+sz(2)*(1-hf)/2,gain,w,hf*sz(2),'fill');
    else
      if orient then
	xstringb(orig(1)+sz(1)*-0.25,orig(2)+sz(2)*-0.2,"k="+string(k),sz(1)*1.5,sz(2)*0.2,"fill");
      else
	xstringb(orig(1)+sz(1)*(1--0.25-1.5),orig(2)+sz(2)*-0.2,"k="+string(k),sz(1)*1.5,sz(2)*0.2,"fill");
      end
    end
    // draw a label above the icon

    if orient then
      xstringb(orig(1)+sz(1)*-0.25,orig(2)+sz(2)*1,label,sz(1)*1.5,sz(2)*0.2,"fill");
    else
      xstringb(orig(1)+sz(1)*(1--0.25-1.5),orig(2)+sz(2)*1,label,sz(1)*1.5,sz(2)*0.2,"fill");
    end
  endfunction
  
  x=[];y=[];typ=[];
  select job
   case 'plot' then
    k=arg1.graphics.exprs(1);
    standard_draw(arg1,%f,_MBI_SISO_dp);
   case 'getinputs' then
    [x,y,typ]=_MBI_SISO_ip(arg1);
   case 'getoutputs' then
    [x,y,typ]=_MBI_SISO_op(arg1);
   case 'getorigin' then
    [x,y]=standard_origin(arg1);
   case 'set' then
    x=arg1;
    graphics=arg1.graphics;exprs=graphics.exprs;
    model=arg1.model;
    while %t do
      [ok,k,exprs]=...
	  getvalue(['';'MBM_Gain';'';'Output the product of a gain value with the input signal';''],...
		   [' k [-] : Gain value multiplied with input signal'],...
		   list('vec',1),exprs);
      if ~ok then break, end
      model.equations.parameters(2)=list(k)
      graphics.exprs=exprs;
      x.graphics=graphics;x.model=model;
      break
    end
   case 'define' then
    model=scicos_model();
    k=1;
    model.sim='Coselica';
    model.blocktype='c';
    model.dep_ut=[%t %f];
    mo=modelica();
    mo.model='Modelica.Blocks.Math.Gain';
    mo.inputs=['u'];
    mo.outputs=['y'];
    mo.parameters=list(['k'],...
		       list(k),...
		       [0]);
    model.equations=mo;
    model.in=ones(size(mo.inputs,'*'),1);
    model.out=ones(size(mo.outputs,'*'),1);
    exprs=[sci2exp(k)];

    gr_i="blk_draw(sz,orig,orient,model.label)";
    x=standard_define([2 2],model,exprs,list(gr_i,0));
    x.graphics.in_implicit=['E'];
    x.graphics.out_implicit=['E'];
  end
endfunction
