// Coselica Toolbox for Scicoslab
// Copyright (C) 2009-2011  Dirk Reusch, Kybernetik Dr. Reusch
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

function [x,y,typ]=MBM_Tan(job,arg1,arg2)
  
  
  function blk_draw(sz,orig,orient,label)
    blue=xget('color','blue');
    white=xget('color','white');
    black=xget('color','black');
    gray=xget('color','gray');
    red = xget('color','red');

    if orient then
      xx=orig(1);yy=orig(2);
      ww=sz(1);hh=sz(2);
    else
      xx=orig(1)+sz(1);yy=orig(2);
      ww=-sz(1);hh=sz(2);
    end
    if orient then
      xrect(orig(1)+sz(1)*0,orig(2)+sz(2)*1,sz(1)*1,sz(2)*1,color=blue,background=white);
    else
      xrect(orig(1)+sz(1)*(1-0-1),orig(2)+sz(2)*1,sz(1)*1,sz(2)*1,color=blue,background=white);
    end
    
    if orient then
      xstringb(orig(1)+sz(1)*-0.25,orig(2)+sz(2)*1.05,label,sz(1)*1.5,sz(2)*0.2,"fill");
    else
      xstringb(orig(1)+sz(1)*(1--0.25-1.5),orig(2)+sz(2)*1.05,label,sz(1)*1.5,sz(2)*0.2,"fill");
    end
    
    xfpoly(xx+ww*[0.5;0.46;0.54;0.5],yy+hh*[0.95;0.84;0.84;0.95],color=gray,fill_color=gray);
    xpoly(xx+ww*[0.5;0.5],yy+hh*[0.1;0.84],color=gray);
    xpoly(xx+ww*[0.1;0.108;0.116;0.128;0.144;0.1645;0.1965;0.2445;0.321;0.4779;0.667;0.747;0.7955;0.8275;0.852;0.868;0.88;0.888;0.9],yy+hh*[0.1;0.158;0.2015;0.25;0.2955;0.335;0.376;0.414;0.4501;0.49465;0.5456;0.581;0.616;0.653;0.6955;0.737;0.7805;0.819;0.9],color=black);
    xpoly(xx+ww*[0.05;0.84],yy+hh*[0.5;0.5],color=gray);
    xfpoly(xx+ww*[0.95;0.84;0.84;0.95],yy+hh*[0.5;0.54;0.46;0.5],color=gray,fill_color=gray);
    if orient then
      xstringb(orig(1)+sz(1)*0.05,orig(2)+sz(2)*0.62,"tan",sz(1)*0.36,sz(2)*0.24,"fill");
    else
      xstringb(orig(1)+sz(1)*(1-0.05-0.36),orig(2)+sz(2)*0.62,"tan",sz(1)*0.36,sz(2)*0.24,"fill");
    end
    
  endfunction
  x=[];y=[];typ=[];
  select job
   case 'plot' then
    standard_draw(arg1,%f,_MBI_SISO_dp);
   case 'getinputs' then
    [x,y,typ]=_MBI_SISO_ip(arg1);
   case 'getoutputs' then
    [x,y,typ]=_MBI_SISO_op(arg1);
   case 'getorigin' then
    [x,y]=standard_origin(arg1);
   case 'set' then
    x=arg1;
   case 'define' then
    model=scicos_model();
    model.sim='Coselica';
    model.blocktype='c';
    model.dep_ut=[%t %f];
    mo=modelica();
    mo.model='Modelica.Blocks.Math.Tan';
    mo.inputs=['u'];
    mo.outputs=['y'];
    mo.parameters=list([],list(),[]);
    model.equations=mo;
    model.in=ones(size(mo.inputs,'*'),1);
    model.out=ones(size(mo.outputs,'*'),1);
    exprs=[];

    gr_i="blk_draw(sz,orig,orient,model.label)";
    x=standard_define([2 2],model,exprs,list(gr_i,0));
    x.graphics.in_implicit=['E'];
    x.graphics.out_implicit=['E'];
  end
endfunction
