// Coselica Toolbox for Scicoslab
// Copyright (C) 2009-2011  Dirk Reusch, Kybernetik Dr. Reusch
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

function [x,y,typ]=MBN_DeadZone(job,arg1,arg2)
  
  function blk_draw(sz,orig,orient,label)
    blue=xget('color','blue');
    white=xget('color','white');
    black=xget('color','black');
    gray=xget('color','gray');
    red = xget('color','red');

    if orient then
      xx=orig(1);yy=orig(2);
      ww=sz(1);hh=sz(2);
    else
      xx=orig(1)+sz(1);yy=orig(2);
      ww=-sz(1);hh=sz(2);
    end
    if orient then
      xrect(orig(1)+sz(1)*0,orig(2)+sz(2)*1,sz(1)*1,sz(2)*1,color=blue,background=white);
    else
      xrect(orig(1)+sz(1)*(1-0-1),orig(2)+sz(2)*1,sz(1)*1,sz(2)*1,color=blue,background=white);
    end
    
    if orient then
      xstringb(orig(1)+sz(1)*-0.25,orig(2)+sz(2)*1.05,label,sz(1)*1.5,sz(2)*0.2,"fill");
    else
      xstringb(orig(1)+sz(1)*(1--0.25-1.5),orig(2)+sz(2)*1.05,label,sz(1)*1.5,sz(2)*0.2,"fill");
    end
    xpoly(xx+ww*[0.5;0.5],yy+hh*[0.05;0.84],color=gray);
    xfpoly(xx+ww*[0.5;0.46;0.54;0.5],yy+hh*[0.95;0.84;0.84;0.95],color=gray,fill_color=gray);
    xpoly(xx+ww*[0.05;0.84],yy+hh*[0.5;0.5],color=gray);
    xfpoly(xx+ww*[0.95;0.84;0.84;0.95],yy+hh*[0.5;0.46;0.54;0.5],color=gray,fill_color=gray);
    xpoly(xx+ww*[0.1;0.4;0.6;0.9],yy+hh*[0.2;0.5;0.5;0.8],color=black);
    if orient then
      xstringb(orig(1)+sz(1)*-0.25,orig(2)+sz(2)*-0.25,"uMax="+string(uMax),sz(1)*1.5,sz(2)*0.2,"fill");
    else
      xstringb(orig(1)+sz(1)*(1--0.25-1.5),orig(2)+sz(2)*-0.25,"uMax="+string(uMax),sz(1)*1.5,sz(2)*0.2,"fill");
    end
    if orient then
      xstringb(orig(1)+sz(1)*-0.25,orig(2)+sz(2)*1.05,label,sz(1)*1.5,sz(2)*0.2,"fill");
    else
      xstringb(orig(1)+sz(1)*(1--0.25-1.5),orig(2)+sz(2)*1.05,label,sz(1)*1.5,sz(2)*0.2,"fill");
    end
    
  endfunction
  x=[];y=[];typ=[];
  select job
   case 'plot' then
    uMax=arg1.graphics.exprs(1);
    uMin=arg1.graphics.exprs(2);
    standard_draw(arg1,%f,_MBI_SISO_dp);
   case 'getinputs' then
    [x,y,typ]=_MBI_SISO_ip(arg1);
   case 'getoutputs' then
    [x,y,typ]=_MBI_SISO_op(arg1);
   case 'getorigin' then
    [x,y]=standard_origin(arg1);
   case 'set' then
    x=arg1;
    graphics=arg1.graphics;exprs=graphics.exprs;
    model=arg1.model;
    while %t do
      [ok,uMax,uMin,exprs]=...
	  getvalue(['';'MBN_DeadZone';'';'Provide a region of zero output';''],...
		   [' uMax [-] : Upper limits of dead zones',' uMin [-] : Lower limits of dead zones'],...
		   list('vec',1,'vec',1),exprs);
      if ~ok then break, end
      model.equations.parameters(2)=list(uMax,uMin)
      graphics.exprs=exprs;
      x.graphics=graphics;x.model=model;
      break
    end
   case 'define' then
    model=scicos_model();
    uMax=1;
    uMin=-1;
    model.sim='Coselica';
    model.blocktype='c';
    model.dep_ut=[%t %f];
    mo=modelica();
    mo.model='Modelica.Blocks.Nonlinear.DeadZone';
    mo.inputs=['u'];
    mo.outputs=['y'];
    mo.parameters=list(['uMax','uMin'],...
		       list(uMax,uMin),...
		       [0,0]);
    model.equations=mo;
    model.in=ones(size(mo.inputs,'*'),1);
    model.out=ones(size(mo.outputs,'*'),1);
    exprs=[sci2exp(uMax);sci2exp(uMin)];

    gr_i="blk_draw(sz,orig,orient,model.label)";
    x=standard_define([2 2],model,exprs,list(gr_i,0));
    x.graphics.in_implicit=['E'];
    x.graphics.out_implicit=['E'];
  end
endfunction
