// Coselica Toolbox for Scicoslab
// Copyright (C) 2009-2011  Dirk Reusch, Kybernetik Dr. Reusch
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

function [x,y,typ]=MEAI_IdealTransformer(job,arg1,arg2)
  function blk_draw(sz,orig,orient,label)
    
    blue=xget('color','blue');
    white=xget('color','white');
    black=xget('color','black');
    gray=xget('color','gray');
    if orient then
      xx=orig(1);yy=orig(2);
      ww=sz(1);hh=sz(2);
    else
      xx=orig(1)+sz(1);yy=orig(2);
      ww=-sz(1);hh=sz(2);
    end
    
    if orient then
      xstringb(orig(1)+sz(1)*-0.21,orig(2)+sz(2)*0.7,label,sz(1)*1.41,sz(2)*0.3,"fill");
    else
      xstringb(orig(1)+sz(1)*(1--0.21-1.41),orig(2)+sz(2)*0.7,label,sz(1)*1.41,sz(2)*0.3,"fill");
    end
    if orient then
      xarc(orig(1)+sz(1)*0.275,orig(2)+sz(2)*0.375,sz(1)*0.125,sz(2)*0.125,-90*64,180*64,color=blue);
      xarc(orig(1)+sz(1)*0.275,orig(2)+sz(2)*0.5,sz(1)*0.125,sz(2)*0.125,-90*64,180*64,color=blue);
      xarc(orig(1)+sz(1)*0.275,orig(2)+sz(2)*0.625,sz(1)*0.125,sz(2)*0.125,-90*64,180*64,color=blue);
      xarc(orig(1)+sz(1)*0.275,orig(2)+sz(2)*0.75,sz(1)*0.125,sz(2)*0.125,-90*64,180*64,color=blue);
    else
      xarc(orig(1)+sz(1)*(1-0.275-0.125),orig(2)+sz(2)*0.375,sz(1)*0.125,sz(2)*0.125,90*64,180*64,color=blue);
      xarc(orig(1)+sz(1)*(1-0.275-0.125),orig(2)+sz(2)*0.5,sz(1)*0.125,sz(2)*0.125,90*64,180*64,color=blue);
      xarc(orig(1)+sz(1)*(1-0.275-0.125),orig(2)+sz(2)*0.625,sz(1)*0.125,sz(2)*0.125,90*64,180*64,color=blue);
      xarc(orig(1)+sz(1)*(1-0.275-0.125),orig(2)+sz(2)*0.75,sz(1)*0.125,sz(2)*0.125,90*64,180*64,color=blue);
    end
    xpoly(xx+ww*[0.05;0.34],yy+hh*[0.75;0.75],color=blue);
    xpoly(xx+ww*[0.05;0.34],yy+hh*[0.25;0.25],color=blue);
    if orient then
      xarc(orig(1)+sz(1)*0.6,orig(2)+sz(2)*0.375,sz(1)*0.125,sz(2)*0.125,90*64,180*64,color=blue);
      xarc(orig(1)+sz(1)*0.6,orig(2)+sz(2)*0.5,sz(1)*0.125,sz(2)*0.125,90*64,180*64,color=blue);
      xarc(orig(1)+sz(1)*0.6,orig(2)+sz(2)*0.625,sz(1)*0.125,sz(2)*0.125,90*64,180*64,color=blue);
      xarc(orig(1)+sz(1)*0.6,orig(2)+sz(2)*0.75,sz(1)*0.125,sz(2)*0.125,90*64,180*64,color=blue);
    else
      xarc(orig(1)+sz(1)*(1-0.6-0.125),orig(2)+sz(2)*0.375,sz(1)*0.125,sz(2)*0.125,-90*64,180*64,color=blue);
      xarc(orig(1)+sz(1)*(1-0.6-0.125),orig(2)+sz(2)*0.5,sz(1)*0.125,sz(2)*0.125,-90*64,180*64,color=blue);
      xarc(orig(1)+sz(1)*(1-0.6-0.125),orig(2)+sz(2)*0.625,sz(1)*0.125,sz(2)*0.125,-90*64,180*64,color=blue);
      xarc(orig(1)+sz(1)*(1-0.6-0.125),orig(2)+sz(2)*0.75,sz(1)*0.125,sz(2)*0.125,-90*64,180*64,color=blue);
    end
    xpoly(xx+ww*[0.66;0.95],yy+hh*[0.75;0.75],color=blue);
    xpoly(xx+ww*[0.66;0.95],yy+hh*[0.25;0.25],color=blue);

    if orient then
      xstringb(orig(1)+sz(1)*-0.18,orig(2)+sz(2)*0,"n="+string(n),sz(1)*1.36,sz(2)*0.2,"fill");
    else
      xstringb(orig(1)+sz(1)*(1--0.18-1.36),orig(2)+sz(2)*0,"n="+string(n),sz(1)*1.36,sz(2)*0.2,"fill");
    end
  endfunction

  
  x=[];y=[];typ=[];
  select job
   case 'plot' then
    n=arg1.graphics.exprs(1);
    standard_draw(arg1,%f,_MEAI_TwoPort_dp);
   case 'getinputs' then
    [x,y,typ]=_MEAI_TwoPort_ip(arg1);
   case 'getoutputs' then
    [x,y,typ]=_MEAI_TwoPort_op(arg1);
   case 'getorigin' then
    [x,y]=standard_origin(arg1);
   case 'set' then
    x=arg1;
    graphics=arg1.graphics;exprs=graphics.exprs;
    model=arg1.model;
    while %t do
      [ok,n,exprs]=...
	  getvalue(['';'MEAI_IdealTransformer';'';'Ideal electrical transformer';''],...
		   [' n [-] : Turns ratio'],...
		   list('vec',1),exprs);
      if ~ok then break, end
      model.equations.parameters(2)=list(n)
      graphics.exprs=exprs;
      x.graphics=graphics;x.model=model;
      break
    end
   case 'define' then
    model=scicos_model();
    n=1;
    model.sim='Coselica';
    model.blocktype='c';
    model.dep_ut=[%t %f];
    mo=modelica();
    mo.model='Modelica.Electrical.Analog.Ideal.IdealTransformer';
    mo.inputs=['p1','n1'];
    mo.outputs=['p2','n2'];
    mo.parameters=list(['n'],...
		       list(n),...
		       [0]);
    model.equations=mo;
    model.in=ones(size(mo.inputs,'*'),1);
    model.out=ones(size(mo.outputs,'*'),1);
    exprs=[sci2exp(n)];
    gr_i="blk_draw(sz,orig,orient,model.label)";
    x=standard_define([2 2],model,exprs,list(gr_i,0));
    x.graphics.in_implicit=['I','I'];
    x.graphics.out_implicit=['I','I'];
  end
endfunction
