// Coselica Toolbox for Scicoslab
// Copyright (C) 2009-2011  Dirk Reusch, Kybernetik Dr. Reusch
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

function [x,y,typ]=CMPP_PointMass(job,arg1,arg2)
  function blk_draw(sz,orig,orient,label)
    blue=xget('color','blue');
    white=xget('color','white');
    black=xget('color','black');
    gray=xget('color','gray');
    if orient then
      xx=orig(1);yy=orig(2);
      ww=sz(1);hh=sz(2);
    else
      xx=orig(1)+sz(1);yy=orig(2);
      ww=-sz(1);hh=sz(2);
    end
    if orient then
      xstringb(orig(1)+sz(1)*-0.145,orig(2)+sz(2)*-0.01,"m="+string(m),sz(1)*1.305,sz(2)*0.23,"fill");
    else
      xstringb(orig(1)+sz(1)*(1--0.145-1.305),orig(2)+sz(2)*-0.01,"m="+string(m),sz(1)*1.305,sz(2)*0.23,"fill");
    end
    if orient then
      xstringb(orig(1)+sz(1)*-0.14,orig(2)+sz(2)*0.775,label,sz(1)*1.3,sz(2)*0.275,"fill");
    else
      xstringb(orig(1)+sz(1)*(1--0.14-1.3),orig(2)+sz(2)*0.775,label, ...
	       sz(1)*1.3,sz(2)*0.275,"fill");
    end
    if orient then
      xarc(orig(1)+sz(1)*0.25,orig(2)+sz(2)*0.75,sz(1)*0.5,sz(2)*0.5,0,360*64,color=black,background=12);
    else
      xarc(orig(1)+sz(1)*(1-0.25-0.5),orig(2)+sz(2)*0.75,sz(1)*0.5,sz(2)*0.5,0,360*64,color=black,background=12);
    end
    //fill_color=color(0,127,255);
  endfunction

  
  x=[];y=[];typ=[];
  select job
   case 'plot' then
    m=arg1.graphics.exprs(1);
    standard_draw(arg1,%f,_CMPP_PointMass_dp);
   case 'getinputs' then
    [x,y,typ]=_CMPP_PointMass_ip(arg1);
   case 'getoutputs' then
    [x,y,typ]=_CMPP_PointMass_op(arg1);
   case 'getorigin' then
    [x,y]=standard_origin(arg1);
   case 'set' then
    x=arg1;
    graphics=arg1.graphics;exprs=graphics.exprs;
    model=arg1.model;
    while %t do
      [ok,m,exprs]=...
	  getvalue(['';'CMPP_PointMass';'';'Rigid body where body rotation and inertia is neglected (no states)';''],...
		   [' m [kg] : Mass of mass point (m > 0)'],...
		   list('vec',1),exprs);
      if ~ok then break, end
      model.equations.parameters(2)=list(m)
      graphics.exprs=exprs;
      x.graphics=graphics;x.model=model;
      break
    end
   case 'define' then
    model=scicos_model();
    m=1;
    model.sim='Coselica';
    model.blocktype='c';
    model.dep_ut=[%t %f];
    mo=modelica();
    mo.model='Coselica.Mechanics.Planar.Parts.PointMass';
    mo.inputs=['frame_a'];
    mo.outputs=[];
    mo.parameters=list(['m'],...
		       list(m),...
		       [0]);
    model.equations=mo;
    model.in=ones(size(mo.inputs,'*'),1);
    model.out=ones(size(mo.outputs,'*'),1);
    exprs=[sci2exp(m)];
    gr_i="blk_draw(sz,orig,orient,model.label)";
    x=standard_define([2 2],model,exprs,list(gr_i,0));
    x.graphics.in_implicit=['I'];
    x.graphics.out_implicit=[];
  end
endfunction
