// Coselica Toolbox for Scicoslab
// Copyright (C) 2009-2011  Dirk Reusch, Kybernetik Dr. Reusch
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

function [x,y,typ]=CMPS_RelVelocity2(job,arg1,arg2)
  function blk_draw(sz,orig,orient,label)
    blue=xget('color','blue');
    white=xget('color','white');
    black=xget('color','black');
    gray=xget('color','gray');

    
    if orient then
      xx=orig(1);yy=orig(2);
      ww=sz(1);hh=sz(2);
    else
      xx=orig(1)+sz(1);yy=orig(2);
      ww=-sz(1);hh=sz(2);
    end
    if orient then
      xrect(orig(1)+sz(1)*0.15,orig(2)+sz(2)*0.6,sz(1)*0.7,sz(2)*0.4,color=black,background=white);
    else
      xrect(orig(1)+sz(1)*(1-0.15-0.7),orig(2)+sz(2)*0.6,sz(1)*0.7,sz(2)*0.4,color=black,background=white);
    end
    xfpoly(xx+ww*[0.5;0.45;0.55;0.5],yy+hh*[0.3;0.42;0.42;0.3],color=black,fill_color=black);
    
    xpoly(xx+ww*[0.5;0.5],yy+hh*[0.5;0.42],color=black);
    xpoly(xx+ww*[0.15;0.5],yy+hh*[0.5;0.5],color=black);
    xpoly(xx+ww*[0.25;0.25],yy+hh*[0.3;0.2],color=black);
    xpoly(xx+ww*[0.35;0.35],yy+hh*[0.3;0.2],color=black);
    xpoly(xx+ww*[0.45;0.45],yy+hh*[0.3;0.2],color=black);
    xpoly(xx+ww*[0.55;0.55],yy+hh*[0.3;0.2],color=black);
    xpoly(xx+ww*[0.65;0.65],yy+hh*[0.3;0.2],color=black);
    xpoly(xx+ww*[0.75;0.75],yy+hh*[0.3;0.2],color=black);
    if orient then
      xstringb(orig(1)+sz(1)*0.6,orig(2)+sz(2)*0,"v_rel",sz(1)*0.7,sz(2)*0.15,"fill");
    else
      xstringb(orig(1)+sz(1)*(1-0.6-0.7),orig(2)+sz(2)*0,"v_rel",sz(1)*0.7,sz(2)*0.15,"fill");
    end
    xpoly(xx+ww*[0.5;0.5],yy+hh*[0.2;0],color=black);
    xpoly(xx+ww*[0.15;-0.005],yy+hh*[0.5;0.5],color=black);
    xpoly(xx+ww*[0.85;1],yy+hh*[0.5;0.5],color=black);
    xpoly(xx+ww*[0.2;0.2;0.49;0.49],yy+hh*[0.02;0.12;0.12;0.12],color=12);
    if orient then
      xstringb(orig(1)+sz(1)*-0.285,orig(2)+sz(2)*0.04,"resolve",sz(1)*0.655,sz(2)*0.125,"fill");
    else
      xstringb(orig(1)+sz(1)*(1--0.285-0.655),orig(2)+sz(2)*0.04,"resolve",sz(1)*0.655,sz(2)*0.125,"fill");
    end
    if orient then
      xstringb(orig(1)+sz(1)*-0.14,orig(2)+sz(2)*0.65,label,sz(1)*1.305,sz(2)*0.24,"fill");
    else
      xstringb(orig(1)+sz(1)*(1--0.14-1.305),orig(2)+sz(2)*0.65,label,sz(1)*1.305,sz(2)*0.24,"fill");
    end
  endfunction

  
  x=[];y=[];typ=[];
  select job
   case 'plot' then
    standard_draw(arg1,%f,_CMPS_RelPosition2_dp);
   case 'getinputs' then
    [x,y,typ]=_CMPS_RelPosition2_ip(arg1);
   case 'getoutputs' then
    [x,y,typ]=_CMPS_RelPosition2_op(arg1);
   case 'getorigin' then
    [x,y]=standard_origin(arg1);
   case 'set' then
    x=arg1;
   case 'define' then
    model=scicos_model();
    model.sim='Coselica';
    model.blocktype='c';
    model.dep_ut=[%t %f];
    mo=modelica();
    mo.model='Coselica.Mechanics.Planar.Sensors.RelVelocity2';
    mo.inputs=['frame_a','frame_resolve'];
    mo.outputs=['frame_b','y'];
    mo.parameters=list([],list(),[]);
    model.equations=mo;
    model.in=ones(size(mo.inputs,'*'),1);
    model.out=ones(size(mo.outputs,'*'),1);
    exprs=[];
    gr_i="blk_draw(sz,orig,orient,model.label)";
    x=standard_define([2 2],model,exprs,list(gr_i,0));
    x.graphics.in_implicit=['I','I'];
    x.graphics.out_implicit=['I','E'];
  end
endfunction
