// Coselica Toolbox for Scicoslab
// Copyright (C) 2009  Dirk Reusch, Kybernetik Dr. Reusch
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

function [] = _CMPJ_ActuatedPrismat_dp( o )
  
  xf = 40;
  yf = 40;
  
  [orig,sz,orient]=(o.graphics.orig,o.graphics.sz,o.graphics.flip)

  // set port shape (planar mechanical frame)
  inout = 0.6*[ -1  -1
		1  -1
		1   1
                -1   1 ] * diag( [ xf/20, yf/7 ] );
  
  // set port shape (translational mechanical flange)
  inout2 = 0.5*[ -1  -1
                 1  -1
                 1   1
		 -1   1 ] * diag( [ xf/10, yf/10 ] );
  
  blue=xget('color','blue');
  white=xget('color','white');
  black=xget('color','black');
  gray=xget('color','gray');
  red=xget('color','red');
  green=xget('color','green');
  
  if orient then
    // input frame_a (left)
    xfpoly(inout(:,1)+ones(4,1)*(orig(1)-xf/30),..
           inout(:,2)+ones(4,1)*(orig(2)+sz(2)/2),color=black,fill_color=gray);
    

    // output frame_b (right)
    xpoly(inout(:,1)+ones(4,1)*(orig(1)+sz(1)+xf/30),..
          inout(:,2)+ones(4,1)*(orig(2)+sz(2)/2),color=black,close=%t);  
    // input bearing (left)
    xpoly(inout2(:,1)+ones(4,1)*(orig(1)+xf/4),..
          inout2(:,2)+ones(4,1)*(orig(2)+sz(2)-yf/5),color=green,close=%t);

    // output axis (right)
    xfpoly(inout2(:,1)+ones(4,1)*(orig(1)+sz(1)-xf/10),..
	   inout2(:,2)+ones(4,1)*(orig(2)+sz(2)-yf/5),color=red,fill_color=red);      
  else
    // input frame_a (right)
    xfpoly(inout(:,1)+ones(4,1)*(orig(1)+sz(1)+xf/30),..
           inout(:,2)+ones(4,1)*(orig(2)+sz(2)/2),color=black,fill_color=gray);

    // output frame_b (left)
    xpoly(inout(:,1)+ones(4,1)*(orig(1)-xf/30),..
          inout(:,2)+ones(4,1)*(orig(2)+sz(2)/2),color=black,close=%t);
    // input bearing (right)
    xpoly(inout2(:,1)+ones(4,1)*(orig(1)+sz(1)-xf/4),..
          inout2(:,2)+ones(4,1)*(orig(2)+sz(2)-yf/5),color=green,close=%t);

    // output axis (left)
    xfpoly(inout2(:,1)+ones(4,1)*(orig(1)+xf/10),..
	   inout2(:,2)+ones(4,1)*(orig(2)+sz(2)-yf/5),color=red,fill_color=red);      
  end
  
endfunction

