// Coselica Toolbox for Scicoslab
// Copyright (C) 2009  Dirk Reusch, Kybernetik Dr. Reusch
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

function [] = _CMPJ_ActuatedRevolut_dp( o )
  
  xf = 40;
  yf = 40;
  
  [orig,sz,orient]=(o.graphics.orig,o.graphics.sz,o.graphics.flip)

  // set port shape
  inout = 0.6*[ -1  -1
		1  -1
		1   1
                -1   1 ] * diag( [ xf/20, yf/7 ] );
  
  blue=xget('color','blue');
  white=xget('color','white');
  black=xget('color','black');
  gray=xget('color','gray');
  red=xget('color','red');
  green=xget('color','green');
  if orient then
    // input frame_a (left)
    xfpoly(inout(:,1)+ones(4,1)*(orig(1)-xf/30),..
           inout(:,2)+ones(4,1)*(orig(2)+sz(2)/2),color=black,fill_color=gray);
    

    // output frame_b (right)
    xpoly(inout(:,1)+ones(4,1)*(orig(1)+sz(1)+xf/30),..
          inout(:,2)+ones(4,1)*(orig(2)+sz(2)/2),color=black,close=%t);      
    // input bearing (left)
    xarc( orig(1)+xf/7, orig(2)+sz(2)+yf/20, xf/10, yf/10, 0, 360*64,color=black );
  else
    // input frame_a (right)
    xfpoly(inout(:,1)+ones(4,1)*(orig(1)+sz(1)+xf/30),..
           inout(:,2)+ones(4,1)*(orig(2)+sz(2)/2),color=black,fill_color=gray);
    
    // output frame_b (left)
    xpoly(inout(:,1)+ones(4,1)*(orig(1)-xf/30),..
          inout(:,2)+ones(4,1)*(orig(2)+sz(2)/2),color=black,close=%t);

    // input bearing (right)
    xarc( orig(1)+sz(1)-xf/4, orig(2)+sz(2)+yf/20, xf/10, yf/10, 0, 360*64,color=black );
  end

  // output axis (top center)
  xfarc( orig(1)+sz(1)/2-xf/20, orig(2)+sz(2)+yf/20, xf/10, yf/10, 0, 360*64,color=black,background=gray );
endfunction

