// Coselica Toolbox for Scicoslab
// Copyright (C) 2009-2011  Dirk Reusch, Kybernetik Dr. Reusch
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

function [x,y,typ]=MMT_Fixed(job,arg1,arg2)
  function blk_draw(sz,orig,orient,label)
    blue=xget('color','blue');
    white=xget('color','white');
    black=xget('color','black');
    gray=xget('color','gray');

    
    if orient then
      xx=orig(1);yy=orig(2);
      ww=sz(1);hh=sz(2);
    else
      xx=orig(1)+sz(1);yy=orig(2);
      ww=-sz(1);hh=sz(2);
    end
    xpoly(xx+ww*[0.1;0.9],yy+hh*[0.3;0.3],color=black);
    xpoly(xx+ww*[0.9;0.7],yy+hh*[0.3;0.1],color=black);
    xpoly(xx+ww*[0.7;0.5],yy+hh*[0.3;0.1],color=black);
    xpoly(xx+ww*[0.5;0.3],yy+hh*[0.3;0.1],color=black);
    xpoly(xx+ww*[0.3;0.1],yy+hh*[0.3;0.1],color=black);
    xpoly(xx+ww*[0.5;0.5],yy+hh*[0.3;0.45],color=black);
    if orient then
      xstringb(orig(1)+sz(1)*0,orig(2)+sz(2)*-0.25,label,sz(1)*1,sz(2)*0.3,"fill");
    else
      xstringb(orig(1)+sz(1)*(1-0-1),orig(2)+sz(2)*-0.25,label,sz(1)*1,sz(2)*0.3,"fill");
    end
    

  endfunction

  
  x=[];y=[];typ=[];
  select job
   case 'plot' then
    s0=arg1.graphics.exprs(1);
    standard_draw(arg1,%f,_MMT_Fixed_dp);
   case 'getinputs' then
    [x,y,typ]=_MMT_Fixed_ip(arg1);
   case 'getoutputs' then
    [x,y,typ]=_MMT_Fixed_op(arg1);
   case 'getorigin' then
    [x,y]=standard_origin(arg1);
   case 'set' then
    x=arg1;
    graphics=arg1.graphics;exprs=graphics.exprs;
    model=arg1.model;
    while %t do
      [ok,s0,exprs]=...
	  getvalue(['';'MMT_Fixed';'';'Fixed flange';''],...
		   [' s0 [m] : fixed offset position of housing'],...
		   list('vec',1),exprs);
      if ~ok then break, end
      model.equations.parameters(2)=list(s0)
      graphics.exprs=exprs;
      x.graphics=graphics;x.model=model;
      break
    end
   case 'define' then
    model=scicos_model();
    s0=0;
    model.sim='Coselica';
    model.blocktype='c';
    model.dep_ut=[%t %f];
    mo=modelica();
    mo.model='Modelica.Mechanics.Translational.Fixed';
    mo.inputs=[];
    mo.outputs=['flange_b'];
    mo.parameters=list(['s0'],...
		       list(s0),...
		       [0]);
    model.equations=mo;
    model.in=ones(size(mo.inputs,'*'),1);
    model.out=ones(size(mo.outputs,'*'),1);
    exprs=[sci2exp(s0)];
    gr_i="blk_draw(sz,orig,orient,model.label)";
    x=standard_define([2 2],model,exprs,list(gr_i,0));
    x.graphics.in_implicit=[];
    x.graphics.out_implicit=['I'];
  end
endfunction
