// Coselica Toolbox for Scicoslab
// Copyright (C) 2009-2011  Dirk Reusch, Kybernetik Dr. Reusch
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

function [x,y,typ]=MTHC_FixedTemperature(job,arg1,arg2)
  function blk_draw(sz,orig,orient,label)
    blue=xget('color','blue');
    green=xget('color','green')
    black=xget('color','black');
    white=xget('color','white');
    gray=xget('color','gray');
    red=xget('color','red');

    lgb=12;// light blue
    if orient then
      xx=orig(1);yy=orig(2);
      ww=sz(1);hh=sz(2);
    else
      xx=orig(1)+sz(1);yy=orig(2);
      ww=-sz(1);hh=sz(2);
    end
    if orient then
      xstringb(orig(1)+sz(1)*-0.09,orig(2)+sz(2)*1.025,label,sz(1)*1.2,sz(2)*0.3,"fill");
    else
      xstringb(orig(1)+sz(1)*(1--0.09-1.2),orig(2)+sz(2)*1.025,label,sz(1)*1.2,sz(2)*0.3,"fill");
    end
    if orient then
      xrect(orig(1)+sz(1)*0,orig(2)+sz(2)*1,sz(1)*1,sz(2)*1,color=black,background=lgb);
    else
      xrect(orig(1)+sz(1)*(1-0-1),orig(2)+sz(2)*1,sz(1)*1,sz(2)*1,color=black,background=lgb);
    end
    if orient then
      xstringb(orig(1)+sz(1)*0,orig(2)+sz(2)*0,"C",sz(1)*0.5,sz(2)*0.5,"fill");
    else
      xstringb(orig(1)+sz(1)*(1-0-0.5),orig(2)+sz(2)*0,"C",sz(1)*0.5,sz(2)*0.5,"fill");
    end
    xfpoly(xx+ww*[0.76;0.76;0.95;0.76],yy+hh*[0.4;0.6;0.5;0.4],color=red,fill_color=red);
    if orient then
      xstringb(orig(1)+sz(1)*-0.225,orig(2)+sz(2)*-0.255,"T="+string(T),sz(1)*1.4,sz(2)*0.245,"fill");
    else
      xstringb(orig(1)+sz(1)*(1--0.225-1.4),orig(2)+sz(2)*-0.255,"T="+string(T),sz(1)*1.4,sz(2)*0.245,"fill");
    end
    xpoly(xx+ww*[0.29;0.83],yy+hh*[0.5;0.5],color=red);
  endfunction
  
  x=[];y=[];typ=[];
  select job
   case 'plot' then
    T=arg1.graphics.exprs(1);
    standard_draw(arg1,%f,_MTH_FixedTemperature_dp);
   case 'getinputs' then
    [x,y,typ]=_MTH_FixedTemperature_ip(arg1);
   case 'getoutputs' then
    [x,y,typ]=_MTH_FixedTemperature_op(arg1);
   case 'getorigin' then
    [x,y]=standard_origin(arg1);
   case 'set' then
    x=arg1;
    graphics=arg1.graphics;exprs=graphics.exprs;
    model=arg1.model;
    while %t do
      [ok,T,exprs]=...
	  getvalue(['';'MTHC_FixedTemperature';'';'Fixed temperature boundary condition in degree Celsius';''],...
		   [' T [degC] : Fixed Temperature at the port'],...
		   list('vec',1),exprs);
      if ~ok then break, end
      model.equations.parameters(2)=list(T)
      graphics.exprs=exprs;
      x.graphics=graphics;x.model=model;
      break
    end
   case 'define' then
    model=scicos_model();
    T=1;
    model.sim='Coselica';
    model.blocktype='c';
    model.dep_ut=[%t %f];
    mo=modelica();
    mo.model='Modelica.Thermal.HeatTransfer.Celsius.FixedTemperature';
    mo.inputs=[];
    mo.outputs=['port'];
    mo.parameters=list(['T'],...
		       list(T),...
		       [0]);
    model.equations=mo;
    model.in=ones(size(mo.inputs,'*'),1);
    model.out=ones(size(mo.outputs,'*'),1);
    exprs=[sci2exp(T)];
    gr_i="blk_draw(sz,orig,orient,model.label)";
    x=standard_define([2 2],model,exprs,list(gr_i,0));
    x.graphics.in_implicit=[];
    x.graphics.out_implicit=['I'];
  end
endfunction
