// Coselica Toolbox for Scicoslab
// Copyright (C) 2009-2011  Dirk Reusch, Kybernetik Dr. Reusch
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

function [x,y,typ]=MTHC_FromKelvin(job,arg1,arg2)
  function blk_draw(sz,orig,orient,label)
    blue=xget('color','blue');
    red=xget('color','red');
    white=xget('color','white');
    green=xget('color','green')
    black=xget('color','black');
    if orient then
      xx=orig(1);yy=orig(2);
      ww=sz(1);hh=sz(2);
    else
      xx=orig(1)+sz(1);yy=orig(2);
      ww=-sz(1);hh=sz(2);
    end
    if orient then
      xstringb(orig(1)+sz(1)*-0.185,orig(2)+sz(2)*0.745,label,sz(1)*1.345,sz(2)*0.25,"fill");
    else
      xstringb(orig(1)+sz(1)*(1--0.185-1.345),orig(2)+sz(2)*0.745,label,sz(1)*1.345,sz(2)*0.25,"fill");
    end
    if orient then
      xarc(orig(1)+sz(1)*0.3,orig(2)+sz(2)*0.7,sz(1)*0.4,sz(2)*0.4,0,360*64,color=black,background=white);
    else
      xarc(orig(1)+sz(1)*(1-0.3-0.4),orig(2)+sz(2)*0.7,sz(1)*0.4,sz(2)*0.4,0,360*64,color=black,background=white);
    end
    if orient then
      xstringb(orig(1)+sz(1)*-0.07,orig(2)+sz(2)*-0.11,"K",sz(1)*0.4,sz(2)*0.4,"fill");
    else
      xstringb(orig(1)+sz(1)*(1--0.07-0.4),orig(2)+sz(2)*-0.11,"K",sz(1)*0.4,sz(2)*0.4,"fill");
    end
    if orient then
      xstringb(orig(1)+sz(1)*0.65,orig(2)+sz(2)*-0.095,"C",sz(1)*0.4,sz(2)*0.4,"fill");
    else
      xstringb(orig(1)+sz(1)*(1-0.65-0.4),orig(2)+sz(2)*-0.095,"C",sz(1)*0.4,sz(2)*0.4,"fill");
    end
    xpoly(xx+ww*[0.3;0],yy+hh*[0.5;0.5],color=blue,color=blue);
    xpoly(xx+ww*[0.7;1],yy+hh*[0.5;0.5],color=blue,color=blue);
  endfunction

  
  x=[];y=[];typ=[];
  select job
   case 'plot' then
    standard_draw(arg1,%f,_MBI_SISO_dp);
   case 'getinputs' then
    [x,y,typ]=_MBI_SISO_ip(arg1);
   case 'getoutputs' then
    [x,y,typ]=_MBI_SISO_op(arg1);
   case 'getorigin' then
    [x,y]=standard_origin(arg1);
   case 'set' then
    x=arg1;
   case 'define' then
    model=scicos_model();
    model.sim='Coselica';
    model.blocktype='c';
    model.dep_ut=[%t %f];
    mo=modelica();
    mo.model='Modelica.Thermal.HeatTransfer.Celsius.FromKelvin';
    mo.inputs=['Kelivn'];
    mo.outputs=['Celsius'];
    mo.parameters=list([],list(),[]);
    model.equations=mo;
    model.in=ones(size(mo.inputs,'*'),1);
    model.out=ones(size(mo.outputs,'*'),1);
    exprs=[];
    gr_i="blk_draw(sz,orig,orient,model.label)";
    x=standard_define([2 2],model,exprs,list(gr_i,0));
    x.graphics.in_implicit=['E'];
    x.graphics.out_implicit=['E'];
  end
endfunction
