function H1=coselica_default_palettes()
  // returns a H table of scicos default palette
  H1 = hash(10);

  // describe the structure of the palette hierarchy.
  H1.structure= list('Blocks','Electrical','Mechanics','Heat Transfer','Obsolete');

  // for each palette describe its contents

  /// block
  H_blk=hash(10);
  H_blk.structure=list('Interface','Routing','Math','Math Vectors','Sources','Continuous','Non Linear');

  H=hash(10);
  
  H('Interface') = list("CBI_RealInput", "CBI_RealOutput");

  H('Routing') = list("CBR_DeMultiplex2", "CBR_Multiplex2", "CBR_Replicator", ...
                      "CBR_Extractor", "CBR_DeMultiplexVector2", "CBR_MultiplexVector2");

  H('Math')= list("MBM_Gain", "MBM_Feedback", "MBM_Add", "CBM_Add3",...
                  "MBM_Product","MBM_Division","MBM_Min","MBM_Max","MBM_Abs",...
                  "MBM_Sign","MBM_Sqrt","MBM_Exp","MBM_Log","MBM_Log10","MBM_Sin","MBM_Cos",...
                  "MBM_Tan","MBM_Asin","MBM_Acos","MBM_Atan","CBM_Atan2","MBM_Sinh","MBM_Cosh",...
                  "MBM_Tanh", "CBM_TwoInputs", "CBM_TwoOutputs");

  H('Math Vectors')=list("CBM_Sum","CBMV_Add","CBMV_DotProduct","CBMV_ElementwiseProduct","CBMV_CrossProduct");

  H('Sources')= list("MBS_Constant","MBS_Step","MBS_Ramp","MBS_Sine","MBS_ExpSine",...
                     "MBS_Exponentials","MBS_Clock","CBS_Pulse","CBS_SawTooth","CBS_Trapezoid");

  H('Continuous')=list("MBC_Integrator","MBC_LimIntegrator","MBC_Der","MBC_Derivative",...
                       "MBC_FirstOrder","MBC_SecondOrder","MBC_PI","MBC_PID","MBC_LimPID");

  H('Non Linear')=list("MBN_Limiter","MBN_DeadZone","CBN_Hysteresis","CBN_RateLimiter");

  H_blk.contents=H

  /// Electrical
  H_elec=hash(10);
  H_elec.structure=list('Basic','Ideal','Semiconductors','Sensors','Sources');

  H=hash(10);

  H('Basic')= list("MEAB_Ground","MEAB_Resistor","MEAB_HeatingResistor","MEAB_Capacitor","MEAB_Inductor",...
                   "MEAB_Transformer",...
                   "MEAB_Gyrator","CEAB_EMF0","CEAB_EMF","CEAB_TranslationalEMF0","CEAB_TranslationalEMF",...
                   "MEAB_VCV","MEAB_VCC","MEAB_CCV","MEAB_CCC","MEAB_OpAmp","MEAB_VariableResistor",...
                   "MEAB_VariableCapacitor","MEAB_VariableInductor");

  H('Ideal')=list("CEAI_IdealDiode","MEAI_IdealTransformer","MEAI_IdealGyrator","MEAI_Idle",...
                  "MEAI_Short","MEAI_IdealOpeningSwitch","MEAI_IdealClosingSwitch");

  H('Semiconductors')=list("MEAS_Diode","CEAS_ZDiode","MEAS_PMOS","MEAS_NMOS","MEAS_NPN","MEAS_PNP",...
                           "CEAS_Thyristor");

  H('Sensors')=list("MEAS_PotentialSensor","MEAS_VoltageSensor","MEAS_CurrentSensor","CEAS_PowerSensor");

  H('Sources')=list("MEAS_SignalVoltage","MEAS_ConstantVoltage","MEAS_StepVoltage","MEAS_RampVoltage",...
                    "MEAS_SineVoltage","MEAS_PulseVoltage","MEAS_SawToothVoltage","CEAS_TrapezoidVoltage",...
                    "MEAS_SignalCurrent","MEAS_ConstantCurrent","MEAS_StepCurrent","MEAS_RampCurrent",...
                    "MEAS_SineCurrent","MEAS_PulseCurrent","MEAS_SawToothCurrent","CEAS_TrapezoidCurrent");

  H_elec.contents=H

  /// Mechanics
  H_mech=hash(10);
  H_mech.structure= list('Translational','Rotational','Planar');

  //Mechanics->Translational
  H_trans = hash(10);
  H_trans.structure= list('Components', 'Sources', 'Sensors');

  H=hash(10);

  H('Components')=list("MMT_Fixed","CMTC_Free","CMTC_Mass","CMTC_MassWithWeight","MMT_Rod",...
                       "MMT_Spring","MMT_Damper","MMT_SpringDamper","CMTC_ElastoGap",...
                        "CMT_MassWithFriction","CMT_Stop","CMTC_Pulley","CMTC_ActuatedPulley","CMTC_Lever");

  H('Sources')=list("CMTS_Position0","CMTS_Speed0","CMTS_Accelerate0","CMTS_Force0","CMTS_Position",...
                     "CMTS_Speed","CMTS_Accelerate","CMTS_Force","CMTS_Force2","CMTS_ConstantForce",...
                     "CMTS_ConstantSpeed","CMTS_ForceStep","CMTS_LinearSpeedDependen",...
                     "CMTS_QuadraticSpeedDepen");

  H('Sensors')=list("CMTS_PositionSensor","CMTS_SpeedSensor","CMTS_AccSensor","CMTS_RelPositionSensor",...
                    "CMTS_RelSpeedSensor","CMTS_RelAccSensor","CMTS_ForceSensor","CMTS_PowerSensor");

  H_trans.contents=H;

  //Mechanics->Rotational
  H_rot = hash(10);
  H_rot.structure= list('Components', 'Sources', 'Sensors');

  H=hash(10);

  H('Components')=list("MMR_Fixed","CMRC_Free","MMR_Inertia","CMRC_Disc","MMR_Spring",...
                       "MMR_Damper","MMR_SpringDamper","CMRC_ElastoBacklash",...
                       "CMR_BearingFriction","CMR_Brake","CMR_Clutch","CMR_OneWayClutch",...
                       "CMR_Freewheel","MMR_IdealGear","MMR_IdealPlanetary","CMRC_IdealDifferential",...
                       "MMR_IdealGearR2T");

  H('Sources')=list("CMRS_Position0","CMRS_Speed0","CMRS_Accelerate0","CMRS_Torque0",...
                    "CMRS_Position","CMRS_Speed","CMRS_Accelerate","CMRS_Torque",...
                    "CMRS_Torque2","CMRS_ConstantTorque","CMRS_ConstantSpeed","CMRS_TorqueStep",...
                    "CMRS_LinearSpeedDependen","CMRS_QuadraticSpeedDepen");

  H('Sensors')=list("MMRS_AngleSensor","MMRS_SpeedSensor","MMRS_AccSensor","MMRS_RelAngleSensor",...
                    "MMRS_RelSpeedSensor","MMRS_RelAccSensor","MMRS_TorqueSensor","CMRS_PowerSensor");

  H_rot.contents=H;

  //Mechanics->Planar
  H_plan = hash(10);
  H_plan.structure= list('World','Forces','Joints','LoopJoints','Parts','Sensors');

  //Mechanics->Planar->Sensors
  H_plan_sens = hash(10);
  H_plan_sens.structure= list('Sensors','Absolute Sensors','Relative Sensors');

  H=hash(10);
  H('Sensors')=list("CMPS_Distance","CMPS_CutForce","CMPS_CutForce2","CMPS_CutTorque","CMPS_Power")

  H('Absolute Sensors')=list("CMPS_AbsPosition","CMPS_AbsVelocity","CMPS_AbsAcceleration",...
                             "CMPS_AbsAngle","CMPS_AbsAngularVelocity","CMPS_AbsAngularAccelerat",...
                             "CMPS_AbsPosition2","CMPS_AbsVelocity2","CMPS_AbsAcceleration2");

  H('Relative Sensors')=list("CMPS_RelPosition","CMPS_RelVelocity","CMPS_RelAcceleration","CMPS_Angle",...
                             "CMPS_RelAngularVelocity","CMPS_RelAngularAccelerat","CMPS_RelPosition2",...
                             "CMPS_RelVelocity2","CMPS_RelAcceleration2");

  H_plan_sens.contents=H;

  H=hash(10);

  H('World')= list("CMP_World");

  H('Forces')=list("CMPF_WorldForce","CMPF_WorldTorque","CMPF_FrameForce","CMPF_LineForce",...
                   "CMPF_LineForceWithMass");

  H('Joints')=list("CMPJ_FreeMotion","CMPJ_Prismatic","CMPJ_Revolute","CMPJ_ActuatedPrismatic",...
                   "CMPJ_ActuatedRevolute","CMPJ_RollingWheel","CMPJ_ActuatedRollingWhee");

  H('LoopJoints')=list("CMPL_Prismatic","CMPL_Revolute","CMPL_ActuatedPrismatic","CMPL_ActuatedRevolute");

  H('Parts')=list("CMPP_Fixed","CMPP_FixedTranslation","CMPP_FixedRotation","CMPP_Body","CMPP_BodyShape",...
                  "CMPP_PointMass");

  H('Sensors')=H_plan_sens;

  H_plan.contents=H;

  H=hash(10);

  H('Translational')= H_trans;

  H('Rotational')=H_rot;

  H('Planar')=H_plan;

  H_mech.contents=H;

  //Heat Transfer
  H_heat=hash(10);
  H_heat.structure=list('Components','Sources','Sensors','Celcius');

  H=hash(10);

  H('Components')=list("MTH_HeatCapacitor","MTH_ThermalConductor","MTH_Convection","MTH_BodyRadiation");

  H('Sources')=list("MTH_FixedTemperature","MTH_PrescribedTemperatur","MTH_FixedHeatFlow",...
                    "MTH_PrescribedHeatFlow");

  H('Sensors')=list("MTH_TemperatureSensor","MTH_RelTemperatureSensor","MTH_HeatFlowSensor");

  H('Celcius')=list("MTHC_ToKelvin","MTHC_FromKelvin","MTHC_FixedTemperature","MTHC_PrescribedTemperatu",...
                    "MTHC_TemperatureSensor");

  H_heat.contents=H;

  H=hash(10);
  H('Blocks')=H_blk
  H('Electrical')=H_elec
  H('Mechanics')=H_mech
  H('Heat Transfer')=H_heat
  H('Obsolete')=list("MMT_SlidingMass","CMT_Position","CMT_Speed","MMT_Accelerate",...
                     "MMT_Force","MEAB_EMF","CMR_Position","CMR_Speed","MMR_Accelerate",...
                     "MMR_Torque","MMR_Torque2","MMR_ConstantTorque","MMR_ConstantSpeed",...
                     "MMR_TorqueStep","MMR_LinearSpeedDependent","MMR_QuadraticSpeedDepend");

  H1.contents = H;

endfunction

//
function scmenu_coselica_palettes()
  Cmenu=''
  if ~exists('scicos_widgets') then scicos_widgets=list();end
  scicos_widgets($+1)=hash(id=scicos_palette_icon_view(coselica_default_palettes()),open=%t,what='IconView');
endfunction

