function modnum_tests(flag)
//Modnum tests function for the Scicos tests center
//Based on the Scicos tests function from F.Nassif
//Copyright (C) 2007-2015 Alan Layec

   lines(0)

   global scicos_test_path
   scicos_test_path=get_modnum_path()+'/tests/'

   if argn(2)<1 then flag='';end

   // load macros libraries and palettes
   //load SCI/macros/scicos/lib;
   //exec(loadpallibs,-1);

   global %scicos_prob
   %scicos_prob=%f
   getvalue=setvalue;
   message=[];
   do_eval=test_do_eval;

   // return the diagrams to test
   cos_files=get_tests_diagram()

   ierr_file=[];
   diag_name=[];

   for i=1:size(cos_files,1)

     curdir=getcwd();
     path=cos_files(i,1)
     chdir(path);

     [a,fname,extF]=fileparts(cos_files(i,2));

     fname=strsubst(fname,'.','_');
     diag_name=[diag_name;fname];

     if extF=='.cos' then
       execstr('load '+cos_files(i,2));
     elseif extF=='.cosf' then
       execstr('exec (""'+cos_files(i,2)+'"",-1)');
     else
       x_message('Type of file is not supported');
       return;
     end

     disp('Diagram test: '+cos_files(i,2));

     [ierreport,scs_m]=do_scicos_test(scs_m);

     ierr_file=[ierr_file;[cos_files(i,2) ierreport]];

     xpause(2000000);

     if flag=='all' then
       [simul_gif,Info]=generating_diag_gif(scs_m,fname);
       generating_diag_html(fname,simul_gif,Info,scs_m);
     end

     chdir(curdir);
   end

   [xml_name,html_info,info_list]=give_test_result(ierr_file);
   printf('Generating the html result page ......................');
   generating_result_html(html_info,xml_name,info_list);
   printf('Done\n');
   printf('Generating the html main page ........................');
   generating_html(diag_name);
   printf('Done\n');
   chdir(curdir);
endfunction


