//Calcul_3eme_ordre - Scilab function - 
//Return the zeros and the pole of a third order digital PLL type 2
//Based on the Rhode's Model
//13 octobre 2003 - IRCOM GROUP - Author : A.Layec
//Copyright (C) 2007-2015 Alan Layec
function [tau1,tau,tau2]=calcul_3eme_ordre(fn,phi,kv,icp,N)
  wn=2*%pi*fn;
  tau2=(-tan(phi)+1/cos(phi))/wn;
  tau1=1/(wn*wn*tau2);
  tau9=(kv*icp/(2*%pi))/(N*wn*wn);
  tau=tau9*sqrt((1+wn*wn*tau1*tau1)/(1+wn*wn*tau2*tau2));
  c0=(tau2/tau1)*((kv*icp/(2*%pi))/(wn*wn*N))*sqrt((1+(wn*tau1)^2)/(1+(wn*tau2)^2));
  c1=c0*((tau1/tau2)-1);
  r1=tau1/c1;
endfunction

