//FMODULO_f Scicos Float Modulo function block
//Classical interface function ver1.0 - scilab-2.7
//19 octobre 2003 - IRCOM GROUP - Author : A.Layec
//Copyright (C) 2007-2015 Alan Layec
function [x,y,typ]=FMODULO_f(job,arg1,arg2)
x=[];y=[];typ=[]
select job
case 'plot' then
  standard_draw(arg1)
case 'getinputs' then
  [x,y,typ]=standard_inputs(arg1)
case 'getoutputs' then
  [x,y,typ]=standard_outputs(arg1)
case 'getorigin' then
  [x,y]=standard_origin(arg1)
case 'set' then
   x=arg1;
   graphics=arg1.graphics;model=arg1.model;
   exprs=graphics.exprs;

   while %t do

      [ok,ampl,exprs]=getvalue('Scicos Float Modulo function block',...
      ['Amplitude'],list('vec',-1),exprs)

      if ~ok then break,end;
      Nu=size(ampl,'*');if Nu==0 then Nu=[],end

      if ok then
          graphics.exprs=exprs
          model.rpar=ampl
          model.in=Nu;model.out=Nu
          x.graphics=graphics;x.model=model
          break;
      end
   end

case 'define' then
  Nu=1
  ampl=1

  model=scicos_model()
  model.sim=list('modnum_fmodulo',2)
  model.in=Nu
  model.out=Nu
  model.evtin=[]
  model.evtout=[]
  model.dstate=[]
  model.rpar=ampl
  model.ipar=[]
  model.blocktype='d'
  model.firing=[]
  model.dep_ut=[%t %f]

  gr_i=['thick=xget(''thickness'')'
        'pat=xget(''pattern'')'
        'fnt=xget(''font'')'
        'xarrows(orig(1)+[0.498;0.498]*sz(1),orig(2)+[0.022;0.94]*sz(2),arsize=4,style=-1)'
        'xarrows(orig(1)+[0.042;0.973]*sz(1),orig(2)+[0.516;0.516]*sz(2),arsize=4,style=-1)'
        'xpoly(orig(1)+[0.102;0.216;0.216;0.753;0.753;0.878]*sz(1),orig(2)+[0.679;0.874;0.116;0.877;0.113;0.27]*sz(2),type="'lines"')'
        'txt=''FMODULO'';'
        'style=5;'
        'xset(''font'',style,fnt(2))'
        'w=sz(1);h=sz(2)/4;'
        'xstringb(orig(1)+sz(1)/2-w/2,orig(2)-h-5,txt,w,h,''fill'');'
        'xset(''thickness'',thick)'
        'xset(''pattern'',pat)'
        'xset(''font'',fnt(1),fnt(2))']
  exprs=string(ampl)
  x=standard_define([2 2],model,exprs,gr_i)
//   x.graphics.id="FMODULO"
end
endfunction
