//CAN_f Analog to Digital Converter block
//Classical interface function ver1.0 - scilab-2.7
//10 octobre 2003 - IRCOM GROUP - Author : A.Layec
//
//Copyright (C) 2007-2015 Alan Layec
function [x,y,typ]=CAN_f(job,arg1,arg2)
x=[];y=[];typ=[]
select job
case 'plot' then
  standard_draw(arg1)
case 'getinputs' then
  [x,y,typ]=standard_inputs(arg1)
case 'getoutputs' then
  [x,y,typ]=standard_outputs(arg1)
case 'getorigin' then
  [x,y]=standard_origin(arg1)
case 'set' then
   x=arg1;
   graphics=arg1.graphics;model=arg1.model;
   exprs=graphics.exprs;

  while %t do

   [ok,q,vmin,typ,nbit,cc2,exprs]=getvalue('Analog to Digital Converter',...
   ['q';'vmin';'type';'number of bit';'code complment  2 (0/1)'],...
   list('vec',-1,'vec',-1,'vec',-1,'vec',-1,'vec',-1),exprs);

   if ~ok then break,end;

   if (size(vmin)==size(q)) then
       Nu = prod(size(q));
       [model,graphics,ok]=check_io(model,graphics,Nu,Nu,1,[]);
       if ok then
          graphics.exprs=exprs;
          rpar=[q;vmin];
          model.rpar=rpar(:);
          alpha=int([typ;nbit;cc2]);
          model.ipar=alpha(:);
          x.graphics=graphics; x.model=model;
          break;
        end
     else
       message('Vector q and Vector vmin state must have the same size');
     end
 end

case 'define' then
  Nu=1;
  nbit=8;
  q=0.1;
  vmin=0;
  typ=1;
  cc2=1;

  model=scicos_model()
  model.sim=list('modnum_can',1)
  model.in=Nu
  model.out=Nu
  model.evtin=1
  model.evtout=[]
  model.dstate=[]
  model.rpar=[q;vmin]
  model.ipar=[typ;nbit;cc2]
  model.blocktype='d'
  model.firing=[]
  model.dep_ut=[%f %f]

//  model=list(list('can',1),Nu,Nu,1,[],[],[],[q vmin],[typ nbit cc2],'c',[],[%f %f],' ',list())
  gr_i=['txt=[''CAN''];';
   'xstringb(orig(1),orig(2),txt,sz(1),sz(2),''fill'');']
  label=[sci2exp(q),sci2exp(vmin),sci2exp(typ),sci2exp(nbit),sci2exp(cc2)];
  x=standard_define([2 2],model,label,gr_i)
end
endfunction
