//OVERLAP_f Scicos Temporal overlap vector
//Classical interface function ver1.0 - scilab-2.7
//22 dcembre 2003 - IRCOM GROUP - Author : A.Layec
//
//Copyright (C) 2007-2015 Alan Layec
function [x,y,typ]=OVERLAP_f(job,arg1,arg2)
x=[];y=[];typ=[]
select job
case 'plot' then
  standard_draw(arg1)
case 'getinputs' then
  [x,y,typ]=standard_inputs(arg1)
case 'getoutputs' then
  [x,y,typ]=standard_outputs(arg1)
case 'getorigin' then
  [x,y]=standard_origin(arg1)
case 'set' then
   x=arg1;
   graphics=arg1.graphics;model=arg1.model;
   exprs=graphics.exprs;

   while %t do

      [ok,nu,ny,nz,exprs]=getvalue('Scicos Temporal overlap vector',...
      ['Size of input';'Size of output';...
      'Lenght of memo word'],list('vec',1,'vec',1,'vec',1),exprs)

      if ~ok then break,end;

      if ok then
          graphics.exprs=exprs
          model.dstate=zeros(nz,1)
          model.in=nu;model.out=ny
          model.dep_ut=[%t %f] //for compatibility
          x.graphics=graphics;x.model=model
          break;
      end
   end

case 'define' then
  nu=8
  ny=16
  nz=3

  model=scicos_model()
  model.sim=list('modnum_overlap',4)
  model.in=nu
  model.out=ny
  model.evtin=[]
  model.evtout=[]
  model.dstate=zeros(1,nz)
  model.rpar=[]
  model.ipar=[]
  model.blocktype='d'
  model.firing=[]
  model.dep_ut=[%t %f]

  gr_i=['txt=[''Overlap''];';
    'xstringb(orig(1),orig(2),txt,sz(1),sz(2),''fill'');']
  exprs=[string(nu),string(ny),string(nz)]
  x=standard_define([2 2],model,exprs,gr_i)
end
endfunction
