 
//
function H1=modnum_default_palettes()
  // returns a H table of scicos default palette
  H1 = hash(10);

  // describe the structure of the palette hierarchy.
  H1.structure= list('Communication','Filter','Integer','NonLinear',...
                     'Pll','Signal','Sinks','Sources','Tools','Old');

  //
  H=hash(10);

  H('Communication') = list("AWGN_f","BITERROR_f","CODINSERVEC_f",...
                            "DECODVEC_f","DEMODGEN_c","DEMODIQ_f",...
                            "DEMODPSK_f","DEMODQAM_f","MODGEN_c",...
                            "MODIQ_f","MODPSK_f","MODQAM_f",...
                            "QPSKREC_f");


  H('Filter')        = list("GAUSSF_c","INTSYMB_f","RCF_c",...
                            "RIFGEN_f","SRRCF_c");


  H('Integer')       = list("ADDER_c","BIN2DEC_c","DEC2BIN_c");


  H('NonLinear')     = list("ADC_c","CHUAFONC_f","COMP_f",...
                            "DAC_c","FMODULO_f","FMODULOB_f",...
                            "FMODULOC_f","IMODULOB_f","IMODULOB_f",...
                            "LCMODULO_f","LOGISTIQUE_f","SYSTEMG_f",...
                            "SYSTEMH_f","VTUNE_f");


  H('Old')           = list("CAN_f","CNA_f","DESTOCKBIT_f",...
                            "EULERINTEGRAL_f","GENINT_f","MASHBLK_f",...
                            "STOCKBIT_f","TRAPINTEGRAL_f","UPSMPL_f",...
                            "VCO_f","ZBUF_f","ZBUFT_f",...
                            "ZGEN_f");


  H('Pll')           = list("CHARGEPUMP_f","CPF_f","PERRDSM_c",...
                            "PFD_f","SDBLK_c","SOLOOPFILTER_f",...
                            "VCO_c","VCOEVT_f");


  H('Signal')        = list("CONVOLGEN_f","CORR_c","DOWNSMPL_f",...
                            "FFTCMPLX_f","INSERZEROVEC_f","OVERLAP_f",...
                            "OVERLAPRSR_f","UPSMPL_c","UPSMPLFFT_f");


  H('Sinks')         = list("EYESCOPE_c","PSPECSCOPE_c","VECTORSCOPE_c",...
                            "VECTORSCOPEXY_c","ZBUF_c","ZBUFT_c");


  H('Sources')       = list("DISCRGEN_f","GENGOLD_f","GENINT_c",...
                            "GENMLLSRS_f","GENPULSE_f","GENSYMB_f",...
                            "NOISEBLK_f","NOISERAYL_c","PCLOCK_f",...
                            "PEVTDLY_c","PEVTDLY_f","Time_f",...
                            "ZGEN_c");


  H('Tools')         = list("BINACCU_c","BINREG_c","CONVPS_f",...
                            "CONVSP_f","EULERINTEGRAL_m","INTBLK_f",...
                            "NDELAY_f","NINTEGRAL_f","TRAPINTEGRAL_m",...
                            "VECTMULTCMPLX_f");

  H1.contents = H;
endfunction

//
if exists('%scicos_pal') && ~%scicos_pal.contents.iskey["Modnum"] then
    %scicos_pal.structure.add_last["Modnum"]
    %scicos_pal.contents.enter[Modnum=modnum_default_palettes()];
end

modnum_path = get_modnum_path();

//
if exists('%scicos_gif') then
  icon_path=file('join',[modnum_path,'macros','png_icons'])
  if isempty(find(%scicos_gif==icon_path)) then
    %scicos_gif=[%scicos_gif;icon_path]
  end
  clear icon_path;
end

//
if exists('%scicos_menu') then
  for i=1:length(%scicos_menu)
    if %scicos_menu(i)(1)(1)=='_Help' then
      ko=%f;
      for j=1:length(%scicos_menu(i))
        if isequal(%scicos_menu(i)(j)(1),'Modnum') then
          ko=%t;
          break;
        end
      end
      if ~ko then
        %scicos_menu(i).add_last[      ["sep3"            "separator" ""                    ""  ""] ];
        %scicos_menu(i).add_last[ list(["Modnum"          "menu"      "scmenu_modnum_menu"  ""  ""               ],
                                       ["ScicosLab Demos" "menuitem"  "scmenu_modnum_demo"  ""  "gtk-open"       ],
                                       ["ssep31"          "separator" ""                    ""  ""               ],
                                       ["Documentation"   "menuitem"  "scmenu_modnum_doc"   ""  "gtk-help"       ],
                                       ["ssep32"          "separator" ""                    ""  ""               ],
                                       ["Website"         "menuitem"  "scmenu_modnum_web"   ""  "gtk-dialog-info"],
                                       ["ssep33"          "separator" ""                    ""  ""               ],
                                       ["About"           "menuitem"  "scmenu_modnum_about" ""  "gtk-about"      ]) ];
      end
      clear ko;
      break;
    end
  end
  clear i; clear j;
end

//
if exists('%scicos_topics') then
  TT=%scicos_topics;
  H1=modnum_default_palettes();
  for i=1:length(H1.structure)
    for j=1:length(H1.contents(H1.structure(i)))
      topic=H1.contents(H1.structure(i))(j)
      TT(topic)='file:///'+modnum_path+'/help/scicos/eng/htm/'+topic+'.htm';
    end
  end
  clear i; clear j; clear topic; clear H1;
  TT('modnum')='file:///'+modnum_path+'/help/scicos/eng/htm/whatis_modnum.htm';
  %scicos_topics=TT;
  clear TT;
end

