/* codinser_c subroutine
 * symbol by chip multiplication
 *
 * Copyright (C) 2007-2015 Alan Layec
 *
 * This file is part of modnumlib.
 *
 * modnumlib is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * modnumlib is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with modnumlib; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */

/* REVISION HISTORY :
 * $Log: codinser_c.c,v $
 * Revision 1.1  2016-07-20 14:00:20  jpc
 * updates
 *
 * Revision 1.1  2015-12-25 15:47:58  layec
 * add
 *
 */

#include "modnum_lib.h"

/* codinser_c routine de multiplication code par symbole
 * nuc : taille du vecteur code
 * nus : taille du vecteur symbole
 * c : adresse de dpart du vecteur code
 * s : adresse de dpart du vecteur symbole
 * y : adresse de dpart du vecteur rsultat
 */

void codinser_c(int *nuc,int *nus,double *c,double *s,double *y)
{
 /*Dclaration des variables compteur*/
 int i,j;

 /*Ralise multiplication code par symbole*/
 for(i=0;i<(*nus);i++) {
   for(j=0;j<(*nuc);j++) {
    y[i*(*nuc)+j]=s[i]*c[j];
   }
 }
 return;
}

void codinserdi_c(int *nuc,int *nus,int *c,double *s,double *y)
{
 /*Dclaration des variables compteur*/
 int i,j;

 /*Ralise multiplication code par symbole*/
 for(i=0;i<(*nus);i++) {
   for(j=0;j<(*nuc);j++) {
    y[i*(*nuc)+j]=s[i]*c[j];
   }
 }
 return;
}

void codinseri_c(int *nuc,int *nus,int *c,int *s,int *y)
{
 /*Dclaration des variables compteur*/
 int i,j;

 /*Ralise multiplication code par symbole*/
 for(i=0;i<(*nus);i++) {
   for(j=0;j<(*nuc);j++) {
    y[i*(*nuc)+j]=s[i]*c[j];
   }
 }
 return;
}

void codinserid_c(int *nuc,int *nus,double *c,int *s,int *y)
{
 /*Dclaration des variables compteur*/
 int i,j;

 int ind_y;

 /*Ralise multiplication code par symbole*/
 for(i=0;i<(*nus);i++) {
   ind_y = i*(*nuc);
   for(j=0;j<(*nuc);j++) {
     y[ind_y+j]=(int)(s[i]*c[j]);
   }
 }
 return;
}

