/* modnum_lib.h header for mod_num_lib
 *
 * Copyright (C) 2007-2016 Alan Layec
 *
 * This file is part of modnumlib.
 *
 * modnumlib is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * modnumlib is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with modnumlib; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */

#ifndef MODNUM_LIB_H
#define MODNUM_LIB_H

#ifndef WITH_SCIFFT
#define WITH_SCIFFT 0
#endif

#ifndef WITH_DFFTPACK
#define WITH_DFFTPACK 1
#endif

#ifndef WITH_FFTW
#define WITH_FFTW 1
#endif

#ifndef WITH_SCISRC
#define WITH_SCISRC 0
#endif

#ifndef WITH_NSPSRC
#define WITH_NSPSRC 1
#endif

#ifndef M_PI
#define M_PI    3.14159265358979323846
#endif

#ifndef Abs
#define Abs(x) ( (x) > 0) ? (x) : -(x)
#endif

#ifndef min
#define min(a,b) ((a) <= (b) ? (a) : (b))
#endif

#ifndef max
#define max(a,b) ((a) >= (b) ? (a) : (b))
#endif

typedef struct fft_pr_st {
  int lfft;
  int isn;
  int ffttyp;
  int nwork;
  double *work;
} fft_pr_struct;

#define modpsk_c modnum_modpsk_c
#define modpski_c modnum_modpski_c
#define modpskv_c modnum_modpskv_c
#define demodpsk_c modnum_demodpsk_c
#define demodpskv_c modnum_demodpskv_c
#define modqam_c modnum_modqam_c
#define modqami_c modnum_modqami_c
#define modqamv_c modnum_modqamv_c
#define demodqam_c modnum_demodqam_c
#define demodqami_c modnum_demodqami_c
#define demodqamv_c modnum_demodqamv_c
#define modgen_c modnum_modgen_c
#define demodgen_c modnum_demodgen_c
#define genint_c modnum_genint_c
#define geninti_c modnum_geninti_c
#define genintv_c modnum_genintv_c
#define surecht_c modnum_surecht_c
#define surechti_c modnum_surechti_c
#define surechty_c modnum_surechty_c
#define sousecht_c modnum_sousecht_c
#define sousechti_c modnum_sousechti_c
#define sousechty_c modnum_sousechty_c
#define intsym_c modnum_intsym_c
#define intsymi_c modnum_intsymi_c
#define intsymy_c modnum_intsymy_c
#define intsymz_c modnum_intsymz_c
#define calc_init_c modnum_calc_init_c
#define cmplxmult_c modnum_cmplxmult_c
#define cmplxadd_c modnum_cmplxadd_c
#define cmplxcopy_c modnum_cmplxcopy_c
#define copyd_c modnum_copyd_c
#define copyi_c modnum_copyi_c
#define setd_c modnum_setd_c
#define codinser_c modnum_codinser_c
#define codinseri_c modnum_codinseri_c
#define codinserid_c modnum_codinserid_c
#define codinserdi_c modnum_codinserdi_c
#define decod_c modnum_decod_c
#define decodi_c modnum_decodi_c
#define decodid_c modnum_decodid_c
#define decoddi_c modnum_decoddi_c
#define overlapadr_c modnum_overlapadr_c
#define overlaprsr_c modnum_overlaprsr_c
#define convolfft_c modnum_convolfft_c
#define convolr_c modnum_convolr_c
#define comp_c modnum_comp_c
#define compv_c modnum_compv_c
#define nfilter_c modnum_nfilter_c
#define nfilterz_c modnum_nfilterz_c
#define nfiltery_c modnum_nfiltery_c
#define nfilteri_c modnum_nfilteri_c
#define cw_c modnum_cw_c
#define vcoy_c modnum_vcoy_c
#define vcoz_c modnum_vcoz_c
#define noiseiq_c modnum_noiseiq_c
#define noiseblk_c modnum_noiseblk_c
#define noiseblkv_c modnum_noiseblkv_c
#define awgn_c modnum_awgn_c
#define awgni_c modnum_awgni_c
#define awgniq_c modnum_awgniq_c
#define awgniqi_c modnum_awgniqi_c
#define gold_c modnum_gold_c
#define goldi_c modnum_goldi_c
#define mllsrs_c modnum_mllsrs_c
#define mllsrsi_c modnum_mllsrsi_c
#define cpf_c modnum_cpf_c
#define cpfy_c modnum_cpfy_c
#define cpfz_c modnum_cpfz_c
#define cpft_c modnum_cpft_c
#define chargepump_c modnum_chargepump_c
#define dsm1_c modnum_dsm1_c
#define dsm2_c modnum_dsm2_c
#define dsm3_c modnum_dsm3_c
#define adc_c modnum_adc_c
#define adcv_c modnum_adcv_c
#define dac_c modnum_dac_c
#define dacv_c modnum_dacv_c
#define calc_win_c modnum_calc_win_c
#define filter_tap_c modnum_filter_tap_c
#define corr_c modnum_corr_c
#define corri_c modnum_corri_c
#define rnoise_c modnum_rnoise_c
#define perrdsm_c modnum_perrdsm_c
#define perrdsmy_c modnum_perrdsmy_c
#define perrdsmz_c modnum_perrdsmz_c
#define alc_fft_c modnum_alc_fft_c
#define pspect_c modnum_pspect_c
#define dec2bindd_c modnum_dec2bindd_c
#define dec2bindi_c modnum_dec2bindi_c
#define dec2binid_c modnum_dec2binid_c
#define dec2binii_c modnum_dec2binii_c
#define bin2decdd_c modnum_bin2decdd_c
#define bin2decdi_c modnum_bin2decdi_c
#define bin2decid_c modnum_bin2decid_c
#define bin2decii_c modnum_bin2decii_c
#define tf2ss_c modnum_tf2ss_c 
#define calc_fft_c modnum_calc_fft_c

extern void modpsk_c(int *n,int *m,int *ns,double *u,double *i_c, double *q_c);
extern void modpski_c(int *n,int *m,int *ns,int *u,double *i_c, double *q_c);
extern void modpskv_c(int *n,int *m,double *u,double *i_c, double *q_c);

extern void demodpsk_c(int *n,int *m,int *ns,double *i_c,double *i_q,double*y);
extern void demodpskv_c(int *n,int *m,double *i_c,double *i_q,double*y);

extern void modqam_c(int *n,int *m,int *ns,double *u,double *i_c,double *q_c);
extern void modqami_c(int *n,int *m,int *ns,int *u,int *i_c,int *q_c);
extern void modqamv_c(int *n,int *m,double *u,double *i_c,double *q_c);

extern void demodqam_c(int *n,int *m,int *ns,double *i_c,double *q_c,double *y);
extern void demodqami_c(int *n,int *m,int *ns,int *i_c,int *q_c,int *y);
extern void demodqamv_c(int *n,int *m,double *i_c,double *q_c,double *y);

extern void modgen_c(int *n,int *m,double *u,double *u_r,double *u_i, \
                     double *i_c, double *q_c);

extern void demodgen_c(int *n,int *m,double *i_c, double *q_c, \
                       double *u_r,double *u_i,double *y);

extern void genint_c(int *n,int *m,int *nbit,int *typ,double *y);
extern void geninti_c(int *n,int *m,int *nbit,int *typ,int *y);
extern void genintv_c(int *n,int *m,int *typ,double *y);

extern void surecht_c(int *opt,int *n,int *m,int *nech,int *init_c,double *u,double *y);
extern void surechti_c(int *opt,int *n,int *m,int *nech,int *init_c,int *u,int *y);
extern void surechty_c(int *opt,int *n,int *m,int *nech,int *init_c,double *u,double *y);

extern void sousecht_c(int *n,int *m,int *nech,int *init_c,double *u,double *y);
extern void sousechti_c(int *n,int *m,int *nech,int *init_c,int *u,int *y);
extern void sousechty_c(int *n,int *m,int *nech,int *init_c,double *u,double *y);

extern void intsym_c(int *n,int *m,int *nech,int *init_c,double *step,\
                     double *u,double *y,double *z);
extern void intsymi_c(int *n,int *m,int *nech,int *init_c,double *step,\
                      int *u,double *y,double *z);
extern void intsymy_c(int *n,int *m,int *nech,int *init_c,double *step,\
                      double *u,double *y,double *z);
extern void intsymz_c(int *n,int *m,double *u,double *y,double *z);

extern void calc_init_c(int *n, int *m, int *ns, int *init);

extern void cmplxmult_c(int *n,double *z1_r,double *z1_i, \
                        double *z2_r,double *z2_i,double *y_r,double *y_i);
extern void cmplxadd_c(int *n,int *sig,double *z1_r,double *z1_i, \
                       double *z2_r,double *z2_i,double *y_r,double *y_i);
extern void cmplxcopy_c(int *n,double *u1,double *u2,double *y1,double *y2);

extern void copyd_c(int *n, double *u,double *y);
extern void copyi_c(int *n, int *u,int *y);
extern void setd_c(int *n,double *v,double *y);

extern void codinser_c(int *nuc,int *nus,double *c,double *s,double *y);
extern void codinseri_c(int *nuc,int *nus,int *c,int *s,int *y);
extern void codinserid_c(int *nuc,int *nus,double *c,int *s,int *y);
extern void codinserdi_c(int *nuc,int *nus,int *c,double *s,double *y);

extern void decod_c(int *nuc,int *nus,double *c,double *s,double *y);
extern void decodi_c(int *nuc,int *nus,int *c,int *s,int *y);
extern void decodid_c(int *nuc,int *nus,double *c,int *s,int *y);
extern void decoddi_c(int *nuc,int *nus,int *c,double *s,double *y);

extern void overlapadr_c(int *m1,int *n,int *nb_coef,double *u_r,double *z_r);
extern void overlaprsr_c(int *n,int *m,double *u,double *y,double *z);

extern void convolfft_c(int *m1,double *z1_r,double *z1_i,double *z2_r,double *z2_i, \
                        double *y_r,double *y_i,fft_pr_struct *fft_pr);
extern void convolr_c(int *n,int *nb_coef,int *m1,double *z1_r,double *z1_i, \
                      double *z2_r,double *z2_i,double *y_r,double *y_i,double *z_r,fft_pr_struct *fft_pr);

extern void comp_c(int *n,double *ampl,double *u,double *y);
extern void compv_c(int *n,double *ampl,double *u,double *y);
extern void nfilter_c(int *n,int *m,int *nbcoef,double *u,double *pulse,double *y,double *z);
extern void nfilterz_c(int *n,int *m,int *nbcoef,double *u,double *pulse,double *y,double *z);
extern void nfiltery_c(int *n,int *m,int *nbcoef,double *u,double *pulse,double *y,double *z);
extern void nfilteri_c(int *n,int *m,int *nbcoef,int *u,double *pulse,double *y,double *z);

extern void cw_c(int *n, int *m, double *ampl, double *fs, double *phi, \
                 double *ti, double *ts, int *opt, double *y1, double *y2);

extern void vcoy_c(int *n, double *u, double *h, double *omega, double *kv, \
                   double *w__n, double *phi_n, double *err, double *u__n, \
                   double *theta);
extern void vcoz_c(int *n, double *u, double *h, double *omega, double *kv, \
                   double *cross_val, double *w__n, double *phi__n, \
                   double *err, double *u__n, double *theta);

extern void noiseiq_c(int *n,int *m,double *sig,double *mean,double *i_c,double *i_q);
extern void noiseblk_c(int *n,int *typ,double *sig,double *mean,double *y);
extern void noiseblkv_c(int *n,int *typ,double *sig,double *mean,double *y_i,double *y_q);

extern void awgn_c(int *n,int *m,double *sig,double *mean,double *u,double *y);
extern void awgni_c(int *n,int *m,double *sig,double *mean,int *u,double *y);
extern void awgniq_c(int *n,int *m,double *sig,double *mean,\
                     double *u_i,double *u_q,\
                     double *y_i,double *y_q);
extern void awgniqi_c(int *n,int *m,double *sig,double *mean,\
                      int *u_i,int *u_q,\
                      double *y_i,double *y_q);

extern void gold_c(int *N, int *ny,double *y,int *reg1, int *reg2,int *coef1, int *coef2);
extern void goldi_c(int *N, int *ny,int *y,int *reg1, int *reg2,int *coef1, int *coef2);

extern void mllsrs_c(int *N, int *ny,double *y,int *reg, int *coef);
extern void mllsrsi_c(int *N, int *ny,int *y,int *reg, int *coef);

extern void cpf_c(int *n,int *nev,double *z1,double *z2,double *y1,double *y2);
extern void cpfy_c(int *n,int *nev,double *z1,double *z2,double *y1,double *y2);
extern void cpfz_c(int *n,int *nev,double *z1,double *z2);
extern void cpft_c(int *n,int *nev,int *flag,double *delay,double *z1,double *z2, \
                   double *evout,double *y1,double *y2,double *sh);
extern void chargepump_c(int *n,double *up,double *down,double *Io, int *typ_leak, \
                         double *Ileak_m,double *Ileak_d,double *Icp);

extern void dsm1_c(int *n,double *m,double *u,double *e,double *z, \
                    double *y,double *q);
extern void dsm2_c(int *n,double *m,double *u,double *e,double *z, \
                    double *y,double *q,double *w);
extern void dsm3_c(int *n,double *m,double *u,double *e,double *z, \
                    double *y,double *q,double *w);

extern void adc_c(int *n,int *type,int *nbit, int *cc2,int *qn,double *q,double *vmin, \
                  double *of_er, double *fsr_er,double *u,double *y1,double *y2);
extern void adcv_c(int *n,int *type,int *nbit, int *cc2,int *qn,double *q,double *vmin,\
                   double *of_er, double *fsr_er,double *u,double *y1,double *y2);
extern void dac_c(int *n,int *nbit, int *cc2,double *q,double *vmin, \
                  double *u,double *y);
extern void dacv_c(int *n,int *nbit, int *cc2,double *q,double *vmin,\
                   double *u,double *y);

extern void calc_win_c(int *n,int *wtyp,double *param,double *y);

extern void filter_tap_c(int *n,int *typ,int *ne,double *param,double *y);

extern void corr_c(int *n,int *m,int *typ,int *lag,double *mean_u1,double *mean_u2,\
                   double *u1,double *u2,double *y);
extern void corri_c(int *n,int *m,int *typ,int *lag,double *mean_u1,double *mean_u2,\
                    int *u1,int *u2,double *y);

extern void rnoise_c(int *n,int *m,double *sig,double *y);

extern void perrdsm_c(int *n,int *m,int *M,int *K, \
                      int *i,int *j,int *u,int *y);
extern void perrdsmy_c(int *n,int *m,int *M,int *K, \
                       long long int *i,long long int *j,int *u,int *y);
extern void perrdsmz_c(int *n,int *m,long long int *i,long long int *j,int *u);


extern int calc_fft_c(fft_pr_struct *fft_pr,double *r_i,double *i_i);

extern void pspect_c(int sec_l,int n_sec,fft_pr_struct *fft_pr, \
                     int *n_call,double *win,double *r_io,double*i_io,double *r_out);

extern void dec2bindd_c(int *nu,int *M,int *msb,int *sig,double *u,double *y);
extern void dec2bindi_c(int *nu,int *M,int *msb,int *sig,double *u,int *y);
extern void dec2binid_c(int *nu,int *M,int *msb,int *sig,int *u,double *y);
extern void dec2binii_c(int *nu,int *M,int *msb,int *sig,int *u,int *y);

extern void bin2decdd_c(int *nu,int *M,int *msb,int *sig,double *u,double *y);
extern void bin2decdi_c(int *nu,int *M,int *msb,int *sig,double *u,int *y);
extern void bin2decid_c(int *nu,int *M,int *msb,int *sig,int *u,double *y);
extern void bin2decii_c(int *nu,int *M,int *msb,int *sig,int *u,int *y);


extern void tf2ss_c(int *index,int *typ,double *num,double *den,double *A,double *B,double *C,double *D);

/* adding a modnum prefix to entry names to avoid clash */

#define awgn modnum_awgn
#define codinservec modnum_codinservec
#define decodvec modnum_decodvec
#define demodgen modnum_demodgen
#define demodpsk modnum_demodpsk
#define demodqam modnum_demodqam
#define modgen modnum_modgen
#define modpsk modnum_modpsk
#define modqam modnum_modqam
#define mpskrec modnum_mpskrec
#define teb2 modnum_teb2
#define teb modnum_teb
#define modiq modnum_modiq
#define demodiq modnum_demodiq

#define com_filter modnum_com_filter
#define int_symb modnum_int_symb
#define int_symbz modnum_int_symbz
#define nfilter modnum_nfilter
#define adder_c modnum_adder_c

#define bin2dec modnum_bin2dec
#define dec2bin modnum_dec2bin

#define adc modnum_adc
#define comp modnum_comp
#define dac modnum_dac
#define chuafonc modnum_chuafonc
#define fmodulo modnum_fmodulo
#define fmodulob modnum_fmodulob
#define fmoduloc modnum_fmoduloc
#define imodulo modnum_imodulo
#define imodulob modnum_imodulob
#define lcmodulo modnum_lcmodulo
#define logistique modnum_logistique
#define systemg modnum_systemg
#define systemh modnum_systemh
#define tanhblk modnum_tanhblk

#define mash modnum_mash
#define surecht modnum_surecht
#define time modnum_time
#define vco modnum_vco
#define destockbit modnum_destockbit
#define int_euler_m modnum_int_euler_m
#define int_trap_m modnum_int_trap_m
#define stockbit modnum_stockbit
#define stockbits modnum_stockbits
#define z_buf modnum_z_buf
#define z_buft modnum_z_buft

#define complex_test modnum_complex_test
#define gainblk2 modnum_gainblk2
#define multport modnum_multport
#define cpf modnum_cpf
#define cpft modnum_cpft
#define perrdsm modnum_perrdsm
#define pfd modnum_pfd
#define pfdt modnum_pfdt
#define pfdt_c modnum_pfdt_c
#define pompecharge modnum_pompecharge
#define sdblk modnum_sdblk
#define vcoblk modnum_vcoblk
#define vcoevt modnum_vcoevt
#define vcoz modnum_vcoz
#define convol modnum_convol
#define corrblk modnum_corrblk
#define fftcmplx modnum_fftcmplx
#define inserzerovec modnum_inserzerovec
#define overlap modnum_overlap
#define overlaprsr modnum_overlaprsr
#define sousecht modnum_sousecht
#define upsmplblk modnum_upsmplblk
#define eye_scope modnum_eye_scope
#define eyeview_draw modnum_eyeview_draw
#define pspec_scope modnum_pspec_scope
#define specview_draw modnum_specview_draw
#define pspec_scope modnum_pspec_scope
#define specview_draw modnum_specview_draw
#define sci_buf modnum_sci_buf
#define sci_buft modnum_sci_buft
#define vectorscope41 modnum_vectorscope41
#define vectorscope_draw modnum_vectorscope_draw
#define vectorscopexy41 modnum_vectorscopexy41
#define vectorscopexy_draw modnum_vectorscopexy_draw
#define z_buf41 modnum_z_buf41
#define z_buft41 modnum_z_buft41
#define cpz modnum_cpz
#define discrgen modnum_discrgen
#define dtime modnum_dtime
#define gencw modnum_gencw
#define gengold modnum_gengold
#define genint modnum_genint
#define genintc modnum_genintc
#define genmllsrs modnum_genmllsrs
#define gensymb modnum_gensymb
#define noiseblk modnum_noiseblk
#define noiseraylblk modnum_noiseraylblk
#define pevtdly modnum_pevtdly
#define pevtdly_c modnum_pevtdly_c
#define pevtdlyz_c modnum_pevtdlyz_c
#define z_gen modnum_z_gen
#define binaccu modnum_binaccu
#define binreg modnum_binreg
#define dollar2 modnum_dollar2
#define vectmultcmplx modnum_vectmultcmplx

#define bidonb modnum_bidonb
#define surechfft modnum_surechfft
#define memoscope modnum_memoscope
#define scopxyz modnum_scopxyz
#define scoxyvec modnum_scoxyvec
#define vectomemoscope modnum_vectomemoscope
#define vectorscope modnum_vectorscope
#define cclck modnum_cclck
#define genpulse modnum_genpulse
#define ref_noise modnum_ref_noise
#define convps modnum_convps
#define convsp modnum_convsp
#define diva modnum_diva
#define diviseur modnum_diviseur
#define divprogr modnum_divprogr
#define intblk modnum_intblk
#define ndelay modnum_ndelay
#define nintegr modnum_nintegr
#define int_euler modnum_int_euler
#define int_trap modnum_int_trap
#define can modnum_can
#define cna modnum_cna


#endif /* MODNUM_LIB_H */
