/* overlaprsr_c subroutine
 * Vectorial Right Shift Register
 * with memory word
 *
 * Copyright (C) 2007-2015 Alan Layec
 *
 * This file is part of modnumlib.
 *
 * modnumlib is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * modnumlib is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with modnumlib; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */

/* REVISION HISTORY :
 * $Log: overlaprsr_c.c,v $
 * Revision 1.1  2016-07-20 14:00:20  jpc
 * updates
 *
 * Revision 1.1  2015-12-25 15:47:58  layec
 * add
 *
 */

#include "modnum_lib.h"

/* overlaprsr_c routine de calcul de dcalage vectoriel  droite avec
 * mot mmoire
 *
 * Entres :
 * n : taille du vecteur
 * m : longueur du dcalage (taille du mot mmoire)
 * u : adresse de dpart du vecteur d'entre
 * Sorties :
 * y : adresse de dpart du vecteur de sortie
 * Entre/Sortie :
 * z : adresse de dpart du vecteur mmoire
 */

void overlaprsr_c(int *n,int *m,double *u,double *y,double *z)
{
 /*Dclaration des variables compteurs*/
 int i;

 for(i=0;i<(*m);i++)
 {
    y[i]=z[i];
    z[i]=u[((*n)-(*m))+i];
 }
 for(i=(*m);i<(*n);i++) y[i]=u[i-(*m)];

 return;
}
