// This is the builder.sce 
// must be run from this directory 

// the part devoted to shared lib generation 

ilib_name  = 'libintmodnum' 		// interface library name 
files = ['intmodnum_lib.o']; // objects files (but do not give mexfiles here)

// other libs needed for linking (must be shared library names)

libs  = [];

// table of (scilab_name,interface-name or mexfile-name, type) 

table =["genint","int_modnum_genint_c";
	"genrayl","int_modnum_genrayl_c";
	"upsmpl","int_modnum_surecht_c";
	"downsmpl","int_modnum_sousecht_c";
	"modpsk","int_modnum_modpsk_c";
	"demodpsk","int_modnum_demodpsk_c";
	"modqam","int_modnum_modqam_c";
	"demodqam","int_modnum_demodqam_c";
	"gengold","int_modnum_gengold_c";
	"genpn","int_modnum_genpn_c";
	"spread","int_modnum_spread_c";
	"despread","int_modnum_despread_c";
	"nfilter","int_modnum_nfilter_c";
	"awgn","int_modnum_awgn_c";
	"intsym","int_modnum_intsym_c";
	"calc_fft","int_modnum_calc_fft_c";
	"modnum_tf2ss","int_modnum_tf2ss_c"];

ldflags = "../libmodnum/libmodnum.la"

if %win32 then 
  msvc = msvc_get_compiler();
  if msvc <> "unknown" then 
    ldflags = "../libmodnum/libmodnum.lib" 
  else
    // cross compilation 
    ldflags = "-L../libmodnum -lmodnum"
  end
end

cflags="-I../libmodnum -DWITH_NSPSRC";

// do not modify below 
// ----------------------------------------------
ilib_build(ilib_name,table,files,libs,cflags=cflags,ldflags=ldflags)



