/* Modnumlib Scicos interfacing function
 * Copyright (C) 2009-2016 Alan Layec
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <scicos/scicos_block.h>
#include <nsp/math.h>
#include <nsp/cnumeric.h>
#include <modnum_lib.h>

static int c__2 = 2;

/*    cna.f Digital to Analog Convertor 
 *    IRCOM Group - A. Layec 
 *    REVISION HISTORY : 
 *    $Log: cna.c,v $
 *    Revision 1.1  2016-07-21 08:19:06  jpc
 *    updates
 * 
 *    Revision 1.1  2015-12-25 15:47:51  layec 
 *    add 
 * 
 * 
 */

int cna(int *flag__, int *nevprt, double *t, double *xd, double *x, int *nx, double *z__, int *nz, double *tvec, int *ntvec, double *rpar, int *nrpar, int *ipar, int *nipar, double *u, int *nu, double *y, int *ny)
{
  int i__1, i__2;
  int i__;

  /* Parameter adjustments */
    --y;
    --u;
    --ipar;
    --rpar;
    --tvec;
    --z__;
    --x;
    --xd;

    /* Function Body */
    i__1 = *nu;
    for (i__ = 1; i__ <= i__1; ++i__) {
      if (ipar[i__ + *nu] == 1) {
	i__2 = ipar[i__] - 1;
	y[i__] = rpar[i__] * (u[i__] + nsp_pow_ii(c__2,i__2)) + rpar[i__ + *nu];
      } else {
	y[i__] = rpar[i__] * u[i__] + rpar[i__ + *nu];
      }
      /* L15: */
    }
    return 0;
}


