/* Modnumlib Scicos interfacing function
 * Copyright (C) 2009-2015 Alan Layec
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
 
/* z_buf Scicos discret memory block
 * Type 4 simulation function ver 1.0 - scilab-3.0
 * 17 janvier 2005 - IRCOM GROUP - Author : A.Layec
 * 29 mars 2007 - INRIA - Author : A.Layec
 *  Rvision
 */

/* REVISION HISTORY :
 * $Log: z_buf.c,v $
 * Revision 1.1  2016-07-20 14:00:21  jpc
 * updates
 *
 * Revision 1.1  2015-12-25 15:47:51  layec
 * add
 *
 */

#include <scicos/scicos_block.h>
#include "modnum_lib.h"


/* Cette fonction de simulation est un buffer
 * qui mmorise la valeur de son entre rgulire
 * dans le vecteur des tats discrets z
 *
 * entre rgulire : u[0..nu-1]
 * sortie rgulire : nant
 * entre vnementielle : Date de dclenchement
 * sortie vnementielle : nant
 *
 * tat discret : z[0..ipar[0]-1] : mot mmoire
 *                z[ipar[0]] : compteur
 * paramtre entier : ipar[0] : taille du mot mmoire
 */

/*prototype*/
void z_buf(scicos_block *block,int flag)
{
 /*dclaration des variables*/
 int i,j;

 /*seulement sur flag 2*/
 if(flag==2)
 {
  /*rcupre valeur du compteur chantillons*/
  j=(int)block->z[block->ipar[0]];

  /*Test valeur compteur chantillons*/
  if (j+block->insz[0]<block->ipar[0]) {
     /*met en mmoire la(les) valeur(s) du port rguliers*/
     for(i=0;i<block->insz[0];i++) {
       block->z[j+i]=block->inptr[0][i];
     }
     /*incrmente compteur chantillons*/
     j=j+block->insz[0];
  }
  else {
    /*met en mmoire  la fin du buffer*/
    for(i=0;i<block->ipar[0]-j;i++) {
      block->z[j+i]=block->inptr[0][i];
    }
    /*met en mmoire au dbut du buffer*/
    for(i=block->ipar[0]-j;i<block->insz[0];i++) {
      block->z[j+i-block->ipar[0]]=block->inptr[0][i];
    }
    /*met  jour compteur chantillons*/
    j=block->insz[0]-block->ipar[0]+j;
  }

  /*mmorise compteur dans z[n+1]*/
  block->z[block->ipar[0]]=j;
 }
}
