/* Modnumlib Scicos interfacing function
 * Copyright (C) 2009-2015 Alan Layec
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
 
/* complex_test : bibliothque utilitaire
 * pour manipuler des nombres complexes
 * IRCOM Group - Alan
 */

/* REVISION HISTORY :
 * $Log: complex_test.c,v $
 * Revision 1.1  2016-07-20 14:00:21  jpc
 * updates
 *
 * Revision 1.1  2015-12-25 15:47:51  layec
 * add
 *
 */

#include <stdio.h>

#include <scicos/scicos_block.h>

typedef struct {double real;double imag;} complex;
typedef struct {double *real;double *imag;int sz;} complex_tab;
typedef struct {double *adr;int sz;} complex_tab2;

double modnum_real(complex myvar){return(myvar.real);}
double modnum_imag(complex myvar){return(myvar.imag);}

complex modnum_cmplx(double real,double imag)
{
  complex myvar;
  myvar.real=real;
  myvar.imag=imag;
  return(myvar);
}

complex modnum_add_cmplx(complex myvar1, complex myvar2)
{
 complex myvar;
 myvar.real=myvar1.real+myvar2.real;
 myvar.imag=myvar1.imag+myvar2.imag;
 return(myvar);
}

complex modnum_mul_cmplx(complex myvar1, complex myvar2)
{
 complex myvar;
 myvar.real=myvar1.real*myvar2.real-myvar1.imag*myvar2.imag;
 myvar.imag=myvar1.real*myvar2.imag+myvar1.imag*myvar2.real;
 return(myvar);
}

complex_tab modnum_cmplx_tab(double *real, double *imag, int sz)
{ 
  complex_tab myvar;
  myvar.real=real;
  myvar.imag=imag;
  myvar.sz=sz;
  return(myvar);
}

void modnum_complex_test(scicos_block *block,int flag)
{
 complex myvar;
 /*complex_tab var;*/

 myvar = modnum_cmplx(block->inptr[0][0],block->inptr[0][1]);
 /*var = cmplx_tab(&block->inptr[0][0],&block->inptr[0][1],1);*/

 if(flag==2)
   {
     
   }
 else if(flag==1)
   {
     block->outptr[0][0] = modnum_real(myvar);
     block->outptr[0][1] = modnum_imag(myvar);
   }
}
