/* Modnumlib Scicos interfacing function
 * Copyright (C) 2009-2015 Alan Layec
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
 
/* d : code utilitaire pour calculer
 * la taille du mot de travail ncessaire  fftmx
 *
 * 25/03/2007 : netoyage du code
 * 18/06/2008 : enleve dependance  f2c
 *
 */

/* REVISION HISTORY :
 * $Log: d.c,v $
 * Revision 1.1  2016-07-20 14:00:21  jpc
 * updates
 *
 * Revision 1.1  2015-12-25 15:47:51  layec
 * add
 *
 */


#define abs(x) ((x) >= 0 ? (x) : -(x))
#define max(a,b) ((a) >= (b) ? (a) : (b))

/* Subroutine d
 *
 * Entre :
 *    n : taille de la tf
 *
 * Sorties :
 *    n_work : taille du tableau de travail
 *    ierr   : numro d'erreur
 */

int modnum_d(int *n, int *n_work, int *ierr)
{
  /* Initialized data */

  /* System generated locals */
  int i__1, i__2, i__3;

  /* Local variables */
  static int j, k, m, jj, kt, kkk, nfac[15], maxf,
    maxp, ntot, nspan, istkgt;
  /*static int nitems;*/

  *ierr = 0;

  /* determine the factors of n */
  m = 0;

  k = abs(*n);
  if ( k == 1) {
    return 0;
  }

  nspan = (i__1 = k , abs(i__1));
  ntot = (i__1 = nspan , abs(i__1));

  if (ntot == 0) {
    *ierr = 1;
    return 0;
  }

  while (k - (k / 16 << 4) == 0) {
    ++m;
    nfac[m - 1] = 4;
    k /= 16;
  }
  j = 3;
  jj = 9;
 L40:
  while (k % jj == 0) {
    ++m;
    nfac[m - 1] = j;
    k /= jj;
  }
  j += 2;
  /* Computing 2nd power */
  jj = j * j;
  if (jj <= k) {
    goto L40;
  }
  if (k > 4) {
    goto L50;
  }
  kt = m;
  nfac[m] = k;
  if (k != 1) {
    ++m;
  }
  goto L90;
 L50:
  if (k - (k / 4 << 2) == 0) {
    ++m;
    nfac[m - 1] = 2;
    k /= 4;
  }
  /* all square factors out now, but k .ge. 5 still */
  kt = m;
  /* Computing MAX */
  i__1 = kt + kt + 2, i__2 = k - 1;
  maxp = max(i__1,i__2);
  j = 2;
 L70:
  if (k % j != 0) {
    goto L80;
  }
  ++m;
  nfac[m - 1] = j;
  k /= j;
 L80:
  j = ((j + 1) / 2 << 1) + 1;
  if (j <= k) {
    goto L70;
  }
 L90:
  if (m <= kt + 1) {
    maxp = m + kt + 1;
  }
  if (m + kt > 15) {
    *ierr = 2;
    return 0;
  }

  if (kt != 0) {
    j = kt;
    ++m;
    nfac[m - 1] = nfac[j - 1];
    --j;
    while (j != 0) {
      ++m;
      nfac[m - 1] = nfac[j - 1];
      --j;
    }
  }

  maxf = m - kt;
  maxf = nfac[maxf - 1];
  if (kt > 0) {
    i__1 = nfac[kt - 1];
    maxf = max(i__1,maxf);
  }

  for (kkk = 1; kkk <= m; ++kkk) {
    /* Computing MAX */
    i__2 = maxf, i__3 = nfac[kkk - 1];
    maxf = max(i__2,i__3);
  }

  /*nitems = maxf << 2;*/
  istkgt = (10 - 1) / 2 + 2;
  *n_work = ((istkgt - 1 + (maxf << 2)) * 2 - 1) + 3;

  /*nitems = maxp; */
  istkgt = ((*n_work) - 1) + 2;
  *n_work = ((istkgt - 1 + maxp) - 1) + 3;

  return 0;
} /* d_ */

