/* Modnumlib Scicos interfacing function
 * Copyright (C) 2009-2015 Alan Layec
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
 
/* dollar2 Scicos Temporal delay
 * Type 4 simulation function ver 1.0 - scilab-3
 * 21 juin 2005 - IRCOM GROUP - Author : A.Layec
 */

/* REVISION HISTORY :
 * $Log: dollar2.c,v $
 * Revision 1.1  2016-07-20 14:00:21  jpc
 * updates
 *
 * Revision 1.1  2015-12-25 15:47:52  layec
 * add
 *
 */

#include <stdio.h>

#include <scicos/scicos_block.h>
#include "modnum_lib.h"
/*prototype*/
void dollar2(scicos_block *block,int flag)
{
  /*dclaration des variables*/
  double *y;
  double *u;
  double t;
  int i,j,nu,nc;
  /*rcupration des adresses des ports*/
  y=(double *)block->outptr[0];
  u=(double *)block->inptr[0];

  /*rcupration des paramtres*/
  nu=block->nz-2;
  nc=block->ipar[0]; /*nb chip*/

  /*rcupre valeur compteur emetteur*/
  i=(int)block->z[nu];
  j=(int)block->z[nu+1];

  t=get_scicos_time();
  fprintf(stderr,"z: nu=%d,flag=%d,nc=%d,t=%f,i=%d,j=%d,nz=%d\n",nu,flag,block->ipar[0],t,i,j,block->nz);

  if(flag==1)
  {
   y[0]=block->z[i];
  }
  else if(flag==2)
  {
   block->z[i]=u[0];
   block->z[nu+1]++;
   if(block->z[nu+1]>=nc)
   {
    block->z[nu+1]=0;
    block->z[nu]++;
    if(block->z[nu]>=nu) block->z[nu]=0;
   }
  }
}
