#ifndef CALPACK_H 
#define CALPACK_H 

#include "nsp/object.h" 
#include "nsp/blas.h" 
#include "nsp/lapack-c.h" 
#include "nsp/cnumeric.h" 
#include "nsp/matutil.h" 

#define U_fp void *
#define intg_f void *
#define S_fp void *


extern double nsp_calpack_arcosh(double *x);
extern double nsp_calpack_arsinh(double *x);
extern int nsp_calpack_calerf(double *arg, double *result, int *jint);
extern double nsp_calpack_derff(double *x);
extern double nsp_calpack_derfcf(double *x);
extern double nsp_calpack_derfcx(double *x);
extern int nsp_calpack_dprxc (int *n, double *roots, double *coeff);
extern int nsp_calpack_ccopy(int *n, char *dx, int *incx, char *dy, int *incy, long int dx_len, long int dy_len);
extern double nsp_calpack_coshin(double *x);
extern int nsp_calpack_cshep2(int *n, double *x, double *y, double *f, int *nc, int *nw, int *nr, int *lcell, int *lnext, double *xmin, double *ymin, double *dx, double *dy, double *rmax, double *rw, double *a, int *ier);
extern double nsp_calpack_cs2val(double *px, double *py, int *n, double *x, double *y, double *f, int *nr, int *lcell, int *lnext, double *xmin, double *ymin, double *dx, double *dy, double *rmax, double *rw, double *a);
extern int nsp_calpack_cs2grd(double *px, double *py, int *n, double *x, double *y, double *f, int *nr, int *lcell, int *lnext, double *xmin, double *ymin, double *dx, double *dy, double *rmax, double *rw, double *a, double *c__, double *cx, double *cy, int *ier);
extern int nsp_calpack_cs2hes(double *px, double *py, int *n, double *x, double *y, double *f, int *nr, int *lcell, int *lnext, double *xmin, double *ymin, double *dx, double *dy, double *rmax, double *rw, double *a, double *c__, double *cx, double *cy, double *cxx, double *cxy, double *cyy, int *ier);
extern int nsp_calpack_getnp2(double *px, double *py, double *x, double *y, int *nr, int *lcell, int *lnext, double *xmin, double *ymin, double *dx, double *dy, int *np, double *dsq);
extern int nsp_calpack_givens(double *a, double *b, double *c__, double *s);
extern int nsp_calpack_rotate(int *n, double *c__, double *s, double *x, double *y);
extern int nsp_calpack_setup2(double *xk, double *yk, double *zk, double *xi, double *yi, double *zi, double *s1, double *s2, double *s3, double *r__, double *row);
extern int nsp_calpack_store2(int *n, double *x, double *y, int *nr, int *lcell, int *lnext, double *xmin, double *ymin, double *dx, double *dy, int *ier);
extern int nsp_calpack_cuproi(int *n, double *wr, double *wi);
extern int nsp_calpack_cupro(int *n, double *w);
extern int nsp_calpack_cusum(int *n, double *w);
extern double nsp_calpack_d1mach(int *i__);
extern int nsp_calpack_d9b0mp(double *x, double *ampl, double *theta);
extern int nsp_calpack_d9b1mp(double *x, double *ampl, double *theta);
extern int nsp_calpack_d9knus(double *xnu, double *x, double *bknu, double *bknu1, int *iswtch);
extern double nsp_calpack_d9lgmc(double *x);
extern int nsp_calpack_dadd(int *n, double *dx, int *incx, double *dy, int *incy);
extern int nsp_calpack_dad(double *a, int *na, int *i1, int *i2, int *j1, int *j2, double *r__, int *isw);
extern int nsp_calpack_dasyik(double *x, double *fnu, int *kode, double *flgik, double *ra, double *arg, int *in, double *y);
extern int nsp_calpack_dasyjy(S_fp funjy, double *x, double *fnu, double *flgjy, int *in, double *y, double *wk, int *iflw);
extern int nsp_calpack_dbdiff(int *l, double *v);
extern double nsp_calpack_dbesi0(double *x);
extern double nsp_calpack_dbesi1(double *x);
extern int nsp_calpack_dbesig(double *x1, double *alpha, int *kode, int *n, double *y, int *nz, double *w, int *ierr);
extern int nsp_calpack_dbesiv(double *x, int *nx, double *alpha, int *na, int *kode, double *y, double *w, int *ierr);
extern int nsp_calpack_dbesi(double *x, double *alpha, int *kode, int *n, double *y, int *nz, int *ierr);
extern double nsp_calpack_dbesj0(double *x);
extern double nsp_calpack_dbesj1(double *x);
extern int nsp_calpack_dbesjg(double *x1, double *alpha, int *n, double *y, int *nz, double *w, int *ierr);
extern int nsp_calpack_dbesjv(double *x, int *nx, double *alpha, int *na, int *kode, double *y, double *w, int *ierr);
extern int nsp_calpack_dbesj(double *x, double *alpha, int *n, double *y, int *nz, int *ierr);
extern double nsp_calpack_dbesk0(double *x);
extern double nsp_calpack_dbesk1(double *x);
extern int nsp_calpack_dbeskg(double *x1, double *alpha, int *kode, int *n, double *y, int *nz, int *ierr);
extern int nsp_calpack_dbeskv(double *x, int *nx, double *alpha, int *na, int *kode, double *y, double *w, int *ierr);
extern int nsp_calpack_dbesk(double *x, double *fnu, int *kode, int *n, double *y, int *nz, int *ierr);
extern int nsp_calpack_dbesks(double *xnu, double *x, int *nin, double *bk);
extern double nsp_calpack_dbesy0(double *x);
extern double nsp_calpack_dbesy1(double *x);
extern int nsp_calpack_dbesyg(double *x1, double *alpha, int *n, double *y, int *nz, double *w, int *ierr);
extern int nsp_calpack_dbesyv(double *x, int *nx, double *alpha, int *na, int *kode, double *y, double *w, int *ierr);
extern int nsp_calpack_dbesy(double *x, double *fnu, int *n, double *y, int *ierr);
extern int nsp_calpack_dbkias(double *x, int *n, int *ktrms, double *t, double *ans, int *ind, int *ms, double *gmrn, double *h__, int *ierr);
extern int nsp_calpack_dbkisr(double *x, int *n, double *sum, int *ierr);
extern double nsp_calpack_dbsi0e(double *x);
extern double nsp_calpack_dbsi1e(double *x);
extern double nsp_calpack_dbsk0e(double *x);
extern double nsp_calpack_dbsk1e(double *x);
extern int nsp_calpack_dbskes(double *xnu, double *x, int *nin, double *bke);
extern int nsp_calpack_dbskin(double *x, int *n, int *kode, int *m, double *y, int *nz, int *ierr);
extern int nsp_calpack_dbsknu(double *x, double *fnu, int *kode, int *n, double *y, int *nz);
extern int nsp_calpack_dbsynu(double *x, double *fnu, int *n, double *y);
extern double nsp_calpack_dcabs1(doubleC *z__);
extern double nsp_calpack_dcsevl(double *x, double *cs, int *n);
extern int nsp_calpack_ddif(int *n, double *a, int *na, double *b, int *nb);
extern int nsp_calpack_ddpow1(int *n, double *v, int *iv, double *p, int *ip, double *rr, double *ri, int *ir, int *ierr, int *iscmpl);
extern int nsp_calpack_ddpowe(double *v, double *p, double *rr, double *ri, int *ierr, int *iscmpl);
extern int nsp_calpack_ddpow(int *n, double *vr, double *vi, int *iv, double *dpow, int *ierr, int *iscmpl);
extern int nsp_calpack_ddrdiv(double *a, int *ia, double *b, int *ib, double *r__, int *ir, int *n, int *ierr);
extern int nsp_calpack_dexint(double *x, int *n, int *kode, int *m, double *tol, double *en, int *nz, int *ierr);
extern int nsp_calpack_dgamlm(double *xmin, double *xmax);
extern double nsp_calpack_dgamln(double *z__, int *ierr);
extern double nsp_calpack_dgamma(double *x);
extern double nsp_calpack_dgamrn(double *x);
extern int nsp_calpack_dhkseq(double *x, int *m, double *h__, int *ierr);
extern int nsp_calpack_dipowe(double *v, int *p, double *r__, int *ierr);
extern int nsp_calpack_dipow(int *n, double *v, int *iv, int *ipow, int *ierr);
extern int nsp_calpack_djairy(double *x, double *rx, double *c__, double *ai, double *dai);
extern int nsp_calpack_dlblks(char *name__, int *nbc, long int name_len);
extern double nsp_calpack_dlgama(double *x);
extern double nsp_calpack_dlngam(double *x);
extern int nsp_calpack_dmcopy(double *a, int *na, double *b, int *nb, int *m, int *n);
extern int nsp_calpack_dmmul1(double *a, int *na, double *b, int *nb, double *c__, int *nc, int *l, int *m, int *n);
extern int nsp_calpack_dmmul(double *a, int *na, double *b, int *nb, double *c__, int *nc, int *l, int *m, int *n);
extern int nsp_calpack_dmprod(int *flag__, double *a, int *na, int *m, int *n, double *v, int *nv);
extern int nsp_calpack_dmsum(int *flag__, double *a, int *na, int *m, int *n, double *v, int *nv);
extern double nsp_calpack_dpsixn(int *n);
extern int nsp_calpack_drdiv(double *a, int *ia, double *b, int *ib, double *r__, int *ir, int *n, int *ierr);
extern int nsp_calpack_dsearchc(double *x, int *m, double *val, int *n, int *indx, int *occ, int *info);
extern int nsp_calpack_dsearchd(double *x, int *m, double *val, int *n, int *indx, int *occ, int *info);
extern int nsp_calpack_dset(int *n, double *dx, double *dy, int *incy);
extern int nsp_calpack_dsort(double *count, int *n, int *index);
extern int nsp_calpack_spfit(double *x, double *y, double *wgt, int *m, double *break__, int *l, double *z__, double *a, double *wk, int *ierr);
extern int nsp_calpack_bslsq(double *tau, double *gtau, double *wgt, int *ntau, double *t, int *n, int *k, double *a, double *wk, double *q, int *ierr);
extern int nsp_calpack_bchfac(double *w, int *nb, int *n, double *diag, int *iflag);
extern int nsp_calpack_bchslv(double *w, int *nb, int *n, double *b);
extern int nsp_calpack_bspvb(double *t, int *k, int *jhigh, int *j, double *x, int *left, double *blist);
extern int nsp_calpack_bspp(double *t, double *a, int *n, int *k, double *break__, double *c__, int *l, double *wk);
extern double nsp_calpack_dsum(int *n, double *dx, int *incx);
extern double nsp_calpack_dbvalu(double *t, double *a, int *n, int *k, int *ideriv, double *x, int *inbv, double *work);
extern int nsp_calpack_dintrv(double *xt, int *lxt, double *x, int *ilo, int *ileft, int *mflag);
extern int nsp_calpack_dbknot(double *x, int *n, int *k, double *t);
extern int nsp_calpack_dbtpcf(double *x, int *n, double *fcn, int *ldf, int *nf, double *t, int *k, double *bcoef, double *work);
extern int nsp_calpack_dbintk(double *x, double *y, double *t, int *n, int *k, double *bcoef, double *q, double *work);
extern int nsp_calpack_dbnfac(double *w, int *nroww, int *nrow, int *nbandl, int *nbandu, int *iflag);
extern int nsp_calpack_dbnslv(double *w, int *nroww, int *nrow, int *nbandl, int *nbandu, double *b);
extern int nsp_calpack_dbspvn(double *t, int *jhigh, int *k, int *index, double *x, int *ileft, double *vnikx, double *work, int *iwork);
extern double nsp_calpack_db3val(double *xval, double *yval, double *zval, int *idx, int *idy, int *idz, double *tx, double *ty, double *tz, int *nx, int *ny, int *nz, int *kx, int *ky, int *kz, double *bcoef, double *work);
extern int nsp_calpack_db3ink(double *x, int *nx, double *y, int *ny, double *z__, int *nz, double *fcn, int *ldf1, int *ldf2, int *kx, int *ky, int *kz, double *tx, double *ty, double *tz, double *bcoef, double *work, int *iflag);
extern int nsp_calpack_dtild(int *n, double *x, int *incx);
extern int nsp_calpack_dvmul(int *n, double *dx, int *incx, double *dy, int *incy);
extern int nsp_calpack_dwdiv(double *ar, double *br, double *bi, double *cr, double *ci, int *ierr);
extern int nsp_calpack_dwpow1(int *n, double *v, int *iv, double *pr, double *pi, int *ip, double *rr, double *ri, int *ir, int *ierr);
extern int nsp_calpack_dwpowe(double *v, double *pr, double *pi, double *rr, double *ri, int *ierr);
extern int nsp_calpack_dwpow(int *n, double *vr, double *vi, int *iv, double *powr, double *powi, int *ierr);
extern int nsp_calpack_dwrdiv(double *ar, int *ia, double *br, double *bi, int *ib, double *rr, double *ri, int *ir, int *n, int *ierr);
extern int nsp_calpack_dxlegf(double *dnu1, int *nudiff, int *mu1, int *mu2, double *x, int *id, double *pqa, int *ipqa, int *ierror);
extern int nsp_calpack_dxpmu(double *nu1, double *nu2, int *mu1, int *mu2, double *x, double *sx, int *id, double *pqa, int *ipqa, int *ierror);
extern int nsp_calpack_dxpmup(double *nu1, double *nu2, int *mu1, int *mu2, double *pqa, int *ipqa, int *ierror);
extern int nsp_calpack_dxpnrm(double *nu1, double *nu2, int *mu1, int *mu2, double *pqa, int *ipqa, int *ierror);
extern int nsp_calpack_dxpqnu(double *nu1, double *nu2, int *mu, double *x, double *sx, int *id, double *pqa, int *ipqa, int *ierror);
extern double nsp_calpack_dxpsi(double *a, int *ipsik, int *ipsix);
extern int nsp_calpack_dxqmu(double *nu1, double *nu2, int *mu1, int *mu2, double *x, double *sx, int *id, double *pqa, int *ipqa, int *ierror);
extern int nsp_calpack_dxqnu(double *nu1, double *nu2, int *mu1, double *x, double *sx, int *id, double *pqa, int *ipqa, int *ierror);
extern int nsp_calpack_dxred(double *x, int *ix, int *ierror);
extern int nsp_calpack_dxset(int *irad, int *nradpl, double *dzero, int *nbits, int *ierror);
extern int nsp_calpack_dxadd(double *x, int *ix, double *y, int *iy, double *z__, int *iz, int *ierror);
extern int nsp_calpack_dxadj(double *x, int *ix, int *ierror);
extern int nsp_calpack_dyairy(double *x, double *rx, double *c__, double *bi, double *dbi);
extern int nsp_calpack_entier(int *n, double *d__, int *s);
extern int nsp_calpack_fdump(void);
extern int nsp_calpack_franck(double *a, int *na, int *n, int *job);
extern double nsp_calpack_dgammacody(double *x);
extern int nsp_calpack_gdcp2i(int *n, int *itab, int *m);
extern int nsp_calpack_hilber(double *a, int *lda, int *n);
extern int nsp_calpack_i1mach(int *i__);
extern int nsp_calpack_icopy(int *n, int *dx, int *incx, int *dy, int *incy);
extern int nsp_calpack_idmax(int *n, double *x, int *incx);
extern int nsp_calpack_idmin(int *n, double *x, int *incx);
extern int nsp_calpack_imcopy(int *a, int *na, int *b, int *nb, int *m, int *n);
extern double nsp_calpack_infinity(double *x);
extern int nsp_calpack_initds(double *os, int *nos, double *eta);
extern int nsp_calpack_int2db(int *n, int *dx, int *incx, double *dy, int *incy);
extern int nsp_calpack_intp(double *x, double *xd, double *yd, int *n, int *nc, double *y);
extern int nsp_calpack_iset(int *n, int *dx, int *dy, int *incy);
extern int nsp_calpack_isort(int *count, int *n, int *index);
extern int nsp_calpack_isova0(double *a, int *lda, int *m, int *n, double *path, int *kpath, int *ir, int *ic, int *dir, int *pend, int *h__, int *v, double *c__);
extern int nsp_calpack_isoval(double *a, int *lda, int *m, int *n, double *c__, double *path, int *npath, int *maxp, int *ierr, int *iw, int *job);
extern int nsp_calpack_ivimp(int *i1, int *i2, int *pas, int *iv);
extern int nsp_calpack_iwamax(int *n, double *xr, double *xi, int *incx);
extern int nsp_calpack_j4save(int *iwhich, int *ivalue, int *iset);
extern int nsp_calpack_kronc(double *ar, double *ai, int *ia, int *ma, int *na, double *br, double *bi, int *ib, int *mb, int *nb, double *pkr, double *pki, int *ik);
extern int nsp_calpack_kronr(double *a, int *ia, int *ma, int *na, double *b, int *ib, int *mb, int *nb, double *pk, int *ik);
extern int nsp_calpack_lnblnk(char *str, long int str_len);
extern int nsp_calpack_magic(double *a, int *lda, int *n);
extern int nsp_calpack_mtran(double *a, int *na, double *b, int *nb, int *m, int *n);
extern double nsp_calpack_nearfloat(double *x, double *dir);
extern int nsp_calpack_dpchim(int *n, double *x, double *f, double *d__, int *incfd);
extern double nsp_calpack_dpchst(double *arg1, double *arg2);
extern double nsp_calpack_psi(double *xx);
extern double nsp_calpack_pythag(double *a, double *b);
extern int nsp_calpack_rat (double x, double eps, int *n, int *d);
extern int nsp_calpack_rcopy(int *n, double *dx, int *incx, double *dy, int *incy);
extern int nsp_calpack_rcsort(intg_f test, int *isz, int *iptr, int *iv, int *n, int *index);
extern int nsp_calpack_rea2db(int *n, double *dx, int *incx, double *dy, int *incy);
extern int nsp_calpack_ribesl(double *x, double *alpha, int *nb, int *ize, double *b, int *ncalc);
extern int nsp_calpack_rjbesl(double *x, double *alpha, int *nb, double *b, int *ncalc);
extern int nsp_calpack_rkbesl(double *x, double *alpha, int *nb, int *ize, double *bk, int *ncalc);
extern double nsp_calpack_sciround(double *x1);
extern int nsp_calpack_rybesl(double *x, double *alpha, int *nb, double *by, int *ncalc);
extern int nsp_calpack_scidcopy(int *n, double *dx, int *incx, double *dy, int *incy);
extern int nsp_calpack_simple(int *n, double *d__, double *s);
extern int nsp_calpack_splinecub(double *x, double *y, double *d__, int *n, int *type__, double *a_d__, double *a_sd__, double *qdy, double *lll);
extern int nsp_calpack_tridiagldltsolve(double *d__, double *l, double *b, int *n);
extern int nsp_calpack_cyclictridiagldltsolve(double *d__, double *lsd, double *lll, double *b, int *n);
extern int nsp_calpack_isearch(double *t, double *x, int *n);
extern int nsp_calpack_evalpwhermite(double *t, double *st, double *dst, double *d2st, double *d3st, int *m, double *x, double *y, double *d__, int *n, int *outmode);
extern int nsp_calpack_evalhermite(double *t, double *xa, double *xb, double *ya, double *yb, double *da, double *db, double *h__, double *dh, double *ddh, double *dddh, int *i__);
extern int fast_int_search_nsp_calpack_(double *xx, double *x, int *nx, int *i__);
extern int coord_by_periodicity_nsp_calpack_(double *t, double *x, int *n, int *i__);
extern int near_grid_point_nsp_calpack_(double *xx, double *x, int *nx, int *i__);
extern int near_interval_nsp_calpack_(double *xx, double *x, int *nx, int *i__);
extern int proj_by_per_nsp_calpack_(double *t, double *xmin, double *xmax);
extern int proj_on_grid_nsp_calpack_(double *xx, double *xmin, double *xmax);
extern double return_a_nan_nsp_calpack_(void);
extern int nsp_calpack_bicubicsubspline(double *x, double *y, double *u, int *nx, int *ny, double *c__, double *p, double *q, double *r__, int *type__);
extern int nsp_calpack_bicubicspline(double *x, double *y, double *u, int *nx, int *ny, double *c__, double *p, double *q, double *r__, double *a_d__, double *a_sd__, double *d__, double *ll, double *qdu, double *u_temp__, int *type__);
extern int nsp_calpack_derivd(double *x, double *u, double *du, int *n, int *inc, int *type__);
extern int coef_bicubic_nsp_calpack_(double *u, double *p, double *q, double *r__, double *x, double *y, int *nx, int *ny, double *c__);
extern double nsp_calpack_evalbicubic(double *xx, double *yy, double *xk, double *yk, double *ck);
extern int evalbicubic_with_grad_nsp_calpack_(double *xx, double *yy, double *xk, double *yk, double *ck, double *u, double *dudx, double *dudy);
extern int evalbicubic_with_grad_and_hes_nsp_calpack_(double *xx, double *yy, double *xk, double *yk, double *ck, double *u, double *dudx, double *dudy, double *d2udx2, double *d2udxy, double *d2udy2);
extern int nsp_calpack_bicubicinterp(double *x, double *y, double *c__, int *nx, int *ny, double *x_eval__, double *y_eval__, double *z_eval__, int *m, int *outmode);
extern int nsp_calpack_bicubicinterpwithgrad(double *x, double *y, double *c__, int *nx, int *ny, double *x_eval__, double *y_eval__, double *z_eval__, double *dzdx_eval__, double *dzdy_eval__, int *m, int *outmode);
extern int nsp_calpack_bicubicinterpwithgradandhes(double *x, double *y, double *c__, int *nx, int *ny, double *x_eval__, double *y_eval__, double *z_eval__, double *dzdx_eval__, double *dzdy_eval__, double *d2zdx2_eval__, double *d2zdxy_eval__, double *d2zdy2_eval__, int *m, int *outmode);
extern int nsp_calpack_driverdb3val(double *xp, double *yp, double *zp, double *fp, int *np, double *tx, double *ty, double *tz, int *nx, int *ny, int *nz, int *kx, int *ky, int *kz, double *bcoef, double *work, double *xmin, double *xmax, double *ymin, double *ymax, double *zmin, double *zmax, int *outmode);
extern int nsp_calpack_driverdb3valwithgrad(double *xp, double *yp, double *zp, double *fp, double *dfpdx, double *dfpdy, double *dfpdz, int *np, double *tx, double *ty, double *tz, int *nx, int *ny, int *nz, int *kx, int *ky, int *kz, double *bcoef, double *work, double *xmin, double *xmax, double *ymin, double *ymax, double *zmin, double *zmax, int *outmode);
extern int nsp_calpack_unsfdcopy(int *n, double *dx, int *incx, double *dy, int *incy);
extern double nsp_calpack_urand(int *iy);
extern int nsp_calpack_vpythag(int *n, double *xr, double *xi);
extern int nsp_calpack_wacos(double *zr, double *zi, double *ar, double *ai);
extern int nsp_calpack_wasin(double *zr, double *zi, double *ar, double *ai);
extern double nsp_calpack_wasum(int *n, double *xr, double *xi, int *incx);
extern int nsp_calpack_watan(double *xr, double *xi, double *yr, double *yi);
extern double nsp_calpack_lnp1m1(double *s);
extern double nsp_calpack_logp1(double *x);
extern int nsp_calpack_waxpy(int *n, double *sr, double *si, double *xr, double *xi, int *incx, double *yr, double *yi, int *incy);
extern int nsp_calpack_wcopy(int *n, double *dxr, double *dxi, int *incx, double *dyr, double *dyi, int *incy);
extern int nsp_calpack_wddiv(double *ar, double *ai, double *br, double *cr, double *ci, int *ierr);
extern int nsp_calpack_wdiv(double *ar, double *ai, double *br, double *bi, double *cr, double *ci);
extern double nsp_calpack_wdotci(int *n, double *xr, double *xi, int *incx, double *yr, double *yi, int *incy);
extern double nsp_calpack_wdotcr(int *n, double *xr, double *xi, int *incx, double *yr, double *yi, int *incy);
extern int nsp_calpack_wdpow1(int *n, double *vr, double *vi, int *iv, double *p, int *ip, double *rr, double *ri, int *ir, int *ierr);
extern int nsp_calpack_wdpowe(double *vr, double *vi, double *p, double *rr, double *ri, int *ierr);
extern int nsp_calpack_wdpow(int *n, double *vr, double *vi, int *iv, double *dpow, int *ierr);
extern int nsp_calpack_wdrdiv(double *ar, double *ai, int *ia, double *br, int *ib, double *rr, double *ri, int *ir, int *n, int *ierr);
extern int nsp_calpack_wipowe(double *vr, double *vi, int *p, double *rr, double *ri, int *ierr);
extern int nsp_calpack_wipow(int *n, double *vr, double *vi, int *iv, int *ipow, int *ierr);
extern int nsp_calpack_wlog(double *xr, double *xi, double *yr, double *yi);
extern int nsp_calpack_wmmul(double *ar, double *ai, int *na, double *br, double *bi, int *nb, double *cr, double *ci, int *nc, int *l, int *m, int *n);
extern int nsp_calpack_wmprod(int *flag__, double *ar, double *ai, int *na, int *m, int *n, double *vr, double *vi, int *nv);
extern int nsp_calpack_wmsum(int *flag__, double *ar, double *ai, int *na, int *m, int *n, double *vr, double *vi, int *nv);
extern int nsp_calpack_wmul(double *ar, double *ai, double *br, double *bi, double *cr, double *ci);
extern double nsp_calpack_wnrm2(int *n, double *xr, double *xi, int *incx);
extern int nsp_calpack_wprxc (int *n, double *rootr, double *rooti, double *coeffr,
		   double *coeffi);
extern int nsp_calpack_wrscal(int *n, double *s, double *xr, double *xi, int *incx);
extern int nsp_calpack_wscal(int *n, double *sr, double *si, double *xr, double *xi, int *incx);
extern int nsp_calpack_wsign(double *xr, double *xi, double *yr, double *yi, double *zr, double *zi);
extern int nsp_calpack_wsort(double *countr, double *counti, int *n, int *index, intg_f test);
extern int nsp_calpack_rptest(double *r1, double *i1, double *r2, double *i2);
extern int nsp_calpack_modtest(double *r1, double *i1, double *r2, double *i2);
extern int nsp_calpack_wsqrt(double *xr, double *xi, double *yr, double *yi);
extern int nsp_calpack_wswap(int *n, double *xr, double *xi, int *incx, double *yr, double *yi, int *incy);
extern int nsp_calpack_wtan(double *xr, double *xi, double *yr, double *yi);
extern int nsp_calpack_wvmul(int *n, double *dxr, double *dxi, int *incx, double *dyr, double *dyi, int *incy);
extern int nsp_calpack_wwdiv(double *ar, double *ai, double *br, double *bi, double *cr, double *ci, int *ierr);
extern int nsp_calpack_wwpow1(int *n, double *vr, double *vi, int *iv, double *pr, double *pi, int *ip, double *rr, double *ri, int *ir, int *ierr);
extern int nsp_calpack_wwpowe(double *vr, double *vi, double *pr, double *pi, double *rr, double *ri, int *ierr);
extern int nsp_calpack_wwpow(int *n, double *vr, double *vi, int *iv, double *powr, double *powi, int *ierr);
extern int nsp_calpack_wwrdiv(double *ar, double *ai, int *ia, double *br, double *bi, int *ib, double *rr, double *ri, int *ir, int *n, int *ierr);
extern int nsp_calpack_xercnt(char *librar, char *subrou, char *messg, int *nerr, int *level, int *kontrl, long int librar_len, long int subrou_len, long int messg_len);
extern int nsp_calpack_xermsg(char *librar, char *subrou, char *messg, int *nerr, int *level, long int librar_len, long int subrou_len, long int messg_len);
extern int nsp_calpack_xerprn(char *prefix, int *npref, char *messg, int *nwrap, long int prefix_len, long int messg_len);
extern int nsp_calpack_xersve(char *librar, char *subrou, char *messg, int *kflag, int *nerr, int *level, int *icount, long int librar_len, long int subrou_len, long int messg_len);
extern int nsp_calpack_xgetua(int *iunita, int *n);
extern double nsp_calpack_zabs(double *zr, double *zi);
extern int nsp_calpack_zacai(double *zr, double *zi, double *fnu, int *kode, int *mr, int *n, double *yr, double *yi, int *nz, double *rl, double *tol, double *elim, double *alim);
extern int nsp_calpack_zacon(double *zr, double *zi, double *fnu, int *kode, int *mr, int *n, double *yr, double *yi, int *nz, double *rl, double *fnul, double *tol, double *elim, double *alim);
extern int nsp_calpack_zairy(double *zr, double *zi, int *id, int *kode, double *air, double *aii, int *nz, int *ierr);
extern int nsp_calpack_zasyi(double *zr, double *zi, double *fnu, int *kode, int *n, double *yr, double *yi, int *nz, double *rl, double *tol, double *elim, double *alim);
extern int nsp_calpack_zbeshg(double *x1r, double *x1i, double *alpha, int *kode, int *k, int *n, double *yr, double *yi, int *nz, double *wr, double *wi, int *ierr);
extern int nsp_calpack_zbeshv(double *xr, double *xi, int *nx, double *alpha, int *na, int *kode, int *k, double *yr, double *yi, double *wr, double *wi, int *ierr);
extern int nsp_calpack_zbesh(double *zr, double *zi, double *fnu, int *kode, int *m, int *n, double *cyr, double *cyi, int *nz, int *ierr);
extern int nsp_calpack_zbesig(double *x1r, double *x1i, double *alpha, int *kode, int *n, double *yr, double *yi, int *nz, double *wr, double *wi, int *ierr);
extern int nsp_calpack_zbesiv(double *xr, double *xi, int *nx, double *alpha, int *na, int *kode, double *yr, double *yi, double *wr, double *wi, int *ierr);
extern int nsp_calpack_zbesi(double *zr, double *zi, double *fnu, int *kode, int *n, double *cyr, double *cyi, int *nz, int *ierr);
extern int nsp_calpack_zbesjg(double *x1r, double *x1i, double *alpha, int *kode, int *n, double *yr, double *yi, int *nz, double *wr, double *wi, int *ierr);
extern int nsp_calpack_zbesjv(double *xr, double *xi, int *nx, double *alpha, int *na, int *kode, double *yr, double *yi, double *wr, double *wi, int *ierr);
extern int nsp_calpack_zbesj(double *zr, double *zi, double *fnu, int *kode, int *n, double *cyr, double *cyi, int *nz, int *ierr);
extern int nsp_calpack_zbeskg(double *x1r, double *x1i, double *alpha, int *kode, int *n, double *yr, double *yi, int *nz, int *ierr);
extern int nsp_calpack_zbeskv(double *xr, double *xi, int *nx, double *alpha, int *na, int *kode, double *yr, double *yi, double *wr, double *wi, int *ierr);
extern int nsp_calpack_zbesk(double *zr, double *zi, double *fnu, int *kode, int *n, double *cyr, double *cyi, int *nz, int *ierr);
extern int nsp_calpack_zbesyg(double *x1r, double *x1i, double *alpha, int *kode, int *n, double *yr, double *yi, int *nz, double *wr, double *wi, int *ierr);
extern int nsp_calpack_zbesyv(double *xr, double *xi, int *nx, double *alpha, int *na, int *kode, double *yr, double *yi, double *wr, double *wi, int *ierr);
extern int nsp_calpack_zbesy(double *zr, double *zi, double *fnu, int *kode, int *n, double *cyr, double *cyi, int *nz, double *cwrkr, double *cwrki, int *ierr);
extern int nsp_calpack_zbinu(double *zr, double *zi, double *fnu, int *kode, int *n, double *cyr, double *cyi, int *nz, double *rl, double *fnul, double *tol, double *elim, double *alim);
extern int nsp_calpack_zbknu(double *zr, double *zi, double *fnu, int *kode, int *n, double *yr, double *yi, int *nz, double *tol, double *elim, double *alim);
extern int nsp_calpack_zbuni(double *zr, double *zi, double *fnu, int *kode, int *n, double *yr, double *yi, int *nz, int *nui, int *nlast, double *fnul, double *tol, double *elim, double *alim);
extern int nsp_calpack_zbunk(double *zr, double *zi, double *fnu, int *kode, int *mr, int *n, double *yr, double *yi, int *nz, double *tol, double *elim, double *alim);
extern int nsp_calpack_zdiv(double *ar, double *ai, double *br, double *bi, double *cr, double *ci);
extern int nsp_calpack_zexp(double *ar, double *ai, double *br, double *bi);
extern int nsp_calpack_zkscl(double *zrr, double *zri, double *fnu, int *n, double *yr, double *yi, int *nz, double *rzr, double *rzi, double *ascle, double *tol, double *elim);
extern int nsp_calpack_zlog(double *ar, double *ai, double *br, double *bi, int *ierr);
extern int nsp_calpack_zmlri(double *zr, double *zi, double *fnu, int *kode, int *n, double *yr, double *yi, int *nz, double *tol);
extern int nsp_calpack_zmlt(double *ar, double *ai, double *br, double *bi, double *cr, double *ci);
extern int nsp_calpack_zrati(double *zr, double *zi, double *fnu, int *n, double *cyr, double *cyi, double *tol);
extern int nsp_calpack_zs1s2(double *zrr, double *zri, double *s1r, double *s1i, double *s2r, double *s2i, int *nz, double *ascle, double *alim, int *iuf);
extern int nsp_calpack_zseri(double *zr, double *zi, double *fnu, int *kode, int *n, double *yr, double *yi, int *nz, double *tol, double *elim, double *alim);
extern int nsp_calpack_zshch(double *zr, double *zi, double *cshr, double *cshi, double *cchr, double *cchi);
extern int nsp_calpack_zsqrt(double *ar, double *ai, double *br, double *bi);
extern int nsp_calpack_zuchk(double *yr, double *yi, int *nz, double *ascle, double *tol);
extern int nsp_calpack_zunhj(double *zr, double *zi, double *fnu, int *ipmtr, double *tol, double *phir, double *phii, double *argr, double *argi, double *zeta1r, double *zeta1i, double *zeta2r, double *zeta2i, double *asumr, double *asumi, double *bsumr, double *bsumi);
extern int nsp_calpack_zuni1(double *zr, double *zi, double *fnu, int *kode, int *n, double *yr, double *yi, int *nz, int *nlast, double *fnul, double *tol, double *elim, double *alim);
extern int nsp_calpack_zuni2(double *zr, double *zi, double *fnu, int *kode, int *n, double *yr, double *yi, int *nz, int *nlast, double *fnul, double *tol, double *elim, double *alim);
extern int nsp_calpack_zunik(double *zrr, double *zri, double *fnu, int *ikflg, int *ipmtr, double *tol, int *init, double *phir, double *phii, double *zeta1r, double *zeta1i, double *zeta2r, double *zeta2i, double *sumr, double *sumi, double *cwrkr, double *cwrki);
extern int nsp_calpack_zunk1(double *zr, double *zi, double *fnu, int *kode, int *mr, int *n, double *yr, double *yi, int *nz, double *tol, double *elim, double *alim);
extern int nsp_calpack_zunk2(double *zr, double *zi, double *fnu, int *kode, int *mr, int *n, double *yr, double *yi, int *nz, double *tol, double *elim, double *alim);
extern int nsp_calpack_zuoik(double *zr, double *zi, double *fnu, int *kode, int *ikflg, int *n, double *yr, double *yi, int *nuf, double *tol, double *elim, double *alim);
extern int nsp_calpack_zwrsk(double *zrr, double *zri, double *fnu, int *kode, int *n, double *yr, double *yi, int *nz, double *cwr, double *cwi, double *tol, double *elim, double *alim);


extern double nsp_calpack_exp(double x) ;
extern double nsp_calpack_log(double x);
extern double nsp_calpack_pow(double x, double y);

#endif 
