#######################################################################
#                                                                     #
#                               Simport                               #
#                                                                     #
#                   Pierre Weis, INRIA Rocquencourt                   #
#                                                                     #
#  Copyright 2010-2019,                                               #
#  Institut National de Recherche en Informatique et en Automatique.  #
#  All rights reserved.                                               #
#                                                                     #
#  This file is distributed under the terms of the BSD License.       #
#                                                                     #
#######################################################################

# $Id: Basic_commands.mk,v 1.1 2019-05-10 13:58:19 jpc Exp $

# This make file is a generic configuration make file.
# This make file is independent of the software to be built and
# defines basic Unix commands and tools for compilation.

# This make file should be included at the beginning of the make file
# that handles a set of files (to build a library or an application).
# Simply write at the beginning of your make file:
# include <path_to_directory_of_Basic_commands.mk>/Basic_commands.mk
# For instance, assuming that Basic_commands.mk is in sub directory
# config of the main directory for your project, write the line
# include $(MAIN_DIR)/config/Basic_commands.mk

# Basic auxiliary commands
CD=cd
CP_CONFIG=-pRf
CP=cp $(CP_CONFIG)
CPC=cp -f
CVS=cvs
DIFF=diff
FIND=find
SORT=env -i $$(which sort) -d
SVN=svn
RM=rm -rf
MV=mv -f
TOUCH=touch
TOUCHC=touch -c
CHMOD=chmod
CHMOD_R=$(CHMOD) -R ug+w
CHMOD_WRITABLE=$(CHMOD) u+w
CHMOD_READ_ONLY=$(CHMOD) a-w
SHELL=/bin/sh
MKDIR=mkdir -p
RMDIR=rm -rf
LN=ln -sf
CHGRP=chgrp -fR
TARC=tar -czf
TARCV=tar -cvzf
RSYNC=rsync -av
MAIL=mail -n -s

# Text processing and viewers
TBL=tbl
MAN=nroff -man
MORE=more
LESS=less

# To browse the html documentation
BROWSER=firefox

# This file has not to be recursively rebuilt by implicit make rules.
$(CONFIG_DIR)/Basic_commands.mk: ;
