(***********************************************************************)
(*                                                                     *)
(*                               Simport                               *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2010-2019,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* $Id: say.ml,v 1.1 2019-05-10 14:09:17 jpc Exp $ *)

type message = Configuration.message;;

type error =
  | Fatal_error of message
;;

exception Error of error;;

let report_error ppf = function
  | Fatal_error s ->
    let soft = Configuration.get_software_name () in
    Format.fprintf ppf
      "@[<v 5>%s: fatal error %s@]@." soft s
;;

let fatal_error s = raise (Error (Fatal_error s));;

let fdebug = Configuration.fdebug;;

let fdebug_call = Configuration.fdebug_call;;

let debug = Configuration.debug;;

let warning = Configuration.warning;;

(*
 Local Variables:
  compile-command: "cd ../..; make"
  End:
*)
