(***********************************************************************)
(*                                                                     *)
(*                               Simport                               *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2010-2019,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.5+dev0 generated code. *)

open Ast_types_print;;

let printer_length ctx ppf = function
  | a_n -> Ast_types_print.printer_natural ctx ppf a_n
;;

let printer_translator _ctx ppf = function
  | Simport_configuration.T_simulink ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Simport_configuration.T_simulink"
  | Simport_configuration.T_mtlb ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Simport_configuration.T_mtlb"
  | Simport_configuration.T_sime ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Simport_configuration.T_sime"
;;

let printer_simulink_source_language _ctx ppf = function
  | Simport_configuration.Mdl ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Simport_configuration.Mdl"
  | Simport_configuration.Slx ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Simport_configuration.Slx"
  | Simport_configuration.Xml ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Simport_configuration.Xml"
;;

let printer_simulink_target_language _ctx ppf = function
  | Simport_configuration.ScicosLab ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Simport_configuration.ScicosLab"
  | Simport_configuration.Nsp ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Simport_configuration.Nsp"
  | Simport_configuration.Modelica ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Simport_configuration.Modelica"
  | Simport_configuration.Hypermath ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Simport_configuration.Hypermath"
  | Simport_configuration.Oml ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Simport_configuration.Oml"
  | Simport_configuration.Octave ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Simport_configuration.Octave"
;;

let printer_mtlb_source_language _ctx ppf = function
  | Simport_configuration.Mtlb ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Simport_configuration.Mtlb"
;;

let printer_mtlb_target_language ctx ppf = function
  | Simport_configuration.Matlab ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Simport_configuration.Matlab"
  | Simport_configuration.Scicos_host s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Simport_configuration.Scicos_host";
    printer_simulink_target_language Og_precedence.Ck_argument ppf s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let printer_sime_source_language _ctx ppf = function
  | Simport_configuration.E_simulink ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Simport_configuration.E_simulink"
;;

let printer_sime_target_language _ctx ppf = function
  | Simport_configuration.E_scicos ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Simport_configuration.E_scicos"
;;

let printer_target_language ctx ppf = function
  | Simport_configuration.Target_simulink s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Simport_configuration.Target_simulink";
    printer_simulink_target_language Og_precedence.Ck_argument ppf s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Simport_configuration.Target_mtlb m ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Simport_configuration.Target_mtlb";
    printer_mtlb_target_language Og_precedence.Ck_argument ppf m;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Simport_configuration.Target_sime s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Simport_configuration.Target_sime";
    printer_sime_target_language Og_precedence.Ck_argument ppf s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let printer_source_language ctx ppf = function
  | Simport_configuration.Source_simulink s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Simport_configuration.Source_simulink";
    printer_simulink_source_language Og_precedence.Ck_argument ppf s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Simport_configuration.Source_mtlb m ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Simport_configuration.Source_mtlb";
    printer_mtlb_source_language Og_precedence.Ck_argument ppf m;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Simport_configuration.Source_sime s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Simport_configuration.Source_sime";
    printer_sime_source_language Og_precedence.Ck_argument ppf s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let printer_language ctx ppf = function
  | Simport_configuration.Source_language s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Simport_configuration.Source_language";
    printer_source_language Og_precedence.Ck_argument ppf s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Simport_configuration.Target_language t ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Simport_configuration.Target_language";
    printer_target_language Og_precedence.Ck_argument ppf t;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let printer_target_modeler _ctx ppf = function
  | Simport_configuration.Modeler_scicos ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Simport_configuration.Modeler_scicos"
  | Simport_configuration.Modeler_scicos_pro ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Simport_configuration.Modeler_scicos_pro"
  | Simport_configuration.Modeler_modelicos ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Simport_configuration.Modeler_modelicos"
;;

let printer_version ctx ppf = function
  | s -> Og_printer.printer_String ctx ppf s
;;

let printer_full_version ctx ppf = function
  | s -> Og_printer.printer_String ctx ppf s
;;

let printer_interface_version ctx ppf = function
  | s -> Og_printer.printer_String ctx ppf s
;;

let printer_interface_source_file_name ctx ppf = function
  | p_e -> Path_print.printer_explicit_file_name ctx ppf p_e
;;

let printer_interface_marshaled_file_name ctx ppf = function
  | p_e -> Path_print.printer_explicit_file_name ctx ppf p_e
;;

let printer_implementation_source_file_name ctx ppf = function
  | p_e -> Path_print.printer_explicit_file_name ctx ppf p_e
;;

let printer_implementation_marshaled_file_name ctx ppf = function
  | p_e -> Path_print.printer_explicit_file_name ctx ppf p_e
;;

let printer_implementation_translated_file_name ctx ppf = function
  | p_e -> Path_print.printer_explicit_file_name ctx ppf p_e
;;

let printer_matlab_source_file_name ctx ppf = function
  | p_e -> Path_print.printer_explicit_file_name ctx ppf p_e
;;

let printer_matlab_translated_file_name ctx ppf = function
  | p_e -> Path_print.printer_explicit_file_name ctx ppf p_e
;;

let printer_mtlb_source_file_name ctx ppf = function
  | p_e -> Path_print.printer_explicit_file_name ctx ppf p_e
;;

let printer_mtlb_translated_file_name ctx ppf = function
  | p_e -> Path_print.printer_explicit_file_name ctx ppf p_e
;;

let printer_sime_source_file_name ctx ppf = function
  | p_e -> Path_print.printer_explicit_file_name ctx ppf p_e
;;

let printer_sime_translated_file_name ctx ppf = function
  | p_e -> Path_print.printer_explicit_file_name ctx ppf p_e
;;

let printer_configuration ctx ppf = function
  | {
      Simport_configuration.software_name = s;
      Simport_configuration.software_version = v;
      Simport_configuration.software_full_version = f;
      Simport_configuration.interface_version = i;
      Simport_configuration.compile_only = b;
      Simport_configuration.verbose = b0;
      Simport_configuration.debug = b1;
      Simport_configuration.debug_slx = b2;
      Simport_configuration.warnings = b3;
      Simport_configuration.search_path = p_s;
      Simport_configuration.translator = t_o;
      Simport_configuration.slx_model_ident = i_i_o;
      Simport_configuration.ignore_encoding = b4;
      Simport_configuration.source_file = p_f_o;
      Simport_configuration.source_encoding = u_c_o;
      Simport_configuration.companion_source_files = p_f_l;
      Simport_configuration.target_file = p_f_o0;
      Simport_configuration.target_encoding = u_c_o0;
      Simport_configuration.companion_target_files = p_f_l0;
      Simport_configuration.interfaces = i_i_l;
      Simport_configuration.target_language = t_o0;
      Simport_configuration.source_language = s_o;
      Simport_configuration.target_modeler = t_o1;
      Simport_configuration.default_font = a_m;
      Simport_configuration.mean_blocks_by_system = n;
      Simport_configuration.mean_block_bindings = n0;
      Simport_configuration.max_block_types = n1;
      Simport_configuration.mean_block_parameters = n2;
      Simport_configuration.block_vertical_spacing = l;
      Simport_configuration.block_port_width = l0;
      Simport_configuration.block_port_height = l1;
      Simport_configuration.block_event_width = l2;
      Simport_configuration.block_event_height = l3;
      Simport_configuration.block_geometry_magnification = n3;
      Simport_configuration.not_yet_translated_mark = s0;
      Simport_configuration.target_model_ident = i_i;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Simport_configuration.@,";
    Format.fprintf ppf "%,@[<hv 2>software_name =";
    Og_printer.printer_String Og_precedence.Ck_record_field ppf s;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>software_version =";
    printer_version Og_precedence.Ck_record_field ppf v;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>software_full_version =";
    printer_full_version Og_precedence.Ck_record_field ppf f;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>interface_version =";
    printer_interface_version Og_precedence.Ck_record_field ppf i;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>compile_only =";
    Og_printer.printer_Bool Og_precedence.Ck_record_field ppf b;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>verbose =";
    Og_printer.printer_Bool Og_precedence.Ck_record_field ppf b0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>debug =";
    Og_printer.printer_Bool Og_precedence.Ck_record_field ppf b1;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>debug_slx =";
    Og_printer.printer_Bool Og_precedence.Ck_record_field ppf b2;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>warnings =";
    Og_printer.printer_Bool Og_precedence.Ck_record_field ppf b3;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>search_path =";
    Path_print.printer_search_path Og_precedence.Ck_record_field ppf p_s;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>translator =";
    Og_printer.printer_Option printer_translator
      Og_precedence.Ck_record_field
      ppf
      t_o;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>slx_model_ident =";
    Og_printer.printer_Option Ident_print.printer_ident
      Og_precedence.Ck_record_field
      ppf
      i_i_o;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>ignore_encoding =";
    Og_printer.printer_Bool Og_precedence.Ck_record_field ppf b4;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>source_file =";
    Og_printer.printer_Option Path_print.printer_file_name
      Og_precedence.Ck_record_field
      ppf
      p_f_o;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>source_encoding =";
    Og_printer.printer_Option
      Uencoding_types_print.printer_character_encoding
      Og_precedence.Ck_record_field
      ppf
      u_c_o;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>companion_source_files =";
    Og_printer.printer_List Path_print.printer_file_name
      Og_precedence.Ck_record_field
      ppf
      p_f_l;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>target_file =";
    Og_printer.printer_Option Path_print.printer_file_name
      Og_precedence.Ck_record_field
      ppf
      p_f_o0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>target_encoding =";
    Og_printer.printer_Option
      Uencoding_types_print.printer_character_encoding
      Og_precedence.Ck_record_field
      ppf
      u_c_o0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>companion_target_files =";
    Og_printer.printer_List Path_print.printer_file_name
      Og_precedence.Ck_record_field
      ppf
      p_f_l0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>interfaces =";
    Og_printer.printer_List Ident_print.printer_ident
      Og_precedence.Ck_record_field
      ppf
      i_i_l;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>target_language =";
    Og_printer.printer_Option printer_target_language
      Og_precedence.Ck_record_field
      ppf
      t_o0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>source_language =";
    Og_printer.printer_Option printer_source_language
      Og_precedence.Ck_record_field
      ppf
      s_o;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>target_modeler =";
    Og_printer.printer_Option printer_target_modeler
      Og_precedence.Ck_record_field
      ppf
      t_o1;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>default_font =";
    Ast_types_print.printer_mdl_font Og_precedence.Ck_record_field ppf a_m;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>mean_blocks_by_system =";
    printer_natural Og_precedence.Ck_record_field ppf n;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>mean_block_bindings =";
    printer_natural Og_precedence.Ck_record_field ppf n0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>max_block_types =";
    printer_natural Og_precedence.Ck_record_field ppf n1;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>mean_block_parameters =";
    printer_natural Og_precedence.Ck_record_field ppf n2;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>block_vertical_spacing =";
    printer_length Og_precedence.Ck_record_field ppf l;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>block_port_width =";
    printer_length Og_precedence.Ck_record_field ppf l0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>block_port_height =";
    printer_length Og_precedence.Ck_record_field ppf l1;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>block_event_width =";
    printer_length Og_precedence.Ck_record_field ppf l2;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>block_event_height =";
    printer_length Og_precedence.Ck_record_field ppf l3;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>block_geometry_magnification =";
    printer_natural Og_precedence.Ck_record_field ppf n3;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>not_yet_translated_mark =";
    Og_printer.printer_String Og_precedence.Ck_record_field ppf s0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>target_model_ident =";
    Ident_print.printer_ident Og_precedence.Ck_record_field ppf i_i;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

(* Defining top printers. *)

let print_length ppf = printer_length Og_precedence.Ck_toplevel ppf
;;

let print_translator ppf = printer_translator Og_precedence.Ck_toplevel ppf
;;

let print_simulink_source_language ppf =
  printer_simulink_source_language Og_precedence.Ck_toplevel ppf
;;

let print_simulink_target_language ppf =
  printer_simulink_target_language Og_precedence.Ck_toplevel ppf
;;

let print_mtlb_source_language ppf =
  printer_mtlb_source_language Og_precedence.Ck_toplevel ppf
;;

let print_mtlb_target_language ppf =
  printer_mtlb_target_language Og_precedence.Ck_toplevel ppf
;;

let print_sime_source_language ppf =
  printer_sime_source_language Og_precedence.Ck_toplevel ppf
;;

let print_sime_target_language ppf =
  printer_sime_target_language Og_precedence.Ck_toplevel ppf
;;

let print_target_language ppf =
  printer_target_language Og_precedence.Ck_toplevel ppf
;;

let print_source_language ppf =
  printer_source_language Og_precedence.Ck_toplevel ppf
;;

let print_language ppf = printer_language Og_precedence.Ck_toplevel ppf
;;

let print_target_modeler ppf =
  printer_target_modeler Og_precedence.Ck_toplevel ppf
;;

let print_version ppf = printer_version Og_precedence.Ck_toplevel ppf
;;

let print_full_version ppf =
  printer_full_version Og_precedence.Ck_toplevel ppf
;;

let print_interface_version ppf =
  printer_interface_version Og_precedence.Ck_toplevel ppf
;;

let print_interface_source_file_name ppf =
  printer_interface_source_file_name Og_precedence.Ck_toplevel ppf
;;

let print_interface_marshaled_file_name ppf =
  printer_interface_marshaled_file_name Og_precedence.Ck_toplevel ppf
;;

let print_implementation_source_file_name ppf =
  printer_implementation_source_file_name Og_precedence.Ck_toplevel ppf
;;

let print_implementation_marshaled_file_name ppf =
  printer_implementation_marshaled_file_name Og_precedence.Ck_toplevel ppf
;;

let print_implementation_translated_file_name ppf =
  printer_implementation_translated_file_name Og_precedence.Ck_toplevel ppf
;;

let print_matlab_source_file_name ppf =
  printer_matlab_source_file_name Og_precedence.Ck_toplevel ppf
;;

let print_matlab_translated_file_name ppf =
  printer_matlab_translated_file_name Og_precedence.Ck_toplevel ppf
;;

let print_mtlb_source_file_name ppf =
  printer_mtlb_source_file_name Og_precedence.Ck_toplevel ppf
;;

let print_mtlb_translated_file_name ppf =
  printer_mtlb_translated_file_name Og_precedence.Ck_toplevel ppf
;;

let print_sime_source_file_name ppf =
  printer_sime_source_file_name Og_precedence.Ck_toplevel ppf
;;

let print_sime_translated_file_name ppf =
  printer_sime_translated_file_name Og_precedence.Ck_toplevel ppf
;;

let print_configuration ppf =
  printer_configuration Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.5+dev0 generated code. *)
