(***********************************************************************)
(*                                                                     *)
(*                               Simport                               *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2010-2019,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.5+dev0 generated code. *)

let printer_natural ctx ppf = function
  | u_t -> Unatural_print.printer_t ctx ppf u_t
;;

let printer_mdl_name ctx ppf = function
  | Ast_types.Mdl_name s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Ast_types.Mdl_name";
    Og_printer.printer_String Og_precedence.Ck_argument ppf s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let printer_mdl_path ctx ppf = function
  | Ast_types.Mdl_path s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Ast_types.Mdl_path";
    Og_printer.printer_String Og_precedence.Ck_argument ppf s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let printer_mdl_bool ctx ppf = function
  | Ast_types.Mdl_bool s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Ast_types.Mdl_bool";
    Og_printer.printer_String Og_precedence.Ck_argument ppf s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let printer_mdl_text ctx ppf = function
  | Ast_types.Mdl_text s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Ast_types.Mdl_text";
    Og_printer.printer_String Og_precedence.Ck_argument ppf s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let printer_mdl_shallow_code ctx ppf = function
  | Ast_types.Mdl_shallow_code m ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Ast_types.Mdl_shallow_code";
    printer_mdl_text Og_precedence.Ck_argument ppf m;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let printer_mdl_code ctx ppf = function
  | Ast_types.Mdl_code m ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Ast_types.Mdl_code";
    printer_mdl_text Og_precedence.Ck_argument ppf m;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let printer_mdl_port_number ctx ppf = function
  | Ast_types.Mdl_port_number n ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Ast_types.Mdl_port_number";
    printer_natural Og_precedence.Ck_argument ppf n;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let rec printer_mdl_font ctx ppf = function
  | {
      Ast_types.mdl_font_name = m;
      Ast_types.mdl_font_angle = s;
      Ast_types.mdl_font_size = n;
      Ast_types.mdl_font_weight = s0;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Ast_types.@,";
    Format.fprintf ppf "%,@[<hv 2>mdl_font_name =";
    printer_mdl_font_name Og_precedence.Ck_record_field ppf m;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>mdl_font_angle =";
    Og_printer.printer_String Og_precedence.Ck_record_field ppf s;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>mdl_font_size =";
    printer_natural Og_precedence.Ck_record_field ppf n;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>mdl_font_weight =";
    Og_printer.printer_String Og_precedence.Ck_record_field ppf s0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"

and printer_mdl_font_name ctx ppf = function
  | s -> Og_printer.printer_String ctx ppf s
;;

(* Defining top printers. *)

let print_natural ppf = printer_natural Og_precedence.Ck_toplevel ppf
;;

let print_mdl_name ppf = printer_mdl_name Og_precedence.Ck_toplevel ppf
;;

let print_mdl_path ppf = printer_mdl_path Og_precedence.Ck_toplevel ppf
;;

let print_mdl_bool ppf = printer_mdl_bool Og_precedence.Ck_toplevel ppf
;;

let print_mdl_text ppf = printer_mdl_text Og_precedence.Ck_toplevel ppf
;;

let print_mdl_shallow_code ppf =
  printer_mdl_shallow_code Og_precedence.Ck_toplevel ppf
;;

let print_mdl_code ppf = printer_mdl_code Og_precedence.Ck_toplevel ppf
;;

let print_mdl_port_number ppf =
  printer_mdl_port_number Og_precedence.Ck_toplevel ppf
;;

let print_mdl_font ppf = printer_mdl_font Og_precedence.Ck_toplevel ppf

and print_mdl_font_name ppf =
  printer_mdl_font_name Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.5+dev0 generated code. *)
