(***********************************************************************)
(*                                                                     *)
(*                          Ocaml-xml Library                          *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2013-2018,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* $Id: hash_table_print.ml,v 1.1 2019-05-10 14:00:49 jpc Exp $ *)

open Format;;

(*
let print pa pb ctx ppf t =

  let print_binding ppf (k, v) =
    fprintf ppf "@ @[<2>%a =>@ %a@]"
      pa k pb v in

  fprintf ppf "@[<hv 3>{| @[<hv 0>";

  let rec pl ppf = function
    | [] -> fprintf ppf "@]@;<0 -3>|}@]"
    | x :: xs -> fprintf ppf "%a ;%a" print_binding x pl xs in

  pl ppf (Hash_table.bindings t)
;;
*)

let break_back ppf n =
  Format.pp_print_break ppf n (-2)
;;

let printer_t pp_a pp_b ctx ppf t =
  let pp_a = pp_a Og_precedence.Ck_toplevel in
  let pp_b = pp_b Og_precedence.Ck_record_field in
  let pp_binding ppf (k, v) =
    fprintf ppf "@[<hv 2>%a =>%a@]" pp_a k pp_b v in
  let rec print_body ppf = function
    | [] -> ()
    | [ elem ] -> Format.fprintf ppf "%a;" pp_binding elem
    | elem :: elems ->
      Format.fprintf ppf "%a;@ %a" pp_binding elem print_body elems in
  let l = Hash_table.bindings t in
  if ctx = Og_precedence.Ck_argument ||
     ctx = Og_precedence.Ck_record_field
  then
    match l with
    | [] -> Format.fprintf ppf " {||}"
    | l ->
      Format.fprintf ppf " {|@ @[%a@]%a|}"
        print_body l
        break_back 1
  else
    match l with
    | [] -> Format.fprintf ppf "{||}"
    | l ->
      Format.fprintf ppf "@[<hv 2>{|@ @[%a@]%a|}@]"
        print_body l
        break_back 1
;;

let print_t pp_a pp_b ppf =
  printer_t pp_a pp_b Og_precedence.Ck_toplevel ppf
;;

(*
 Local Variables:
  compile-command: "cd ../..; make"
 End:
*)
