(***********************************************************************)
(*                                                                     *)
(*                          Ocaml-xml Library                          *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2013-2018,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* $Id: int8.ml,v 1.1 2019-05-10 14:00:49 jpc Exp $ *)

(** Implementing one byte signed integers. *)

type int8 = char;;

let add c1 c2 =
  let i1 = int_of_char c1 and i2 = int_of_char c2 in
  char_of_int (0xFF land (i1 + i2))
;;

let sub c1 c2 =
  let i1 = int_of_char c1 and i2 = int_of_char c2 in
  char_of_int (0xFF land (i1 - i2))
;;

let mul c1 c2 =
  let i1 = int_of_char c1 and i2 = int_of_char c2 in
  char_of_int (0xFF land (i1 * i2))
;;

let div c1 c2 =
  let i1 = int_of_char c1 and i2 = int_of_char c2 in
  char_of_int (0xFF land (i1 / i2))
;;

(*
 Local Variables:
  compile-command: "cd ../..; make"
  End:
*)
