(***********************************************************************)
(*                                                                     *)
(*                          Ocaml-xml Library                          *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2013-2018,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* $Id: name.ml,v 1.1 2019-05-10 14:00:49 jpc Exp $ *)

type prefix = string;;
type suffix = string;;

type t = private string;;

external to_t : string -> t = "%identity";;
external of_t : t -> string = "%identity";;

external to_string : t -> string = "%identity";;

external compare : t -> t -> int = "%compare";;
external same_name : t -> t -> bool = "%equal";;

let fresh pref =
  to_t (Printf.sprintf "%s%s" pref (Uid.to_string (Uid.fresh ())))
;;

(*
 Local Variables:
  compile-command: "cd ../..; make"
  End:
*)
