(***********************************************************************)
(*                                                                     *)
(*                              OCamlGen                               *)
(*                                                                     *)
(*                       OCaml module Generator                        *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 1997-2018 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Clement Franchini <Clement.Franchini@inria.fr>                     *)
(*                                                                     *)
(***********************************************************************)

(* $Id: og_outputer.ml,v 1.1 2019-05-10 14:02:41 jpc Exp $ *)

(* Runtime library for pretty-outputers generated with OCamlGen. *)

(* FIXME:
 This implementation, strictly equal to that of Printer, must be adapted to
 correct pretty-outputing. *)

open Og_printer;;

(* Printers for basic monomorphic values. *)

let outputer_Unit = printer_Unit
and outputer_Bool = printer_Bool
and outputer_Char = printer_Char
and outputer_String = printer_String
and outputer_Bytes = printer_Bytes
and outputer_Format = printer_Format
and outputer_Format4 = printer_Format4
and outputer_Format6 = printer_Format6
;;

let outputer_Int = printer_Int
and outputer_Int32 = printer_Int32
and outputer_Int64 = printer_Int64
and outputer_Nativeint = printer_Nativeint
and outputer_Float = printer_Float
;;

(* Printers for basic polymorphic values. *)

let outputer_List = printer_List
and outputer_Array = printer_Array
;;

let outputer_Option = printer_Option
and outputer_Ref = printer_Ref
;;

(* Printers for functional, abstract and polymorphic values. *)

let outputer_Fun = printer_Fun
and outputer_Poly = printer_Poly
and outputer_Abstract = printer_Abstract
and outputer_External = printer_External
;;
