(***********************************************************************)
(*                                                                     *)
(*                          Ocaml-xml Library                          *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2013-2018,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* $Id: uid.ml,v 1.1 2019-05-10 14:00:49 jpc Exp $ *)

type t = int64;;

external of_t : t -> int64 = "%identity";;
external to_t : int64 -> t = "%identity";;

let dummy = 0L;;

let current = ref dummy;;

let ( + ) = Int64.add;;

let incr_current () = current := !current + 1L;;

let fresh () =
  incr_current ();
  to_t !current
;;

let to_string = Int64.to_string
;;

(*
 Local Variables:
  compile-command: "cd ../..; make"
  End:
*)
