(***********************************************************************)
(*                                                                     *)
(*                          Ocaml-xml Library                          *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2013-2018,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* $Id: uname_pprint.ml,v 1.1 2019-05-10 14:00:49 jpc Exp $ *)

let pprint_t ppf = function
  | { Uname.name = n_t; Uname.uid = _; } ->
    Format.fprintf ppf "%s" (Name.to_string n_t);
;;

let pprint_full_t ppf = function
  | { Uname.name = n_t; Uname.uid = u_t; } ->
    Format.fprintf ppf "%s_%Ld" (Name.to_string n_t) (Uid.of_t u_t);
;;

(*
 Local Variables:
  compile-command: "cd ../..; make"
  End:
*)
