(***********************************************************************)
(*                                                                     *)
(*                          Ocaml-xml Library                          *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2013-2018,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* $Id: unatural_types.mli,v 1.1 2019-05-10 14:00:49 jpc Exp $ *)

(** {3 The private type of natural numbers} *)

type natural = private int;;

val to_natural : int -> natural;;
external of_natural : natural -> int = "%identity";;

val natural_failwith : string -> string -> 'a;;
(* [natural_failwith fun_name msg] raises a [Failure] for function [fun_name]
  with message [msg]. *)

(*
 Local Variables:
  compile-command: "cd ../..; make"
  End:
*)
