(***********************************************************************)
(*                                                                     *)
(*                          Ocaml-xml Library                          *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2013-2018,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* $Id: uoption.ml,v 1.1 2019-05-10 14:00:49 jpc Exp $ *)

(** Additional functionality for options. *)

type 'a t = 'a option;;

let map f = function
  | None -> None
  | Some x -> Some (f x)
;;

let cons x_opt l =
  match x_opt with
  | None -> l
  | Some x -> x :: l
;;

let cons_map f x_opt l = cons (map f x_opt) l;;

(*
 Local Variables:
  compile-command: "cd ../..; make"
  End:
*)
