(***********************************************************************)
(*                                                                     *)
(*                          Ocaml-xml Library                          *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2013-2018,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* $Id: xml_basics_ast.mli,v 1.1 2019-05-10 14:00:49 jpc Exp $ *)

type text = string;;
type char_data_text = text;;

type nm_token = string;;

type xml_name = private nm_token;;
val to_xml_name : nm_token -> xml_name;;
val of_xml_name : xml_name -> nm_token;;

type pi_target = private xml_name;;
val to_pi_target : xml_name -> pi_target;;
val of_pi_target : pi_target -> xml_name;;

type pi_instructions = text;;

type tag_name = xml_name;;
type tag_attribute_name = xml_name;;
type entity_name = xml_name;;
type notation_name = xml_name;;

type att_value_text = text;;
type entity_value_text = text;;

type reference =
  | Char_ref of int32
  | Entity_ref of entity_name
;;

type att_value = att_value_elem list
and att_value_elem =
  | Att_value_text of att_value_text
  | Att_value_reference of reference
;;

type entity_value = entity_value_elem list
and entity_value_elem =
  | Entity_value_text of entity_value_text
  | Entity_value_reference of reference
  | Entity_value_pe_reference of entity_name
;;

(*
 Local Variables:
  compile-command: "cd ../../..; make"
 End:
*)
