type token =
  | Eof
  | OpenConditionalSect
  | CloseConditionalSect
  | OpenBracket
  | CloseBracket
  | OpenParen
  | CloseParen
  | CloseParenQuestion
  | CloseParenStar
  | CloseParenPlus
  | GT
  | Question
  | Star
  | Plus
  | Eq
  | Comma
  | Bar
  | XmlDeclStart
  | XmlDeclEnd
  | ExternalIDSystem of (string)
  | ExternalIDPublic of (string * string)
  | PublicID of (string)
  | PCDATA
  | REQUIRED
  | IMPLIED
  | FIXED
  | INCLUDE
  | Ignore of (string)
  | VersionInfo of (string)
  | EncodingDecl of (string)
  | SDDecl of (bool)
  | NDataDecl of (Xml_basics_ast.xml_name)
  | AttlistName of (Xml_basics_ast.xml_name)
  | NotationTypeName of (Xml_basics_ast.xml_name)
  | Space of (string)
  | Comment of (string)
  | NotationName of (Xml_basics_ast.xml_name)
  | GEDeclName of (Xml_basics_ast.xml_name)
  | PEDeclName of (Xml_basics_ast.xml_name)
  | AttValue of (Xml_basics_ast.att_value)
  | PEReference of (Xml_basics_ast.xml_name)
  | CharRef of (int32)
  | EntityRef of (Xml_basics_ast.xml_name)
  | CData of (string)
  | CharDataIntercal of (Xml_lexer_types.char_data_intercal)
  | FirstSTag of (Xml_lexer_types.token_tag)
  | FirstEmptyElemTag of (Xml_lexer_types.token_tag)
  | STag of (Xml_lexer_types.token_tag)
  | EmptyElemTag of (Xml_lexer_types.token_tag)
  | ETag of (Xml_basics_ast.tag_name)
  | Nmtoken of (Xml_basics_ast.nm_token)
  | DocTypeName of (Xml_basics_ast.tag_attribute_name)
  | ElementName of (Xml_basics_ast.tag_attribute_name)
  | PI of (Xml_basics_ast.pi_target * Xml_basics_ast.pi_instructions)

val prolog :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Xml_ast.prolog
val element :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Xml_ast.element
val element_after_prolog :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Xml_ast.element
val ext_subset :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Xml_ast.raw_ext_subset
