(***********************************************************************)
(*                                                                     *)
(*                          Ocaml-xml Library                          *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2013-2018,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* $Id: xml_say.mli,v 1.1 2019-05-10 14:00:17 jpc Exp $ *)

type message = string;;

val warning : message -> unit;;

val fatal_error : message -> 'a;;

val debug : message -> unit;;

val fdebug : (Format.formatter -> unit) -> unit
(** [fdebug f] apply [f] to a formatter only if debug is set. *)
;;

(*
 Local Variables:
  compile-command: "cd ../..; make"
  End:
*)
