(***********************************************************************)
(*                                                                     *)
(*                           Matlab Parser                             *)
(*                                                                     *)
(*          J.Ph Chancelier, Enpc/Cermics                              *)
(*                                                                     *)
(*  Copyright 2012-2019,                                               *)
(*  Ecole Nationale des ponts et chaussées                             *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.5+dev0 generated code. *)

open Ast_node_print;;

let printer_parsing _ctx ppf = function
  | Mtlb_ast.ParsingMtlb ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mtlb_ast.ParsingMtlb"
;;

let printer_mtlb_constant ctx ppf = function
  | Mtlb_ast.Num s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.Num";
    Og_printer.printer_String Og_precedence.Ck_argument ppf s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.Imag_num s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.Imag_num";
    Og_printer.printer_String Og_precedence.Ck_argument ppf s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.Dq_string s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.Dq_string";
    Og_printer.printer_String Og_precedence.Ck_argument ppf s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.Sq_string s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.Sq_string";
    Og_printer.printer_String Og_precedence.Ck_argument ppf s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let rec printer_mtlb_ast pp_info ctx ppf = function
  | i_m_i_a ->
    printer_ast_node (printer_mtlb_ast_desc pp_info) pp_info ctx ppf i_m_i_a

and printer_mtlb_ast_desc pp_info ctx ppf = function
  | Mtlb_ast.Ast i_e_l ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.Ast";
    Og_printer.printer_List (printer_exprs pp_info)
      Og_precedence.Ck_argument
      ppf
      i_e_l;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_exprs pp_info ctx ppf = function
  | i_e_i_a ->
    printer_ast_node (printer_exprs_desc pp_info) pp_info ctx ppf i_e_i_a

and printer_exprs_desc pp_info ctx ppf = function
  | i_e_l -> Og_printer.printer_List (printer_exprsep pp_info) ctx ppf i_e_l

and printer_exprsep pp_info ctx ppf = function
  | i_e_i_a ->
    printer_ast_node (printer_exprsep_desc pp_info) pp_info ctx ppf i_e_i_a

and printer_exprsep_desc pp_info ctx ppf = function
  | Mtlb_ast.Exprsep (i_e, i_s) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.Exprsep";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_expr pp_info Og_precedence.Ck_tuple_item ppf i_e;
    Format.fprintf ppf "%,,@ ";
    printer_sep pp_info Og_precedence.Ck_tuple_item ppf i_s;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_sep pp_info ctx ppf = function
  | i_s_i_a ->
    printer_ast_node (printer_sep_desc pp_info) pp_info ctx ppf i_s_i_a

and printer_sep_desc _pp_info ctx ppf = function
  | Mtlb_ast.Comma i ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.Comma";
    Og_printer.printer_Int Og_precedence.Ck_argument ppf i;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.Newline i ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.Newline";
    Og_printer.printer_Int Og_precedence.Ck_argument ppf i;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.Semi i ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.Semi";
    Og_printer.printer_Int Og_precedence.Ck_argument ppf i;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.Sep_None i ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.Sep_None";
    Og_printer.printer_Int Og_precedence.Ck_argument ppf i;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_expr pp_info ctx ppf = function
  | i_e_i_a ->
    printer_ast_node (printer_expr_desc pp_info) pp_info ctx ppf i_e_i_a

and printer_expr_desc pp_info ctx ppf = function
  | Mtlb_ast.Expression i_e ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.Expression";
    printer_expression pp_info Og_precedence.Ck_argument ppf i_e;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.Command i_c ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.Command";
    printer_command pp_info Og_precedence.Ck_argument ppf i_c;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.WordListCmd (i_i, i_w) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.WordListCmd";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_identifier pp_info Og_precedence.Ck_tuple_item ppf i_i;
    Format.fprintf ppf "%,,@ ";
    printer_word_list pp_info Og_precedence.Ck_tuple_item ppf i_w;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.Comments s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.Comments";
    Og_printer.printer_String Og_precedence.Ck_argument ppf s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.Pcomments s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.Pcomments";
    Og_printer.printer_String Og_precedence.Ck_argument ppf s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.Dcomments s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.Dcomments";
    Og_printer.printer_String Og_precedence.Ck_argument ppf s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.Empty ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mtlb_ast.Empty"

and printer_word_list pp_info ctx ppf = function
  | i_w_i_a ->
    printer_ast_node (printer_word_list_desc pp_info) pp_info ctx ppf i_w_i_a

and printer_word_list_desc pp_info ctx ppf = function
  | i_w_l ->
    Og_printer.printer_List (printer_wcmds_desc pp_info) ctx ppf i_w_l

and printer_wcmds_desc _pp_info ctx ppf = function
  | Mtlb_ast.SQ s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.SQ";
    Og_printer.printer_String Og_precedence.Ck_argument ppf s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.DQ s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.DQ";
    Og_printer.printer_String Og_precedence.Ck_argument ppf s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_expression pp_info ctx ppf = function
  | i_e_i_a ->
    printer_ast_node (printer_expression_desc pp_info) pp_info
      ctx
      ppf
      i_e_i_a

and printer_expression_desc pp_info ctx ppf = function
  | Mtlb_ast.SimpleExpr i_s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.SimpleExpr";
    printer_simple_expr pp_info Og_precedence.Ck_argument ppf i_s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.AssignExpr i_a ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.AssignExpr";
    printer_assign_expr pp_info Og_precedence.Ck_argument ppf i_a;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.AnonFcnHandle (i_p, i_e) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.AnonFcnHandle";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_param_list pp_info Og_precedence.Ck_tuple_item ppf i_p;
    Format.fprintf ppf "%,,@ ";
    printer_expression pp_info Og_precedence.Ck_tuple_item ppf i_e;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_command pp_info ctx ppf = function
  | i_c_i_a ->
    printer_ast_node (printer_command_desc pp_info) pp_info ctx ppf i_c_i_a

and printer_command_desc pp_info ctx ppf = function
  | Mtlb_ast.Declaration i_d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.Declaration";
    printer_declaration pp_info Og_precedence.Ck_argument ppf i_d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.Switch (i_e, i_c) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.Switch";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_expression pp_info Og_precedence.Ck_tuple_item ppf i_e;
    Format.fprintf ppf "%,,@ ";
    printer_case_list pp_info Og_precedence.Ck_tuple_item ppf i_c;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.IfCommand i_i ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.IfCommand";
    printer_if_command pp_info Og_precedence.Ck_argument ppf i_i;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.LoopCommand i_l ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.LoopCommand";
    printer_loop_command pp_info Og_precedence.Ck_argument ppf i_l;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.JumpCommand i_j ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.JumpCommand";
    printer_jump_command pp_info Og_precedence.Ck_argument ppf i_j;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.ExceptCommand i_e ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.ExceptCommand";
    printer_except_command pp_info Og_precedence.Ck_argument ppf i_e;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.SciptFile i_o ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.SciptFile";
    printer_opt_list pp_info Og_precedence.Ck_argument ppf i_o;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.MFunction i_m ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.MFunction";
    printer_mfunction pp_info Og_precedence.Ck_argument ppf i_m;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_jump_command pp_info ctx ppf = function
  | i_j_i_a ->
    printer_ast_node (printer_jump_command_desc pp_info) pp_info
      ctx
      ppf
      i_j_i_a

and printer_jump_command_desc pp_info ctx ppf = function
  | Mtlb_ast.Break ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mtlb_ast.Break"
  | Mtlb_ast.FReturn i_r ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.FReturn";
    printer_return_list pp_info Og_precedence.Ck_argument ppf i_r;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.Continue ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mtlb_ast.Continue"

and printer_primary_expr pp_info ctx ppf = function
  | i_p_i_a ->
    printer_ast_node (printer_primary_expr_desc pp_info) pp_info
      ctx
      ppf
      i_p_i_a

and printer_primary_expr_desc pp_info ctx ppf = function
  | Mtlb_ast.PexpIdentifier i_i ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.PexpIdentifier";
    printer_identifier pp_info Og_precedence.Ck_argument ppf i_i;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.PexpConstant i_c ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.PexpConstant";
    printer_constant pp_info Og_precedence.Ck_argument ppf i_c;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.PexpFcnHandle i_i ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.PexpFcnHandle";
    printer_identifier pp_info Og_precedence.Ck_argument ppf i_i;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.PexpMatrix i_e_l ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.PexpMatrix";
    Og_printer.printer_List (printer_exprs pp_info)
      Og_precedence.Ck_argument
      ppf
      i_e_l;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.PexpCell i_e_l ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.PexpCell";
    Og_printer.printer_List (printer_exprs pp_info)
      Og_precedence.Ck_argument
      ppf
      i_e_l;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.PexpMetaIdentifier i_m ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.PexpMetaIdentifier";
    printer_meta_identifier pp_info Og_precedence.Ck_argument ppf i_m;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.PexpSuperIdentifier i_s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.PexpSuperIdentifier";
    printer_superclass_identifier pp_info Og_precedence.Ck_argument ppf i_s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.PexpExpression i_e ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.PexpExpression";
    printer_expression pp_info Og_precedence.Ck_argument ppf i_e;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_identifier pp_info ctx ppf = function
  | i_i_i_a ->
    printer_ast_node (printer_identifier_desc pp_info) pp_info
      ctx
      ppf
      i_i_i_a

and printer_identifier_desc _pp_info ctx ppf = function
  | s -> Og_printer.printer_String ctx ppf s

and printer_meta_identifier pp_info ctx ppf = function
  | i_m_i_a ->
    printer_ast_node (printer_meta_identifier_desc pp_info) pp_info
      ctx
      ppf
      i_m_i_a

and printer_meta_identifier_desc _pp_info ctx ppf = function
  | s -> Og_printer.printer_String ctx ppf s

and printer_superclass_identifier pp_info ctx ppf = function
  | i_s_i_a ->
    printer_ast_node (printer_superclass_identifier_desc pp_info) pp_info
      ctx
      ppf
      i_s_i_a

and printer_superclass_identifier_desc _pp_info ctx ppf = function
  | s -> Og_printer.printer_String ctx ppf s

and printer_arg_list pp_info ctx ppf = function
  | i_a_i_a ->
    printer_ast_node (printer_arg_list_desc pp_info) pp_info ctx ppf i_a_i_a

and printer_arg_list_desc pp_info ctx ppf = function
  | i_a_l -> Og_printer.printer_List (printer_arg pp_info) ctx ppf i_a_l

and printer_arg pp_info ctx ppf = function
  | i_a_i_a ->
    printer_ast_node (printer_arg_desc pp_info) pp_info ctx ppf i_a_i_a

and printer_arg_desc pp_info ctx ppf = function
  | Mtlb_ast.ArgExpression i_e ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.ArgExpression";
    printer_expression pp_info Og_precedence.Ck_argument ppf i_e;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.ArgColon ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mtlb_ast.ArgColon"
  | Mtlb_ast.ArgTilde ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mtlb_ast.ArgTilde"

and printer_oper_expr pp_info ctx ppf = function
  | i_o_i_a ->
    printer_ast_node (printer_oper_expr_desc pp_info) pp_info ctx ppf i_o_i_a

and printer_oper_expr_desc pp_info ctx ppf = function
  | Mtlb_ast.PrimaryExpr i_p ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.PrimaryExpr";
    printer_primary_expr pp_info Og_precedence.Ck_argument ppf i_p;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.PostfixOp (s, i_o) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.PostfixOp";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    Og_printer.printer_String Og_precedence.Ck_tuple_item ppf s;
    Format.fprintf ppf "%,,@ ";
    printer_oper_expr pp_info Og_precedence.Ck_tuple_item ppf i_o;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.IndexExpr (i_o, i_a, s, s0) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.IndexExpr";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_oper_expr pp_info Og_precedence.Ck_tuple_item ppf i_o;
    Format.fprintf ppf "%,,@ ";
    printer_arg_list pp_info Og_precedence.Ck_tuple_item ppf i_a;
    Format.fprintf ppf "%,,@ ";
    Og_printer.printer_String Og_precedence.Ck_tuple_item ppf s;
    Format.fprintf ppf "%,,@ ";
    Og_printer.printer_String Og_precedence.Ck_tuple_item ppf s0;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.IndirectRef (i_o, i_e) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.IndirectRef";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_oper_expr pp_info Og_precedence.Ck_tuple_item ppf i_o;
    Format.fprintf ppf "%,,@ ";
    printer_expression pp_info Og_precedence.Ck_tuple_item ppf i_e;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.IndirectRefU (i_o, i_i) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.IndirectRefU";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_oper_expr pp_info Og_precedence.Ck_tuple_item ppf i_o;
    Format.fprintf ppf "%,,@ ";
    printer_identifier pp_info Og_precedence.Ck_tuple_item ppf i_i;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.PrefixOpUnary (s, i_o) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.PrefixOpUnary";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    Og_printer.printer_String Og_precedence.Ck_tuple_item ppf s;
    Format.fprintf ppf "%,,@ ";
    printer_oper_expr pp_info Og_precedence.Ck_tuple_item ppf i_o;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.BinaryOp (s, i_o, i_o0) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.BinaryOp";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    Og_printer.printer_String Og_precedence.Ck_tuple_item ppf s;
    Format.fprintf ppf "%,,@ ";
    printer_oper_expr pp_info Og_precedence.Ck_tuple_item ppf i_o;
    Format.fprintf ppf "%,,@ ";
    printer_oper_expr pp_info Og_precedence.Ck_tuple_item ppf i_o0;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.Op_stars (i_s, i_o, i_o0) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.Op_stars";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_stars pp_info Og_precedence.Ck_tuple_item ppf i_s;
    Format.fprintf ppf "%,,@ ";
    printer_oper_expr pp_info Og_precedence.Ck_tuple_item ppf i_o;
    Format.fprintf ppf "%,,@ ";
    printer_oper_expr pp_info Og_precedence.Ck_tuple_item ppf i_o0;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.Op_divs (i_d, i_o, i_o0) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.Op_divs";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_divs pp_info Og_precedence.Ck_tuple_item ppf i_d;
    Format.fprintf ppf "%,,@ ";
    printer_oper_expr pp_info Og_precedence.Ck_tuple_item ppf i_o;
    Format.fprintf ppf "%,,@ ";
    printer_oper_expr pp_info Og_precedence.Ck_tuple_item ppf i_o0;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_simple_expr pp_info ctx ppf = function
  | i_s_i_a ->
    printer_ast_node (printer_simple_expr_desc pp_info) pp_info
      ctx
      ppf
      i_s_i_a

and printer_simple_expr_desc pp_info ctx ppf = function
  | Mtlb_ast.ColonExpr i_o_l ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.ColonExpr";
    Og_printer.printer_List (printer_oper_expr pp_info)
      Og_precedence.Ck_argument
      ppf
      i_o_l;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.Op_compare (i_c, i_s, i_s0) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.Op_compare";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_compare pp_info Og_precedence.Ck_tuple_item ppf i_c;
    Format.fprintf ppf "%,,@ ";
    printer_simple_expr pp_info Og_precedence.Ck_tuple_item ppf i_s;
    Format.fprintf ppf "%,,@ ";
    printer_simple_expr pp_info Og_precedence.Ck_tuple_item ppf i_s0;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.SexpBinaryOp (s, i_s, i_s0) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.SexpBinaryOp";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    Og_printer.printer_String Og_precedence.Ck_tuple_item ppf s;
    Format.fprintf ppf "%,,@ ";
    printer_simple_expr pp_info Og_precedence.Ck_tuple_item ppf i_s;
    Format.fprintf ppf "%,,@ ";
    printer_simple_expr pp_info Og_precedence.Ck_tuple_item ppf i_s0;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.BooleanOp (s, i_s, i_s0) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.BooleanOp";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    Og_printer.printer_String Og_precedence.Ck_tuple_item ppf s;
    Format.fprintf ppf "%,,@ ";
    printer_simple_expr pp_info Og_precedence.Ck_tuple_item ppf i_s;
    Format.fprintf ppf "%,,@ ";
    printer_simple_expr pp_info Og_precedence.Ck_tuple_item ppf i_s0;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_constant pp_info ctx ppf = function
  | i_c_i_a ->
    printer_ast_node (printer_constant_desc pp_info) pp_info ctx ppf i_c_i_a

and printer_constant_desc _pp_info ctx ppf = function
  | Mtlb_ast.Constant m ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.Constant";
    printer_mtlb_constant Og_precedence.Ck_argument ppf m;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_param_list pp_info ctx ppf = function
  | i_p_i_a ->
    printer_ast_node (printer_param_list_desc pp_info) pp_info
      ctx
      ppf
      i_p_i_a

and printer_param_list_desc pp_info ctx ppf = function
  | Mtlb_ast.EmptyParamList ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mtlb_ast.EmptyParamList"
  | Mtlb_ast.ParamList i_d_l ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.ParamList";
    Og_printer.printer_List (printer_decl2 pp_info)
      Og_precedence.Ck_argument
      ppf
      i_d_l;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_assign_lhs pp_info ctx ppf = function
  | i_a_i_a ->
    printer_ast_node (printer_assign_lhs_desc pp_info) pp_info
      ctx
      ppf
      i_a_i_a

and printer_assign_lhs_desc pp_info ctx ppf = function
  | Mtlb_ast.LhsSimple i_s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.LhsSimple";
    printer_simple_expr pp_info Og_precedence.Ck_argument ppf i_s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.LhsArgs i_e ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.LhsArgs";
    printer_exprs pp_info Og_precedence.Ck_argument ppf i_e;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_assign_expr pp_info ctx ppf = function
  | i_a_i_a ->
    printer_ast_node (printer_assign_expr_desc pp_info) pp_info
      ctx
      ppf
      i_a_i_a

and printer_assign_expr_desc pp_info ctx ppf = function
  | Mtlb_ast.Assign (s, i_a, i_e) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.Assign";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    Og_printer.printer_String Og_precedence.Ck_tuple_item ppf s;
    Format.fprintf ppf "%,,@ ";
    printer_assign_lhs pp_info Og_precedence.Ck_tuple_item ppf i_a;
    Format.fprintf ppf "%,,@ ";
    printer_expression pp_info Og_precedence.Ck_tuple_item ppf i_e;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_declaration pp_info ctx ppf = function
  | i_d_i_a ->
    printer_ast_node (printer_declaration_desc pp_info) pp_info
      ctx
      ppf
      i_d_i_a

and printer_declaration_desc pp_info ctx ppf = function
  | Mtlb_ast.Global i_d_l ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.Global";
    Og_printer.printer_List (printer_decl2 pp_info)
      Og_precedence.Ck_argument
      ppf
      i_d_l;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.Static i_d_l ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.Static";
    Og_printer.printer_List (printer_decl2 pp_info)
      Og_precedence.Ck_argument
      ppf
      i_d_l;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_decl2 pp_info ctx ppf = function
  | i_d_i_a ->
    printer_ast_node (printer_decl2_desc pp_info) pp_info ctx ppf i_d_i_a

and printer_decl2_desc pp_info ctx ppf = function
  | Mtlb_ast.Declare i_i ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.Declare";
    printer_identifier pp_info Og_precedence.Ck_argument ppf i_i;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.DeclareSet (i_i, i_e) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.DeclareSet";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_identifier pp_info Og_precedence.Ck_tuple_item ppf i_i;
    Format.fprintf ppf "%,,@ ";
    printer_expression pp_info Og_precedence.Ck_tuple_item ppf i_e;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.MagicTilde ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mtlb_ast.MagicTilde"

and printer_case_list pp_info ctx ppf = function
  | i_c_i_a ->
    printer_ast_node (printer_case_list_desc pp_info) pp_info ctx ppf i_c_i_a

and printer_case_list_desc pp_info ctx ppf = function
  | Mtlb_ast.Nocase ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mtlb_ast.Nocase"
  | Mtlb_ast.DefaultCase i_d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.DefaultCase";
    printer_default_case pp_info Og_precedence.Ck_argument ppf i_d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.Cases i_s_l ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.Cases";
    Og_printer.printer_List (printer_switch_case pp_info)
      Og_precedence.Ck_argument
      ppf
      i_s_l;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.CasesOther (i_s_l, i_d) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.CasesOther";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    Og_printer.printer_List (printer_switch_case pp_info)
      Og_precedence.Ck_tuple_item
      ppf
      i_s_l;
    Format.fprintf ppf "%,,@ ";
    printer_default_case pp_info Og_precedence.Ck_tuple_item ppf i_d;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_switch_case pp_info ctx ppf = function
  | i_s_i_a ->
    printer_ast_node (printer_switch_case_desc pp_info) pp_info
      ctx
      ppf
      i_s_i_a

and printer_switch_case_desc pp_info ctx ppf = function
  | Mtlb_ast.Case (i_o, i_o0, i_o1) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.Case";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_opt_list pp_info Og_precedence.Ck_tuple_item ppf i_o;
    Format.fprintf ppf "%,,@ ";
    printer_opt_list pp_info Og_precedence.Ck_tuple_item ppf i_o0;
    Format.fprintf ppf "%,,@ ";
    printer_opt_list pp_info Og_precedence.Ck_tuple_item ppf i_o1;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_default_case pp_info ctx ppf = function
  | i_d_i_a ->
    printer_ast_node (printer_default_case_desc pp_info) pp_info
      ctx
      ppf
      i_d_i_a

and printer_default_case_desc pp_info ctx ppf = function
  | Mtlb_ast.Otherwize i_o ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.Otherwize";
    printer_opt_list pp_info Og_precedence.Ck_argument ppf i_o;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_opt_list pp_info ctx ppf = function
  | i_o_i_a ->
    printer_ast_node (printer_opt_list_desc pp_info) pp_info ctx ppf i_o_i_a

and printer_opt_list_desc pp_info ctx ppf = function
  | i_e_l -> Og_printer.printer_List (printer_exprs pp_info) ctx ppf i_e_l

and printer_if_command pp_info ctx ppf = function
  | i_i_i_a ->
    printer_ast_node (printer_if_command_desc pp_info) pp_info
      ctx
      ppf
      i_i_i_a

and printer_if_command_desc pp_info ctx ppf = function
  | Mtlb_ast.IfCmd i_i_l ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.IfCmd";
    Og_printer.printer_List (printer_if_cmd pp_info)
      Og_precedence.Ck_argument
      ppf
      i_i_l;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.IfCmdWithElse (i_i_l, i_e) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.IfCmdWithElse";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    Og_printer.printer_List (printer_if_cmd pp_info)
      Og_precedence.Ck_tuple_item
      ppf
      i_i_l;
    Format.fprintf ppf "%,,@ ";
    printer_else_clause pp_info Og_precedence.Ck_tuple_item ppf i_e;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_if_cmd pp_info ctx ppf = function
  | i_i_i_a ->
    printer_ast_node (printer_if_cmd_desc pp_info) pp_info ctx ppf i_i_i_a

and printer_if_cmd_desc pp_info ctx ppf = function
  | Mtlb_ast.If (i_o, i_o0, i_o1) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.If"; Format.fprintf ppf "%, (@,";
    Format.fprintf ppf "%,@[<hv 0>";
    printer_opt_list pp_info Og_precedence.Ck_tuple_item ppf i_o;
    Format.fprintf ppf "%,,@ ";
    printer_opt_list pp_info Og_precedence.Ck_tuple_item ppf i_o0;
    Format.fprintf ppf "%,,@ ";
    printer_opt_list pp_info Og_precedence.Ck_tuple_item ppf i_o1;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.ElseIf (i_o, i_o0, i_o1) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.ElseIf";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_opt_list pp_info Og_precedence.Ck_tuple_item ppf i_o;
    Format.fprintf ppf "%,,@ ";
    printer_opt_list pp_info Og_precedence.Ck_tuple_item ppf i_o0;
    Format.fprintf ppf "%,,@ ";
    printer_opt_list pp_info Og_precedence.Ck_tuple_item ppf i_o1;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_else_clause pp_info ctx ppf = function
  | i_e_i_a ->
    printer_ast_node (printer_else_clause_desc pp_info) pp_info
      ctx
      ppf
      i_e_i_a

and printer_else_clause_desc pp_info ctx ppf = function
  | Mtlb_ast.Else i_o ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.Else";
    printer_opt_list pp_info Og_precedence.Ck_argument ppf i_o;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_loop_command pp_info ctx ppf = function
  | i_l_i_a ->
    printer_ast_node (printer_loop_command_desc pp_info) pp_info
      ctx
      ppf
      i_l_i_a

and printer_loop_command_desc pp_info ctx ppf = function
  | Mtlb_ast.WhileCommand (i_o, i_o0, i_o1) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.WhileCommand";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_opt_list pp_info Og_precedence.Ck_tuple_item ppf i_o;
    Format.fprintf ppf "%,,@ ";
    printer_opt_list pp_info Og_precedence.Ck_tuple_item ppf i_o0;
    Format.fprintf ppf "%,,@ ";
    printer_opt_list pp_info Og_precedence.Ck_tuple_item ppf i_o1;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.DoUntilCommand (i_o, i_e) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.DoUntilCommand";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_opt_list pp_info Og_precedence.Ck_tuple_item ppf i_o;
    Format.fprintf ppf "%,,@ ";
    printer_expression pp_info Og_precedence.Ck_tuple_item ppf i_e;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.ForCommand (i_o, i_o0, i_o1) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.ForCommand";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_opt_list pp_info Og_precedence.Ck_tuple_item ppf i_o;
    Format.fprintf ppf "%,,@ ";
    printer_opt_list pp_info Og_precedence.Ck_tuple_item ppf i_o0;
    Format.fprintf ppf "%,,@ ";
    printer_opt_list pp_info Og_precedence.Ck_tuple_item ppf i_o1;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_except_command pp_info ctx ppf = function
  | i_e_i_a ->
    printer_ast_node (printer_except_command_desc pp_info) pp_info
      ctx
      ppf
      i_e_i_a

and printer_except_command_desc pp_info ctx ppf = function
  | Mtlb_ast.UnwindCommand (i_o, i_o0) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.UnwindCommand";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_opt_list pp_info Og_precedence.Ck_tuple_item ppf i_o;
    Format.fprintf ppf "%,,@ ";
    printer_opt_list pp_info Og_precedence.Ck_tuple_item ppf i_o0;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.TryCatchCommand (i_o, i_o0) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.TryCatchCommand";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_opt_list pp_info Og_precedence.Ck_tuple_item ppf i_o;
    Format.fprintf ppf "%,,@ ";
    printer_opt_list pp_info Og_precedence.Ck_tuple_item ppf i_o0;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.TryCommand i_o ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.TryCommand";
    printer_opt_list pp_info Og_precedence.Ck_argument ppf i_o;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_mfunction pp_info ctx ppf = function
  | i_m_i_a ->
    printer_ast_node (printer_mfunction_desc pp_info) pp_info ctx ppf i_m_i_a

and printer_mfunction_desc pp_info ctx ppf = function
  | Mtlb_ast.FunctionNoRet (i_i, i_b) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.FunctionNoRet";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_identifier pp_info Og_precedence.Ck_tuple_item ppf i_i;
    Format.fprintf ppf "%,,@ ";
    printer_body pp_info Og_precedence.Ck_tuple_item ppf i_b;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.Function (i_r, i_i, i_b) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.Function";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_return_list pp_info Og_precedence.Ck_tuple_item ppf i_r;
    Format.fprintf ppf "%,,@ ";
    printer_identifier pp_info Og_precedence.Ck_tuple_item ppf i_i;
    Format.fprintf ppf "%,,@ ";
    printer_body pp_info Og_precedence.Ck_tuple_item ppf i_b;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_body pp_info ctx ppf = function
  | i_b_i_a ->
    printer_ast_node (printer_body_desc pp_info) pp_info ctx ppf i_b_i_a

and printer_body_desc pp_info ctx ppf = function
  | Mtlb_ast.Body (i_p, i_o, i_e) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.Body";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_param_list pp_info Og_precedence.Ck_tuple_item ppf i_p;
    Format.fprintf ppf "%,,@ ";
    printer_opt_list pp_info Og_precedence.Ck_tuple_item ppf i_o;
    Format.fprintf ppf "%,,@ ";
    printer_endfun pp_info Og_precedence.Ck_tuple_item ppf i_e;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mtlb_ast.SimpleBody (i_o, i_e) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.SimpleBody";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_opt_list pp_info Og_precedence.Ck_tuple_item ppf i_o;
    Format.fprintf ppf "%,,@ ";
    printer_endfun pp_info Og_precedence.Ck_tuple_item ppf i_e;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_endfun pp_info ctx ppf = function
  | i_e_i_a ->
    printer_ast_node (printer_endfun_desc pp_info) pp_info ctx ppf i_e_i_a

and printer_endfun_desc _pp_info _ctx ppf = function
  | Mtlb_ast.End_fun ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mtlb_ast.End_fun"
  | Mtlb_ast.Eof_fun ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mtlb_ast.Eof_fun"

and printer_return_list pp_info ctx ppf = function
  | i_r_i_a ->
    printer_ast_node (printer_return_list_desc pp_info) pp_info
      ctx
      ppf
      i_r_i_a

and printer_return_list_desc pp_info ctx ppf = function
  | Mtlb_ast.EmptyReturn ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mtlb_ast.EmptyReturn"
  | Mtlb_ast.Return i_i_l ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mtlb_ast.Return";
    Og_printer.printer_List (printer_identifier pp_info)
      Og_precedence.Ck_argument
      ppf
      i_i_l;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_compare pp_info ctx ppf = function
  | i_c_i_a ->
    printer_ast_node (printer_compare_desc pp_info) pp_info ctx ppf i_c_i_a

and printer_compare_desc pp_info ctx ppf = function
  | (i_o, s) ->
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ "
      else
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_tuple_item then
      Format.fprintf ppf "%,@[<hv 2>(@,";
    Format.fprintf ppf "%,@[<hv 0>";
    printer_op_compare_desc pp_info Og_precedence.Ck_tuple_item ppf i_o;
    Format.fprintf ppf "%,,@ ";
    Og_printer.printer_String Og_precedence.Ck_tuple_item ppf s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
      else
    if ctx = Og_precedence.Ck_tuple_item then
      Format.fprintf ppf "%,@;<0 -2>)@]"

and printer_op_compare_desc _pp_info _ctx ppf = function
  | Mtlb_ast.Lt ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mtlb_ast.Lt"
  | Mtlb_ast.Le ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mtlb_ast.Le"
  | Mtlb_ast.Eq ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mtlb_ast.Eq"
  | Mtlb_ast.Ne ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mtlb_ast.Ne"
  | Mtlb_ast.Ge ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mtlb_ast.Ge"
  | Mtlb_ast.Gt ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mtlb_ast.Gt"

and printer_stars pp_info ctx ppf = function
  | i_s_i_a ->
    printer_ast_node (printer_stars_desc pp_info) pp_info ctx ppf i_s_i_a

and printer_stars_desc pp_info ctx ppf = function
  | (i_o, s) ->
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ "
      else
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_tuple_item then
      Format.fprintf ppf "%,@[<hv 2>(@,";
    Format.fprintf ppf "%,@[<hv 0>";
    printer_op_stars_desc pp_info Og_precedence.Ck_tuple_item ppf i_o;
    Format.fprintf ppf "%,,@ ";
    Og_printer.printer_String Og_precedence.Ck_tuple_item ppf s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
      else
    if ctx = Og_precedence.Ck_tuple_item then
      Format.fprintf ppf "%,@;<0 -2>)@]"

and printer_op_stars_desc _pp_info _ctx ppf = function
  | Mtlb_ast.Star ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mtlb_ast.Star"
  | Mtlb_ast.Dot_star ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mtlb_ast.Dot_star"

and printer_divs pp_info ctx ppf = function
  | i_d_i_a ->
    printer_ast_node (printer_divs_desc pp_info) pp_info ctx ppf i_d_i_a

and printer_divs_desc pp_info ctx ppf = function
  | (i_o, s) ->
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ "
      else
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_tuple_item then
      Format.fprintf ppf "%,@[<hv 2>(@,";
    Format.fprintf ppf "%,@[<hv 0>";
    printer_op_divs_desc pp_info Og_precedence.Ck_tuple_item ppf i_o;
    Format.fprintf ppf "%,,@ ";
    Og_printer.printer_String Og_precedence.Ck_tuple_item ppf s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
      else
    if ctx = Og_precedence.Ck_tuple_item then
      Format.fprintf ppf "%,@;<0 -2>)@]"

and printer_op_divs_desc _pp_info _ctx ppf = function
  | Mtlb_ast.Slash ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mtlb_ast.Slash"
  | Mtlb_ast.Bslash ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mtlb_ast.Bslash"
  | Mtlb_ast.Dot_slash ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mtlb_ast.Dot_slash"
  | Mtlb_ast.Dot_bslash ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mtlb_ast.Dot_bslash"
;;

(* Defining top printers. *)

let print_parsing ppf = printer_parsing Og_precedence.Ck_toplevel ppf
;;

let print_mtlb_constant ppf =
  printer_mtlb_constant Og_precedence.Ck_toplevel ppf
;;

let print_mtlb_ast pp_info ppf =
  printer_mtlb_ast pp_info Og_precedence.Ck_toplevel ppf

and print_mtlb_ast_desc pp_info ppf =
  printer_mtlb_ast_desc pp_info Og_precedence.Ck_toplevel ppf

and print_exprs pp_info ppf =
  printer_exprs pp_info Og_precedence.Ck_toplevel ppf

and print_exprs_desc pp_info ppf =
  printer_exprs_desc pp_info Og_precedence.Ck_toplevel ppf

and print_exprsep pp_info ppf =
  printer_exprsep pp_info Og_precedence.Ck_toplevel ppf

and print_exprsep_desc pp_info ppf =
  printer_exprsep_desc pp_info Og_precedence.Ck_toplevel ppf

and print_sep pp_info ppf = printer_sep pp_info Og_precedence.Ck_toplevel ppf

and print_sep_desc pp_info ppf =
  printer_sep_desc pp_info Og_precedence.Ck_toplevel ppf

and print_expr pp_info ppf =
  printer_expr pp_info Og_precedence.Ck_toplevel ppf

and print_expr_desc pp_info ppf =
  printer_expr_desc pp_info Og_precedence.Ck_toplevel ppf

and print_word_list pp_info ppf =
  printer_word_list pp_info Og_precedence.Ck_toplevel ppf

and print_word_list_desc pp_info ppf =
  printer_word_list_desc pp_info Og_precedence.Ck_toplevel ppf

and print_wcmds_desc pp_info ppf =
  printer_wcmds_desc pp_info Og_precedence.Ck_toplevel ppf

and print_expression pp_info ppf =
  printer_expression pp_info Og_precedence.Ck_toplevel ppf

and print_expression_desc pp_info ppf =
  printer_expression_desc pp_info Og_precedence.Ck_toplevel ppf

and print_command pp_info ppf =
  printer_command pp_info Og_precedence.Ck_toplevel ppf

and print_command_desc pp_info ppf =
  printer_command_desc pp_info Og_precedence.Ck_toplevel ppf

and print_jump_command pp_info ppf =
  printer_jump_command pp_info Og_precedence.Ck_toplevel ppf

and print_jump_command_desc pp_info ppf =
  printer_jump_command_desc pp_info Og_precedence.Ck_toplevel ppf

and print_primary_expr pp_info ppf =
  printer_primary_expr pp_info Og_precedence.Ck_toplevel ppf

and print_primary_expr_desc pp_info ppf =
  printer_primary_expr_desc pp_info Og_precedence.Ck_toplevel ppf

and print_identifier pp_info ppf =
  printer_identifier pp_info Og_precedence.Ck_toplevel ppf

and print_identifier_desc pp_info ppf =
  printer_identifier_desc pp_info Og_precedence.Ck_toplevel ppf

and print_meta_identifier pp_info ppf =
  printer_meta_identifier pp_info Og_precedence.Ck_toplevel ppf

and print_meta_identifier_desc pp_info ppf =
  printer_meta_identifier_desc pp_info Og_precedence.Ck_toplevel ppf

and print_superclass_identifier pp_info ppf =
  printer_superclass_identifier pp_info Og_precedence.Ck_toplevel ppf

and print_superclass_identifier_desc pp_info ppf =
  printer_superclass_identifier_desc pp_info Og_precedence.Ck_toplevel ppf

and print_arg_list pp_info ppf =
  printer_arg_list pp_info Og_precedence.Ck_toplevel ppf

and print_arg_list_desc pp_info ppf =
  printer_arg_list_desc pp_info Og_precedence.Ck_toplevel ppf

and print_arg pp_info ppf = printer_arg pp_info Og_precedence.Ck_toplevel ppf

and print_arg_desc pp_info ppf =
  printer_arg_desc pp_info Og_precedence.Ck_toplevel ppf

and print_oper_expr pp_info ppf =
  printer_oper_expr pp_info Og_precedence.Ck_toplevel ppf

and print_oper_expr_desc pp_info ppf =
  printer_oper_expr_desc pp_info Og_precedence.Ck_toplevel ppf

and print_simple_expr pp_info ppf =
  printer_simple_expr pp_info Og_precedence.Ck_toplevel ppf

and print_simple_expr_desc pp_info ppf =
  printer_simple_expr_desc pp_info Og_precedence.Ck_toplevel ppf

and print_constant pp_info ppf =
  printer_constant pp_info Og_precedence.Ck_toplevel ppf

and print_constant_desc pp_info ppf =
  printer_constant_desc pp_info Og_precedence.Ck_toplevel ppf

and print_param_list pp_info ppf =
  printer_param_list pp_info Og_precedence.Ck_toplevel ppf

and print_param_list_desc pp_info ppf =
  printer_param_list_desc pp_info Og_precedence.Ck_toplevel ppf

and print_assign_lhs pp_info ppf =
  printer_assign_lhs pp_info Og_precedence.Ck_toplevel ppf

and print_assign_lhs_desc pp_info ppf =
  printer_assign_lhs_desc pp_info Og_precedence.Ck_toplevel ppf

and print_assign_expr pp_info ppf =
  printer_assign_expr pp_info Og_precedence.Ck_toplevel ppf

and print_assign_expr_desc pp_info ppf =
  printer_assign_expr_desc pp_info Og_precedence.Ck_toplevel ppf

and print_declaration pp_info ppf =
  printer_declaration pp_info Og_precedence.Ck_toplevel ppf

and print_declaration_desc pp_info ppf =
  printer_declaration_desc pp_info Og_precedence.Ck_toplevel ppf

and print_decl2 pp_info ppf =
  printer_decl2 pp_info Og_precedence.Ck_toplevel ppf

and print_decl2_desc pp_info ppf =
  printer_decl2_desc pp_info Og_precedence.Ck_toplevel ppf

and print_case_list pp_info ppf =
  printer_case_list pp_info Og_precedence.Ck_toplevel ppf

and print_case_list_desc pp_info ppf =
  printer_case_list_desc pp_info Og_precedence.Ck_toplevel ppf

and print_switch_case pp_info ppf =
  printer_switch_case pp_info Og_precedence.Ck_toplevel ppf

and print_switch_case_desc pp_info ppf =
  printer_switch_case_desc pp_info Og_precedence.Ck_toplevel ppf

and print_default_case pp_info ppf =
  printer_default_case pp_info Og_precedence.Ck_toplevel ppf

and print_default_case_desc pp_info ppf =
  printer_default_case_desc pp_info Og_precedence.Ck_toplevel ppf

and print_opt_list pp_info ppf =
  printer_opt_list pp_info Og_precedence.Ck_toplevel ppf

and print_opt_list_desc pp_info ppf =
  printer_opt_list_desc pp_info Og_precedence.Ck_toplevel ppf

and print_if_command pp_info ppf =
  printer_if_command pp_info Og_precedence.Ck_toplevel ppf

and print_if_command_desc pp_info ppf =
  printer_if_command_desc pp_info Og_precedence.Ck_toplevel ppf

and print_if_cmd pp_info ppf =
  printer_if_cmd pp_info Og_precedence.Ck_toplevel ppf

and print_if_cmd_desc pp_info ppf =
  printer_if_cmd_desc pp_info Og_precedence.Ck_toplevel ppf

and print_else_clause pp_info ppf =
  printer_else_clause pp_info Og_precedence.Ck_toplevel ppf

and print_else_clause_desc pp_info ppf =
  printer_else_clause_desc pp_info Og_precedence.Ck_toplevel ppf

and print_loop_command pp_info ppf =
  printer_loop_command pp_info Og_precedence.Ck_toplevel ppf

and print_loop_command_desc pp_info ppf =
  printer_loop_command_desc pp_info Og_precedence.Ck_toplevel ppf

and print_except_command pp_info ppf =
  printer_except_command pp_info Og_precedence.Ck_toplevel ppf

and print_except_command_desc pp_info ppf =
  printer_except_command_desc pp_info Og_precedence.Ck_toplevel ppf

and print_mfunction pp_info ppf =
  printer_mfunction pp_info Og_precedence.Ck_toplevel ppf

and print_mfunction_desc pp_info ppf =
  printer_mfunction_desc pp_info Og_precedence.Ck_toplevel ppf

and print_body pp_info ppf =
  printer_body pp_info Og_precedence.Ck_toplevel ppf

and print_body_desc pp_info ppf =
  printer_body_desc pp_info Og_precedence.Ck_toplevel ppf

and print_endfun pp_info ppf =
  printer_endfun pp_info Og_precedence.Ck_toplevel ppf

and print_endfun_desc pp_info ppf =
  printer_endfun_desc pp_info Og_precedence.Ck_toplevel ppf

and print_return_list pp_info ppf =
  printer_return_list pp_info Og_precedence.Ck_toplevel ppf

and print_return_list_desc pp_info ppf =
  printer_return_list_desc pp_info Og_precedence.Ck_toplevel ppf

and print_compare pp_info ppf =
  printer_compare pp_info Og_precedence.Ck_toplevel ppf

and print_compare_desc pp_info ppf =
  printer_compare_desc pp_info Og_precedence.Ck_toplevel ppf

and print_op_compare_desc pp_info ppf =
  printer_op_compare_desc pp_info Og_precedence.Ck_toplevel ppf

and print_stars pp_info ppf =
  printer_stars pp_info Og_precedence.Ck_toplevel ppf

and print_stars_desc pp_info ppf =
  printer_stars_desc pp_info Og_precedence.Ck_toplevel ppf

and print_op_stars_desc pp_info ppf =
  printer_op_stars_desc pp_info Og_precedence.Ck_toplevel ppf

and print_divs pp_info ppf =
  printer_divs pp_info Og_precedence.Ck_toplevel ppf

and print_divs_desc pp_info ppf =
  printer_divs_desc pp_info Og_precedence.Ck_toplevel ppf

and print_op_divs_desc pp_info ppf =
  printer_op_divs_desc pp_info Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.5+dev0 generated code. *)
