(***********************************************************************)
(*                                                                     *)
(*                           Matlab Parser                             *)
(*                                                                     *)
(*          J.Ph Chancelier, Enpc/Cermics                              *)
(*                                                                     *)
(*  Copyright 2012-2019,                                               *)
(*  Ecole Nationale des ponts et chaussées                             *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* $Id: mtlb_location.mli,v 1.1 2019-05-10 14:09:18 jpc Exp $ *)

type position = Lexing.position = {
  pos_fname : string;
  pos_lnum : int;
  pos_bol : int;
  pos_cnum : int;
}
;;

type t = {
  loc_beg : position;
  loc_end : position;
}
(** The location of an AST node,
    beginning and ending position of its corresponding source text. *)
;;

val init : Lexing.lexbuf -> Path.file_name -> unit;;
val mk_loc : position -> position -> t;;
val none : t;;
val print : Format.formatter -> t -> unit;;

(*
 Local Variables:
  compile-command: "cd ../../..; make"
  End:
*)
