(***********************************************************************)
(*                                                                     *)
(*                           Matlab Parser                             *)
(*                                                                     *)
(*          J.Ph Chancelier, Enpc/Cermics                              *)
(*                                                                     *)
(*  Copyright 2012-2019,                                               *)
(*  Ecole Nationale des ponts et chaussées                             *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* $Id: mtlb_syntaxerr.ml,v 1.1 2019-05-10 14:09:18 jpc Exp $ *)

type error =
  | Other of Mtlb_location.t
;;

exception Error of error;;

let report_error ppf = function
  | Other loc ->
    Format.fprintf ppf "@[Syntax error (matlab parser): %a@]@."
      Mtlb_location.print loc
;;

(*
 Local Variables:
  compile-command: "cd ../../..; make"
  End:
*)
