(***********************************************************************)
(*                                                                     *)
(*                           Matlab Parser                             *)
(*                                                                     *)
(*          J.Ph Chancelier, Enpc/Cermics                              *)
(*                                                                     *)
(*  Copyright 2012-2019,                                               *)
(*  Ecole Nationale des ponts et chaussées                             *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* $Id: mtlb_to_rewritten_ast.ml,v 1.1 2019-05-10 14:09:18 jpc Exp $ *)

(* Parse a file *)

let read_mtlb_file efname =
  let mtlb_ast = Mtlb_to_ast.read_mtlb_file efname in
  Mtlb_rewrite_ast.rewrite_mtlb_ast mtlb_ast
;;

(* Parse a string *)

let read_mtlb_string s =
  let mtlb_ast = Mtlb_to_ast.read_mtlb_string s in
  Mtlb_rewrite_ast.rewrite_mtlb_ast mtlb_ast
;;

(*
 Local Variables:
  compile-command: "cd ../../..; make"
  End:
*)
