(***********************************************************************)
(*                                                                     *)
(*                               Simport                               *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2010-2019,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* $Id: mdl_action.mli,v 1.1 2019-05-10 14:07:13 jpc Exp $ *)

(** {3 From models with split links to models with action links} *)

(** From explicit split link model to explicit action link models:
  activation is translated to event generator blocks and event links. *)

(** Translate all the activation of split link blocks
  to an explicit_model with action links.
*)
val action_model :
  Mdl_split_ast.split_model ->
  Mdl_action_ast.action_model
;;

(*
 Local Variables:
  compile-command: "cd ../../..; make"
  End:
*)
