(***********************************************************************)
(*                                                                     *)
(*                               Simport                               *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2010-2019,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* $Id: mdl_ast_functions.mli,v 1.1 2019-05-10 14:07:13 jpc Exp $ *)

val make_binding : Ident.ident -> 'a -> 'a Binding.ident_binding;;

(*
val config_set_ident : Ident.ident;;
*)
val config_set_longident : Mdl_ast.configuration_longident;;
val data_type_ident : Ident.ident;;
val dimension_ident : Ident.ident;;
val location_ident : Ident.ident;;
val port_ident : Ident.ident;;
val port_dimensions_ident : Ident.ident;;
val port_number_ident : Ident.ident;;
val string_ident : Ident.ident;;
val saved_character_encoding_ident : Ident.ident;;
val side_ident : Ident.ident;;
val system_ident : Ident.ident;;
val tag_ident : Ident.ident;;
val treat_as_atomic_unit_ident : Ident.ident;;
val sf_block_type_ident : Ident.ident;;
val system_sample_time_ident : Ident.ident;;
val zoom_factor_ident : Ident.ident;;
val sample_time_ident : Ident.ident;;
val action_type_ident : Ident.ident;;
val array_ident : Ident.ident;;
val trigger_type_ident : Ident.ident;;
val value_ident : Ident.ident;;
val interface_name_ident : Ident.ident;;
val text_ident : Ident.ident;;
val type_ident : Ident.ident;;
val version_ident : Ident.ident;;
val sid_ident : Ident.ident;;

(* Stateflow (lowercase) keywords *)

val larray_ident : Ident.ident;;
val lchart_ident : Ident.ident;;
val ldata_ident : Ident.ident;;
val ldst_ident : Ident.ident;;
val leml_ident : Ident.ident;;
val lenable_ident : Ident.ident;;
val levent_ident : Ident.ident;;
val lexecution_order_ident : Ident.ident;;
val lfirst_data_ident : Ident.ident;;
val lfirst_event_ident : Ident.ident;;
val lfirst_index_ident : Ident.ident;;
val lfirst_junction_ident : Ident.ident;;
val lfirst_transition_ident : Ident.ident;;
val lfirst_target_ident : Ident.ident;;
val lid_ident : Ident.ident;;
val linstance_ident : Ident.ident;;
val lintersection_ident : Ident.ident;;
val ljunction_ident : Ident.ident;;
val llabel_string_ident : Ident.ident;;
val llink_node_ident : Ident.ident;;
val lmachine_ident : Ident.ident;;
val lchart_file_number_ident : Ident.ident;;
val lname_ident : Ident.ident;;
val lprops_ident : Ident.ident;;
val lscope_ident : Ident.ident;;
val lsize_ident : Ident.ident;;
val lsrc_ident : Ident.ident;;
val lss_id_number_ident : Ident.ident;;
val lstate_ident : Ident.ident;;
val ltarget_ident : Ident.ident;;
val ltransition_ident : Ident.ident;;
val ltree_node_ident : Ident.ident;;
val ltrigger_ident : Ident.ident;;
val ltype_ident : Ident.ident;;
val lscript_ident : Ident.ident;;
val lparamIndexForInitFromWorkspace_ident : Ident.ident;;

val make_dimension_binding :
  Mdl_ast.model_value -> Mdl_ast.model_value Binding.ident_binding
;;

val make_port_binding :
  Mdl_ast.model_value -> Mdl_ast.model_value Binding.ident_binding
;;

val make_port_number_binding :
  Mdl_ast.model_value -> Mdl_ast.model_value Binding.ident_binding
;;

val make_system_binding :
  Mdl_ast.model_value -> Mdl_ast.model_value Binding.ident_binding
;;

val make_treat_as_atomic_unit_binding :
  Mdl_ast.model_value -> Mdl_ast.model_value Binding.ident_binding
;;

val make_sf_block_type_binding :
  Mdl_ast.model_value -> Mdl_ast.model_value Binding.ident_binding
;;

val make_interface_block_parameter :
  Ident.ident -> 'a -> 'a Binding.ident_binding
;;

val make_ident : string -> Ident.ident;;

val mdl_name_of_vendor : Mdl_ast.vendor_ident -> Ast_types.mdl_name;;

(*
 Local Variables:
  compile-command: "cd ../../..; make"
  End:
*)
