(* Defining top printers. *)

let print_ast_node pp_a ppf =
  printer_ast_node pp_a Og_precedence.Ck_toplevel ppf
;;

let print_model_ident ppf = printer_model_ident Og_precedence.Ck_toplevel ppf
;;

let print_block_name ppf = printer_block_name Og_precedence.Ck_toplevel ppf

and print_system_name ppf = printer_system_name Og_precedence.Ck_toplevel ppf

and print_prop_name ppf = printer_prop_name Og_precedence.Ck_toplevel ppf

and print_class_name ppf = printer_class_name Og_precedence.Ck_toplevel ppf

and print_block_source_block ppf =
  printer_block_source_block Og_precedence.Ck_toplevel ppf

and print_block_source_type ppf =
  printer_block_source_type Og_precedence.Ck_toplevel ppf

and print_line_name ppf = printer_line_name Og_precedence.Ck_toplevel ppf

and print_annotation_name ppf =
  printer_annotation_name Og_precedence.Ck_toplevel ppf

and print_port_name ppf = printer_port_name Og_precedence.Ck_toplevel ppf

and print_port_number ppf = printer_port_number Og_precedence.Ck_toplevel ppf

and print_object_name ppf = printer_object_name Og_precedence.Ck_toplevel ppf

and print_backup_class_name ppf =
  printer_backup_class_name Og_precedence.Ck_toplevel ppf

and print_array_name ppf = printer_array_name Og_precedence.Ck_toplevel ppf

and print_ui_name ppf = printer_ui_name Og_precedence.Ck_toplevel ppf

and print_matstruct_name ppf =
  printer_matstruct_name Og_precedence.Ck_toplevel ppf
;;

let print_enum ppf = printer_enum Og_precedence.Ck_toplevel ppf
;;

let print_configuration_ident ppf =
  printer_configuration_ident Og_precedence.Ck_toplevel ppf
;;

let print_configuration_longident ppf =
  printer_configuration_longident Og_precedence.Ck_toplevel ppf
;;

let print_tag_ident ppf = printer_tag_ident Og_precedence.Ck_toplevel ppf
;;

let print_line_type ppf = printer_line_type Og_precedence.Ck_toplevel ppf

and print_connect_type ppf =
  printer_connect_type Og_precedence.Ck_toplevel ppf

and print_array_type ppf = printer_array_type Og_precedence.Ck_toplevel ppf

and print_object_type ppf = printer_object_type Og_precedence.Ck_toplevel ppf

and print_matstruct_type ppf =
  printer_matstruct_type Og_precedence.Ck_toplevel ppf

and print_interface_block_parameter_type ppf =
  printer_interface_block_parameter_type Og_precedence.Ck_toplevel ppf
;;

let print_custom_property_type ppf =
  printer_custom_property_type Og_precedence.Ck_toplevel ppf
;;

let print_naturals ppf = printer_naturals Og_precedence.Ck_toplevel ppf
;;

let print_integer_matrix ppf =
  printer_integer_matrix Og_precedence.Ck_toplevel ppf
;;

let print_object_id ppf = printer_object_id Og_precedence.Ck_toplevel ppf
;;

let print_zorder ppf = printer_zorder Og_precedence.Ck_toplevel ppf
;;

let print_simple_values ppf =
  printer_simple_values Og_precedence.Ck_toplevel ppf

and print_simple_value ppf =
  printer_simple_value Og_precedence.Ck_toplevel ppf
;;

let print_simple_binding ppf =
  printer_simple_binding Og_precedence.Ck_toplevel ppf
;;

let print_model_values ppf =
  printer_model_values Og_precedence.Ck_toplevel ppf

and print_model_value ppf = printer_model_value Og_precedence.Ck_toplevel ppf

and print_bindings ppf = printer_bindings Og_precedence.Ck_toplevel ppf

and print_binding ppf = printer_binding Og_precedence.Ck_toplevel ppf
;;

let print_poly_annotation_graphical_default pp_font_and_color ppf =
  printer_poly_annotation_graphical_default pp_font_and_color
    Og_precedence.Ck_toplevel
    ppf

and print_horizontal_alignment ppf =
  printer_horizontal_alignment Og_precedence.Ck_toplevel ppf

and print_vertical_alignment ppf =
  printer_vertical_alignment Og_precedence.Ck_toplevel ppf
;;

let print_font_items ppf = printer_font_items Og_precedence.Ck_toplevel ppf

and print_font_item ppf = printer_font_item Og_precedence.Ck_toplevel ppf
;;

let print_font_and_color ppf =
  printer_font_and_color Og_precedence.Ck_toplevel ppf

and print_color ppf = printer_color Og_precedence.Ck_toplevel ppf
;;

let print_block_graphical_defaults ppf =
  printer_block_graphical_defaults Og_precedence.Ck_toplevel ppf

and print_block_graphical_default ppf =
  printer_block_graphical_default Og_precedence.Ck_toplevel ppf
;;

let print_block_parameter_defaults_list ppf =
  printer_block_parameter_defaults_list Og_precedence.Ck_toplevel ppf

and print_block_parameter_defaults ppf =
  printer_block_parameter_defaults Og_precedence.Ck_toplevel ppf
;;

let print_line_graphical_defaults ppf =
  printer_line_graphical_defaults Og_precedence.Ck_toplevel ppf

and print_line_graphical_default ppf =
  printer_line_graphical_default Og_precedence.Ck_toplevel ppf
;;

let print_mask_graphical_defaults ppf =
  printer_mask_graphical_defaults Og_precedence.Ck_toplevel ppf

and print_mask_graphical_default ppf =
  printer_mask_graphical_default Og_precedence.Ck_toplevel ppf

and print_mask_parameter_defaults ppf =
  printer_mask_parameter_defaults Og_precedence.Ck_toplevel ppf

and print_mask_parameter_default ppf =
  printer_mask_parameter_default Og_precedence.Ck_toplevel ppf
;;

let print_annotation_graphical_defaults ppf =
  printer_annotation_graphical_defaults Og_precedence.Ck_toplevel ppf

and print_annotation_graphical_default ppf =
  printer_annotation_graphical_default Og_precedence.Ck_toplevel ppf
;;

let print_lines ppf = printer_lines Og_precedence.Ck_toplevel ppf

and print_line ppf = printer_line Og_precedence.Ck_toplevel ppf

and print_line_items ppf = printer_line_items Og_precedence.Ck_toplevel ppf

and print_line_item ppf = printer_line_item Og_precedence.Ck_toplevel ppf

and print_source ppf = printer_source Og_precedence.Ck_toplevel ppf

and print_target ppf = printer_target Og_precedence.Ck_toplevel ppf

and print_connector ppf = printer_connector Og_precedence.Ck_toplevel ppf

and print_port_value ppf = printer_port_value Og_precedence.Ck_toplevel ppf

and print_destination ppf = printer_destination Og_precedence.Ck_toplevel ppf

and print_branch ppf = printer_branch Og_precedence.Ck_toplevel ppf

and print_branch_items ppf =
  printer_branch_items Og_precedence.Ck_toplevel ppf

and print_branch_item ppf = printer_branch_item Og_precedence.Ck_toplevel ppf

and print_points ppf = printer_points Og_precedence.Ck_toplevel ppf

and print_labels ppf = printer_labels Og_precedence.Ck_toplevel ppf
;;

let print_annotations ppf = printer_annotations Og_precedence.Ck_toplevel ppf

and print_annotation ppf = printer_annotation Og_precedence.Ck_toplevel ppf

and print_annotation_items ppf =
  printer_annotation_items Og_precedence.Ck_toplevel ppf

and print_annotation_item ppf =
  printer_annotation_item Og_precedence.Ck_toplevel ppf

and print_block_sid ppf = printer_block_sid Og_precedence.Ck_toplevel ppf

and print_block_sid_compound ppf =
  printer_block_sid_compound Og_precedence.Ck_toplevel ppf

and print_position ppf = printer_position Og_precedence.Ck_toplevel ppf
;;

let print_system_connectors ppf =
  printer_system_connectors Og_precedence.Ck_toplevel ppf

and print_system_connector ppf =
  printer_system_connector Og_precedence.Ck_toplevel ppf
;;

let print_array_description ppf =
  printer_array_description Og_precedence.Ck_toplevel ppf

and print_dimension ppf = printer_dimension Og_precedence.Ck_toplevel ppf

and print_array_items ppf = printer_array_items Og_precedence.Ck_toplevel ppf

and print_array_item ppf = printer_array_item Og_precedence.Ck_toplevel ppf

and print_vendor_binding ppf =
  printer_vendor_binding Og_precedence.Ck_toplevel ppf

and print_block_vendor ppf =
  printer_block_vendor Og_precedence.Ck_toplevel ppf

and print_vendor_items ppf =
  printer_vendor_items Og_precedence.Ck_toplevel ppf

and print_vendor_item ppf = printer_vendor_item Og_precedence.Ck_toplevel ppf

and print_dollar_binding ppf =
  printer_dollar_binding Og_precedence.Ck_toplevel ppf

and print_vendor_ident ppf =
  printer_vendor_ident Og_precedence.Ck_toplevel ppf

and print_custom_property ppf =
  printer_custom_property Og_precedence.Ck_toplevel ppf

and print_matstruct_items ppf =
  printer_matstruct_items Og_precedence.Ck_toplevel ppf

and print_matstruct_item ppf =
  printer_matstruct_item Og_precedence.Ck_toplevel ppf

and print_enum_str_pairs ppf =
  printer_enum_str_pairs Og_precedence.Ck_toplevel ppf

and print_enum_str_pair ppf =
  printer_enum_str_pair Og_precedence.Ck_toplevel ppf

and print_object_description ppf =
  printer_object_description Og_precedence.Ck_toplevel ppf

and print_object_item ppf = printer_object_item Og_precedence.Ck_toplevel ppf
;;

let print_block_mask_item ppf =
  printer_block_mask_item Og_precedence.Ck_toplevel ppf

and print_mdl_expression ppf =
  printer_mdl_expression Og_precedence.Ck_toplevel ppf

and print_mdl_comma_bools ppf =
  printer_mdl_comma_bools Og_precedence.Ck_toplevel ppf

and print_mdl_pipe_expressions ppf =
  printer_mdl_pipe_expressions Og_precedence.Ck_toplevel ppf

and print_mdl_pipe_texts ppf =
  printer_mdl_pipe_texts Og_precedence.Ck_toplevel ppf

and print_mdl_comma_texts ppf =
  printer_mdl_comma_texts Og_precedence.Ck_toplevel ppf

and print_mdl_semi_texts ppf =
  printer_mdl_semi_texts Og_precedence.Ck_toplevel ppf
;;

let print_blocks ppf = printer_blocks Og_precedence.Ck_toplevel ppf

and print_block ppf = printer_block Og_precedence.Ck_toplevel ppf

and print_block_items ppf = printer_block_items Og_precedence.Ck_toplevel ppf

and print_block_item ppf = printer_block_item Og_precedence.Ck_toplevel ppf

and print_block_port ppf = printer_block_port Og_precedence.Ck_toplevel ppf

and print_port_bindings ppf =
  printer_port_bindings Og_precedence.Ck_toplevel ppf

and print_port_binding ppf =
  printer_port_binding Og_precedence.Ck_toplevel ppf

and print_block_ports_description ppf =
  printer_block_ports_description Og_precedence.Ck_toplevel ppf

and print_system ppf = printer_system Og_precedence.Ck_toplevel ppf
;;

let print_model_section ppf =
  printer_model_section Og_precedence.Ck_toplevel ppf

and print_configuration_set_parameters ppf =
  printer_configuration_set_parameters Og_precedence.Ck_toplevel ppf

and print_configuration_set_parameter ppf =
  printer_configuration_set_parameter Og_precedence.Ck_toplevel ppf

and print_graphical_interface_items ppf =
  printer_graphical_interface_items Og_precedence.Ck_toplevel ppf

and print_graphical_interface_item ppf =
  printer_graphical_interface_item Og_precedence.Ck_toplevel ppf

and print_io_port_binding_items ppf =
  printer_io_port_binding_items Og_precedence.Ck_toplevel ppf

and print_io_port_binding_item ppf =
  printer_io_port_binding_item Og_precedence.Ck_toplevel ppf

and print_model_configurations ppf =
  printer_model_configurations Og_precedence.Ck_toplevel ppf

and print_model_configuration ppf =
  printer_model_configuration Og_precedence.Ck_toplevel ppf

and print_model_configuration_set_section ppf =
  printer_model_configuration_set_section Og_precedence.Ck_toplevel ppf

and print_configuration_set ppf =
  printer_configuration_set Og_precedence.Ck_toplevel ppf

and print_model_workspace ppf =
  printer_model_workspace Og_precedence.Ck_toplevel ppf

and print_workspace_data_source_type ppf =
  printer_workspace_data_source_type Og_precedence.Ck_toplevel ppf

and print_model_workspace_items ppf =
  printer_model_workspace_items Og_precedence.Ck_toplevel ppf

and print_model_workspace_item ppf =
  printer_model_workspace_item Og_precedence.Ck_toplevel ppf
;;

let print_matdata_section ppf =
  printer_matdata_section Og_precedence.Ck_toplevel ppf

and print_matdata_section_item ppf =
  printer_matdata_section_item Og_precedence.Ck_toplevel ppf

and print_matdata_records ppf =
  printer_matdata_records Og_precedence.Ck_toplevel ppf

and print_matdata_record ppf =
  printer_matdata_record Og_precedence.Ck_toplevel ppf
;;

let print_stateflow_section_item ppf =
  printer_stateflow_section_item Og_precedence.Ck_toplevel ppf

and print_stateflow_items ppf =
  printer_stateflow_items Og_precedence.Ck_toplevel ppf

and print_stateflow_item ppf =
  printer_stateflow_item Og_precedence.Ck_toplevel ppf
;;

let print_stateflow_section ppf =
  printer_stateflow_section Og_precedence.Ck_toplevel ppf

and print_stateflow_section_items ppf =
  printer_stateflow_section_items Og_precedence.Ck_toplevel ppf
;;

let print_interface_block_parameters ppf =
  printer_interface_block_parameters Og_precedence.Ck_toplevel ppf

and print_interface_block_parameter ppf =
  printer_interface_block_parameter Og_precedence.Ck_toplevel ppf
;;

let print_interface_block ppf =
  printer_interface_block Og_precedence.Ck_toplevel ppf
;;

let print_interface_section ppf =
  printer_interface_section Og_precedence.Ck_toplevel ppf
;;

let print_implementation_section ppf =
  printer_implementation_section Og_precedence.Ck_toplevel ppf

and print_implementation_section_item ppf =
  printer_implementation_section_item Og_precedence.Ck_toplevel ppf
;;

let print_simulink_file_contents ppf =
  printer_simulink_file_contents Og_precedence.Ck_toplevel ppf
;;

let print_simulink_file ppf =
  printer_simulink_file Og_precedence.Ck_toplevel ppf
;;
