(***********************************************************************)
(*                                                                     *)
(*                               Simport                               *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2010-2019,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* $Id: mdl_block_types.mli,v 1.1 2019-05-10 14:07:13 jpc Exp $ *)

type block_type =

   | M_S_Function | S_Function
   | Reference
   | SubSystem

   | Abs
   | ActionPort
   | Actuator
   | ArithShift
   | Assertion
   | Assignment
   | AsynchronousTaskSpecification
   | Backlash
   | Bias
   | Buffer
   | BusAssignment
   | BusCreator
   | BusSelector
   | BusToVector
   | Clock
   | CombinatorialLogic
   | ComplexToMagnitudeAngle
   | ComplexToRealImag
   | Concatenate
   | Constant
   | ConstellationDiagram
   | DataStoreMemory
   | DataStoreRead
   | DataStoreWrite
   | DataTypeConversion
   | DataTypeDuplicate
   | DeadZone
   | Delay
   | Demux
   | Derivative
   | DigitalClock
   | DiscreteFilter
   | DiscreteFir
   | DiscreteIntegrator
   | DiscretePulseGenerator
   | DiscreteStateSpace
   | DiscreteTransferFcn
   | DiscreteZeroPole
   | Display
   | DotProduct
   | DSPFlip
   | ElementaryMath
   | EnablePort
   | Fcn
   | Find
   | ForEach
   | ForIterator
   | FrameConversion
   | From
   | FromFile
   | FromWorkspace
   | FunctionCallSplit
   | FunctionCallFeedbackLatch
   | Gain
   | Goto
   | GotoTagVisibility
   | Ground
   | HitCross
   | If
   | InitialCondition
   | Inport
   | InportShadow
   | Integrator
   | Interpolation_n_D
   | Logic
   | Lookup
   | Lookup2D
   | LookupNDDirect
   | Lookup_n_D
   | MATLABFcn
   | MATLABSystem
   | MagnitudeAngleToComplex
   | ManualSwitch
   | Math
   | Memory
   | Merge
   | MinMax
   | ModelReference
   | MultiPortSwitch
   | Mux
   | Outport
   | PMComponent
   | PMIOPort
   | PermuteDimensions
   | Polyval
   | PreLookup
   | Probe
   | Product
   | Quantizer
   | RandomNumber
   | RateLimiter
   | RateTransition
   | RealImagToComplex
   | RelationalOperator
   | Relay
   | Reshape
   | Rounding
   | SampleTimeMath
   | Saturate
   | Scope
   | SecondOrderIntegrator
   | Selector
   | Sensor
   | SignalConversion
   | SignalFromWorkspace
   | SignalGenerator
   | SignalSpecification
   | SignalToWorkspace
   | SignalViewerScope
   | Signum
   | Sin
   | SpectrumAnalyzer
   | Sqrt
   | Squeeze
   | StateSpace
   | Step
   | Stop
   | Sum
   | Switch
   | SwitchCase
   | Terminator
   | TimeScope
   | ToFile
   | ToWorkspace
   | TransferFcn
   | TransportDelay
   | TriggerPort
   | Trigonometry
   | TwoWayConnection
   | UnaryMinus
   | Unbuffer
   | UniformRandomNumber
   | UnitConversion
   | UnitDelay
   | VariableTransportDelay
   | VideoViewer
   | Width
   | WhileIterator
   | ZeroOrderHold
   | ZeroPole
;;

(*
 Local Variables:
  compile-command: "cd ../../..; make"
  End:
*)
