(***********************************************************************)
(*                                                                     *)
(*                               Simport                               *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2010-2019,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.5+dev0 generated code. *)

open Ident_print;;

open Ast_types_print;;

open Mdl_ast_print;;

let printer_stateflow_machine_ref ctx ppf = function
  | s -> printer_stateflow_ref ctx ppf s

and printer_stateflow_chart_ref ctx ppf = function
  | s -> printer_stateflow_ref ctx ppf s

and printer_stateflow_data_ref ctx ppf = function
  | s -> printer_stateflow_ref ctx ppf s

and printer_stateflow_event_ref ctx ppf = function
  | s -> printer_stateflow_ref ctx ppf s

and printer_stateflow_junction_ref ctx ppf = function
  | s -> printer_stateflow_ref ctx ppf s

and printer_stateflow_transition_ref ctx ppf = function
  | s -> printer_stateflow_ref ctx ppf s

and printer_stateflow_target_ref ctx ppf = function
  | s -> printer_stateflow_ref ctx ppf s

and printer_stateflow_chart_file_number_ref ctx ppf = function
  | n -> printer_natural ctx ppf n
;;

let printer_stateflow_link_node ctx ppf = function
  | {
      Mdl_parsing_ast.link_node_parent_ref = n;
      Mdl_parsing_ast.link_node_prev_ref = n0;
      Mdl_parsing_ast.link_node_next_ref = n1;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_parsing_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>link_node_parent_ref =";
    printer_natural Og_precedence.Ck_record_field ppf n;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>link_node_prev_ref =";
    printer_natural Og_precedence.Ck_record_field ppf n0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>link_node_next_ref =";
    printer_natural Og_precedence.Ck_record_field ppf n1;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"

and printer_stateflow_tree_node ctx ppf = function
  | {
      Mdl_parsing_ast.tree_node_parent_ref = n;
      Mdl_parsing_ast.tree_node_first_child_ref = n0;
      Mdl_parsing_ast.tree_node_prev_ref = n1;
      Mdl_parsing_ast.tree_node_next_ref = n2;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_parsing_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>tree_node_parent_ref =";
    printer_natural Og_precedence.Ck_record_field ppf n;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>tree_node_first_child_ref =";
    printer_natural Og_precedence.Ck_record_field ppf n0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>tree_node_prev_ref =";
    printer_natural Og_precedence.Ck_record_field ppf n1;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>tree_node_next_ref =";
    printer_natural Og_precedence.Ck_record_field ppf n2;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let rec printer_mdl_stateflow_items ctx ppf = function
  | m_l -> Og_printer.printer_List printer_mdl_stateflow_item ctx ppf m_l

and printer_mdl_stateflow_section_item ctx ppf = function
  | Mdl_parsing_ast.Mdl_stateflow_chart m ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_parsing_ast.Mdl_stateflow_chart";
    printer_mdl_stateflow_items Og_precedence.Ck_argument ppf m;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_parsing_ast.Mdl_stateflow_data m ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_parsing_ast.Mdl_stateflow_data";
    printer_mdl_stateflow_items Og_precedence.Ck_argument ppf m;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_parsing_ast.Mdl_stateflow_event m ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_parsing_ast.Mdl_stateflow_event";
    printer_mdl_stateflow_items Og_precedence.Ck_argument ppf m;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_parsing_ast.Mdl_stateflow_instance m ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_parsing_ast.Mdl_stateflow_instance";
    printer_mdl_stateflow_items Og_precedence.Ck_argument ppf m;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_parsing_ast.Mdl_stateflow_junction m ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_parsing_ast.Mdl_stateflow_junction";
    printer_mdl_stateflow_items Og_precedence.Ck_argument ppf m;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_parsing_ast.Mdl_stateflow_machine m ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_parsing_ast.Mdl_stateflow_machine";
    printer_mdl_stateflow_items Og_precedence.Ck_argument ppf m;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_parsing_ast.Mdl_stateflow_state m ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_parsing_ast.Mdl_stateflow_state";
    printer_mdl_stateflow_items Og_precedence.Ck_argument ppf m;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_parsing_ast.Mdl_stateflow_target m ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_parsing_ast.Mdl_stateflow_target";
    printer_mdl_stateflow_items Og_precedence.Ck_argument ppf m;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_parsing_ast.Mdl_stateflow_transition m ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_parsing_ast.Mdl_stateflow_transition";
    printer_mdl_stateflow_items Og_precedence.Ck_argument ppf m;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_mdl_stateflow_item ctx ppf = function
  | Mdl_parsing_ast.Mdl_stateflow_binding b ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_parsing_ast.Mdl_stateflow_binding";
    printer_binding Og_precedence.Ck_argument ppf b;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_parsing_ast.Mdl_stateflow_chart_ref s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_parsing_ast.Mdl_stateflow_chart_ref";
    printer_stateflow_chart_ref Og_precedence.Ck_argument ppf s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_parsing_ast.Mdl_stateflow_eml m_s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_parsing_ast.Mdl_stateflow_eml";
    Mdl_ast_print.printer_stateflow_eml_items
      Og_precedence.Ck_argument
      ppf
      m_s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_parsing_ast.Mdl_stateflow_execution_order n ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_parsing_ast.Mdl_stateflow_execution_order";
    printer_natural Og_precedence.Ck_argument ppf n;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_parsing_ast.Mdl_stateflow_first_data s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_parsing_ast.Mdl_stateflow_first_data";
    printer_stateflow_data_ref Og_precedence.Ck_argument ppf s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_parsing_ast.Mdl_stateflow_first_event s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_parsing_ast.Mdl_stateflow_first_event";
    printer_stateflow_event_ref Og_precedence.Ck_argument ppf s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_parsing_ast.Mdl_stateflow_first_junction s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_parsing_ast.Mdl_stateflow_first_junction";
    printer_stateflow_junction_ref Og_precedence.Ck_argument ppf s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_parsing_ast.Mdl_stateflow_first_transition s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_parsing_ast.Mdl_stateflow_first_transition";
    printer_stateflow_transition_ref Og_precedence.Ck_argument ppf s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_parsing_ast.Mdl_stateflow_first_target s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_parsing_ast.Mdl_stateflow_first_target";
    printer_stateflow_target_ref Og_precedence.Ck_argument ppf s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_parsing_ast.Mdl_stateflow_id s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_parsing_ast.Mdl_stateflow_id";
    printer_stateflow_id Og_precedence.Ck_argument ppf s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_parsing_ast.Mdl_stateflow_label_string m ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_parsing_ast.Mdl_stateflow_label_string";
    printer_mdl_text Og_precedence.Ck_argument ppf m;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_parsing_ast.Mdl_stateflow_link_node s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_parsing_ast.Mdl_stateflow_link_node";
    printer_stateflow_link_node Og_precedence.Ck_argument ppf s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_parsing_ast.Mdl_stateflow_tree_node s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_parsing_ast.Mdl_stateflow_tree_node";
    printer_stateflow_tree_node Og_precedence.Ck_argument ppf s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_parsing_ast.Mdl_stateflow_machine_ref s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_parsing_ast.Mdl_stateflow_machine_ref";
    printer_stateflow_machine_ref Og_precedence.Ck_argument ppf s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_parsing_ast.Mdl_stateflow_chart_file_number s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_parsing_ast.Mdl_stateflow_chart_file_number";
    printer_stateflow_chart_file_number_ref Og_precedence.Ck_argument ppf s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_parsing_ast.Mdl_stateflow_name m ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_parsing_ast.Mdl_stateflow_name";
    printer_mdl_name Og_precedence.Ck_argument ppf m;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_parsing_ast.Mdl_stateflow_scope i ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_parsing_ast.Mdl_stateflow_scope";
    printer_ident Og_precedence.Ck_argument ppf i; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_parsing_ast.Mdl_stateflow_props m_s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_parsing_ast.Mdl_stateflow_props";
    Mdl_ast_print.printer_stateflow_props_items
      Og_precedence.Ck_argument
      ppf
      m_s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_parsing_ast.Mdl_stateflow_ssid_number n ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_parsing_ast.Mdl_stateflow_ssid_number";
    printer_natural Og_precedence.Ck_argument ppf n;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_parsing_ast.Mdl_stateflow_trigger i ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_parsing_ast.Mdl_stateflow_trigger";
    printer_ident Og_precedence.Ck_argument ppf i; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_parsing_ast.Mdl_stateflow_type i ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_parsing_ast.Mdl_stateflow_type";
    printer_ident Og_precedence.Ck_argument ppf i; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_parsing_ast.Mdl_stateflow_src m_s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_parsing_ast.Mdl_stateflow_src";
    Mdl_ast_print.printer_stateflow_src_dst_items
      Og_precedence.Ck_argument
      ppf
      m_s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_parsing_ast.Mdl_stateflow_dst m_s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_parsing_ast.Mdl_stateflow_dst";
    Mdl_ast_print.printer_stateflow_src_dst_items
      Og_precedence.Ck_argument
      ppf
      m_s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_parsing_ast.Mdl_stateflow_plant_modeling_info ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_parsing_ast.Mdl_stateflow_plant_modeling_info"
;;

let rec printer_mdl_stateflow_section_items ctx ppf = function
  | m_l ->
    Og_printer.printer_List printer_mdl_stateflow_section_item ctx ppf m_l

and printer_mdl_stateflow_section ctx ppf = function
  | Mdl_parsing_ast.Mdl_stateflow_section m ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_parsing_ast.Mdl_stateflow_section";
    printer_mdl_stateflow_section_items Og_precedence.Ck_argument ppf m;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let printer_simulink_file_contents ctx ppf = function
  | m_p ->
    printer_poly_simulink_file_contents printer_mdl_stateflow_section
      ctx
      ppf
      m_p
;;

let printer_simulink_file ctx ppf = function
  | m_p ->
    printer_poly_simulink_file printer_mdl_stateflow_section ctx ppf m_p
;;

(* Defining top printers. *)

let print_stateflow_machine_ref ppf =
  printer_stateflow_machine_ref Og_precedence.Ck_toplevel ppf

and print_stateflow_chart_ref ppf =
  printer_stateflow_chart_ref Og_precedence.Ck_toplevel ppf

and print_stateflow_data_ref ppf =
  printer_stateflow_data_ref Og_precedence.Ck_toplevel ppf

and print_stateflow_event_ref ppf =
  printer_stateflow_event_ref Og_precedence.Ck_toplevel ppf

and print_stateflow_junction_ref ppf =
  printer_stateflow_junction_ref Og_precedence.Ck_toplevel ppf

and print_stateflow_transition_ref ppf =
  printer_stateflow_transition_ref Og_precedence.Ck_toplevel ppf

and print_stateflow_target_ref ppf =
  printer_stateflow_target_ref Og_precedence.Ck_toplevel ppf

and print_stateflow_chart_file_number_ref ppf =
  printer_stateflow_chart_file_number_ref Og_precedence.Ck_toplevel ppf
;;

let print_stateflow_link_node ppf =
  printer_stateflow_link_node Og_precedence.Ck_toplevel ppf

and print_stateflow_tree_node ppf =
  printer_stateflow_tree_node Og_precedence.Ck_toplevel ppf
;;

let print_mdl_stateflow_items ppf =
  printer_mdl_stateflow_items Og_precedence.Ck_toplevel ppf

and print_mdl_stateflow_section_item ppf =
  printer_mdl_stateflow_section_item Og_precedence.Ck_toplevel ppf

and print_mdl_stateflow_item ppf =
  printer_mdl_stateflow_item Og_precedence.Ck_toplevel ppf
;;

let print_mdl_stateflow_section_items ppf =
  printer_mdl_stateflow_section_items Og_precedence.Ck_toplevel ppf

and print_mdl_stateflow_section ppf =
  printer_mdl_stateflow_section Og_precedence.Ck_toplevel ppf
;;

let print_simulink_file_contents ppf =
  printer_simulink_file_contents Og_precedence.Ck_toplevel ppf
;;

let print_simulink_file ppf =
  printer_simulink_file Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.5+dev0 generated code. *)
