(***********************************************************************)
(*                                                                     *)
(*                               Simport                               *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2010-2019,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.5+dev0 generated code. *)

let printer_ident ctx ppf = function
  | i_i -> Ident_print.printer_ident ctx ppf i_i
;;

let printer_natural ctx ppf = function
  | a_n -> Ast_types_print.printer_natural ctx ppf a_n

and printer_deep_text ctx ppf = function
  | a_m -> Ast_types_print.printer_mdl_text ctx ppf a_m

and printer_deep_code ctx ppf = function
  | a_m -> Ast_types_print.printer_mdl_code ctx ppf a_m
;;

let printer_deep_port_number ctx ppf = function
  | m_p -> Mdl_ast_print.printer_port_number ctx ppf m_p

and printer_deep_port_name ctx ppf = function
  | m_p -> Mdl_ast_print.printer_port_name ctx ppf m_p

and printer_deep_line_name ctx ppf = function
  | m_l -> Mdl_ast_print.printer_line_name ctx ppf m_l

and printer_deep_array_name ctx ppf = function
  | m_a -> Mdl_ast_print.printer_array_name ctx ppf m_a

and printer_deep_prop_name ctx ppf = function
  | m_p -> Mdl_ast_print.printer_prop_name ctx ppf m_p

and printer_deep_class_name ctx ppf = function
  | m_c -> Mdl_ast_print.printer_class_name ctx ppf m_c

and printer_deep_line_connector ctx ppf = function
  | m_l -> Mdl_ast_print.printer_line_connector ctx ppf m_l

and printer_deep_labels ctx ppf = function
  | m_l -> Mdl_ast_print.printer_labels ctx ppf m_l

and printer_deep_block_name ctx ppf = function
  | m_b -> Mdl_ast_print.printer_block_name ctx ppf m_b

and printer_deep_system_name ctx ppf = function
  | m_s -> Mdl_ast_print.printer_system_name ctx ppf m_s

and printer_deep_array_type ctx ppf = function
  | m_a -> Mdl_ast_print.printer_array_type ctx ppf m_a

and printer_deep_sf_block_type ctx ppf = function
  | m_b -> Mdl_ast_print.printer_block_sf_block_type ctx ppf m_b

and printer_deep_name ctx ppf = function
  | a_m -> Ast_types_print.printer_mdl_name ctx ppf a_m
;;

let rec printer_deep_binding ctx ppf = function
  | d_b_i ->
    Binding_print.printer_ident_binding printer_deep_value ctx ppf d_b_i

and printer_deep_value ctx ppf = function
  | Mdl_basics_deep_ast.Deep_bool b ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_basics_deep_ast.Deep_bool";
    Og_printer.printer_Bool Og_precedence.Ck_argument ppf b;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_basics_deep_ast.Deep_float s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_basics_deep_ast.Deep_float";
    Og_printer.printer_String Og_precedence.Ck_argument ppf s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_basics_deep_ast.Deep_int s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_basics_deep_ast.Deep_int";
    Og_printer.printer_String Og_precedence.Ck_argument ppf s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_basics_deep_ast.Deep_string s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_basics_deep_ast.Deep_string";
    Og_printer.printer_String Og_precedence.Ck_argument ppf s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_basics_deep_ast.Deep_wstring w_w ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_basics_deep_ast.Deep_wstring";
    Wstring_print.printer_wstring Og_precedence.Ck_argument ppf w_w;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_basics_deep_ast.Deep_ident i ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_basics_deep_ast.Deep_ident";
    printer_ident Og_precedence.Ck_argument ppf i; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_basics_deep_ast.Deep_code d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_basics_deep_ast.Deep_code";
    printer_deep_code Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_basics_deep_ast.Deep_expression d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_basics_deep_ast.Deep_expression";
    printer_deep_text Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_basics_deep_ast.Deep_vector d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_basics_deep_ast.Deep_vector";
    printer_deep_values Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_basics_deep_ast.Deep_matrix d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_basics_deep_ast.Deep_matrix";
    printer_deep_values Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_basics_deep_ast.Deep_bindings d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_basics_deep_ast.Deep_bindings";
    printer_deep_bindings Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_deep_bindings ctx ppf = function
  | d_l -> Og_printer.printer_List printer_deep_binding ctx ppf d_l

and printer_deep_binding_table ctx ppf = function
  | i_d_h_t ->
    Hash_table_print.printer_t printer_ident printer_deep_binding
      ctx
      ppf
      i_d_h_t

and printer_deep_values ctx ppf = function
  | d_l -> Og_printer.printer_List printer_deep_value ctx ppf d_l
;;

let printer_deep_connection_type_side _ctx ppf = function
  | Mdl_basics_deep_ast.Deep_side_src ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.Deep_side_src"
  | Mdl_basics_deep_ast.Deep_side_dst ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.Deep_side_dst"
;;

let printer_deep_connection_type ctx ppf = function
  | {
      Mdl_basics_deep_ast.deep_connection_type_parent = d;
      Mdl_basics_deep_ast.deep_connection_type_self = d0;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>deep_connection_type_parent =";
    printer_deep_connection_type_side Og_precedence.Ck_record_field ppf d;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_connection_type_self =";
    printer_deep_connection_type_side Og_precedence.Ck_record_field ppf d0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let rec printer_deep_color ctx ppf = function
  | Mdl_basics_deep_ast.Deep_red ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.Deep_red"
  | Mdl_basics_deep_ast.Deep_green ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.Deep_green"
  | Mdl_basics_deep_ast.Deep_blue ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.Deep_blue"
  | Mdl_basics_deep_ast.Deep_cyan ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.Deep_cyan"
  | Mdl_basics_deep_ast.Deep_magenta ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.Deep_magenta"
  | Mdl_basics_deep_ast.Deep_yellow ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.Deep_yellow"
  | Mdl_basics_deep_ast.Deep_white ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.Deep_white"
  | Mdl_basics_deep_ast.Deep_black ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.Deep_black"
  | Mdl_basics_deep_ast.Deep_grey ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.Deep_grey"
  | Mdl_basics_deep_ast.Deep_orange ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.Deep_orange"
  | Mdl_basics_deep_ast.Deep_lightred ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.Deep_lightred"
  | Mdl_basics_deep_ast.Deep_lightgreen ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.Deep_lightgreen"
  | Mdl_basics_deep_ast.Deep_lightblue ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.Deep_lightblue"
  | Mdl_basics_deep_ast.Deep_lightgrey ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.Deep_lightgrey"
  | Mdl_basics_deep_ast.Deep_darkred ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.Deep_darkred"
  | Mdl_basics_deep_ast.Deep_darkgreen ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.Deep_darkgreen"
  | Mdl_basics_deep_ast.Deep_darkblue ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.Deep_darkblue"
  | Mdl_basics_deep_ast.Deep_darkgrey ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.Deep_darkgrey"
  | Mdl_basics_deep_ast.Deep_purple ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.Deep_purple"
  | Mdl_basics_deep_ast.Deep_rgb r ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_basics_deep_ast.Deep_rgb";
    printer_rgb_color Og_precedence.Ck_argument ppf r;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_rgb_color ctx ppf = function
  | {
      Mdl_basics_deep_ast.red = f;
      Mdl_basics_deep_ast.green = f0;
      Mdl_basics_deep_ast.blue = f1;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>red =";
    Og_printer.printer_Float Og_precedence.Ck_record_field ppf f;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>green =";
    Og_printer.printer_Float Og_precedence.Ck_record_field ppf f0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>blue =";
    Og_printer.printer_Float Og_precedence.Ck_record_field ppf f1;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let printer_deep_position ctx ppf = function
  | {
      Mdl_basics_deep_ast.xmin = i;
      Mdl_basics_deep_ast.ymin = i0;
      Mdl_basics_deep_ast.xmax = i1;
      Mdl_basics_deep_ast.ymax = i2;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>xmin =";
    Og_printer.printer_Int Og_precedence.Ck_record_field ppf i;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>ymin =";
    Og_printer.printer_Int Og_precedence.Ck_record_field ppf i0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>xmax =";
    Og_printer.printer_Int Og_precedence.Ck_record_field ppf i1;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>ymax =";
    Og_printer.printer_Int Og_precedence.Ck_record_field ppf i2;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let rec printer_deep_font ctx ppf = function
  | {
      Mdl_basics_deep_ast.deep_font_name = a_m_o;
      Mdl_basics_deep_ast.deep_font_angle = d_o;
      Mdl_basics_deep_ast.deep_font_size = d_o0;
      Mdl_basics_deep_ast.deep_font_weight = d_o1;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>deep_font_name =";
    Og_printer.printer_Option Ast_types_print.printer_mdl_font_name
      Og_precedence.Ck_record_field
      ppf
      a_m_o;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_font_angle =";
    Og_printer.printer_Option printer_deep_font_angle
      Og_precedence.Ck_record_field
      ppf
      d_o;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_font_size =";
    Og_printer.printer_Option printer_deep_font_size
      Og_precedence.Ck_record_field
      ppf
      d_o0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_font_weight =";
    Og_printer.printer_Option printer_deep_font_weight
      Og_precedence.Ck_record_field
      ppf
      d_o1;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"

and printer_deep_font_angle _ctx ppf = function
  | Mdl_basics_deep_ast.Angle_italic ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.Angle_italic"
  | Mdl_basics_deep_ast.Angle_normal ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.Angle_normal"
  | Mdl_basics_deep_ast.Angle_oblique ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.Angle_oblique"

and printer_deep_font_size ctx ppf = function
  | n -> printer_natural ctx ppf n

and printer_deep_font_weight _ctx ppf = function
  | Mdl_basics_deep_ast.Weight_normal ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.Weight_normal"
  | Mdl_basics_deep_ast.Weight_bold ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.Weight_bold"
  | Mdl_basics_deep_ast.Weight_light ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.Weight_light"
;;

let rec printer_deep_block_port ctx ppf = function
  | {
      Mdl_basics_deep_ast.deep_block_port_number = d;
      Mdl_basics_deep_ast.deep_block_port_name = d_o;
      Mdl_basics_deep_ast.deep_block_port_bindings = d0;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>deep_block_port_number =";
    printer_deep_port_number Og_precedence.Ck_record_field ppf d;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_block_port_name =";
    Og_printer.printer_Option printer_deep_port_name
      Og_precedence.Ck_record_field
      ppf
      d_o;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_block_port_bindings =";
    printer_deep_block_port_bindings Og_precedence.Ck_record_field ppf d0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"

and printer_deep_block_port_bindings ctx ppf = function
  | d -> printer_deep_bindings ctx ppf d

and printer_deep_block_ports ctx ppf = function
  | d_l -> Og_printer.printer_List printer_deep_block_port ctx ppf d_l
;;

let printer_deep_chart_file_number ctx ppf = function
  | n -> printer_natural ctx ppf n
;;

let printer_deep_machine_name ctx ppf = function
  | d -> printer_deep_name ctx ppf d
;;

let printer_deep_state ctx ppf = function | d -> printer_deep_value ctx ppf d

and printer_deep_tag ctx ppf = function
  | (d, d0) ->
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ "
      else
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_tuple_item then
      Format.fprintf ppf "%,@[<hv 2>(@,";
    Format.fprintf ppf "%,@[<hv 0>";
    printer_deep_machine_name Og_precedence.Ck_tuple_item ppf d;
    Format.fprintf ppf "%,,@ ";
    printer_deep_chart_file_number Og_precedence.Ck_tuple_item ppf d0;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
      else
    if ctx = Og_precedence.Ck_tuple_item then
      Format.fprintf ppf "%,@;<0 -2>)@]"

and printer_deep_rotation ctx ppf = function | n -> printer_natural ctx ppf n

and printer_deep_mirror ctx ppf = function
  | b -> Og_printer.printer_Bool ctx ppf b

and printer_deep_zorder ctx ppf = function
  | i -> Og_printer.printer_Int ctx ppf i
;;

let rec printer_deep_annotation_position ctx ppf = function
  | {
      Mdl_basics_deep_ast.xpos = i;
      Mdl_basics_deep_ast.ypos = i0;
      Mdl_basics_deep_ast.maxpos = d_o;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>xpos =";
    Og_printer.printer_Int Og_precedence.Ck_record_field ppf i;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>ypos =";
    Og_printer.printer_Int Og_precedence.Ck_record_field ppf i0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>maxpos =";
    Og_printer.printer_Option printer_deep_annotation_max_position
      Og_precedence.Ck_record_field
      ppf
      d_o;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"

and printer_deep_annotation_max_position ctx ppf = function
  | { Mdl_basics_deep_ast.xmaxpos = i; Mdl_basics_deep_ast.ymaxpos = i0; } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>xmaxpos =";
    Og_printer.printer_Int Og_precedence.Ck_record_field ppf i;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>ymaxpos =";
    Og_printer.printer_Int Og_precedence.Ck_record_field ppf i0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let printer_deep_orientation _ctx ppf = function
  | Mdl_basics_deep_ast.Orientation_right ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.Orientation_right"
  | Mdl_basics_deep_ast.Orientation_left ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.Orientation_left"
  | Mdl_basics_deep_ast.Orientation_up ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.Orientation_up"
  | Mdl_basics_deep_ast.Orientation_down ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.Orientation_down"
;;

let printer_deep_placement _ctx ppf = function
  | Mdl_basics_deep_ast.Deep_placement_normal ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.Deep_placement_normal"
  | Mdl_basics_deep_ast.Deep_placement_alternate ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.Deep_placement_alternate"
;;

let rec printer_deep_font_and_colors ctx ppf = function
  | d_l -> Og_printer.printer_List printer_deep_font_and_color ctx ppf d_l

and printer_deep_font_and_color ctx ppf = function
  | Mdl_basics_deep_ast.Deep_background d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_basics_deep_ast.Deep_background";
    printer_deep_color Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_basics_deep_ast.Deep_drop_shadow d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_basics_deep_ast.Deep_drop_shadow";
    printer_deep_drop_shadow Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_basics_deep_ast.Deep_font d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_basics_deep_ast.Deep_font";
    printer_deep_font Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_basics_deep_ast.Deep_foreground d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_basics_deep_ast.Deep_foreground";
    printer_deep_color Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_deep_drop_shadow ctx ppf = function
  | b -> Og_printer.printer_Bool ctx ppf b
;;

let printer_deep_number_of_regular_ports ctx ppf = function
  | { Mdl_basics_deep_ast.port_nin = n; Mdl_basics_deep_ast.port_nout = n0; } ->
     if ctx = Og_precedence.Ck_argument ||
        ctx = Og_precedence.Ck_record_field
       then Format.fprintf ppf "%, {@ " else
     Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
     Format.fprintf ppf "%,Mdl_basics_deep_ast.@,";
     Format.fprintf ppf "%,@[<hv 2>port_nin =";
     printer_natural Og_precedence.Ck_record_field ppf n;
     Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
     Format.fprintf ppf "%,@[<hv 2>port_nout =";
     printer_natural Og_precedence.Ck_record_field ppf n0;
     Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
     if ctx = Og_precedence.Ck_argument ||
        ctx = Og_precedence.Ck_record_field
       then Format.fprintf ppf "%,@;<1 -2>}" else
     Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let printer_deep_number_of_implicit_ports ctx ppf = function
  | { Mdl_basics_deep_ast.port_niin = n; Mdl_basics_deep_ast.port_niout = n0;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>port_niin =";
    printer_natural Og_precedence.Ck_record_field ppf n;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>port_niout =";
    printer_natural Og_precedence.Ck_record_field ppf n0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let printer_deep_ports_description ctx ppf = function
  | {
      Mdl_basics_deep_ast.number_of_regular_ports = d;
      Mdl_basics_deep_ast.port_enable = b;
      Mdl_basics_deep_ast.port_trigger = b0;
      Mdl_basics_deep_ast.port_ifaction = b1;
      Mdl_basics_deep_ast.port_state = b2;
      Mdl_basics_deep_ast.number_of_implicit_ports = d0;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>number_of_regular_ports =";
    printer_deep_number_of_regular_ports Og_precedence.Ck_record_field ppf d;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>port_enable =";
    Og_printer.printer_Bool Og_precedence.Ck_record_field ppf b;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>port_trigger =";
    Og_printer.printer_Bool Og_precedence.Ck_record_field ppf b0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>port_ifaction =";
    Og_printer.printer_Bool Og_precedence.Ck_record_field ppf b1;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>port_state =";
    Og_printer.printer_Bool Og_precedence.Ck_record_field ppf b2;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>number_of_implicit_ports =";
    printer_deep_number_of_implicit_ports
      Og_precedence.Ck_record_field
      ppf
      d0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let printer_deep_workspace_data_source_code ctx ppf = function
  | Mdl_basics_deep_ast.Deep_workspace_data_source_code d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_basics_deep_ast.Deep_workspace_data_source_code";
    printer_deep_code Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let printer_deep_source_code ctx ppf = function
  | Mdl_basics_deep_ast.Deep_source_code d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_basics_deep_ast.Deep_source_code";
    printer_deep_text Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let rec printer_deep_block_graphical_default ctx ppf = function
  | Mdl_basics_deep_ast.Deep_block_mirror d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_basics_deep_ast.Deep_block_mirror";
    printer_deep_mirror Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_basics_deep_ast.Deep_block_name_placement d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_basics_deep_ast.Deep_block_name_placement";
    printer_deep_placement Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_basics_deep_ast.Deep_block_orientation d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_basics_deep_ast.Deep_block_orientation";
    printer_deep_orientation Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_basics_deep_ast.Deep_block_rotation d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_basics_deep_ast.Deep_block_rotation";
    printer_deep_rotation Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_basics_deep_ast.Deep_block_show_name b ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_basics_deep_ast.Deep_block_show_name";
    Og_printer.printer_Bool Og_precedence.Ck_argument ppf b;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_basics_deep_ast.Deep_block_hide_automatic_name b ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_basics_deep_ast.Deep_block_hide_automatic_name";
    Og_printer.printer_Bool Og_precedence.Ck_argument ppf b;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_basics_deep_ast.Deep_block_zorder d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_basics_deep_ast.Deep_block_zorder";
    printer_deep_zorder Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_basics_deep_ast.Deep_block_ports d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_basics_deep_ast.Deep_block_ports";
    printer_deep_block_ports Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_basics_deep_ast.Deep_block_ports_description d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_basics_deep_ast.Deep_block_ports_description";
    printer_deep_ports_description Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_basics_deep_ast.Deep_block_font_and_color d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_basics_deep_ast.Deep_block_font_and_color";
    printer_deep_font_and_color Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_deep_block_graphical_defaults ctx ppf = function
  | d_l ->
    Og_printer.printer_List printer_deep_block_graphical_default ctx ppf d_l
;;

let rec printer_deep_block_parameter_defaults ctx ppf = function
  | {
      Mdl_basics_deep_ast.deep_parameter_block_type = m_b;
      Mdl_basics_deep_ast.deep_parameter_defaults = d;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>deep_parameter_block_type =";
    Mdl_block_types_print.printer_block_type
      Og_precedence.Ck_record_field
      ppf
      m_b;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_parameter_defaults =";
    printer_deep_bindings Og_precedence.Ck_record_field ppf d;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"

and printer_deep_annotation_graphical_defaults ctx ppf = function
  | d_l ->
    Og_printer.printer_List printer_deep_annotation_graphical_default
      ctx
      ppf
      d_l

and printer_deep_annotation_graphical_default ctx ppf = function
  | d_m_p ->
    Mdl_ast_print.printer_poly_annotation_graphical_default
      printer_deep_font_and_color
      ctx
      ppf
      d_m_p

and printer_deep_line_graphical_defaults ctx ppf = function
  | {
      Mdl_basics_deep_ast.deep_line_default_font = d;
      Mdl_basics_deep_ast.deep_line_default_zorder = d_o;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>deep_line_default_font =";
    printer_deep_font Og_precedence.Ck_record_field ppf d;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_line_default_zorder =";
    Og_printer.printer_Option printer_deep_zorder
      Og_precedence.Ck_record_field
      ppf
      d_o;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"

and printer_deep_mask_graphical_defaults ctx ppf = function
  | d -> printer_deep_bindings ctx ppf d

and printer_deep_mask_parameter_defaults ctx ppf = function
  | d -> printer_deep_bindings ctx ppf d
;;

let printer_deep_model_defaults ctx ppf = function
  | {
      Mdl_basics_deep_ast.deep_model_block_graphical_defaults = d;
      Mdl_basics_deep_ast.deep_model_block_parameter_defaults = d_l;
      Mdl_basics_deep_ast.deep_model_annotation_graphical_defaults = d0;
      Mdl_basics_deep_ast.deep_model_line_graphical_defaults = d1;
      Mdl_basics_deep_ast.deep_model_mask_graphical_defaults = d2;
      Mdl_basics_deep_ast.deep_model_mask_parameter_defaults = d3;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>deep_model_block_graphical_defaults =";
    printer_deep_block_graphical_defaults Og_precedence.Ck_record_field ppf d;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_model_block_parameter_defaults =";
    Og_printer.printer_List printer_deep_block_parameter_defaults
      Og_precedence.Ck_record_field
      ppf
      d_l;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_model_annotation_graphical_defaults =";
    printer_deep_annotation_graphical_defaults
      Og_precedence.Ck_record_field
      ppf
      d0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_model_line_graphical_defaults =";
    printer_deep_line_graphical_defaults Og_precedence.Ck_record_field ppf d1;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_model_mask_graphical_defaults =";
    printer_deep_mask_graphical_defaults Og_precedence.Ck_record_field ppf d2;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_model_mask_parameter_defaults =";
    printer_deep_mask_parameter_defaults Og_precedence.Ck_record_field ppf d3;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let printer_deep_mask_parameter_ident ctx ppf = function
  | i -> printer_ident ctx ppf i
;;

let printer_mask_parameter_style_range ctx ppf = function
  | Mdl_basics_deep_ast.Mask_parameter_style_range s_l ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_basics_deep_ast.Mask_parameter_style_range";
    Og_printer.printer_List Og_printer.printer_String
      Og_precedence.Ck_argument
      ppf
      s_l;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let rec printer_deep_mask_parameter_style ctx ppf = function
  | Mdl_basics_deep_ast.Deep_mask_parameter_edit ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.Deep_mask_parameter_edit"
  | Mdl_basics_deep_ast.Deep_mask_parameter_checkbox ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.Deep_mask_parameter_checkbox"
  | Mdl_basics_deep_ast.Deep_mask_parameter_popup m ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_basics_deep_ast.Deep_mask_parameter_popup";
    printer_mask_parameter_style_items Og_precedence.Ck_argument ppf m;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_basics_deep_ast.Deep_mask_parameter_unidt d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_basics_deep_ast.Deep_mask_parameter_unidt";
    printer_deep_text Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_basics_deep_ast.Deep_mask_parameter_min ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.Deep_mask_parameter_min"
  | Mdl_basics_deep_ast.Deep_mask_parameter_max ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.Deep_mask_parameter_max"
  | Mdl_basics_deep_ast.Deep_mask_parameter_promote ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.Deep_mask_parameter_promote"
  | Mdl_basics_deep_ast.Deep_mask_parameter_radiobutton m ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_basics_deep_ast.Deep_mask_parameter_radiobutton";
    printer_mask_parameter_style_items Og_precedence.Ck_argument ppf m;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_basics_deep_ast.Deep_mask_parameter_slider m_o ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_basics_deep_ast.Deep_mask_parameter_slider";
    Og_printer.printer_Option printer_mask_parameter_style_range
      Og_precedence.Ck_argument
      ppf
      m_o;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_basics_deep_ast.Deep_mask_parameter_spinbox m_o ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_basics_deep_ast.Deep_mask_parameter_spinbox";
    Og_printer.printer_Option printer_mask_parameter_style_range
      Og_precedence.Ck_argument
      ppf
      m_o;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_mask_parameter_style_item ctx ppf = function
  | Mdl_basics_deep_ast.Item_int i ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_basics_deep_ast.Item_int";
    Og_printer.printer_Int Og_precedence.Ck_argument ppf i;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_basics_deep_ast.Item_text d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_basics_deep_ast.Item_text";
    printer_deep_text Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_mask_parameter_style_items ctx ppf = function
  | m_l ->
    Og_printer.printer_List printer_mask_parameter_style_item ctx ppf m_l
;;

let printer_deep_mask_parameter_prompt ctx ppf = function
  | d -> printer_deep_text ctx ppf d
;;

let printer_deep_mask_parameter_callback ctx ppf = function
  | d -> printer_deep_source_code ctx ppf d
;;

let printer_deep_mask_parameter_tunable ctx ppf = function
  | b -> Og_printer.printer_Bool ctx ppf b
;;

let printer_deep_mask_parameter_value ctx ppf = function
  | Mdl_basics_deep_ast.Deep_mask_parameter_value d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_basics_deep_ast.Deep_mask_parameter_value";
    printer_deep_text Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let printer_deep_mask_parameter_evaluation _ctx ppf = function
  | Mdl_basics_deep_ast.Quote ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.Quote"
  | Mdl_basics_deep_ast.Eval ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.Eval"
;;

let printer_deep_mask_parameter_enable _ctx ppf = function
  | Mdl_basics_deep_ast.Enable ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.Enable"
  | Mdl_basics_deep_ast.Disable ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.Disable"
;;

let printer_deep_mask_parameter_visible _ctx ppf = function
  | Mdl_basics_deep_ast.Visible ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.Visible"
  | Mdl_basics_deep_ast.Hidden ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.Hidden"
;;

let printer_deep_mask_parameter_internal _ctx ppf = function
  | Mdl_basics_deep_ast.Internal ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.Internal"
  | Mdl_basics_deep_ast.External ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.External"
;;

let printer_deep_mask_parameter_never_save _ctx ppf = function
  | Mdl_basics_deep_ast.Never_save ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.Never_save"
  | Mdl_basics_deep_ast.Save ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.Save"
;;

let printer_deep_mask_parameter_read_only _ctx ppf = function
  | Mdl_basics_deep_ast.Read_only ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.Read_only"
  | Mdl_basics_deep_ast.Read_write ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.Read_write"
;;

let rec printer_deep_mask_parameter ctx ppf = function
  | {
      Mdl_basics_deep_ast.deep_mask_parameter_ident = d;
      Mdl_basics_deep_ast.deep_mask_parameter_style = d0;
      Mdl_basics_deep_ast.deep_mask_parameter_prompt = d1;
      Mdl_basics_deep_ast.deep_mask_parameter_callback = d_o;
      Mdl_basics_deep_ast.deep_mask_parameter_tunable = d_o0;
      Mdl_basics_deep_ast.deep_mask_parameter_value = d2;
      Mdl_basics_deep_ast.deep_mask_parameter_evaluation = d_o1;
      Mdl_basics_deep_ast.deep_mask_parameter_enable = d_o2;
      Mdl_basics_deep_ast.deep_mask_parameter_visible = d_o3;
      Mdl_basics_deep_ast.deep_mask_parameter_internal = d_o4;
      Mdl_basics_deep_ast.deep_mask_parameter_never_save = d_o5;
      Mdl_basics_deep_ast.deep_mask_parameter_read_only = d_o6;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>deep_mask_parameter_ident =";
    printer_deep_mask_parameter_ident Og_precedence.Ck_record_field ppf d;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_mask_parameter_style =";
    printer_deep_mask_parameter_style Og_precedence.Ck_record_field ppf d0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_mask_parameter_prompt =";
    printer_deep_mask_parameter_prompt Og_precedence.Ck_record_field ppf d1;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_mask_parameter_callback =";
    Og_printer.printer_Option printer_deep_mask_parameter_callback
      Og_precedence.Ck_record_field
      ppf
      d_o;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_mask_parameter_tunable =";
    Og_printer.printer_Option printer_deep_mask_parameter_tunable
      Og_precedence.Ck_record_field
      ppf
      d_o0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_mask_parameter_value =";
    printer_deep_mask_parameter_value Og_precedence.Ck_record_field ppf d2;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_mask_parameter_evaluation =";
    Og_printer.printer_Option printer_deep_mask_parameter_evaluation
      Og_precedence.Ck_record_field
      ppf
      d_o1;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_mask_parameter_enable =";
    Og_printer.printer_Option printer_deep_mask_parameter_enable
      Og_precedence.Ck_record_field
      ppf
      d_o2;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_mask_parameter_visible =";
    Og_printer.printer_Option printer_deep_mask_parameter_visible
      Og_precedence.Ck_record_field
      ppf
      d_o3;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_mask_parameter_internal =";
    Og_printer.printer_Option printer_deep_mask_parameter_internal
      Og_precedence.Ck_record_field
      ppf
      d_o4;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_mask_parameter_never_save =";
    Og_printer.printer_Option printer_deep_mask_parameter_never_save
      Og_precedence.Ck_record_field
      ppf
      d_o5;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_mask_parameter_read_only =";
    Og_printer.printer_Option printer_deep_mask_parameter_read_only
      Og_precedence.Ck_record_field
      ppf
      d_o6;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"

and printer_deep_mask_parameters ctx ppf = function
  | d_l -> Og_printer.printer_List printer_deep_mask_parameter ctx ppf d_l
;;

let printer_deep_mask_type ctx ppf = function
  | d -> printer_deep_text ctx ppf d

and printer_deep_mask_description ctx ppf = function
  | d -> printer_deep_text ctx ppf d
;;

let printer_deep_mask ctx ppf = function
  | {
      Mdl_basics_deep_ast.deep_mask_type = d_o;
      Mdl_basics_deep_ast.deep_mask_description = d_o0;
      Mdl_basics_deep_ast.deep_mask_initialisation = d_o1;
      Mdl_basics_deep_ast.deep_mask_display = d_o2;
      Mdl_basics_deep_ast.deep_mask_parameters = d;
      Mdl_basics_deep_ast.deep_mask_bindings = d0;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>deep_mask_type =";
    Og_printer.printer_Option printer_deep_mask_type
      Og_precedence.Ck_record_field
      ppf
      d_o;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_mask_description =";
    Og_printer.printer_Option printer_deep_mask_description
      Og_precedence.Ck_record_field
      ppf
      d_o0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_mask_initialisation =";
    Og_printer.printer_Option printer_deep_source_code
      Og_precedence.Ck_record_field
      ppf
      d_o1;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_mask_display =";
    Og_printer.printer_Option printer_deep_source_code
      Og_precedence.Ck_record_field
      ppf
      d_o2;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_mask_parameters =";
    printer_deep_mask_parameters Og_precedence.Ck_record_field ppf d;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_mask_bindings =";
    printer_deep_bindings Og_precedence.Ck_record_field ppf d0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let printer_deep_sid ctx ppf = function
  | m_b -> Mdl_ast_print.printer_block_sid ctx ppf m_b
;;

let rec printer_deep_block_item ctx ppf = function
  | Mdl_basics_deep_ast.Deep_block_position d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_basics_deep_ast.Deep_block_position";
    printer_deep_position Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_basics_deep_ast.Deep_block_sid d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_basics_deep_ast.Deep_block_sid";
    printer_deep_sid Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_basics_deep_ast.Deep_block_state d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_basics_deep_ast.Deep_block_state";
    printer_deep_state Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_basics_deep_ast.Deep_block_tag d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_basics_deep_ast.Deep_block_tag";
    printer_deep_tag Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_basics_deep_ast.Deep_block_graphical_default d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_basics_deep_ast.Deep_block_graphical_default";
    printer_deep_block_graphical_default Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_basics_deep_ast.Deep_block_binding d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_basics_deep_ast.Deep_block_binding";
    printer_deep_binding Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_deep_block_items ctx ppf = function
  | d_l -> Og_printer.printer_List printer_deep_block_item ctx ppf d_l
;;

let rec printer_deep_points ctx ppf = function
  | d_l -> Og_printer.printer_List printer_deep_point ctx ppf d_l

and printer_deep_point ctx ppf = function
  | { Mdl_basics_deep_ast.deep_x = i; Mdl_basics_deep_ast.deep_y = i0; } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>deep_x =";
    Og_printer.printer_Int Og_precedence.Ck_record_field ppf i;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_y =";
    Og_printer.printer_Int Og_precedence.Ck_record_field ppf i0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let rec printer_deep_branches ctx ppf = function
  | d_l -> Og_printer.printer_List printer_deep_branch ctx ppf d_l

and printer_deep_branch ctx ppf = function
  | Mdl_basics_deep_ast.Deep_branch_connection (d, d0) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_basics_deep_ast.Deep_branch_connection";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_deep_connection_type Og_precedence.Ck_tuple_item ppf d;
    Format.fprintf ppf "%,,@ ";
    printer_deep_branch_body Og_precedence.Ck_tuple_item ppf d0;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_basics_deep_ast.Deep_branch_directed d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_basics_deep_ast.Deep_branch_directed";
    printer_deep_branch_body Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_deep_branch_body ctx ppf = function
  | {
      Mdl_basics_deep_ast.deep_branch_source = d_o;
      Mdl_basics_deep_ast.deep_branch_target = d_o0;
      Mdl_basics_deep_ast.deep_branch_branches = d;
      Mdl_basics_deep_ast.deep_branch_labels = d_o1;
      Mdl_basics_deep_ast.deep_branch_points = d_o2;
      Mdl_basics_deep_ast.deep_branch_zorder = d_o3;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>deep_branch_source =";
    Og_printer.printer_Option printer_deep_line_connector
      Og_precedence.Ck_record_field
      ppf
      d_o;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_branch_target =";
    Og_printer.printer_Option printer_deep_line_connector
      Og_precedence.Ck_record_field
      ppf
      d_o0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_branch_branches =";
    printer_deep_branches Og_precedence.Ck_record_field ppf d;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_branch_labels =";
    Og_printer.printer_Option printer_deep_labels
      Og_precedence.Ck_record_field
      ppf
      d_o1;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_branch_points =";
    Og_printer.printer_Option printer_deep_points
      Og_precedence.Ck_record_field
      ppf
      d_o2;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_branch_zorder =";
    Og_printer.printer_Option printer_deep_zorder
      Og_precedence.Ck_record_field
      ppf
      d_o3;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let rec printer_deep_line ctx ppf = function
  | Mdl_basics_deep_ast.Deep_line_connection d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_basics_deep_ast.Deep_line_connection";
    printer_deep_line_body Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_basics_deep_ast.Deep_line_directed d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_basics_deep_ast.Deep_line_directed";
    printer_deep_line_body Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_deep_line_body ctx ppf = function
  | {
      Mdl_basics_deep_ast.deep_line_name = d_o;
      Mdl_basics_deep_ast.deep_line_source = d_o0;
      Mdl_basics_deep_ast.deep_line_target = d_o1;
      Mdl_basics_deep_ast.deep_line_branches = d;
      Mdl_basics_deep_ast.deep_line_labels = d_o2;
      Mdl_basics_deep_ast.deep_line_points = d_o3;
      Mdl_basics_deep_ast.deep_line_font = d_o4;
      Mdl_basics_deep_ast.deep_line_zorder = d_o5;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>deep_line_name =";
    Og_printer.printer_Option printer_deep_line_name
      Og_precedence.Ck_record_field
      ppf
      d_o;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_line_source =";
    Og_printer.printer_Option printer_deep_line_connector
      Og_precedence.Ck_record_field
      ppf
      d_o0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_line_target =";
    Og_printer.printer_Option printer_deep_line_connector
      Og_precedence.Ck_record_field
      ppf
      d_o1;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_line_branches =";
    printer_deep_branches Og_precedence.Ck_record_field ppf d;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_line_labels =";
    Og_printer.printer_Option printer_deep_labels
      Og_precedence.Ck_record_field
      ppf
      d_o2;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_line_points =";
    Og_printer.printer_Option printer_deep_points
      Og_precedence.Ck_record_field
      ppf
      d_o3;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_line_font =";
    Og_printer.printer_Option printer_deep_font
      Og_precedence.Ck_record_field
      ppf
      d_o4;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_line_zorder =";
    Og_printer.printer_Option printer_deep_zorder
      Og_precedence.Ck_record_field
      ppf
      d_o5;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let printer_deep_annotation ctx ppf = function
  | {
      Mdl_basics_deep_ast.deep_annotation_name = d;
      Mdl_basics_deep_ast.deep_annotation_position = d0;
      Mdl_basics_deep_ast.deep_annotation_font = d1;
      Mdl_basics_deep_ast.deep_annotation_graphical = d2;
      Mdl_basics_deep_ast.deep_annotation_graphical_defaults = d3;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_basics_deep_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>deep_annotation_name =";
    printer_deep_text Og_precedence.Ck_record_field ppf d;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_annotation_position =";
    printer_deep_annotation_position Og_precedence.Ck_record_field ppf d0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_annotation_font =";
    printer_deep_font Og_precedence.Ck_record_field ppf d1;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_annotation_graphical =";
    printer_deep_font_and_colors Og_precedence.Ck_record_field ppf d2;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_annotation_graphical_defaults =";
    printer_deep_annotation_graphical_defaults
      Og_precedence.Ck_record_field
      ppf
      d3;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

(* Defining top printers. *)

let print_ident ppf = printer_ident Og_precedence.Ck_toplevel ppf
;;

let print_natural ppf = printer_natural Og_precedence.Ck_toplevel ppf

and print_deep_text ppf = printer_deep_text Og_precedence.Ck_toplevel ppf

and print_deep_code ppf = printer_deep_code Og_precedence.Ck_toplevel ppf
;;

let print_deep_port_number ppf =
  printer_deep_port_number Og_precedence.Ck_toplevel ppf

and print_deep_port_name ppf =
  printer_deep_port_name Og_precedence.Ck_toplevel ppf

and print_deep_line_name ppf =
  printer_deep_line_name Og_precedence.Ck_toplevel ppf

and print_deep_array_name ppf =
  printer_deep_array_name Og_precedence.Ck_toplevel ppf

and print_deep_prop_name ppf =
  printer_deep_prop_name Og_precedence.Ck_toplevel ppf

and print_deep_class_name ppf =
  printer_deep_class_name Og_precedence.Ck_toplevel ppf

and print_deep_line_connector ppf =
  printer_deep_line_connector Og_precedence.Ck_toplevel ppf

and print_deep_labels ppf = printer_deep_labels Og_precedence.Ck_toplevel ppf

and print_deep_block_name ppf =
  printer_deep_block_name Og_precedence.Ck_toplevel ppf

and print_deep_system_name ppf =
  printer_deep_system_name Og_precedence.Ck_toplevel ppf

and print_deep_array_type ppf =
  printer_deep_array_type Og_precedence.Ck_toplevel ppf

and print_deep_sf_block_type ppf =
  printer_deep_sf_block_type Og_precedence.Ck_toplevel ppf

and print_deep_name ppf = printer_deep_name Og_precedence.Ck_toplevel ppf
;;

let print_deep_binding ppf =
  printer_deep_binding Og_precedence.Ck_toplevel ppf

and print_deep_value ppf = printer_deep_value Og_precedence.Ck_toplevel ppf

and print_deep_bindings ppf =
  printer_deep_bindings Og_precedence.Ck_toplevel ppf

and print_deep_binding_table ppf =
  printer_deep_binding_table Og_precedence.Ck_toplevel ppf

and print_deep_values ppf = printer_deep_values Og_precedence.Ck_toplevel ppf
;;

let print_deep_connection_type_side ppf =
  printer_deep_connection_type_side Og_precedence.Ck_toplevel ppf
;;

let print_deep_connection_type ppf =
  printer_deep_connection_type Og_precedence.Ck_toplevel ppf
;;

let print_deep_color ppf = printer_deep_color Og_precedence.Ck_toplevel ppf

and print_rgb_color ppf = printer_rgb_color Og_precedence.Ck_toplevel ppf
;;

let print_deep_position ppf =
  printer_deep_position Og_precedence.Ck_toplevel ppf
;;

let print_deep_font ppf = printer_deep_font Og_precedence.Ck_toplevel ppf

and print_deep_font_angle ppf =
  printer_deep_font_angle Og_precedence.Ck_toplevel ppf

and print_deep_font_size ppf =
  printer_deep_font_size Og_precedence.Ck_toplevel ppf

and print_deep_font_weight ppf =
  printer_deep_font_weight Og_precedence.Ck_toplevel ppf
;;

let print_deep_block_port ppf =
  printer_deep_block_port Og_precedence.Ck_toplevel ppf

and print_deep_block_port_bindings ppf =
  printer_deep_block_port_bindings Og_precedence.Ck_toplevel ppf

and print_deep_block_ports ppf =
  printer_deep_block_ports Og_precedence.Ck_toplevel ppf
;;

let print_deep_chart_file_number ppf =
  printer_deep_chart_file_number Og_precedence.Ck_toplevel ppf
;;

let print_deep_machine_name ppf =
  printer_deep_machine_name Og_precedence.Ck_toplevel ppf
;;

let print_deep_state ppf = printer_deep_state Og_precedence.Ck_toplevel ppf

and print_deep_tag ppf = printer_deep_tag Og_precedence.Ck_toplevel ppf

and print_deep_rotation ppf =
  printer_deep_rotation Og_precedence.Ck_toplevel ppf

and print_deep_mirror ppf = printer_deep_mirror Og_precedence.Ck_toplevel ppf

and print_deep_zorder ppf = printer_deep_zorder Og_precedence.Ck_toplevel ppf
;;

let print_deep_annotation_position ppf =
  printer_deep_annotation_position Og_precedence.Ck_toplevel ppf

and print_deep_annotation_max_position ppf =
  printer_deep_annotation_max_position Og_precedence.Ck_toplevel ppf
;;

let print_deep_orientation ppf =
  printer_deep_orientation Og_precedence.Ck_toplevel ppf
;;

let print_deep_placement ppf =
  printer_deep_placement Og_precedence.Ck_toplevel ppf
;;

let print_deep_font_and_colors ppf =
  printer_deep_font_and_colors Og_precedence.Ck_toplevel ppf

and print_deep_font_and_color ppf =
  printer_deep_font_and_color Og_precedence.Ck_toplevel ppf

and print_deep_drop_shadow ppf =
  printer_deep_drop_shadow Og_precedence.Ck_toplevel ppf
;;

let print_deep_number_of_regular_ports ppf =
  printer_deep_number_of_regular_ports Og_precedence.Ck_toplevel ppf
;;

let print_deep_number_of_implicit_ports ppf =
  printer_deep_number_of_implicit_ports Og_precedence.Ck_toplevel ppf
;;

let print_deep_ports_description ppf =
  printer_deep_ports_description Og_precedence.Ck_toplevel ppf
;;

let print_deep_workspace_data_source_code ppf =
  printer_deep_workspace_data_source_code Og_precedence.Ck_toplevel ppf
;;

let print_deep_source_code ppf =
  printer_deep_source_code Og_precedence.Ck_toplevel ppf
;;

let print_deep_block_graphical_default ppf =
  printer_deep_block_graphical_default Og_precedence.Ck_toplevel ppf

and print_deep_block_graphical_defaults ppf =
  printer_deep_block_graphical_defaults Og_precedence.Ck_toplevel ppf
;;

let print_deep_block_parameter_defaults ppf =
  printer_deep_block_parameter_defaults Og_precedence.Ck_toplevel ppf

and print_deep_annotation_graphical_defaults ppf =
  printer_deep_annotation_graphical_defaults Og_precedence.Ck_toplevel ppf

and print_deep_annotation_graphical_default ppf =
  printer_deep_annotation_graphical_default Og_precedence.Ck_toplevel ppf

and print_deep_line_graphical_defaults ppf =
  printer_deep_line_graphical_defaults Og_precedence.Ck_toplevel ppf

and print_deep_mask_graphical_defaults ppf =
  printer_deep_mask_graphical_defaults Og_precedence.Ck_toplevel ppf

and print_deep_mask_parameter_defaults ppf =
  printer_deep_mask_parameter_defaults Og_precedence.Ck_toplevel ppf
;;

let print_deep_model_defaults ppf =
  printer_deep_model_defaults Og_precedence.Ck_toplevel ppf
;;

let print_deep_mask_parameter_ident ppf =
  printer_deep_mask_parameter_ident Og_precedence.Ck_toplevel ppf
;;

let print_mask_parameter_style_range ppf =
  printer_mask_parameter_style_range Og_precedence.Ck_toplevel ppf
;;

let print_deep_mask_parameter_style ppf =
  printer_deep_mask_parameter_style Og_precedence.Ck_toplevel ppf

and print_mask_parameter_style_item ppf =
  printer_mask_parameter_style_item Og_precedence.Ck_toplevel ppf

and print_mask_parameter_style_items ppf =
  printer_mask_parameter_style_items Og_precedence.Ck_toplevel ppf
;;

let print_deep_mask_parameter_prompt ppf =
  printer_deep_mask_parameter_prompt Og_precedence.Ck_toplevel ppf
;;

let print_deep_mask_parameter_callback ppf =
  printer_deep_mask_parameter_callback Og_precedence.Ck_toplevel ppf
;;

let print_deep_mask_parameter_tunable ppf =
  printer_deep_mask_parameter_tunable Og_precedence.Ck_toplevel ppf
;;

let print_deep_mask_parameter_value ppf =
  printer_deep_mask_parameter_value Og_precedence.Ck_toplevel ppf
;;

let print_deep_mask_parameter_evaluation ppf =
  printer_deep_mask_parameter_evaluation Og_precedence.Ck_toplevel ppf
;;

let print_deep_mask_parameter_enable ppf =
  printer_deep_mask_parameter_enable Og_precedence.Ck_toplevel ppf
;;

let print_deep_mask_parameter_visible ppf =
  printer_deep_mask_parameter_visible Og_precedence.Ck_toplevel ppf
;;

let print_deep_mask_parameter_internal ppf =
  printer_deep_mask_parameter_internal Og_precedence.Ck_toplevel ppf
;;

let print_deep_mask_parameter_never_save ppf =
  printer_deep_mask_parameter_never_save Og_precedence.Ck_toplevel ppf
;;

let print_deep_mask_parameter_read_only ppf =
  printer_deep_mask_parameter_read_only Og_precedence.Ck_toplevel ppf
;;

let print_deep_mask_parameter ppf =
  printer_deep_mask_parameter Og_precedence.Ck_toplevel ppf

and print_deep_mask_parameters ppf =
  printer_deep_mask_parameters Og_precedence.Ck_toplevel ppf
;;

let print_deep_mask_type ppf =
  printer_deep_mask_type Og_precedence.Ck_toplevel ppf

and print_deep_mask_description ppf =
  printer_deep_mask_description Og_precedence.Ck_toplevel ppf
;;

let print_deep_mask ppf = printer_deep_mask Og_precedence.Ck_toplevel ppf
;;

let print_deep_sid ppf = printer_deep_sid Og_precedence.Ck_toplevel ppf
;;

let print_deep_block_item ppf =
  printer_deep_block_item Og_precedence.Ck_toplevel ppf

and print_deep_block_items ppf =
  printer_deep_block_items Og_precedence.Ck_toplevel ppf
;;

let print_deep_points ppf = printer_deep_points Og_precedence.Ck_toplevel ppf

and print_deep_point ppf = printer_deep_point Og_precedence.Ck_toplevel ppf
;;

let print_deep_branches ppf =
  printer_deep_branches Og_precedence.Ck_toplevel ppf

and print_deep_branch ppf = printer_deep_branch Og_precedence.Ck_toplevel ppf

and print_deep_branch_body ppf =
  printer_deep_branch_body Og_precedence.Ck_toplevel ppf
;;

let print_deep_line ppf = printer_deep_line Og_precedence.Ck_toplevel ppf

and print_deep_line_body ppf =
  printer_deep_line_body Og_precedence.Ck_toplevel ppf
;;

let print_deep_annotation ppf =
  printer_deep_annotation Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.5+dev0 generated code. *)
