(***********************************************************************)
(*                                                                     *)
(*                               Simport                               *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2010-2019,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.5+dev0 generated code. *)

open Ast_types_print;;

open Mdl_ast_print;;

let printer_deep_file_name ctx ppf = function
  | p_e -> Path_print.printer_explicit_file_name ctx ppf p_e
;;

let printer_natural ctx ppf = function
  | m_n -> Mdl_basics_deep_ast_print.printer_natural ctx ppf m_n

and printer_ident ctx ppf = function
  | m_i -> Mdl_basics_deep_ast_print.printer_ident ctx ppf m_i
;;

let printer_deep_name ctx ppf = function
  | m_d -> Mdl_basics_deep_ast_print.printer_deep_name ctx ppf m_d

and printer_deep_value ctx ppf = function
  | m_d -> Mdl_basics_deep_ast_print.printer_deep_value ctx ppf m_d

and printer_deep_binding ctx ppf = function
  | m_d -> Mdl_basics_deep_ast_print.printer_deep_binding ctx ppf m_d

and printer_deep_bindings ctx ppf = function
  | m_d -> Mdl_basics_deep_ast_print.printer_deep_bindings ctx ppf m_d

and printer_deep_mask ctx ppf = function
  | m_d -> Mdl_basics_deep_ast_print.printer_deep_mask ctx ppf m_d

and printer_deep_sf_block_type ctx ppf = function
  | m_d -> Mdl_basics_deep_ast_print.printer_deep_sf_block_type ctx ppf m_d

and printer_deep_ports_description ctx ppf = function
  | m_d ->
    Mdl_basics_deep_ast_print.printer_deep_ports_description ctx ppf m_d
;;

let printer_deep_block_name ctx ppf = function
  | m_d -> Mdl_basics_deep_ast_print.printer_deep_block_name ctx ppf m_d

and printer_deep_sid ctx ppf = function
  | m_d -> Mdl_basics_deep_ast_print.printer_deep_sid ctx ppf m_d

and printer_deep_block_items ctx ppf = function
  | m_d -> Mdl_basics_deep_ast_print.printer_deep_block_items ctx ppf m_d
;;

let printer_deep_line ctx ppf = function
  | m_d -> Mdl_basics_deep_ast_print.printer_deep_line ctx ppf m_d

and printer_deep_annotation ctx ppf = function
  | m_d -> Mdl_basics_deep_ast_print.printer_deep_annotation ctx ppf m_d
;;

let printer_deep_system_name ctx ppf = function
  | m_d -> Mdl_basics_deep_ast_print.printer_deep_system_name ctx ppf m_d

and printer_deep_prop_name ctx ppf = function
  | m_d -> Mdl_basics_deep_ast_print.printer_deep_prop_name ctx ppf m_d

and printer_deep_array_name ctx ppf = function
  | m_d -> Mdl_basics_deep_ast_print.printer_deep_array_name ctx ppf m_d

and printer_deep_class_name ctx ppf = function
  | m_d -> Mdl_basics_deep_ast_print.printer_deep_class_name ctx ppf m_d

and printer_deep_object_name ctx ppf = function
  | m_o -> Mdl_ast_print.printer_object_name ctx ppf m_o

and printer_deep_object_type ctx ppf = function
  | m_o -> Mdl_ast_print.printer_object_type ctx ppf m_o

and printer_deep_object_id ctx ppf = function
  | m_o -> Mdl_ast_print.printer_object_id ctx ppf m_o

and printer_object_description ctx ppf = function
  | m_o -> Mdl_ast_print.printer_object_description ctx ppf m_o

and printer_deep_position ctx ppf = function
  | m_d -> Mdl_basics_deep_ast_print.printer_deep_position ctx ppf m_d

and printer_deep_array_type ctx ppf = function
  | m_d -> Mdl_basics_deep_ast_print.printer_deep_array_type ctx ppf m_d

and printer_deep_model_defaults ctx ppf = function
  | m_d -> Mdl_basics_deep_ast_print.printer_deep_model_defaults ctx ppf m_d
;;

let printer_deep_chart_file_number ctx ppf = function
  | m_d ->
    Mdl_stateflow_deep_ast_print.printer_deep_chart_file_number ctx ppf m_d
;;

let printer_deep_block_regular_type ctx ppf = function
  | m_b -> Mdl_block_types_print.printer_block_type ctx ppf m_b

and printer_deep_block_source_type ctx ppf = function
  | m_b -> Mdl_ast_print.printer_block_source_type ctx ppf m_b

and printer_deep_block_source_path ctx ppf = function
  | m_b -> Mdl_ast_print.printer_block_source_path ctx ppf m_b
;;

let printer_deep_block_reference_type ctx ppf = function
  | {
      Mdl_deep_ast.deep_block_source_type = d;
      Mdl_deep_ast.deep_block_source_path = d0;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_deep_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>deep_block_source_type =";
    printer_deep_block_source_type Og_precedence.Ck_record_field ppf d;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_block_source_path =";
    printer_deep_block_source_path Og_precedence.Ck_record_field ppf d0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let printer_deep_interface_block_parameter_type _ctx ppf = function
  | Mdl_deep_ast.Parameter_type_bool ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_deep_ast.Parameter_type_bool"
  | Mdl_deep_ast.Parameter_type_string ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_deep_ast.Parameter_type_string"
  | Mdl_deep_ast.Parameter_type_enum ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_deep_ast.Parameter_type_enum"
  | Mdl_deep_ast.Parameter_type_matrix ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_deep_ast.Parameter_type_matrix"
  | Mdl_deep_ast.Parameter_type_list ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_deep_ast.Parameter_type_list"
  | Mdl_deep_ast.Parameter_type_rectangle ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_deep_ast.Parameter_type_rectangle"
;;

let rec printer_deep_interface_block_binding ctx ppf = function
  | d_b_i ->
    Binding_print.printer_ident_binding
      printer_deep_interface_block_parameter_type
      ctx
      ppf
      d_b_i

and printer_deep_interface_block_bindings ctx ppf = function
  | d_l ->
    Og_printer.printer_List printer_deep_interface_block_binding ctx ppf d_l
;;

let rec printer_deep_interface_block ctx ppf = function
  | {
      Mdl_deep_ast.deep_interface_block_desc = d;
      Mdl_deep_ast.deep_interface_block_ports_description = d0;
      Mdl_deep_ast.deep_interface_block_parameters = d1;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_deep_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>deep_interface_block_desc =";
    printer_deep_interface_block_desc Og_precedence.Ck_record_field ppf d;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_interface_block_ports_description =";
    printer_deep_ports_description Og_precedence.Ck_record_field ppf d0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_interface_block_parameters =";
    printer_deep_interface_block_bindings
      Og_precedence.Ck_record_field
      ppf
      d1;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"

and printer_deep_interface_block_desc ctx ppf = function
  | Mdl_deep_ast.Deep_interface_block_simulink d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_deep_ast.Deep_interface_block_simulink";
    printer_deep_block_regular_type Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_deep_ast.Deep_interface_block_sub_system d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_deep_ast.Deep_interface_block_sub_system";
    printer_deep_block_reference_type Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_deep_ast.Deep_interface_block_s_function d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_deep_ast.Deep_interface_block_s_function";
    printer_deep_block_reference_type Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let printer_deep_s_function_desc ctx ppf = function
  | Mdl_deep_ast.Deep_s_function ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_deep_ast.Deep_s_function"
  | Mdl_deep_ast.Deep_s_function_stateflow (d, d0) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_deep_ast.Deep_s_function_stateflow";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_deep_name Og_precedence.Ck_tuple_item ppf d;
    Format.fprintf ppf "%,,@ ";
    printer_deep_chart_file_number Og_precedence.Ck_tuple_item ppf d0;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let rec printer_deep_block ctx ppf = function
  | {
      Mdl_deep_ast.deep_block_name = d;
      Mdl_deep_ast.deep_block_sid = d_o;
      Mdl_deep_ast.deep_block_body = d0;
      Mdl_deep_ast.deep_block_desc = d1;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_deep_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>deep_block_name =";
    printer_deep_block_name Og_precedence.Ck_record_field ppf d;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_block_sid =";
    Og_printer.printer_Option printer_deep_sid
      Og_precedence.Ck_record_field
      ppf
      d_o;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_block_body =";
    printer_deep_block_body_elements Og_precedence.Ck_record_field ppf d0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_block_desc =";
    printer_deep_block_desc Og_precedence.Ck_record_field ppf d1;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"

and printer_deep_block_desc ctx ppf = function
  | Mdl_deep_ast.Deep_block_regular d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_deep_ast.Deep_block_regular";
    printer_deep_block_regular_type Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_deep_ast.Deep_block_reference d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_deep_ast.Deep_block_reference";
    printer_deep_block_reference_type Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_deep_ast.Deep_block_sub_system d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_deep_ast.Deep_block_sub_system";
    printer_deep_system Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_deep_ast.Deep_block_s_function d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_deep_ast.Deep_block_s_function";
    printer_deep_s_function_desc Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_deep_block_body_element ctx ppf = function
  | Mdl_deep_ast.Deep_block_mask d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_deep_ast.Deep_block_mask";
    printer_deep_mask Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_deep_ast.Deep_block_sf_block_type d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_deep_ast.Deep_block_sf_block_type";
    printer_deep_sf_block_type Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_deep_ast.Deep_block_bindings d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_deep_ast.Deep_block_bindings";
    printer_deep_block_items Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_deep_ast.Deep_block_array d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_deep_ast.Deep_block_array";
    printer_deep_array_description Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_deep_ast.Deep_block_object d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_deep_ast.Deep_block_object";
    printer_deep_object_description Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_deep_ast.Deep_block_instance_data d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_deep_ast.Deep_block_instance_data";
    printer_deep_bindings Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_deep_block_body_elements ctx ppf = function
  | d_l ->
    Og_printer.printer_List printer_deep_block_body_element ctx ppf d_l

and printer_deep_system ctx ppf = function
  | {
      Mdl_deep_ast.deep_system_name = d;
      Mdl_deep_ast.deep_system_position = d0;
      Mdl_deep_ast.deep_system_bindings = d1;
      Mdl_deep_ast.deep_system_blocks = d2;
      Mdl_deep_ast.deep_system_lines = d3;
      Mdl_deep_ast.deep_system_annotations = d4;
      Mdl_deep_ast.deep_system_connectors = d5;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_deep_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>deep_system_name =";
    printer_deep_system_name Og_precedence.Ck_record_field ppf d;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_system_position =";
    printer_deep_position Og_precedence.Ck_record_field ppf d0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_system_bindings =";
    printer_deep_bindings Og_precedence.Ck_record_field ppf d1;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_system_blocks =";
    printer_deep_system_blocks Og_precedence.Ck_record_field ppf d2;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_system_lines =";
    printer_deep_lines Og_precedence.Ck_record_field ppf d3;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_system_annotations =";
    printer_deep_annotations Og_precedence.Ck_record_field ppf d4;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_system_connectors =";
    printer_deep_system_connectors Og_precedence.Ck_record_field ppf d5;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"

and printer_deep_array_description ctx ppf = function
  | {
      Mdl_deep_ast.deep_array_type = d;
      Mdl_deep_ast.deep_array_items = d0;
      Mdl_deep_ast.deep_array_prop_name = d1;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_deep_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>deep_array_type =";
    printer_deep_array_type Og_precedence.Ck_record_field ppf d;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_array_items =";
    printer_deep_array_items Og_precedence.Ck_record_field ppf d0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_array_prop_name =";
    printer_deep_prop_name Og_precedence.Ck_record_field ppf d1;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"

and printer_deep_array_items ctx ppf = function
  | d_a -> Og_printer.printer_Array printer_deep_array_item ctx ppf d_a

and printer_deep_array_item ctx ppf = function
  | Mdl_deep_ast.Deep_array_name d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_deep_ast.Deep_array_name";
    printer_deep_array_name Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_deep_ast.Deep_array_sub_array d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_deep_ast.Deep_array_sub_array";
    printer_deep_array_description Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_deep_ast.Deep_array_custom_property m_c ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_deep_ast.Deep_array_custom_property";
    Mdl_ast_print.printer_custom_property Og_precedence.Ck_argument ppf m_c;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_deep_ast.Deep_array_matstruct m_m ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_deep_ast.Deep_array_matstruct";
    Mdl_ast_print.printer_matstruct_items Og_precedence.Ck_argument ppf m_m;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_deep_ast.Deep_array_object d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_deep_ast.Deep_array_object";
    printer_deep_object_description Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_deep_ast.Deep_array_vendor_binding m_v ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_deep_ast.Deep_array_vendor_binding";
    Mdl_ast_print.printer_vendor_binding Og_precedence.Ck_argument ppf m_v;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_deep_ast.Deep_array_vendor_configset (m_v, m_v0) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_deep_ast.Deep_array_vendor_configset";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    Mdl_ast_print.printer_vendor_ident Og_precedence.Ck_tuple_item ppf m_v;
    Format.fprintf ppf "%,,@ ";
    Mdl_ast_print.printer_vendor_items Og_precedence.Ck_tuple_item ppf m_v0;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_deep_ast.Deep_array_binding d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_deep_ast.Deep_array_binding";
    printer_deep_binding Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_deep_object_description ctx ppf = function
  | {
      Mdl_deep_ast.deep_object_id = d;
      Mdl_deep_ast.deep_object_class_name = d_o;
      Mdl_deep_ast.deep_object_prop_name = d_o0;
      Mdl_deep_ast.deep_object_items = d0;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_deep_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>deep_object_id =";
    printer_deep_object_id Og_precedence.Ck_record_field ppf d;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_object_class_name =";
    Og_printer.printer_Option printer_deep_class_name
      Og_precedence.Ck_record_field
      ppf
      d_o;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_object_prop_name =";
    Og_printer.printer_Option printer_deep_prop_name
      Og_precedence.Ck_record_field
      ppf
      d_o0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_object_items =";
    printer_deep_object_items Og_precedence.Ck_record_field ppf d0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"

and printer_deep_object_items ctx ppf = function
  | d_l -> Og_printer.printer_List printer_deep_object_item ctx ppf d_l

and printer_deep_object_item ctx ppf = function
  | Mdl_deep_ast.Deep_object_type d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_deep_ast.Deep_object_type";
    printer_deep_object_type Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_deep_ast.Deep_object_name d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_deep_ast.Deep_object_name";
    printer_deep_object_name Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_deep_ast.Deep_object_dollar_binding d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_deep_ast.Deep_object_dollar_binding";
    printer_dollar_binding Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_deep_ast.Deep_object_array d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_deep_ast.Deep_object_array";
    printer_deep_array_description Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_deep_ast.Deep_object_custom_property c ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_deep_ast.Deep_object_custom_property";
    printer_custom_property Og_precedence.Ck_argument ppf c;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_deep_ast.Deep_object_object d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_deep_ast.Deep_object_object";
    printer_deep_object_description Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_deep_ast.Deep_object_binding d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_deep_ast.Deep_object_binding";
    printer_deep_binding Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_deep_lines ctx ppf = function
  | d_l -> Og_printer.printer_List printer_deep_line ctx ppf d_l

and printer_deep_annotations ctx ppf = function
  | d_l -> Og_printer.printer_List printer_deep_annotation ctx ppf d_l

and printer_deep_system_connectors ctx ppf = function
  | d_l -> Og_printer.printer_List printer_deep_system_connector ctx ppf d_l

and printer_deep_system_connector ctx ppf = function
  | d -> printer_deep_bindings ctx ppf d

and printer_deep_system_blocks ctx ppf = function
  | d_l -> Og_printer.printer_List printer_deep_block ctx ppf d_l
;;

let rec printer_deep_model_configuration_section ctx ppf = function
  | {
      Mdl_deep_ast.deep_graphical_parameters = g_l;
      Mdl_deep_ast.deep_configuration_bindings = d;
      Mdl_deep_ast.deep_vendor_bindings = v;
      Mdl_deep_ast.deep_object_bindings = o;
      Mdl_deep_ast.deep_model_configurations = d0;
      Mdl_deep_ast.deep_model_set_configuration_option = m;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_deep_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>deep_graphical_parameters =";
    Og_printer.printer_List printer_graphical_interface_item
      Og_precedence.Ck_record_field
      ppf
      g_l;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_configuration_bindings =";
    printer_deep_environment Og_precedence.Ck_record_field ppf d;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_vendor_bindings =";
    printer_vendor_bindings Og_precedence.Ck_record_field ppf v;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_object_bindings =";
    printer_object_descriptions Og_precedence.Ck_record_field ppf o;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_model_configurations =";
    printer_deep_model_configurations Og_precedence.Ck_record_field ppf d0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_model_set_configuration_option =";
    printer_model_set_configuration_option
      Og_precedence.Ck_record_field
      ppf
      m;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"

and printer_deep_environment ctx ppf = function
  | i_d_h_t ->
    Hash_table_print.printer_t printer_ident printer_deep_value
      ctx
      ppf
      i_d_h_t

and printer_vendor_bindings ctx ppf = function
  | v_l -> Og_printer.printer_List printer_vendor_binding ctx ppf v_l

and printer_object_descriptions ctx ppf = function
  | o_l -> Og_printer.printer_List printer_object_description ctx ppf o_l

and printer_deep_model_configurations ctx ppf = function
  | d_l ->
    Og_printer.printer_List printer_deep_model_configuration ctx ppf d_l

and printer_deep_model_configuration ctx ppf = function
  | {
      Mdl_deep_ast.deep_configuration_name = c;
      Mdl_deep_ast.deep_configuration_object_id = o;
      Mdl_deep_ast.deep_configuration_vendor_items = v;
      Mdl_deep_ast.deep_configuration_vendor_components = v0;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_deep_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>deep_configuration_name =";
    printer_configuration_name Og_precedence.Ck_record_field ppf c;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_configuration_object_id =";
    printer_object_id Og_precedence.Ck_record_field ppf o;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_configuration_vendor_items =";
    printer_vendor_items Og_precedence.Ck_record_field ppf v;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_configuration_vendor_components =";
    printer_vendor_components Og_precedence.Ck_record_field ppf v0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"

and printer_vendor_components ctx ppf = function
  | v_l -> Og_printer.printer_List printer_vendor_component ctx ppf v_l

and printer_vendor_component ctx ppf = function
  | (c, d) ->
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ "
      else
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_tuple_item then
      Format.fprintf ppf "%,@[<hv 2>(@,";
    Format.fprintf ppf "%,@[<hv 0>";
    printer_component_name Og_precedence.Ck_tuple_item ppf c;
    Format.fprintf ppf "%,,@ ";
    printer_deep_bindings Og_precedence.Ck_tuple_item ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
      else
    if ctx = Og_precedence.Ck_tuple_item then
      Format.fprintf ppf "%,@;<0 -2>)@]"

and printer_component_name ctx ppf = function
  | c -> printer_configuration_longident ctx ppf c

and printer_configuration_name ctx ppf = function
  | m -> printer_mdl_name ctx ppf m
;;

let rec printer_deep_model_body ctx ppf = function
  | {
      Mdl_deep_ast.deep_model_ident = m;
      Mdl_deep_ast.deep_model_version = d;
      Mdl_deep_ast.deep_model_explicit_file_name = d0;
      Mdl_deep_ast.deep_model_configuration_section = d1;
      Mdl_deep_ast.deep_model_defaults = d2;
      Mdl_deep_ast.deep_model_system = d3;
      Mdl_deep_ast.deep_model_workspace = d4;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_deep_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>deep_model_ident =";
    printer_model_ident Og_precedence.Ck_record_field ppf m;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_model_version =";
    printer_deep_model_version Og_precedence.Ck_record_field ppf d;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_model_explicit_file_name =";
    printer_deep_file_name Og_precedence.Ck_record_field ppf d0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_model_configuration_section =";
    printer_deep_model_configuration_section
      Og_precedence.Ck_record_field
      ppf
      d1;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_model_defaults =";
    printer_deep_model_defaults Og_precedence.Ck_record_field ppf d2;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_model_system =";
    printer_deep_system Og_precedence.Ck_record_field ppf d3;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_model_workspace =";
    printer_deep_model_workspace Og_precedence.Ck_record_field ppf d4;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"

and printer_deep_model_version ctx ppf = function
  | Mdl_deep_ast.Deep_mdl_model_version d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_deep_ast.Deep_mdl_model_version";
    printer_deep_version Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_deep_ast.Deep_slx_model_version d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_deep_ast.Deep_slx_model_version";
    printer_deep_version Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_deep_version ctx ppf = function
  | {
      Mdl_deep_ast.deep_major_version = n;
      Mdl_deep_ast.deep_minor_version = n0;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_deep_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>deep_major_version =";
    printer_natural Og_precedence.Ck_record_field ppf n;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_minor_version =";
    printer_natural Og_precedence.Ck_record_field ppf n0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"

and printer_deep_model_workspace ctx ppf = function
  | d_l ->
    Og_printer.printer_List printer_deep_model_workspace_data ctx ppf d_l

and printer_deep_model_workspace_data ctx ppf = function
  | Mdl_deep_ast.Deep_code_workspace_data d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_deep_ast.Deep_code_workspace_data";
    printer_deep_model_code_workspace_data Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_deep_ast.Deep_mat_file_workspace_data p_f ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_deep_ast.Deep_mat_file_workspace_data";
    Path_print.printer_file_name Og_precedence.Ck_argument ppf p_f;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_deep_model_code_workspace_data ctx ppf = function
  | {
      Mdl_deep_ast.workspace_data_source_type = d_o;
      Mdl_deep_ast.workspace_data_source_code = m_d;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_deep_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>workspace_data_source_type =";
    Og_printer.printer_Option printer_deep_workspace_data_source_type
      Og_precedence.Ck_record_field
      ppf
      d_o;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>workspace_data_source_code =";
    Mdl_basics_deep_ast_print.printer_deep_workspace_data_source_code
      Og_precedence.Ck_record_field
      ppf
      m_d;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"

and printer_deep_workspace_data_source_type ctx ppf = function
  | Mdl_deep_ast.Deep_M_Code ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_deep_ast.Deep_M_Code"
  | Mdl_deep_ast.Deep_MATLAB_Code ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_deep_ast.Deep_MATLAB_Code"
  | Mdl_deep_ast.Deep_MATLAB_File p_f ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_deep_ast.Deep_MATLAB_File";
    Path_print.printer_file_name Og_precedence.Ck_argument ppf p_f;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let printer_deep_model_stateflow ctx ppf = function
  | m_d ->
    Mdl_stateflow_deep_ast_print.printer_deep_stateflow_section ctx ppf m_d
;;

let rec printer_deep_model_matdatas ctx ppf = function
  | d_l -> Og_printer.printer_List printer_deep_model_matdata ctx ppf d_l

and printer_deep_model_matdata ctx ppf = function
  | Mdl_deep_ast.Deep_matdata_section d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_deep_ast.Deep_matdata_section";
    printer_deep_matdata_section_item Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_deep_matdata_section_item ctx ppf = function
  | m_m -> Mdl_ast_print.printer_matdata_records ctx ppf m_m
;;

let printer_deep_implementation_model ctx ppf = function
  | {
      Mdl_deep_ast.deep_model_body = d;
      Mdl_deep_ast.deep_model_matdatas_option = d_o;
      Mdl_deep_ast.deep_model_stateflow_option = d_o0;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_deep_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>deep_model_body =";
    printer_deep_model_body Og_precedence.Ck_record_field ppf d;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_model_matdatas_option =";
    Og_printer.printer_Option printer_deep_model_matdatas
      Og_precedence.Ck_record_field
      ppf
      d_o;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_model_stateflow_option =";
    Og_printer.printer_Option printer_deep_model_stateflow
      Og_precedence.Ck_record_field
      ppf
      d_o0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let rec printer_deep_interface ctx ppf = function
  | {
      Mdl_deep_ast.deep_interface_ident = m;
      Mdl_deep_ast.deep_interface_explicit_file_name = d;
      Mdl_deep_ast.deep_interface_blocks = d0;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_deep_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>deep_interface_ident =";
    printer_model_ident Og_precedence.Ck_record_field ppf m;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_interface_explicit_file_name =";
    printer_deep_file_name Og_precedence.Ck_record_field ppf d;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_interface_blocks =";
    printer_deep_interface_blocks Og_precedence.Ck_record_field ppf d0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"

and printer_deep_interface_blocks ctx ppf = function
  | d_l -> Og_printer.printer_List printer_deep_interface_block ctx ppf d_l
;;

let printer_deep_implementation ctx ppf = function
  | Mdl_deep_ast.Deep_implementation_model d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_deep_ast.Deep_implementation_model";
    printer_deep_implementation_model Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_deep_ast.Deep_implementation_library d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_deep_ast.Deep_implementation_library";
    printer_deep_implementation_model Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let printer_deep_simulink_file ctx ppf = function
  | Mdl_deep_ast.Deep_implementation d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_deep_ast.Deep_implementation";
    printer_deep_implementation Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_deep_ast.Deep_interface d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_deep_ast.Deep_interface";
    printer_deep_interface Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

(* Defining top printers. *)

let print_deep_file_name ppf =
  printer_deep_file_name Og_precedence.Ck_toplevel ppf
;;

let print_natural ppf = printer_natural Og_precedence.Ck_toplevel ppf

and print_ident ppf = printer_ident Og_precedence.Ck_toplevel ppf
;;

let print_deep_name ppf = printer_deep_name Og_precedence.Ck_toplevel ppf

and print_deep_value ppf = printer_deep_value Og_precedence.Ck_toplevel ppf

and print_deep_binding ppf =
  printer_deep_binding Og_precedence.Ck_toplevel ppf

and print_deep_bindings ppf =
  printer_deep_bindings Og_precedence.Ck_toplevel ppf

and print_deep_mask ppf = printer_deep_mask Og_precedence.Ck_toplevel ppf

and print_deep_sf_block_type ppf =
  printer_deep_sf_block_type Og_precedence.Ck_toplevel ppf

and print_deep_ports_description ppf =
  printer_deep_ports_description Og_precedence.Ck_toplevel ppf
;;

let print_deep_block_name ppf =
  printer_deep_block_name Og_precedence.Ck_toplevel ppf

and print_deep_sid ppf = printer_deep_sid Og_precedence.Ck_toplevel ppf

and print_deep_block_items ppf =
  printer_deep_block_items Og_precedence.Ck_toplevel ppf
;;

let print_deep_line ppf = printer_deep_line Og_precedence.Ck_toplevel ppf

and print_deep_annotation ppf =
  printer_deep_annotation Og_precedence.Ck_toplevel ppf
;;

let print_deep_system_name ppf =
  printer_deep_system_name Og_precedence.Ck_toplevel ppf

and print_deep_prop_name ppf =
  printer_deep_prop_name Og_precedence.Ck_toplevel ppf

and print_deep_array_name ppf =
  printer_deep_array_name Og_precedence.Ck_toplevel ppf

and print_deep_class_name ppf =
  printer_deep_class_name Og_precedence.Ck_toplevel ppf

and print_deep_object_name ppf =
  printer_deep_object_name Og_precedence.Ck_toplevel ppf

and print_deep_object_type ppf =
  printer_deep_object_type Og_precedence.Ck_toplevel ppf

and print_deep_object_id ppf =
  printer_deep_object_id Og_precedence.Ck_toplevel ppf

and print_object_description ppf =
  printer_object_description Og_precedence.Ck_toplevel ppf

and print_deep_position ppf =
  printer_deep_position Og_precedence.Ck_toplevel ppf

and print_deep_array_type ppf =
  printer_deep_array_type Og_precedence.Ck_toplevel ppf

and print_deep_model_defaults ppf =
  printer_deep_model_defaults Og_precedence.Ck_toplevel ppf
;;

let print_deep_chart_file_number ppf =
  printer_deep_chart_file_number Og_precedence.Ck_toplevel ppf
;;

let print_deep_block_regular_type ppf =
  printer_deep_block_regular_type Og_precedence.Ck_toplevel ppf

and print_deep_block_source_type ppf =
  printer_deep_block_source_type Og_precedence.Ck_toplevel ppf

and print_deep_block_source_path ppf =
  printer_deep_block_source_path Og_precedence.Ck_toplevel ppf
;;

let print_deep_block_reference_type ppf =
  printer_deep_block_reference_type Og_precedence.Ck_toplevel ppf
;;

let print_deep_interface_block_parameter_type ppf =
  printer_deep_interface_block_parameter_type Og_precedence.Ck_toplevel ppf
;;

let print_deep_interface_block_binding ppf =
  printer_deep_interface_block_binding Og_precedence.Ck_toplevel ppf

and print_deep_interface_block_bindings ppf =
  printer_deep_interface_block_bindings Og_precedence.Ck_toplevel ppf
;;

let print_deep_interface_block ppf =
  printer_deep_interface_block Og_precedence.Ck_toplevel ppf

and print_deep_interface_block_desc ppf =
  printer_deep_interface_block_desc Og_precedence.Ck_toplevel ppf
;;

let print_deep_s_function_desc ppf =
  printer_deep_s_function_desc Og_precedence.Ck_toplevel ppf
;;

let print_deep_block ppf = printer_deep_block Og_precedence.Ck_toplevel ppf

and print_deep_block_desc ppf =
  printer_deep_block_desc Og_precedence.Ck_toplevel ppf

and print_deep_block_body_element ppf =
  printer_deep_block_body_element Og_precedence.Ck_toplevel ppf

and print_deep_block_body_elements ppf =
  printer_deep_block_body_elements Og_precedence.Ck_toplevel ppf

and print_deep_system ppf = printer_deep_system Og_precedence.Ck_toplevel ppf

and print_deep_array_description ppf =
  printer_deep_array_description Og_precedence.Ck_toplevel ppf

and print_deep_array_items ppf =
  printer_deep_array_items Og_precedence.Ck_toplevel ppf

and print_deep_array_item ppf =
  printer_deep_array_item Og_precedence.Ck_toplevel ppf

and print_deep_object_description ppf =
  printer_deep_object_description Og_precedence.Ck_toplevel ppf

and print_deep_object_items ppf =
  printer_deep_object_items Og_precedence.Ck_toplevel ppf

and print_deep_object_item ppf =
  printer_deep_object_item Og_precedence.Ck_toplevel ppf

and print_deep_lines ppf = printer_deep_lines Og_precedence.Ck_toplevel ppf

and print_deep_annotations ppf =
  printer_deep_annotations Og_precedence.Ck_toplevel ppf

and print_deep_system_connectors ppf =
  printer_deep_system_connectors Og_precedence.Ck_toplevel ppf

and print_deep_system_connector ppf =
  printer_deep_system_connector Og_precedence.Ck_toplevel ppf

and print_deep_system_blocks ppf =
  printer_deep_system_blocks Og_precedence.Ck_toplevel ppf
;;

let print_deep_model_configuration_section ppf =
  printer_deep_model_configuration_section Og_precedence.Ck_toplevel ppf

and print_deep_environment ppf =
  printer_deep_environment Og_precedence.Ck_toplevel ppf

and print_vendor_bindings ppf =
  printer_vendor_bindings Og_precedence.Ck_toplevel ppf

and print_object_descriptions ppf =
  printer_object_descriptions Og_precedence.Ck_toplevel ppf

and print_deep_model_configurations ppf =
  printer_deep_model_configurations Og_precedence.Ck_toplevel ppf

and print_deep_model_configuration ppf =
  printer_deep_model_configuration Og_precedence.Ck_toplevel ppf

and print_vendor_components ppf =
  printer_vendor_components Og_precedence.Ck_toplevel ppf

and print_vendor_component ppf =
  printer_vendor_component Og_precedence.Ck_toplevel ppf

and print_component_name ppf =
  printer_component_name Og_precedence.Ck_toplevel ppf

and print_configuration_name ppf =
  printer_configuration_name Og_precedence.Ck_toplevel ppf
;;

let print_deep_model_body ppf =
  printer_deep_model_body Og_precedence.Ck_toplevel ppf

and print_deep_model_version ppf =
  printer_deep_model_version Og_precedence.Ck_toplevel ppf

and print_deep_version ppf =
  printer_deep_version Og_precedence.Ck_toplevel ppf

and print_deep_model_workspace ppf =
  printer_deep_model_workspace Og_precedence.Ck_toplevel ppf

and print_deep_model_workspace_data ppf =
  printer_deep_model_workspace_data Og_precedence.Ck_toplevel ppf

and print_deep_model_code_workspace_data ppf =
  printer_deep_model_code_workspace_data Og_precedence.Ck_toplevel ppf

and print_deep_workspace_data_source_type ppf =
  printer_deep_workspace_data_source_type Og_precedence.Ck_toplevel ppf
;;

let print_deep_model_stateflow ppf =
  printer_deep_model_stateflow Og_precedence.Ck_toplevel ppf
;;

let print_deep_model_matdatas ppf =
  printer_deep_model_matdatas Og_precedence.Ck_toplevel ppf

and print_deep_model_matdata ppf =
  printer_deep_model_matdata Og_precedence.Ck_toplevel ppf

and print_deep_matdata_section_item ppf =
  printer_deep_matdata_section_item Og_precedence.Ck_toplevel ppf
;;

let print_deep_implementation_model ppf =
  printer_deep_implementation_model Og_precedence.Ck_toplevel ppf
;;

let print_deep_interface ppf =
  printer_deep_interface Og_precedence.Ck_toplevel ppf

and print_deep_interface_blocks ppf =
  printer_deep_interface_blocks Og_precedence.Ck_toplevel ppf
;;

let print_deep_implementation ppf =
  printer_deep_implementation Og_precedence.Ck_toplevel ppf
;;

let print_deep_simulink_file ppf =
  printer_deep_simulink_file Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.5+dev0 generated code. *)
