(***********************************************************************)
(*                                                                     *)
(*                               Simport                               *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2010-2019,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.5+dev0 generated code. *)

let printer_ident ctx ppf = function
  | i_i -> Ident_print.printer_ident ctx ppf i_i

and printer_natural ctx ppf = function
  | m_n -> Mdl_basics_deep_ast_print.printer_natural ctx ppf m_n
;;

let printer_deep_text ctx ppf = function
  | m_d -> Mdl_basics_deep_ast_print.printer_deep_text ctx ppf m_d

and printer_deep_name ctx ppf = function
  | m_d -> Mdl_basics_deep_ast_print.printer_deep_name ctx ppf m_d

and printer_deep_code ctx ppf = function
  | m_d -> Mdl_basics_deep_ast_print.printer_deep_code ctx ppf m_d

and printer_deep_binding_table ctx ppf = function
  | m_d -> Mdl_basics_deep_ast_print.printer_deep_binding_table ctx ppf m_d
;;

let printer_matlab_code ctx ppf = function | d -> printer_deep_code ctx ppf d
;;

let rec printer_deep_stateflow_id ctx ppf = function
  | n -> printer_natural ctx ppf n

and printer_deep_stateflow_name ctx ppf = function
  | d -> printer_deep_name ctx ppf d

and printer_deep_stateflow_reference ctx ppf = function
  | n -> printer_natural ctx ppf n

and printer_deep_stateflow_number ctx ppf = function
  | m_s -> Mdl_ast_print.printer_stateflow_number ctx ppf m_s

and printer_deep_chart_file_number ctx ppf = function
  | m_d ->
    Mdl_basics_deep_ast_print.printer_deep_chart_file_number ctx ppf m_d

and printer_deep_stateflow_chart_file_number ctx ppf = function
  | d -> printer_deep_chart_file_number ctx ppf d
;;

let printer_deep_stateflow_name_option ctx ppf = function
  | d_o -> Og_printer.printer_Option printer_deep_stateflow_name ctx ppf d_o
;;

let printer_deep_stateflow_reference_option ctx ppf = function
  | d_o ->
    Og_printer.printer_Option printer_deep_stateflow_reference ctx ppf d_o
;;

let printer_deep_stateflow_execution_order_option ctx ppf = function
  | n_o -> Og_printer.printer_Option printer_natural ctx ppf n_o

and printer_deep_stateflow_label_string_option ctx ppf = function
  | d_o -> Og_printer.printer_Option printer_deep_text ctx ppf d_o

and printer_deep_stateflow_id_option ctx ppf = function
  | d_o -> Og_printer.printer_Option printer_deep_stateflow_id ctx ppf d_o

and printer_deep_stateflow_ssid_number_option ctx ppf = function
  | n_o -> Og_printer.printer_Option printer_natural ctx ppf n_o
;;

let printer_deep_stateflow_state_type ctx ppf = function
  | Mdl_stateflow_deep_ast.Deep_state_type_and ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_stateflow_deep_ast.Deep_state_type_and"
  | Mdl_stateflow_deep_ast.Deep_state_type_or ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_stateflow_deep_ast.Deep_state_type_or"
  | Mdl_stateflow_deep_ast.Deep_state_type_func ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_stateflow_deep_ast.Deep_state_type_func"
  | Mdl_stateflow_deep_ast.Deep_state_type_group ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_stateflow_deep_ast.Deep_state_type_group"
  | Mdl_stateflow_deep_ast.Deep_state_type_sub ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_stateflow_deep_ast.Deep_state_type_sub"
  | Mdl_stateflow_deep_ast.Deep_state_type_super ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_stateflow_deep_ast.Deep_state_type_super"
  | Mdl_stateflow_deep_ast.Deep_state_type_eml_chart ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_stateflow_deep_ast.Deep_state_type_eml_chart"
  | Mdl_stateflow_deep_ast.Deep_state_type_string d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_stateflow_deep_ast.Deep_state_type_string";
    printer_deep_text Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let printer_deep_stateflow_chart_type ctx ppf = function
  | d -> printer_deep_stateflow_state_type ctx ppf d
;;

let printer_deep_stateflow_junction_type ctx ppf = function
  | Mdl_stateflow_deep_ast.Deep_junction_type_connective_junction ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,Mdl_stateflow_deep_ast.Deep_junction_type_connective_junction"
  | Mdl_stateflow_deep_ast.Deep_junction_type_history_junction ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,Mdl_stateflow_deep_ast.Deep_junction_type_history_junction"
  | Mdl_stateflow_deep_ast.Deep_junction_type_string d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_stateflow_deep_ast.Deep_junction_type_string";
    printer_deep_text Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let printer_deep_stateflow_transition_type ctx ppf = function
  | Mdl_stateflow_deep_ast.Deep_transition_type_sub ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_stateflow_deep_ast.Deep_transition_type_sub"
  | Mdl_stateflow_deep_ast.Deep_transition_type_string d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_stateflow_deep_ast.Deep_transition_type_string";
    printer_deep_text Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let printer_deep_stateflow_transition_type_option ctx ppf = function
  | d_o ->
    Og_printer.printer_Option printer_deep_stateflow_transition_type
      ctx
      ppf
      d_o
;;

let printer_deep_stateflow_data_scope ctx ppf = function
  | Mdl_stateflow_deep_ast.Deep_scope_constant_data ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_stateflow_deep_ast.Deep_scope_constant_data"
  | Mdl_stateflow_deep_ast.Deep_scope_data_store_memory_data ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,Mdl_stateflow_deep_ast.Deep_scope_data_store_memory_data"
  | Mdl_stateflow_deep_ast.Deep_scope_exported_data ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_stateflow_deep_ast.Deep_scope_exported_data"
  | Mdl_stateflow_deep_ast.Deep_scope_function_input_data ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,Mdl_stateflow_deep_ast.Deep_scope_function_input_data"
  | Mdl_stateflow_deep_ast.Deep_scope_function_output_data ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,Mdl_stateflow_deep_ast.Deep_scope_function_output_data"
  | Mdl_stateflow_deep_ast.Deep_scope_input_data ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_stateflow_deep_ast.Deep_scope_input_data"
  | Mdl_stateflow_deep_ast.Deep_scope_input_event ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_stateflow_deep_ast.Deep_scope_input_event"
  | Mdl_stateflow_deep_ast.Deep_scope_local_data ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_stateflow_deep_ast.Deep_scope_local_data"
  | Mdl_stateflow_deep_ast.Deep_scope_local_event ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_stateflow_deep_ast.Deep_scope_local_event"
  | Mdl_stateflow_deep_ast.Deep_scope_output_data ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_stateflow_deep_ast.Deep_scope_output_data"
  | Mdl_stateflow_deep_ast.Deep_scope_output_event ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_stateflow_deep_ast.Deep_scope_output_event"
  | Mdl_stateflow_deep_ast.Deep_scope_parameter_data ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_stateflow_deep_ast.Deep_scope_parameter_data"
  | Mdl_stateflow_deep_ast.Deep_scope_temporary_data ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_stateflow_deep_ast.Deep_scope_temporary_data"
  | Mdl_stateflow_deep_ast.Deep_scope_data_string s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_stateflow_deep_ast.Deep_scope_data_string";
    Og_printer.printer_String Og_precedence.Ck_argument ppf s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let printer_deep_stateflow_props_array ctx ppf = function
  | {
      Mdl_stateflow_deep_ast.deep_props_array_item_size = d;
      Mdl_stateflow_deep_ast.deep_props_array_item_first_index = d_o;
      Mdl_stateflow_deep_ast.deep_props_array_item_binding_table = d0;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_stateflow_deep_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>deep_props_array_item_size =";
    printer_deep_text Og_precedence.Ck_record_field ppf d;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_props_array_item_first_index =";
    Og_printer.printer_Option printer_deep_text
      Og_precedence.Ck_record_field
      ppf
      d_o;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_props_array_item_binding_table =";
    printer_deep_binding_table Og_precedence.Ck_record_field ppf d0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let rec printer_deep_stateflow_data_props ctx ppf = function
  | {
      Mdl_stateflow_deep_ast.deep_props_array = d_o;
      Mdl_stateflow_deep_ast.deep_props_type = d_o0;
      Mdl_stateflow_deep_ast.deep_props_binding_table = d;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_stateflow_deep_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>deep_props_array =";
    Og_printer.printer_Option printer_deep_stateflow_props_array
      Og_precedence.Ck_record_field
      ppf
      d_o;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_props_type =";
    Og_printer.printer_Option printer_deep_stateflow_props_type
      Og_precedence.Ck_record_field
      ppf
      d_o0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_props_binding_table =";
    printer_deep_binding_table Og_precedence.Ck_record_field ppf d;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"

and printer_deep_stateflow_props_type ctx ppf = function
  | d -> printer_deep_binding_table ctx ppf d
;;

let printer_deep_data_reference ctx ppf = function
  | Mdl_stateflow_deep_ast.Deep_data_reference_chart d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_stateflow_deep_ast.Deep_data_reference_chart";
    printer_deep_stateflow_reference Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_stateflow_deep_ast.Deep_data_reference_machine d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_stateflow_deep_ast.Deep_data_reference_machine";
    printer_deep_stateflow_reference Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let printer_deep_stateflow_event_trigger ctx ppf = function
  | Mdl_stateflow_deep_ast.Deep_event_trigger_either_edge_event ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,Mdl_stateflow_deep_ast.Deep_event_trigger_either_edge_event"
  | Mdl_stateflow_deep_ast.Deep_event_trigger_falling_edge_event ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,Mdl_stateflow_deep_ast.Deep_event_trigger_falling_edge_event"
  | Mdl_stateflow_deep_ast.Deep_event_trigger_function_call_event ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,Mdl_stateflow_deep_ast.Deep_event_trigger_function_call_event"
  | Mdl_stateflow_deep_ast.Deep_event_trigger_rising_edge_event ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,Mdl_stateflow_deep_ast.Deep_event_trigger_rising_edge_event"
  | Mdl_stateflow_deep_ast.Deep_event_trigger_ident i ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_stateflow_deep_ast.Deep_event_trigger_ident";
    printer_ident Og_precedence.Ck_argument ppf i; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let printer_deep_intersection ctx ppf = function
  | {
      Mdl_stateflow_deep_ast.i0 = d;
      Mdl_stateflow_deep_ast.i1 = d0;
      Mdl_stateflow_deep_ast.i2 = d1;
      Mdl_stateflow_deep_ast.i3 = d2;
      Mdl_stateflow_deep_ast.i4 = d3;
      Mdl_stateflow_deep_ast.i5 = d4;
      Mdl_stateflow_deep_ast.i6 = d5;
      Mdl_stateflow_deep_ast.i7 = d6;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_stateflow_deep_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>i0 =";
    printer_deep_stateflow_number Og_precedence.Ck_record_field ppf d;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>i1 =";
    printer_deep_stateflow_number Og_precedence.Ck_record_field ppf d0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>i2 =";
    printer_deep_stateflow_number Og_precedence.Ck_record_field ppf d1;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>i3 =";
    printer_deep_stateflow_number Og_precedence.Ck_record_field ppf d2;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>i4 =";
    printer_deep_stateflow_number Og_precedence.Ck_record_field ppf d3;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>i5 =";
    printer_deep_stateflow_number Og_precedence.Ck_record_field ppf d4;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>i6 =";
    printer_deep_stateflow_number Og_precedence.Ck_record_field ppf d5;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>i7 =";
    printer_deep_stateflow_number Og_precedence.Ck_record_field ppf d6;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let printer_deep_transition_src ctx ppf = function
  | {
      Mdl_stateflow_deep_ast.src_id = d;
      Mdl_stateflow_deep_ast.src_intersection = d0;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_stateflow_deep_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>src_id =";
    printer_deep_stateflow_id_option Og_precedence.Ck_record_field ppf d;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>src_intersection =";
    printer_deep_intersection Og_precedence.Ck_record_field ppf d0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let printer_deep_transition_dst ctx ppf = function
  | {
      Mdl_stateflow_deep_ast.dst_id = d;
      Mdl_stateflow_deep_ast.dst_intersection = d0;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_stateflow_deep_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>dst_id =";
    printer_deep_stateflow_id_option Og_precedence.Ck_record_field ppf d;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>dst_intersection =";
    printer_deep_intersection Og_precedence.Ck_record_field ppf d0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let printer_deep_stateflow_state_eml ctx ppf = function
  | {
      Mdl_stateflow_deep_ast.state_eml_script = d_o;
      Mdl_stateflow_deep_ast.state_eml_binding_table = d;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_stateflow_deep_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>state_eml_script =";
    Og_printer.printer_Option printer_deep_code
      Og_precedence.Ck_record_field
      ppf
      d_o;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>state_eml_binding_table =";
    printer_deep_binding_table Og_precedence.Ck_record_field ppf d;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let printer_deep_stateflow_chart_eml ctx ppf = function
  | {
      Mdl_stateflow_deep_ast.chart_eml_name = d;
      Mdl_stateflow_deep_ast.chart_eml_binding_table = d0;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_stateflow_deep_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>chart_eml_name =";
    printer_deep_name Og_precedence.Ck_record_field ppf d;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>chart_eml_binding_table =";
    printer_deep_binding_table Og_precedence.Ck_record_field ppf d0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let rec printer_deep_stateflow_junctions ctx ppf = function
  | d_l ->
    Og_printer.printer_List printer_deep_stateflow_junction ctx ppf d_l

and printer_deep_stateflow_junction ctx ppf = function
  | {
      Mdl_stateflow_deep_ast.deep_junction_id = d;
      Mdl_stateflow_deep_ast.deep_junction_ssid_number = d0;
      Mdl_stateflow_deep_ast.deep_junction_type = d1;
      Mdl_stateflow_deep_ast.deep_junction_label_string = d2;
      Mdl_stateflow_deep_ast.deep_junction_binding_table = d3;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_stateflow_deep_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>deep_junction_id =";
    printer_deep_stateflow_id Og_precedence.Ck_record_field ppf d;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_junction_ssid_number =";
    printer_deep_stateflow_ssid_number_option
      Og_precedence.Ck_record_field
      ppf
      d0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_junction_type =";
    printer_deep_stateflow_junction_type Og_precedence.Ck_record_field ppf d1;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_junction_label_string =";
    printer_deep_stateflow_label_string_option
      Og_precedence.Ck_record_field
      ppf
      d2;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_junction_binding_table =";
    printer_deep_binding_table Og_precedence.Ck_record_field ppf d3;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let rec printer_deep_stateflow_transitions ctx ppf = function
  | d_l ->
    Og_printer.printer_List printer_deep_stateflow_transition ctx ppf d_l

and printer_deep_stateflow_transition ctx ppf = function
  | {
      Mdl_stateflow_deep_ast.deep_transition_id = d;
      Mdl_stateflow_deep_ast.deep_transition_ssid_number = d0;
      Mdl_stateflow_deep_ast.deep_transition_type = d1;
      Mdl_stateflow_deep_ast.deep_transition_label_string = d2;
      Mdl_stateflow_deep_ast.deep_transition_src = d3;
      Mdl_stateflow_deep_ast.deep_transition_dst = d4;
      Mdl_stateflow_deep_ast.deep_transition_execution_order = d5;
      Mdl_stateflow_deep_ast.deep_transition_binding_table = d6;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_stateflow_deep_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>deep_transition_id =";
    printer_deep_stateflow_id Og_precedence.Ck_record_field ppf d;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_transition_ssid_number =";
    printer_deep_stateflow_ssid_number_option
      Og_precedence.Ck_record_field
      ppf
      d0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_transition_type =";
    printer_deep_stateflow_transition_type_option
      Og_precedence.Ck_record_field
      ppf
      d1;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_transition_label_string =";
    printer_deep_stateflow_label_string_option
      Og_precedence.Ck_record_field
      ppf
      d2;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_transition_src =";
    printer_deep_transition_src Og_precedence.Ck_record_field ppf d3;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_transition_dst =";
    printer_deep_transition_dst Og_precedence.Ck_record_field ppf d4;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_transition_execution_order =";
    printer_deep_stateflow_execution_order_option
      Og_precedence.Ck_record_field
      ppf
      d5;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_transition_binding_table =";
    printer_deep_binding_table Og_precedence.Ck_record_field ppf d6;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let rec printer_deep_stateflow_events ctx ppf = function
  | d_l -> Og_printer.printer_List printer_deep_stateflow_event ctx ppf d_l

and printer_deep_stateflow_event ctx ppf = function
  | {
      Mdl_stateflow_deep_ast.deep_event_id = d;
      Mdl_stateflow_deep_ast.deep_event_name = d0;
      Mdl_stateflow_deep_ast.deep_event_scope = d1;
      Mdl_stateflow_deep_ast.deep_event_trigger = d2;
      Mdl_stateflow_deep_ast.deep_event_binding_table = d3;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_stateflow_deep_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>deep_event_id =";
    printer_deep_stateflow_id Og_precedence.Ck_record_field ppf d;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_event_name =";
    printer_deep_stateflow_name Og_precedence.Ck_record_field ppf d0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_event_scope =";
    printer_deep_stateflow_data_scope Og_precedence.Ck_record_field ppf d1;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_event_trigger =";
    printer_deep_stateflow_event_trigger Og_precedence.Ck_record_field ppf d2;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_event_binding_table =";
    printer_deep_binding_table Og_precedence.Ck_record_field ppf d3;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let rec printer_deep_stateflow_datas ctx ppf = function
  | d_l -> Og_printer.printer_List printer_deep_stateflow_data ctx ppf d_l

and printer_deep_stateflow_data ctx ppf = function
  | {
      Mdl_stateflow_deep_ast.deep_data_id = d;
      Mdl_stateflow_deep_ast.deep_data_name = d0;
      Mdl_stateflow_deep_ast.deep_data_ssid_number = d1;
      Mdl_stateflow_deep_ast.deep_data_scope = d2;
      Mdl_stateflow_deep_ast.deep_data_props = d3;
      Mdl_stateflow_deep_ast.deep_data_binding_table = d4;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_stateflow_deep_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>deep_data_id =";
    printer_deep_stateflow_id Og_precedence.Ck_record_field ppf d;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_data_name =";
    printer_deep_stateflow_name Og_precedence.Ck_record_field ppf d0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_data_ssid_number =";
    printer_deep_stateflow_ssid_number_option
      Og_precedence.Ck_record_field
      ppf
      d1;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_data_scope =";
    printer_deep_stateflow_data_scope Og_precedence.Ck_record_field ppf d2;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_data_props =";
    printer_deep_stateflow_data_props Og_precedence.Ck_record_field ppf d3;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_data_binding_table =";
    printer_deep_binding_table Og_precedence.Ck_record_field ppf d4;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let rec printer_deep_stateflow_states ctx ppf = function
  | d_l -> Og_printer.printer_List printer_deep_stateflow_state ctx ppf d_l

and printer_deep_stateflow_state ctx ppf = function
  | {
      Mdl_stateflow_deep_ast.deep_state_id = d;
      Mdl_stateflow_deep_ast.deep_state_ssid_number = d0;
      Mdl_stateflow_deep_ast.deep_state_type = d1;
      Mdl_stateflow_deep_ast.deep_state_label_string = d2;
      Mdl_stateflow_deep_ast.deep_state_execution_order = d3;
      Mdl_stateflow_deep_ast.deep_stateflow_state_eml = d_o;
      Mdl_stateflow_deep_ast.deep_stateflow_state_datas = d4;
      Mdl_stateflow_deep_ast.deep_stateflow_state_events = d5;
      Mdl_stateflow_deep_ast.deep_stateflow_state_junctions = d6;
      Mdl_stateflow_deep_ast.deep_stateflow_state_states = d7;
      Mdl_stateflow_deep_ast.deep_stateflow_state_transitions = d8;
      Mdl_stateflow_deep_ast.deep_state_binding_table = d9;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_stateflow_deep_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>deep_state_id =";
    printer_deep_stateflow_id Og_precedence.Ck_record_field ppf d;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_state_ssid_number =";
    printer_deep_stateflow_ssid_number_option
      Og_precedence.Ck_record_field
      ppf
      d0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_state_type =";
    printer_deep_stateflow_state_type Og_precedence.Ck_record_field ppf d1;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_state_label_string =";
    printer_deep_text Og_precedence.Ck_record_field ppf d2;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_state_execution_order =";
    printer_deep_stateflow_execution_order_option
      Og_precedence.Ck_record_field
      ppf
      d3;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_stateflow_state_eml =";
    Og_printer.printer_Option printer_deep_stateflow_state_eml
      Og_precedence.Ck_record_field
      ppf
      d_o;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_stateflow_state_datas =";
    printer_deep_stateflow_datas Og_precedence.Ck_record_field ppf d4;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_stateflow_state_events =";
    printer_deep_stateflow_events Og_precedence.Ck_record_field ppf d5;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_stateflow_state_junctions =";
    printer_deep_stateflow_junctions Og_precedence.Ck_record_field ppf d6;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_stateflow_state_states =";
    printer_deep_stateflow_states Og_precedence.Ck_record_field ppf d7;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_stateflow_state_transitions =";
    printer_deep_stateflow_transitions Og_precedence.Ck_record_field ppf d8;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_state_binding_table =";
    printer_deep_binding_table Og_precedence.Ck_record_field ppf d9;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let rec printer_deep_stateflow_targets ctx ppf = function
  | d_l -> Og_printer.printer_List printer_deep_stateflow_target ctx ppf d_l

and printer_deep_stateflow_target ctx ppf = function
  | {
      Mdl_stateflow_deep_ast.deep_target_id = d;
      Mdl_stateflow_deep_ast.deep_target_name = d0;
      Mdl_stateflow_deep_ast.deep_target_binding_table = d1;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_stateflow_deep_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>deep_target_id =";
    printer_deep_stateflow_id Og_precedence.Ck_record_field ppf d;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_target_name =";
    printer_deep_stateflow_name_option Og_precedence.Ck_record_field ppf d0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_target_binding_table =";
    printer_deep_binding_table Og_precedence.Ck_record_field ppf d1;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let rec printer_deep_stateflow_charts ctx ppf = function
  | d_l -> Og_printer.printer_List printer_deep_stateflow_chart ctx ppf d_l

and printer_deep_stateflow_chart ctx ppf = function
  | {
      Mdl_stateflow_deep_ast.deep_chart_id = d;
      Mdl_stateflow_deep_ast.deep_chart_name = d0;
      Mdl_stateflow_deep_ast.deep_chart_file_number = d1;
      Mdl_stateflow_deep_ast.deep_chart_type = d_o;
      Mdl_stateflow_deep_ast.deep_stateflow_chart_eml = d_o0;
      Mdl_stateflow_deep_ast.deep_stateflow_chart_datas = d2;
      Mdl_stateflow_deep_ast.deep_stateflow_chart_events = d3;
      Mdl_stateflow_deep_ast.deep_stateflow_chart_junctions = d4;
      Mdl_stateflow_deep_ast.deep_stateflow_chart_states = d5;
      Mdl_stateflow_deep_ast.deep_stateflow_chart_transitions = d6;
      Mdl_stateflow_deep_ast.deep_chart_binding_table = d7;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_stateflow_deep_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>deep_chart_id =";
    printer_deep_stateflow_id Og_precedence.Ck_record_field ppf d;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_chart_name =";
    printer_deep_stateflow_name Og_precedence.Ck_record_field ppf d0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_chart_file_number =";
    printer_deep_stateflow_chart_file_number
      Og_precedence.Ck_record_field
      ppf
      d1;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_chart_type =";
    Og_printer.printer_Option printer_deep_stateflow_chart_type
      Og_precedence.Ck_record_field
      ppf
      d_o;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_stateflow_chart_eml =";
    Og_printer.printer_Option printer_deep_stateflow_chart_eml
      Og_precedence.Ck_record_field
      ppf
      d_o0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_stateflow_chart_datas =";
    printer_deep_stateflow_datas Og_precedence.Ck_record_field ppf d2;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_stateflow_chart_events =";
    printer_deep_stateflow_events Og_precedence.Ck_record_field ppf d3;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_stateflow_chart_junctions =";
    printer_deep_stateflow_junctions Og_precedence.Ck_record_field ppf d4;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_stateflow_chart_states =";
    printer_deep_stateflow_states Og_precedence.Ck_record_field ppf d5;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_stateflow_chart_transitions =";
    printer_deep_stateflow_transitions Og_precedence.Ck_record_field ppf d6;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_chart_binding_table =";
    printer_deep_binding_table Og_precedence.Ck_record_field ppf d7;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let printer_deep_stateflow_machine ctx ppf = function
  | {
      Mdl_stateflow_deep_ast.deep_machine_id = d;
      Mdl_stateflow_deep_ast.deep_machine_name = d0;
      Mdl_stateflow_deep_ast.deep_stateflow_machine_charts = d1;
      Mdl_stateflow_deep_ast.deep_stateflow_machine_datas = d2;
      Mdl_stateflow_deep_ast.deep_stateflow_machine_events = d3;
      Mdl_stateflow_deep_ast.deep_stateflow_machine_targets = d4;
      Mdl_stateflow_deep_ast.deep_machine_binding_table = d5;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_stateflow_deep_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>deep_machine_id =";
    printer_deep_stateflow_id Og_precedence.Ck_record_field ppf d;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_machine_name =";
    printer_deep_stateflow_name_option Og_precedence.Ck_record_field ppf d0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_stateflow_machine_charts =";
    printer_deep_stateflow_charts Og_precedence.Ck_record_field ppf d1;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_stateflow_machine_datas =";
    printer_deep_stateflow_datas Og_precedence.Ck_record_field ppf d2;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_stateflow_machine_events =";
    printer_deep_stateflow_events Og_precedence.Ck_record_field ppf d3;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_stateflow_machine_targets =";
    printer_deep_stateflow_targets Og_precedence.Ck_record_field ppf d4;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_machine_binding_table =";
    printer_deep_binding_table Og_precedence.Ck_record_field ppf d5;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let printer_deep_stateflow_instance ctx ppf = function
  | {
      Mdl_stateflow_deep_ast.deep_instance_id = d;
      Mdl_stateflow_deep_ast.deep_instance_name = d0;
      Mdl_stateflow_deep_ast.deep_instance_machine_ref = d1;
      Mdl_stateflow_deep_ast.deep_instance_chart_ref = d2;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_stateflow_deep_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>deep_instance_id =";
    printer_deep_stateflow_id Og_precedence.Ck_record_field ppf d;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_instance_name =";
    printer_deep_stateflow_name Og_precedence.Ck_record_field ppf d0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_instance_machine_ref =";
    printer_deep_stateflow_reference Og_precedence.Ck_record_field ppf d1;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_instance_chart_ref =";
    printer_deep_stateflow_reference Og_precedence.Ck_record_field ppf d2;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let rec printer_deep_stateflow_section_items ctx ppf = function
  | d_l ->
    Og_printer.printer_List printer_deep_stateflow_section_item ctx ppf d_l

and printer_deep_stateflow_section_item ctx ppf = function
  | Mdl_stateflow_deep_ast.Deep_stateflow_section_machine d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_stateflow_deep_ast.Deep_stateflow_section_machine";
    printer_deep_stateflow_machine Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_stateflow_deep_ast.Deep_stateflow_section_instance d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_stateflow_deep_ast.Deep_stateflow_section_instance";
    printer_deep_stateflow_instance Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let printer_deep_stateflow_section ctx ppf = function
  | Mdl_stateflow_deep_ast.Deep_stateflow_section d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_stateflow_deep_ast.Deep_stateflow_section";
    printer_deep_stateflow_section_items Og_precedence.Ck_argument ppf d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

(* Defining top printers. *)

let print_ident ppf = printer_ident Og_precedence.Ck_toplevel ppf

and print_natural ppf = printer_natural Og_precedence.Ck_toplevel ppf
;;

let print_deep_text ppf = printer_deep_text Og_precedence.Ck_toplevel ppf

and print_deep_name ppf = printer_deep_name Og_precedence.Ck_toplevel ppf

and print_deep_code ppf = printer_deep_code Og_precedence.Ck_toplevel ppf

and print_deep_binding_table ppf =
  printer_deep_binding_table Og_precedence.Ck_toplevel ppf
;;

let print_matlab_code ppf = printer_matlab_code Og_precedence.Ck_toplevel ppf
;;

let print_deep_stateflow_id ppf =
  printer_deep_stateflow_id Og_precedence.Ck_toplevel ppf

and print_deep_stateflow_name ppf =
  printer_deep_stateflow_name Og_precedence.Ck_toplevel ppf

and print_deep_stateflow_reference ppf =
  printer_deep_stateflow_reference Og_precedence.Ck_toplevel ppf

and print_deep_stateflow_number ppf =
  printer_deep_stateflow_number Og_precedence.Ck_toplevel ppf

and print_deep_chart_file_number ppf =
  printer_deep_chart_file_number Og_precedence.Ck_toplevel ppf

and print_deep_stateflow_chart_file_number ppf =
  printer_deep_stateflow_chart_file_number Og_precedence.Ck_toplevel ppf
;;

let print_deep_stateflow_name_option ppf =
  printer_deep_stateflow_name_option Og_precedence.Ck_toplevel ppf
;;

let print_deep_stateflow_reference_option ppf =
  printer_deep_stateflow_reference_option Og_precedence.Ck_toplevel ppf
;;

let print_deep_stateflow_execution_order_option ppf =
  printer_deep_stateflow_execution_order_option Og_precedence.Ck_toplevel ppf

and print_deep_stateflow_label_string_option ppf =
  printer_deep_stateflow_label_string_option Og_precedence.Ck_toplevel ppf

and print_deep_stateflow_id_option ppf =
  printer_deep_stateflow_id_option Og_precedence.Ck_toplevel ppf

and print_deep_stateflow_ssid_number_option ppf =
  printer_deep_stateflow_ssid_number_option Og_precedence.Ck_toplevel ppf
;;

let print_deep_stateflow_state_type ppf =
  printer_deep_stateflow_state_type Og_precedence.Ck_toplevel ppf
;;

let print_deep_stateflow_chart_type ppf =
  printer_deep_stateflow_chart_type Og_precedence.Ck_toplevel ppf
;;

let print_deep_stateflow_junction_type ppf =
  printer_deep_stateflow_junction_type Og_precedence.Ck_toplevel ppf
;;

let print_deep_stateflow_transition_type ppf =
  printer_deep_stateflow_transition_type Og_precedence.Ck_toplevel ppf
;;

let print_deep_stateflow_transition_type_option ppf =
  printer_deep_stateflow_transition_type_option Og_precedence.Ck_toplevel ppf
;;

let print_deep_stateflow_data_scope ppf =
  printer_deep_stateflow_data_scope Og_precedence.Ck_toplevel ppf
;;

let print_deep_stateflow_props_array ppf =
  printer_deep_stateflow_props_array Og_precedence.Ck_toplevel ppf
;;

let print_deep_stateflow_data_props ppf =
  printer_deep_stateflow_data_props Og_precedence.Ck_toplevel ppf

and print_deep_stateflow_props_type ppf =
  printer_deep_stateflow_props_type Og_precedence.Ck_toplevel ppf
;;

let print_deep_data_reference ppf =
  printer_deep_data_reference Og_precedence.Ck_toplevel ppf
;;

let print_deep_stateflow_event_trigger ppf =
  printer_deep_stateflow_event_trigger Og_precedence.Ck_toplevel ppf
;;

let print_deep_intersection ppf =
  printer_deep_intersection Og_precedence.Ck_toplevel ppf
;;

let print_deep_transition_src ppf =
  printer_deep_transition_src Og_precedence.Ck_toplevel ppf
;;

let print_deep_transition_dst ppf =
  printer_deep_transition_dst Og_precedence.Ck_toplevel ppf
;;

let print_deep_stateflow_state_eml ppf =
  printer_deep_stateflow_state_eml Og_precedence.Ck_toplevel ppf
;;

let print_deep_stateflow_chart_eml ppf =
  printer_deep_stateflow_chart_eml Og_precedence.Ck_toplevel ppf
;;

let print_deep_stateflow_junctions ppf =
  printer_deep_stateflow_junctions Og_precedence.Ck_toplevel ppf

and print_deep_stateflow_junction ppf =
  printer_deep_stateflow_junction Og_precedence.Ck_toplevel ppf
;;

let print_deep_stateflow_transitions ppf =
  printer_deep_stateflow_transitions Og_precedence.Ck_toplevel ppf

and print_deep_stateflow_transition ppf =
  printer_deep_stateflow_transition Og_precedence.Ck_toplevel ppf
;;

let print_deep_stateflow_events ppf =
  printer_deep_stateflow_events Og_precedence.Ck_toplevel ppf

and print_deep_stateflow_event ppf =
  printer_deep_stateflow_event Og_precedence.Ck_toplevel ppf
;;

let print_deep_stateflow_datas ppf =
  printer_deep_stateflow_datas Og_precedence.Ck_toplevel ppf

and print_deep_stateflow_data ppf =
  printer_deep_stateflow_data Og_precedence.Ck_toplevel ppf
;;

let print_deep_stateflow_states ppf =
  printer_deep_stateflow_states Og_precedence.Ck_toplevel ppf

and print_deep_stateflow_state ppf =
  printer_deep_stateflow_state Og_precedence.Ck_toplevel ppf
;;

let print_deep_stateflow_targets ppf =
  printer_deep_stateflow_targets Og_precedence.Ck_toplevel ppf

and print_deep_stateflow_target ppf =
  printer_deep_stateflow_target Og_precedence.Ck_toplevel ppf
;;

let print_deep_stateflow_charts ppf =
  printer_deep_stateflow_charts Og_precedence.Ck_toplevel ppf

and print_deep_stateflow_chart ppf =
  printer_deep_stateflow_chart Og_precedence.Ck_toplevel ppf
;;

let print_deep_stateflow_machine ppf =
  printer_deep_stateflow_machine Og_precedence.Ck_toplevel ppf
;;

let print_deep_stateflow_instance ppf =
  printer_deep_stateflow_instance Og_precedence.Ck_toplevel ppf
;;

let print_deep_stateflow_section_items ppf =
  printer_deep_stateflow_section_items Og_precedence.Ck_toplevel ppf

and print_deep_stateflow_section_item ppf =
  printer_deep_stateflow_section_item Og_precedence.Ck_toplevel ppf
;;

let print_deep_stateflow_section ppf =
  printer_deep_stateflow_section Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.5+dev0 generated code. *)
