(***********************************************************************)
(*                                                                     *)
(*                               Simport                               *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2010-2019,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* $Id: mdl_stateflow_to_deep_ast.mli,v 1.1 2019-05-10 14:07:14 jpc Exp $ *)

(* From parse tree to deep syntax:
   - we perform various validity checks on the tree obtained from the parser,
   - we build explicit record representations of data instead of simple
     values with associated so-called property lists.
*)

val deep_stateflow_section :
  Mdl_ast.stateflow_section -> Mdl_stateflow_deep_ast.deep_stateflow_section
;;

(*
 Local Variables:
  compile-command: "cd ../../..; make"
  End:
*)
