(***********************************************************************)
(*                                                                     *)
(*                               Simport                               *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2010-2019,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.5+dev0 generated code. *)

let printer_natural ctx ppf = function
  | a_n -> Ast_types_print.printer_natural ctx ppf a_n

and printer_mdl_text ctx ppf = function
  | a_m -> Ast_types_print.printer_mdl_text ctx ppf a_m

and printer_mdl_font_name ctx ppf = function
  | a_m -> Ast_types_print.printer_mdl_font_name ctx ppf a_m
;;

let rec printer_explicit_value ctx ppf = function
  | m_d -> Mdl_basics_deep_ast_print.printer_deep_value ctx ppf m_d

and printer_explicit_binding ctx ppf = function
  | m_d -> Mdl_basics_deep_ast_print.printer_deep_binding ctx ppf m_d

and printer_explicit_bindings ctx ppf = function
  | m_d -> Mdl_basics_deep_ast_print.printer_deep_bindings ctx ppf m_d

and printer_explicit_points ctx ppf = function
  | m_d -> Mdl_basics_deep_ast_print.printer_deep_points ctx ppf m_d

and printer_explicit_color ctx ppf = function
  | m_d -> Mdl_basics_deep_ast_print.printer_deep_color ctx ppf m_d

and printer_explicit_rotation ctx ppf = function
  | n -> printer_natural ctx ppf n

and printer_explicit_mirror ctx ppf = function
  | m_d -> Mdl_basics_deep_ast_print.printer_deep_mirror ctx ppf m_d

and printer_explicit_number_of_regular_ports ctx ppf = function
  | m_d ->
    Mdl_basics_deep_ast_print.printer_deep_number_of_regular_ports
      ctx
      ppf
      m_d

and printer_explicit_number_of_implicit_ports ctx ppf = function
  | m_d ->
    Mdl_basics_deep_ast_print.printer_deep_number_of_implicit_ports
      ctx
      ppf
      m_d

and printer_explicit_position ctx ppf = function
  | m_d -> Mdl_basics_deep_ast_print.printer_deep_position ctx ppf m_d

and printer_explicit_state ctx ppf = function
  | m_d -> Mdl_basics_deep_ast_print.printer_deep_state ctx ppf m_d

and printer_explicit_tag ctx ppf = function
  | m_d -> Mdl_basics_deep_ast_print.printer_deep_tag ctx ppf m_d

and printer_explicit_zorder ctx ppf = function
  | m_d -> Mdl_basics_deep_ast_print.printer_deep_zorder ctx ppf m_d

and printer_explicit_block_name ctx ppf = function
  | m_d -> Mdl_basics_deep_ast_print.printer_deep_block_name ctx ppf m_d

and printer_explicit_block_port ctx ppf = function
  | m_d -> Mdl_basics_deep_ast_print.printer_deep_block_port ctx ppf m_d

and printer_explicit_port_number ctx ppf = function
  | m_d -> Mdl_basics_deep_ast_print.printer_deep_port_number ctx ppf m_d

and printer_explicit_block_ports ctx ppf = function
  | m_d -> Mdl_basics_deep_ast_print.printer_deep_block_ports ctx ppf m_d

and printer_explicit_ports_description ctx ppf = function
  | m_d ->
    Mdl_basics_deep_ast_print.printer_deep_ports_description ctx ppf m_d

and printer_explicit_line_name ctx ppf = function
  | m_d -> Mdl_basics_deep_ast_print.printer_deep_line_name ctx ppf m_d

and printer_explicit_placement ctx ppf = function
  | m_d -> Mdl_basics_deep_ast_print.printer_deep_placement ctx ppf m_d

and printer_explicit_drop_shadow ctx ppf = function
  | b -> Og_printer.printer_Bool ctx ppf b

and printer_explicit_show_name ctx ppf = function
  | b -> Og_printer.printer_Bool ctx ppf b

and printer_explicit_hide_automatic_name ctx ppf = function
  | b -> Og_printer.printer_Bool ctx ppf b

and printer_explicit_treat_as_atomic_unit ctx ppf = function
  | b_o -> Og_printer.printer_Option Og_printer.printer_Bool ctx ppf b_o

and printer_explicit_system_sample_time ctx ppf = function
  | m_d_o ->
    Og_printer.printer_Option Mdl_basics_deep_ast_print.printer_deep_value
      ctx
      ppf
      m_d_o

and printer_explicit_zoom_factor ctx ppf = function
  | n_o -> Og_printer.printer_Option printer_natural ctx ppf n_o

and printer_explicit_sid ctx ppf = function
  | m_d -> Mdl_basics_deep_ast_print.printer_deep_sid ctx ppf m_d

and printer_explicit_font_and_colors ctx ppf = function
  | m_d -> Mdl_basics_deep_ast_print.printer_deep_font_and_colors ctx ppf m_d

and printer_explicit_font_size ctx ppf = function
  | n -> printer_natural ctx ppf n

and printer_explicit_font_angle ctx ppf = function
  | m_d -> Mdl_basics_deep_ast_print.printer_deep_font_angle ctx ppf m_d

and printer_explicit_font_weight ctx ppf = function
  | m_d -> Mdl_basics_deep_ast_print.printer_deep_font_weight ctx ppf m_d

and printer_explicit_annotation_position ctx ppf = function
  | m_d ->
    Mdl_basics_deep_ast_print.printer_deep_annotation_position ctx ppf m_d

and printer_explicit_annotation_graphical_defaults ctx ppf = function
  | e_l ->
    Og_printer.printer_List printer_explicit_annotation_graphical_default
      ctx
      ppf
      e_l

and printer_explicit_annotation_graphical_default ctx ppf = function
  | m_d ->
    Mdl_basics_deep_ast_print.printer_deep_annotation_graphical_default
      ctx
      ppf
      m_d

and printer_explicit_branches ctx ppf = function
  | e_l -> Og_printer.printer_List printer_explicit_branch ctx ppf e_l

and printer_explicit_branch ctx ppf = function
  | m_d -> Mdl_basics_deep_ast_print.printer_deep_branch ctx ppf m_d
;;

let printer_explicit_mask_parameter_ident ctx ppf = function
  | m_d ->
    Mdl_basics_deep_ast_print.printer_deep_mask_parameter_ident ctx ppf m_d

and printer_explicit_mask_parameter_style ctx ppf = function
  | m_d ->
    Mdl_basics_deep_ast_print.printer_deep_mask_parameter_style ctx ppf m_d

and printer_explicit_mask_parameter_prompt ctx ppf = function
  | m_d ->
    Mdl_basics_deep_ast_print.printer_deep_mask_parameter_prompt ctx ppf m_d

and printer_explicit_mask_parameter_evaluation ctx ppf = function
  | m_d ->
    Mdl_basics_deep_ast_print.printer_deep_mask_parameter_evaluation
      ctx
      ppf
      m_d

and printer_explicit_mask_parameter_enable ctx ppf = function
  | m_d ->
    Mdl_basics_deep_ast_print.printer_deep_mask_parameter_enable ctx ppf m_d

and printer_explicit_mask_parameter_visible ctx ppf = function
  | m_d ->
    Mdl_basics_deep_ast_print.printer_deep_mask_parameter_visible ctx ppf m_d

and printer_explicit_source_code ctx ppf = function
  | m_d -> Mdl_basics_deep_ast_print.printer_deep_source_code ctx ppf m_d

and printer_explicit_stateflow_name ctx ppf = function
  | m_d ->
    Mdl_stateflow_deep_ast_print.printer_deep_stateflow_name ctx ppf m_d

and printer_explicit_stateflow_chart_file_number ctx ppf = function
  | m_d ->
    Mdl_stateflow_deep_ast_print.printer_deep_stateflow_chart_file_number
      ctx
      ppf
      m_d
;;

let printer_explicit_font ctx ppf = function
  | {
      Mdl_basics_explicit_ast.explicit_font_name = m;
      Mdl_basics_explicit_ast.explicit_font_angle = e;
      Mdl_basics_explicit_ast.explicit_font_size = e0;
      Mdl_basics_explicit_ast.explicit_font_weight = e1;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_basics_explicit_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>explicit_font_name =";
    printer_mdl_font_name Og_precedence.Ck_record_field ppf m;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_font_angle =";
    printer_explicit_font_angle Og_precedence.Ck_record_field ppf e;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_font_size =";
    printer_explicit_font_size Og_precedence.Ck_record_field ppf e0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_font_weight =";
    printer_explicit_font_weight Og_precedence.Ck_record_field ppf e1;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let printer_explicit_mask_parameter_rank ctx ppf = function
  | n -> printer_natural ctx ppf n
;;

let printer_explicit_mask_parameter_value ctx ppf = function
  | Mdl_basics_explicit_ast.Explicit_mask_parameter_quote m ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_basics_explicit_ast.Explicit_mask_parameter_quote";
    printer_mdl_text Og_precedence.Ck_argument ppf m;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_basics_explicit_ast.Explicit_mask_parameter_eval m ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_basics_explicit_ast.Explicit_mask_parameter_eval";
    printer_mdl_text Og_precedence.Ck_argument ppf m;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let rec printer_explicit_mask_parameter ctx ppf = function
  | {
      Mdl_basics_explicit_ast.explicit_mask_parameter_ident = e;
      Mdl_basics_explicit_ast.explicit_mask_parameter_rank = e0;
      Mdl_basics_explicit_ast.explicit_mask_parameter_style = e1;
      Mdl_basics_explicit_ast.explicit_mask_parameter_prompt = e2;
      Mdl_basics_explicit_ast.explicit_mask_parameter_value = e3;
      Mdl_basics_explicit_ast.explicit_mask_parameter_evaluation = e4;
      Mdl_basics_explicit_ast.explicit_mask_parameter_enable = e_o;
      Mdl_basics_explicit_ast.explicit_mask_parameter_visible = e_o0;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_basics_explicit_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>explicit_mask_parameter_ident =";
    printer_explicit_mask_parameter_ident Og_precedence.Ck_record_field ppf e;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_mask_parameter_rank =";
    printer_explicit_mask_parameter_rank Og_precedence.Ck_record_field ppf e0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_mask_parameter_style =";
    printer_explicit_mask_parameter_style
      Og_precedence.Ck_record_field
      ppf
      e1;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_mask_parameter_prompt =";
    printer_explicit_mask_parameter_prompt
      Og_precedence.Ck_record_field
      ppf
      e2;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_mask_parameter_value =";
    printer_explicit_mask_parameter_value
      Og_precedence.Ck_record_field
      ppf
      e3;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_mask_parameter_evaluation =";
    printer_explicit_mask_parameter_evaluation
      Og_precedence.Ck_record_field
      ppf
      e4;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_mask_parameter_enable =";
    Og_printer.printer_Option printer_explicit_mask_parameter_enable
      Og_precedence.Ck_record_field
      ppf
      e_o;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_mask_parameter_visible =";
    Og_printer.printer_Option printer_explicit_mask_parameter_visible
      Og_precedence.Ck_record_field
      ppf
      e_o0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"

and printer_explicit_mask_parameters ctx ppf = function
  | e_l ->
    Og_printer.printer_List printer_explicit_mask_parameter ctx ppf e_l
;;

let printer_explicit_mask_type ctx ppf = function
  | m_d_o ->
    Og_printer.printer_Option
      Mdl_basics_deep_ast_print.printer_deep_mask_type
      ctx
      ppf
      m_d_o
;;

let printer_explicit_mask_description ctx ppf = function
  | m_d_o ->
    Og_printer.printer_Option
      Mdl_basics_deep_ast_print.printer_deep_mask_description
      ctx
      ppf
      m_d_o
;;

let printer_explicit_mask ctx ppf = function
  | {
      Mdl_basics_explicit_ast.explicit_mask_type = e;
      Mdl_basics_explicit_ast.explicit_mask_description = e0;
      Mdl_basics_explicit_ast.explicit_mask_initialisation = e_o;
      Mdl_basics_explicit_ast.explicit_mask_display = e_o0;
      Mdl_basics_explicit_ast.explicit_mask_parameters = e1;
      Mdl_basics_explicit_ast.explicit_mask_bindings = e2;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_basics_explicit_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>explicit_mask_type =";
    printer_explicit_mask_type Og_precedence.Ck_record_field ppf e;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_mask_description =";
    printer_explicit_mask_description Og_precedence.Ck_record_field ppf e0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_mask_initialisation =";
    Og_printer.printer_Option printer_explicit_source_code
      Og_precedence.Ck_record_field
      ppf
      e_o;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_mask_display =";
    Og_printer.printer_Option printer_explicit_source_code
      Og_precedence.Ck_record_field
      ppf
      e_o0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_mask_parameters =";
    printer_explicit_mask_parameters Og_precedence.Ck_record_field ppf e1;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_mask_bindings =";
    printer_explicit_bindings Og_precedence.Ck_record_field ppf e2;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let printer_explicit_array ctx ppf = function
  | m_d -> Mdl_deep_ast_print.printer_deep_array_description ctx ppf m_d

and printer_explicit_object ctx ppf = function
  | m_d -> Mdl_deep_ast_print.printer_deep_object_description ctx ppf m_d

and printer_explicit_vendor_bindings ctx ppf = function
  | m_v -> Mdl_deep_ast_print.printer_vendor_bindings ctx ppf m_v
;;

let printer_explicit_block_regular_type ctx ppf = function
  | m_d -> Mdl_deep_ast_print.printer_deep_block_regular_type ctx ppf m_d
;;

let printer_explicit_block_reference_type ctx ppf = function
  | m_d -> Mdl_deep_ast_print.printer_deep_block_reference_type ctx ppf m_d
;;

let printer_explicit_block_type ctx ppf = function
  | Mdl_basics_explicit_ast.Explicit_block_regular_type e ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_basics_explicit_ast.Explicit_block_regular_type";
    printer_explicit_block_regular_type Og_precedence.Ck_argument ppf e;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_basics_explicit_ast.Explicit_block_reference_type e ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_basics_explicit_ast.Explicit_block_reference_type";
    printer_explicit_block_reference_type Og_precedence.Ck_argument ppf e;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let printer_explicit_sf_block_type ctx ppf = function
  | m_d -> Mdl_deep_ast_print.printer_deep_sf_block_type ctx ppf m_d
;;

let printer_explicit_model_version ctx ppf = function
  | m_d -> Mdl_deep_ast_print.printer_deep_model_version ctx ppf m_d

and printer_explicit_model_workspace_data ctx ppf = function
  | m_d -> Mdl_deep_ast_print.printer_deep_model_workspace_data ctx ppf m_d

and printer_explicit_active_configuration ctx ppf = function
  | m_d -> Mdl_deep_ast_print.printer_deep_model_configuration ctx ppf m_d
;;

let printer_explicit_model_body_kind _ctx ppf = function
  | Mdl_basics_explicit_ast.Explicit_model ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_basics_explicit_ast.Explicit_model"
  | Mdl_basics_explicit_ast.Explicit_library ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_basics_explicit_ast.Explicit_library"
;;

(* Defining top printers. *)

let print_natural ppf = printer_natural Og_precedence.Ck_toplevel ppf

and print_mdl_text ppf = printer_mdl_text Og_precedence.Ck_toplevel ppf

and print_mdl_font_name ppf =
  printer_mdl_font_name Og_precedence.Ck_toplevel ppf
;;

let print_explicit_value ppf =
  printer_explicit_value Og_precedence.Ck_toplevel ppf

and print_explicit_binding ppf =
  printer_explicit_binding Og_precedence.Ck_toplevel ppf

and print_explicit_bindings ppf =
  printer_explicit_bindings Og_precedence.Ck_toplevel ppf

and print_explicit_points ppf =
  printer_explicit_points Og_precedence.Ck_toplevel ppf

and print_explicit_color ppf =
  printer_explicit_color Og_precedence.Ck_toplevel ppf

and print_explicit_rotation ppf =
  printer_explicit_rotation Og_precedence.Ck_toplevel ppf

and print_explicit_mirror ppf =
  printer_explicit_mirror Og_precedence.Ck_toplevel ppf

and print_explicit_number_of_regular_ports ppf =
  printer_explicit_number_of_regular_ports Og_precedence.Ck_toplevel ppf

and print_explicit_number_of_implicit_ports ppf =
  printer_explicit_number_of_implicit_ports Og_precedence.Ck_toplevel ppf

and print_explicit_position ppf =
  printer_explicit_position Og_precedence.Ck_toplevel ppf

and print_explicit_state ppf =
  printer_explicit_state Og_precedence.Ck_toplevel ppf

and print_explicit_tag ppf =
  printer_explicit_tag Og_precedence.Ck_toplevel ppf

and print_explicit_zorder ppf =
  printer_explicit_zorder Og_precedence.Ck_toplevel ppf

and print_explicit_block_name ppf =
  printer_explicit_block_name Og_precedence.Ck_toplevel ppf

and print_explicit_block_port ppf =
  printer_explicit_block_port Og_precedence.Ck_toplevel ppf

and print_explicit_port_number ppf =
  printer_explicit_port_number Og_precedence.Ck_toplevel ppf

and print_explicit_block_ports ppf =
  printer_explicit_block_ports Og_precedence.Ck_toplevel ppf

and print_explicit_ports_description ppf =
  printer_explicit_ports_description Og_precedence.Ck_toplevel ppf

and print_explicit_line_name ppf =
  printer_explicit_line_name Og_precedence.Ck_toplevel ppf

and print_explicit_placement ppf =
  printer_explicit_placement Og_precedence.Ck_toplevel ppf

and print_explicit_drop_shadow ppf =
  printer_explicit_drop_shadow Og_precedence.Ck_toplevel ppf

and print_explicit_show_name ppf =
  printer_explicit_show_name Og_precedence.Ck_toplevel ppf

and print_explicit_hide_automatic_name ppf =
  printer_explicit_hide_automatic_name Og_precedence.Ck_toplevel ppf

and print_explicit_treat_as_atomic_unit ppf =
  printer_explicit_treat_as_atomic_unit Og_precedence.Ck_toplevel ppf

and print_explicit_system_sample_time ppf =
  printer_explicit_system_sample_time Og_precedence.Ck_toplevel ppf

and print_explicit_zoom_factor ppf =
  printer_explicit_zoom_factor Og_precedence.Ck_toplevel ppf

and print_explicit_sid ppf =
  printer_explicit_sid Og_precedence.Ck_toplevel ppf

and print_explicit_font_and_colors ppf =
  printer_explicit_font_and_colors Og_precedence.Ck_toplevel ppf

and print_explicit_font_size ppf =
  printer_explicit_font_size Og_precedence.Ck_toplevel ppf

and print_explicit_font_angle ppf =
  printer_explicit_font_angle Og_precedence.Ck_toplevel ppf

and print_explicit_font_weight ppf =
  printer_explicit_font_weight Og_precedence.Ck_toplevel ppf

and print_explicit_annotation_position ppf =
  printer_explicit_annotation_position Og_precedence.Ck_toplevel ppf

and print_explicit_annotation_graphical_defaults ppf =
  printer_explicit_annotation_graphical_defaults
    Og_precedence.Ck_toplevel
    ppf

and print_explicit_annotation_graphical_default ppf =
  printer_explicit_annotation_graphical_default Og_precedence.Ck_toplevel ppf

and print_explicit_branches ppf =
  printer_explicit_branches Og_precedence.Ck_toplevel ppf

and print_explicit_branch ppf =
  printer_explicit_branch Og_precedence.Ck_toplevel ppf
;;

let print_explicit_mask_parameter_ident ppf =
  printer_explicit_mask_parameter_ident Og_precedence.Ck_toplevel ppf

and print_explicit_mask_parameter_style ppf =
  printer_explicit_mask_parameter_style Og_precedence.Ck_toplevel ppf

and print_explicit_mask_parameter_prompt ppf =
  printer_explicit_mask_parameter_prompt Og_precedence.Ck_toplevel ppf

and print_explicit_mask_parameter_evaluation ppf =
  printer_explicit_mask_parameter_evaluation Og_precedence.Ck_toplevel ppf

and print_explicit_mask_parameter_enable ppf =
  printer_explicit_mask_parameter_enable Og_precedence.Ck_toplevel ppf

and print_explicit_mask_parameter_visible ppf =
  printer_explicit_mask_parameter_visible Og_precedence.Ck_toplevel ppf

and print_explicit_source_code ppf =
  printer_explicit_source_code Og_precedence.Ck_toplevel ppf

and print_explicit_stateflow_name ppf =
  printer_explicit_stateflow_name Og_precedence.Ck_toplevel ppf

and print_explicit_stateflow_chart_file_number ppf =
  printer_explicit_stateflow_chart_file_number Og_precedence.Ck_toplevel ppf
;;

let print_explicit_font ppf =
  printer_explicit_font Og_precedence.Ck_toplevel ppf
;;

let print_explicit_mask_parameter_rank ppf =
  printer_explicit_mask_parameter_rank Og_precedence.Ck_toplevel ppf
;;

let print_explicit_mask_parameter_value ppf =
  printer_explicit_mask_parameter_value Og_precedence.Ck_toplevel ppf
;;

let print_explicit_mask_parameter ppf =
  printer_explicit_mask_parameter Og_precedence.Ck_toplevel ppf

and print_explicit_mask_parameters ppf =
  printer_explicit_mask_parameters Og_precedence.Ck_toplevel ppf
;;

let print_explicit_mask_type ppf =
  printer_explicit_mask_type Og_precedence.Ck_toplevel ppf
;;

let print_explicit_mask_description ppf =
  printer_explicit_mask_description Og_precedence.Ck_toplevel ppf
;;

let print_explicit_mask ppf =
  printer_explicit_mask Og_precedence.Ck_toplevel ppf
;;

let print_explicit_array ppf =
  printer_explicit_array Og_precedence.Ck_toplevel ppf

and print_explicit_object ppf =
  printer_explicit_object Og_precedence.Ck_toplevel ppf

and print_explicit_vendor_bindings ppf =
  printer_explicit_vendor_bindings Og_precedence.Ck_toplevel ppf
;;

let print_explicit_block_regular_type ppf =
  printer_explicit_block_regular_type Og_precedence.Ck_toplevel ppf
;;

let print_explicit_block_reference_type ppf =
  printer_explicit_block_reference_type Og_precedence.Ck_toplevel ppf
;;

let print_explicit_block_type ppf =
  printer_explicit_block_type Og_precedence.Ck_toplevel ppf
;;

let print_explicit_sf_block_type ppf =
  printer_explicit_sf_block_type Og_precedence.Ck_toplevel ppf
;;

let print_explicit_model_version ppf =
  printer_explicit_model_version Og_precedence.Ck_toplevel ppf

and print_explicit_model_workspace_data ppf =
  printer_explicit_model_workspace_data Og_precedence.Ck_toplevel ppf

and print_explicit_active_configuration ppf =
  printer_explicit_active_configuration Og_precedence.Ck_toplevel ppf
;;

let print_explicit_model_body_kind ppf =
  printer_explicit_model_body_kind Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.5+dev0 generated code. *)
