(***********************************************************************)
(*                                                                     *)
(*                               Simport                               *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2010-2019,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.5+dev0 generated code. *)

let printer_explicit_simulink_file pp_line ctx ppf = function
  | Mdl_explicit_ast.Explicit_model l_m_e ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_explicit_ast.Explicit_model";
    Mdl_implementation_explicit_ast_print.printer_explicit_model pp_line
      Og_precedence.Ck_argument
      ppf
      l_m_e;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_explicit_ast.Explicit_library l_m_e ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_explicit_ast.Explicit_library";
    Mdl_implementation_explicit_ast_print.printer_explicit_model pp_line
      Og_precedence.Ck_argument
      ppf
      l_m_e;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_explicit_ast.Explicit_interface m_e ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_explicit_ast.Explicit_interface";
    Mdl_interface_explicit_ast_print.printer_explicit_interface
      Og_precedence.Ck_argument
      ppf
      m_e;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let printer_explicit_line_simulink_file ctx ppf = function
  | m_e_e ->
    printer_explicit_simulink_file
      Mdl_implementation_explicit_ast_print.printer_explicit_line
      ctx
      ppf
      m_e_e
;;

(* Defining top printers. *)

let print_explicit_simulink_file pp_line ppf =
  printer_explicit_simulink_file pp_line Og_precedence.Ck_toplevel ppf
;;

let print_explicit_line_simulink_file ppf =
  printer_explicit_line_simulink_file Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.5+dev0 generated code. *)
