(***********************************************************************)
(*                                                                     *)
(*                               Simport                               *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2010-2019,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.5+dev0 generated code. *)

open Mdl_ast_print;;

open Mdl_basics_explicit_ast_print;;

let printer_explicit_block_name ctx ppf = function
  | m_e ->
    Mdl_basics_explicit_ast_print.printer_explicit_block_name ctx ppf m_e

and printer_explicit_model_version ctx ppf = function
  | m_e ->
    Mdl_basics_explicit_ast_print.printer_explicit_model_version ctx ppf m_e

and printer_explicit_matlab_function_script ctx ppf = function
  | m_e ->
    Mdl_basics_explicit_ast_print.printer_explicit_source_code ctx ppf m_e
;;

let printer_explicit_block_graphical ctx ppf = function
  | {
      Mdl_implementation_explicit_ast.explicit_block_background_color = m_e;
      Mdl_implementation_explicit_ast.explicit_block_foreground_color = e;
      Mdl_implementation_explicit_ast.explicit_block_mirror = m_e0;
      Mdl_implementation_explicit_ast.explicit_block_ports = m_e1;
      Mdl_implementation_explicit_ast.explicit_block_ports_description = m_e2;
      Mdl_implementation_explicit_ast.explicit_block_position = m_e3;
      Mdl_implementation_explicit_ast.explicit_block_rotation = m_e4;
      Mdl_implementation_explicit_ast.explicit_block_show_name = m_e5;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_implementation_explicit_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>explicit_block_background_color =";
    Mdl_basics_explicit_ast_print.printer_explicit_color
      Og_precedence.Ck_record_field
      ppf
      m_e;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_block_foreground_color =";
    printer_explicit_color Og_precedence.Ck_record_field ppf e;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_block_mirror =";
    Mdl_basics_explicit_ast_print.printer_explicit_mirror
      Og_precedence.Ck_record_field
      ppf
      m_e0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_block_ports =";
    Mdl_basics_explicit_ast_print.printer_explicit_block_ports
      Og_precedence.Ck_record_field
      ppf
      m_e1;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_block_ports_description =";
    Mdl_basics_explicit_ast_print.printer_explicit_ports_description
      Og_precedence.Ck_record_field
      ppf
      m_e2;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_block_position =";
    Mdl_basics_explicit_ast_print.printer_explicit_position
      Og_precedence.Ck_record_field
      ppf
      m_e3;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_block_rotation =";
    Mdl_basics_explicit_ast_print.printer_explicit_rotation
      Og_precedence.Ck_record_field
      ppf
      m_e4;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_block_show_name =";
    Mdl_basics_explicit_ast_print.printer_explicit_show_name
      Og_precedence.Ck_record_field
      ppf
      m_e5;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let printer_explicit_block_optional_graphical ctx ppf = function
  | {
      Mdl_implementation_explicit_ast.explicit_block_drop_shadow = e_o;
      Mdl_implementation_explicit_ast.explicit_block_font = e;
      Mdl_implementation_explicit_ast.explicit_block_name_placement = e_o0;
      Mdl_implementation_explicit_ast.explicit_block_hide_automatic_name =
        e_o1;
      Mdl_implementation_explicit_ast.explicit_block_state = e_o2;
      Mdl_implementation_explicit_ast.explicit_block_tag = e_o3;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_implementation_explicit_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>explicit_block_drop_shadow =";
    Og_printer.printer_Option printer_explicit_drop_shadow
      Og_precedence.Ck_record_field
      ppf
      e_o;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_block_font =";
    printer_explicit_font Og_precedence.Ck_record_field ppf e;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_block_name_placement =";
    Og_printer.printer_Option printer_explicit_placement
      Og_precedence.Ck_record_field
      ppf
      e_o0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_block_hide_automatic_name =";
    Og_printer.printer_Option printer_explicit_hide_automatic_name
      Og_precedence.Ck_record_field
      ppf
      e_o1;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_block_state =";
    Og_printer.printer_Option printer_explicit_state
      Og_precedence.Ck_record_field
      ppf
      e_o2;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_block_tag =";
    Og_printer.printer_Option printer_explicit_tag
      Og_precedence.Ck_record_field
      ppf
      e_o3;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let printer_explicit_binding_table ctx ppf = function
  | e_b_i ->
    Binding_print.printer_ident_binding_table printer_explicit_value
      ctx
      ppf
      e_b_i
;;

let printer_explicit_block_parameters ctx ppf = function
  | e -> printer_explicit_binding_table ctx ppf e
;;

let printer_explicit_block_all_bindings ctx ppf = function
  | {
      Mdl_implementation_explicit_ast.explicit_block_parameters = e;
      Mdl_implementation_explicit_ast.explicit_block_bindings = e0;
      Mdl_implementation_explicit_ast.explicit_block_graphical = e1;
      Mdl_implementation_explicit_ast.explicit_block_optional_graphical = e2;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_implementation_explicit_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>explicit_block_parameters =";
    printer_explicit_block_parameters Og_precedence.Ck_record_field ppf e;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_block_bindings =";
    printer_explicit_binding_table Og_precedence.Ck_record_field ppf e0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_block_graphical =";
    printer_explicit_block_graphical Og_precedence.Ck_record_field ppf e1;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_block_optional_graphical =";
    printer_explicit_block_optional_graphical
      Og_precedence.Ck_record_field
      ppf
      e2;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let rec printer_explicit_annotation ctx ppf = function
  | {
      Mdl_implementation_explicit_ast.explicit_annotation_name = a_m;
      Mdl_implementation_explicit_ast.explicit_annotation_position = e;
      Mdl_implementation_explicit_ast.explicit_annotation_font = e0;
      Mdl_implementation_explicit_ast.explicit_annotation_graphical = e1;
      Mdl_implementation_explicit_ast.explicit_annotation_graphical_defaults =
        e2;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_implementation_explicit_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>explicit_annotation_name =";
    Ast_types_print.printer_mdl_text Og_precedence.Ck_record_field ppf a_m;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_annotation_position =";
    printer_explicit_annotation_position Og_precedence.Ck_record_field ppf e;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_annotation_font =";
    printer_explicit_font Og_precedence.Ck_record_field ppf e0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_annotation_graphical =";
    printer_explicit_font_and_colors Og_precedence.Ck_record_field ppf e1;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_annotation_graphical_defaults =";
    printer_explicit_annotation_graphical_defaults
      Og_precedence.Ck_record_field
      ppf
      e2;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"

and printer_explicit_annotations ctx ppf = function
  | e_l -> Og_printer.printer_List printer_explicit_annotation ctx ppf e_l
;;

let rec printer_explicit_simple_block_activation ctx ppf = function
  | Mdl_implementation_explicit_ast.Simple_block_plain ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_implementation_explicit_ast.Simple_block_plain"
  | Mdl_implementation_explicit_ast.Simple_block_activated s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_implementation_explicit_ast.Simple_block_activated";
    printer_simple_block_activation Og_precedence.Ck_argument ppf s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_simple_block_activation _ctx ppf = function
  | Mdl_implementation_explicit_ast.Simple_block_enabled ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,Mdl_implementation_explicit_ast.Simple_block_enabled"
  | Mdl_implementation_explicit_ast.Simple_block_if_action ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,Mdl_implementation_explicit_ast.Simple_block_if_action"
  | Mdl_implementation_explicit_ast.Simple_block_triggered ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,Mdl_implementation_explicit_ast.Simple_block_triggered"
  | Mdl_implementation_explicit_ast.Simple_block_triggered_and_enabled ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,Mdl_implementation_explicit_ast.Simple_block_triggered_and_enabled"
;;

let printer_explicit_simple_block_desc pp_ty ctx ppf = function
  | {
      Mdl_implementation_explicit_ast.explicit_simple_block_type = t;
      Mdl_implementation_explicit_ast.explicit_simple_block_activation = e;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_implementation_explicit_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>explicit_simple_block_type =";
    pp_ty Og_precedence.Ck_record_field ppf t; Format.fprintf ppf "%,;@]";
    Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_simple_block_activation =";
    printer_explicit_simple_block_activation
      Og_precedence.Ck_record_field
      ppf
      e;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let printer_explicit_action_type _ctx ppf = function
  | Mdl_implementation_explicit_ast.Action_case ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_implementation_explicit_ast.Action_case"
  | Mdl_implementation_explicit_ast.Action_default ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_implementation_explicit_ast.Action_default"
  | Mdl_implementation_explicit_ast.Action_else ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_implementation_explicit_ast.Action_else"
  | Mdl_implementation_explicit_ast.Action_elseif ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_implementation_explicit_ast.Action_elseif"
  | Mdl_implementation_explicit_ast.Action_then ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_implementation_explicit_ast.Action_then"
  | Mdl_implementation_explicit_ast.Action_unset ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_implementation_explicit_ast.Action_unset"

and printer_explicit_trigger_type _ctx ppf = function
  | Mdl_implementation_explicit_ast.Trigger_either ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_implementation_explicit_ast.Trigger_either"
  | Mdl_implementation_explicit_ast.Trigger_falling ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_implementation_explicit_ast.Trigger_falling"
  | Mdl_implementation_explicit_ast.Trigger_function_call ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,Mdl_implementation_explicit_ast.Trigger_function_call"
  | Mdl_implementation_explicit_ast.Trigger_rising ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_implementation_explicit_ast.Trigger_rising"
  | Mdl_implementation_explicit_ast.Trigger_rising_edge ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,Mdl_implementation_explicit_ast.Trigger_rising_edge"
  | Mdl_implementation_explicit_ast.Trigger_unset ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_implementation_explicit_ast.Trigger_unset"
;;

let printer_explicit_matlab_function_data_desc ctx ppf = function
  | {
      Mdl_implementation_explicit_ast.explicit_matlab_function_data_name =
        a_m;
      Mdl_implementation_explicit_ast.explicit_matlab_function_data_size =
        a_m0;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_implementation_explicit_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>explicit_matlab_function_data_name =";
    Ast_types_print.printer_mdl_name Og_precedence.Ck_record_field ppf a_m;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_matlab_function_data_size =";
    Ast_types_print.printer_mdl_text Og_precedence.Ck_record_field ppf a_m0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let printer_explicit_matlab_function_parameter_data_desc ctx ppf = function
  | {
      Mdl_implementation_explicit_ast.explicit_matlab_function_parameter_data_name =
        a_m;
      Mdl_implementation_explicit_ast.explicit_matlab_function_parameter_data_size =
        a_m0;
      Mdl_implementation_explicit_ast.explicit_matlab_function_parameter_data_index =
        u_t;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_implementation_explicit_ast.@,";
    Format.fprintf ppf
      "%,@[<hv 2>explicit_matlab_function_parameter_data_name =";
    Ast_types_print.printer_mdl_name Og_precedence.Ck_record_field ppf a_m;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>explicit_matlab_function_parameter_data_size =";
    Ast_types_print.printer_mdl_text Og_precedence.Ck_record_field ppf a_m0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>explicit_matlab_function_parameter_data_index =";
    Unatural_print.printer_t Og_precedence.Ck_record_field ppf u_t;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let rec printer_explicit_matlab_function_arguments ctx ppf = function
  | e_a ->
    Og_printer.printer_Array printer_explicit_matlab_function_argument
      ctx
      ppf
      e_a

and printer_explicit_matlab_function_argument ctx ppf = function
  | Mdl_implementation_explicit_ast.Explicit_matlab_function_input e ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_implementation_explicit_ast.Explicit_matlab_function_input";
    printer_explicit_matlab_function_data_desc
      Og_precedence.Ck_argument
      ppf
      e;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_implementation_explicit_ast.Explicit_matlab_function_parameter e ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_implementation_explicit_ast.Explicit_matlab_function_parameter";
    printer_explicit_matlab_function_parameter_data_desc
      Og_precedence.Ck_argument
      ppf
      e;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let rec printer_explicit_matlab_function_returns ctx ppf = function
  | e_a ->
    Og_printer.printer_Array printer_explicit_matlab_function_return
      ctx
      ppf
      e_a

and printer_explicit_matlab_function_return ctx ppf = function
  | Mdl_implementation_explicit_ast.Explicit_matlab_function_output e ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_implementation_explicit_ast.Explicit_matlab_function_output";
    printer_explicit_matlab_function_data_desc
      Og_precedence.Ck_argument
      ppf
      e;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let rec printer_explicit_s_function_type ctx ppf = function
  | Mdl_implementation_explicit_ast.Explicit_s_function ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,Mdl_implementation_explicit_ast.Explicit_s_function"
  | Mdl_implementation_explicit_ast.Explicit_s_function_stateflow (e, e0) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_implementation_explicit_ast.Explicit_s_function_stateflow";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_explicit_stateflow_name Og_precedence.Ck_tuple_item ppf e;
    Format.fprintf ppf "%,,@ ";
    printer_explicit_stateflow_chart_file_number
      Og_precedence.Ck_tuple_item
      ppf
      e0;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_implementation_explicit_ast.Explicit_matlab_function e ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_implementation_explicit_ast.Explicit_matlab_function";
    printer_explicit_matlab_function_desc Og_precedence.Ck_argument ppf e;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_explicit_matlab_function_desc ctx ppf = function
  | {
      Mdl_implementation_explicit_ast.explicit_matlab_function_name = a_m;
      Mdl_implementation_explicit_ast.explicit_matlab_function_script = e;
      Mdl_implementation_explicit_ast.explicit_matlab_function_arguments = e0;
      Mdl_implementation_explicit_ast.explicit_matlab_function_returns = e1;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_implementation_explicit_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>explicit_matlab_function_name =";
    Ast_types_print.printer_mdl_name Og_precedence.Ck_record_field ppf a_m;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_matlab_function_script =";
    printer_explicit_matlab_function_script
      Og_precedence.Ck_record_field
      ppf
      e;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_matlab_function_arguments =";
    printer_explicit_matlab_function_arguments
      Og_precedence.Ck_record_field
      ppf
      e0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_matlab_function_returns =";
    printer_explicit_matlab_function_returns
      Og_precedence.Ck_record_field
      ppf
      e1;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let rec printer_explicit_block pp_line ctx ppf = function
  | {
      Mdl_implementation_explicit_ast.explicit_block_name = e;
      Mdl_implementation_explicit_ast.explicit_block_sid = e0;
      Mdl_implementation_explicit_ast.explicit_block_body = e1;
      Mdl_implementation_explicit_ast.explicit_block_known = b;
      Mdl_implementation_explicit_ast.explicit_block_desc = l_e;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_implementation_explicit_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>explicit_block_name =";
    printer_explicit_block_name Og_precedence.Ck_record_field ppf e;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_block_sid =";
    printer_explicit_block_sid Og_precedence.Ck_record_field ppf e0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_block_body =";
    printer_explicit_block_body Og_precedence.Ck_record_field ppf e1;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_block_known =";
    Og_printer.printer_Bool Og_precedence.Ck_record_field ppf b;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_block_desc =";
    printer_explicit_block_desc pp_line Og_precedence.Ck_record_field ppf l_e;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"

and printer_explicit_block_sid ctx ppf = function
  | e_o -> Og_printer.printer_Option printer_explicit_sid ctx ppf e_o

and printer_explicit_block_desc pp_line ctx ppf = function
  | Mdl_implementation_explicit_ast.Explicit_block_regular e_e ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_implementation_explicit_ast.Explicit_block_regular";
    printer_explicit_simple_block_desc printer_explicit_block_regular_type
      Og_precedence.Ck_argument
      ppf
      e_e;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_implementation_explicit_ast.Explicit_block_reference e_e ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_implementation_explicit_ast.Explicit_block_reference";
    printer_explicit_simple_block_desc printer_explicit_block_reference_type
      Og_precedence.Ck_argument
      ppf
      e_e;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_implementation_explicit_ast.Explicit_block_sub_system l_e ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_implementation_explicit_ast.Explicit_block_sub_system";
    printer_explicit_block_sub_system_desc pp_line
      Og_precedence.Ck_argument
      ppf
      l_e;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_implementation_explicit_ast.Explicit_block_s_function e_e ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_implementation_explicit_ast.Explicit_block_s_function";
    printer_explicit_simple_block_desc printer_explicit_s_function_type
      Og_precedence.Ck_argument
      ppf
      e_e;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_explicit_block_sub_system_desc pp_line ctx ppf = function
  | {
      Mdl_implementation_explicit_ast.explicit_block_sub_system_activation =
        l_e;
      Mdl_implementation_explicit_ast.explicit_block_sub_system_body = l_e0;
      Mdl_implementation_explicit_ast.explicit_block_sub_system_treat_as_atomic_unit =
        m_e;
      Mdl_implementation_explicit_ast.explicit_block_sub_system_sample_time =
        m_e0;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_implementation_explicit_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>explicit_block_sub_system_activation =";
    printer_explicit_sub_system_activation pp_line
      Og_precedence.Ck_record_field
      ppf
      l_e;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_block_sub_system_body =";
    printer_explicit_system pp_line Og_precedence.Ck_record_field ppf l_e0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>explicit_block_sub_system_treat_as_atomic_unit =";
    Mdl_basics_explicit_ast_print.printer_explicit_treat_as_atomic_unit
      Og_precedence.Ck_record_field
      ppf
      m_e;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_block_sub_system_sample_time =";
    Mdl_basics_explicit_ast_print.printer_explicit_system_sample_time
      Og_precedence.Ck_record_field
      ppf
      m_e0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"

and printer_explicit_sub_system_activation pp_line ctx ppf = function
  | Mdl_implementation_explicit_ast.Sub_system_plain ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_implementation_explicit_ast.Sub_system_plain"
  | Mdl_implementation_explicit_ast.Sub_system_activated l_s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_implementation_explicit_ast.Sub_system_activated";
    printer_sub_system_activation pp_line Og_precedence.Ck_argument ppf l_s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_sub_system_activation pp_line ctx ppf = function
  | Mdl_implementation_explicit_ast.Sub_system_plain_atomic_unit m_d ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_implementation_explicit_ast.Sub_system_plain_atomic_unit";
    Mdl_deep_ast_print.printer_deep_value Og_precedence.Ck_argument ppf m_d;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_implementation_explicit_ast.Sub_system_enabled l_e ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_implementation_explicit_ast.Sub_system_enabled";
    printer_explicit_block pp_line Og_precedence.Ck_argument ppf l_e;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_implementation_explicit_ast.Sub_system_if_action (e, l_e) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_implementation_explicit_ast.Sub_system_if_action";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_explicit_action_type Og_precedence.Ck_tuple_item ppf e;
    Format.fprintf ppf "%,,@ ";
    printer_explicit_block pp_line Og_precedence.Ck_tuple_item ppf l_e;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_implementation_explicit_ast.Sub_system_triggered (e, l_e) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_implementation_explicit_ast.Sub_system_triggered";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_explicit_trigger_type Og_precedence.Ck_tuple_item ppf e;
    Format.fprintf ppf "%,,@ ";
    printer_explicit_block pp_line Og_precedence.Ck_tuple_item ppf l_e;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_implementation_explicit_ast.Sub_system_triggered_and_enabled ((e,
    l_e), l_e0) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_implementation_explicit_ast.Sub_system_triggered_and_enabled";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,@[<hv 2>(@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_explicit_trigger_type Og_precedence.Ck_tuple_item ppf e;
    Format.fprintf ppf "%,,@ ";
    printer_explicit_block pp_line Og_precedence.Ck_tuple_item ppf l_e;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)@]";
    Format.fprintf ppf "%,,@ ";
    printer_explicit_block pp_line Og_precedence.Ck_tuple_item ppf l_e0;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_explicit_block_body ctx ppf = function
  | {
      Mdl_implementation_explicit_ast.explicit_block_all_bindings = e;
      Mdl_implementation_explicit_ast.explicit_block_array = e_o;
      Mdl_implementation_explicit_ast.explicit_block_object = e_o0;
      Mdl_implementation_explicit_ast.explicit_block_mask = m_e_o;
      Mdl_implementation_explicit_ast.explicit_block_sf_block_type = m_e_o0;
      Mdl_implementation_explicit_ast.explicit_block_instance_data = e_o1;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_implementation_explicit_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>explicit_block_all_bindings =";
    printer_explicit_block_all_bindings Og_precedence.Ck_record_field ppf e;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_block_array =";
    Og_printer.printer_Option printer_explicit_array
      Og_precedence.Ck_record_field
      ppf
      e_o;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_block_object =";
    Og_printer.printer_Option printer_explicit_object
      Og_precedence.Ck_record_field
      ppf
      e_o0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_block_mask =";
    Og_printer.printer_Option
      Mdl_basics_explicit_ast_print.printer_explicit_mask
      Og_precedence.Ck_record_field
      ppf
      m_e_o;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_block_sf_block_type =";
    Og_printer.printer_Option
      Mdl_basics_explicit_ast_print.printer_explicit_sf_block_type
      Og_precedence.Ck_record_field
      ppf
      m_e_o0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_block_instance_data =";
    Og_printer.printer_Option printer_explicit_binding_table
      Og_precedence.Ck_record_field
      ppf
      e_o1;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"

and printer_explicit_system pp_line ctx ppf = function
  | {
      Mdl_implementation_explicit_ast.explicit_system_name = s;
      Mdl_implementation_explicit_ast.explicit_system_position = m_e;
      Mdl_implementation_explicit_ast.explicit_system_bindings = e;
      Mdl_implementation_explicit_ast.explicit_system_blocks = l_e;
      Mdl_implementation_explicit_ast.explicit_system_lines = l_l;
      Mdl_implementation_explicit_ast.explicit_system_annotations = e0;
      Mdl_implementation_explicit_ast.explicit_system_connectors = e1;
      Mdl_implementation_explicit_ast.explicit_system_zoom_factor = e2;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_implementation_explicit_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>explicit_system_name =";
    printer_system_name Og_precedence.Ck_record_field ppf s;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_system_position =";
    Mdl_basics_explicit_ast_print.printer_explicit_position
      Og_precedence.Ck_record_field
      ppf
      m_e;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_system_bindings =";
    printer_explicit_binding_table Og_precedence.Ck_record_field ppf e;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_system_blocks =";
    printer_explicit_blocks pp_line Og_precedence.Ck_record_field ppf l_e;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_system_lines =";
    Og_printer.printer_List pp_line Og_precedence.Ck_record_field ppf l_l;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_system_annotations =";
    printer_explicit_annotations Og_precedence.Ck_record_field ppf e0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_system_connectors =";
    printer_explicit_system_connectors Og_precedence.Ck_record_field ppf e1;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_system_zoom_factor =";
    printer_explicit_zoom_factor Og_precedence.Ck_record_field ppf e2;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"

and printer_explicit_blocks pp_line ctx ppf = function
  | l_e_l ->
    Og_printer.printer_List (printer_explicit_block pp_line) ctx ppf l_e_l

and printer_explicit_system_connectors ctx ppf = function
  | e_l ->
    Og_printer.printer_List printer_explicit_system_connector ctx ppf e_l

and printer_explicit_system_connector ctx ppf = function
  | e -> printer_explicit_binding_table ctx ppf e
;;

let rec printer_explicit_model pp_line ctx ppf = function
  | {
      Mdl_implementation_explicit_ast.explicit_model_body = l_e;
      Mdl_implementation_explicit_ast.explicit_model_matdatas_option = e_o;
      Mdl_implementation_explicit_ast.explicit_stateflow_option = m_e_o;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_implementation_explicit_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>explicit_model_body =";
    printer_explicit_model_body pp_line Og_precedence.Ck_record_field ppf l_e;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_model_matdatas_option =";
    Og_printer.printer_Option printer_explicit_model_matdatas
      Og_precedence.Ck_record_field
      ppf
      e_o;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_stateflow_option =";
    Og_printer.printer_Option
      Mdl_stateflow_explicit_ast_print.printer_explicit_stateflow_section
      Og_precedence.Ck_record_field
      ppf
      m_e_o;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"

and printer_explicit_model_matdata ctx ppf = function
  | Mdl_implementation_explicit_ast.Explicit_matdata_section e ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_implementation_explicit_ast.Explicit_matdata_section";
    printer_explicit_matdata_section_item Og_precedence.Ck_argument ppf e;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_explicit_matdata_section_item ctx ppf = function
  | m_d -> Mdl_deep_ast_print.printer_deep_matdata_section_item ctx ppf m_d

and printer_explicit_model_matdatas ctx ppf = function
  | e_l -> Og_printer.printer_List printer_explicit_model_matdata ctx ppf e_l

and printer_explicit_model_body pp_line ctx ppf = function
  | {
      Mdl_implementation_explicit_ast.explicit_model_ident = m;
      Mdl_implementation_explicit_ast.explicit_model_version = e;
      Mdl_implementation_explicit_ast.explicit_model_explicit_file_name = p_e;
      Mdl_implementation_explicit_ast.explicit_model_configuration = e0;
      Mdl_implementation_explicit_ast.explicit_model_workspace = e1;
      Mdl_implementation_explicit_ast.explicit_model_system = l_e;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_implementation_explicit_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>explicit_model_ident =";
    printer_model_ident Og_precedence.Ck_record_field ppf m;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_model_version =";
    printer_explicit_model_version Og_precedence.Ck_record_field ppf e;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_model_explicit_file_name =";
    Path_print.printer_explicit_file_name
      Og_precedence.Ck_record_field
      ppf
      p_e;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_model_configuration =";
    printer_explicit_model_configuration Og_precedence.Ck_record_field ppf e0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_model_workspace =";
    printer_explicit_model_workspace Og_precedence.Ck_record_field ppf e1;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_model_system =";
    printer_explicit_system pp_line Og_precedence.Ck_record_field ppf l_e;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"

and printer_explicit_model_workspace ctx ppf = function
  | m_e_l ->
    Og_printer.printer_List
      Mdl_basics_explicit_ast_print.printer_explicit_model_workspace_data
      ctx
      ppf
      m_e_l

and printer_explicit_model_configuration ctx ppf = function
  | {
      Mdl_implementation_explicit_ast.explicit_graphical_parameters = g_l;
      Mdl_implementation_explicit_ast.explicit_configuration_bindings =
        i_i_e_h_t;
      Mdl_implementation_explicit_ast.explicit_vendor_bindings = e;
      Mdl_implementation_explicit_ast.explicit_active_configuration = e_o;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_implementation_explicit_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>explicit_graphical_parameters =";
    Og_printer.printer_List printer_graphical_interface_item
      Og_precedence.Ck_record_field
      ppf
      g_l;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_configuration_bindings =";
    Hash_table_print.printer_t
      Ident_print.printer_ident
      printer_explicit_value
      Og_precedence.Ck_record_field
      ppf
      i_i_e_h_t;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_vendor_bindings =";
    printer_explicit_vendor_bindings Og_precedence.Ck_record_field ppf e;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_active_configuration =";
    Og_printer.printer_Option printer_explicit_active_configuration
      Og_precedence.Ck_record_field
      ppf
      e_o;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let printer_explicit_connector_port pp_port_type ctx ppf = function
  | {
      Mdl_implementation_explicit_ast.explicit_connector_port_block = b;
      Mdl_implementation_explicit_ast.explicit_connector_port_desc = p;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_implementation_explicit_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>explicit_connector_port_block =";
    printer_block_name Og_precedence.Ck_record_field ppf b;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_connector_port_desc =";
    pp_port_type Og_precedence.Ck_record_field ppf p;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let printer_explicit_directed_connector_port ctx ppf = function
  | m_p_e ->
    printer_explicit_connector_port Mdl_ast_print.printer_port_value
      ctx
      ppf
      m_p_e
;;

let rec printer_explicit_connection_connector_port ctx ppf = function
  | e_e ->
    printer_explicit_connector_port
      printer_explicit_connection_connector_desc
      ctx
      ppf
      e_e

and printer_explicit_connection_connector_desc ctx ppf = function
  | Mdl_implementation_explicit_ast.Explicit_left_connector c ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_implementation_explicit_ast.Explicit_left_connector";
    printer_connection_port_value Og_precedence.Ck_argument ppf c;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_implementation_explicit_ast.Explicit_right_connector c ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_implementation_explicit_ast.Explicit_right_connector";
    printer_connection_port_value Og_precedence.Ck_argument ppf c;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_connection_port_value ctx ppf = function
  | Mdl_implementation_explicit_ast.Connection_port_value a_m ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_implementation_explicit_ast.Connection_port_value";
    Ast_types_print.printer_mdl_port_number Og_precedence.Ck_argument ppf a_m;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let printer_explicit_relative_points ctx ppf = function
  | e -> printer_explicit_points ctx ppf e
;;

let printer_explicit_absolute_point ctx ppf = function
  | {
      Mdl_implementation_explicit_ast.explicit_x = i;
      Mdl_implementation_explicit_ast.explicit_y = i0;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_implementation_explicit_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>explicit_x =";
    Og_printer.printer_Int Og_precedence.Ck_record_field ppf i;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_y =";
    Og_printer.printer_Int Og_precedence.Ck_record_field ppf i0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let printer_explicit_directed_points ctx ppf = function
  | e -> printer_explicit_relative_points ctx ppf e

and printer_explicit_connection_points ctx ppf = function
  | Mdl_implementation_explicit_ast.Explicit_relative_points e ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_implementation_explicit_ast.Explicit_relative_points";
    printer_explicit_relative_points Og_precedence.Ck_argument ppf e;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_implementation_explicit_ast.Explicit_absolute_points (e, e0) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_implementation_explicit_ast.Explicit_absolute_points";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_explicit_absolute_point Og_precedence.Ck_tuple_item ppf e;
    Format.fprintf ppf "%,,@ ";
    printer_explicit_relative_points Og_precedence.Ck_tuple_item ppf e0;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let rec printer_explicit_connection_connector ctx ppf = function
  | Mdl_implementation_explicit_ast.Explicit_connection_connector_port e ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_implementation_explicit_ast.Explicit_connection_connector_port";
    printer_explicit_connection_connector_port
      Og_precedence.Ck_argument
      ppf
      e;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_implementation_explicit_ast.Explicit_connection_connector_branches e ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_implementation_explicit_ast.Explicit_connection_connector_branches";
    printer_explicit_connection_branches Og_precedence.Ck_argument ppf e;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_explicit_connection_branches ctx ppf = function
  | e_l ->
    Og_printer.printer_List printer_explicit_connection_branch ctx ppf e_l

and printer_explicit_connection_branch ctx ppf = function
  | {
      Mdl_implementation_explicit_ast.explicit_connection_branch_points = e_o;
      Mdl_implementation_explicit_ast.explicit_connection_branch_child = e;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_implementation_explicit_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>explicit_connection_branch_points =";
    Og_printer.printer_Option printer_explicit_connection_points
      Og_precedence.Ck_record_field
      ppf
      e_o;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_connection_branch_child =";
    printer_explicit_connection_branch_child
      Og_precedence.Ck_record_field
      ppf
      e;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"

and printer_explicit_connection_branch_child ctx ppf = function
  | Mdl_implementation_explicit_ast.Explicit_connection_branch_source e ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_implementation_explicit_ast.Explicit_connection_branch_source";
    printer_explicit_connection_connector Og_precedence.Ck_argument ppf e;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_implementation_explicit_ast.Explicit_connection_branch_target e ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_implementation_explicit_ast.Explicit_connection_branch_target";
    printer_explicit_connection_connector Og_precedence.Ck_argument ppf e;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let printer_explicit_connection_connectors ctx ppf = function
  | {
      Mdl_implementation_explicit_ast.explicit_source_connection_connector =
        e;
      Mdl_implementation_explicit_ast.explicit_target_connection_connector =
        e0;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_implementation_explicit_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>explicit_source_connection_connector =";
    printer_explicit_connection_connector Og_precedence.Ck_record_field ppf e;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_target_connection_connector =";
    printer_explicit_connection_connector
      Og_precedence.Ck_record_field
      ppf
      e0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let printer_explicit_directed_connectors ctx ppf = function
  | {
      Mdl_implementation_explicit_ast.explicit_directed_source = e;
      Mdl_implementation_explicit_ast.explicit_directed_target = e_o;
      Mdl_implementation_explicit_ast.explicit_directed_branches = m_e;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_implementation_explicit_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>explicit_directed_source =";
    printer_explicit_directed_connector_port
      Og_precedence.Ck_record_field
      ppf
      e;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_directed_target =";
    Og_printer.printer_Option printer_explicit_directed_connector_port
      Og_precedence.Ck_record_field
      ppf
      e_o;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_directed_branches =";
    Mdl_basics_explicit_ast_print.printer_explicit_branches
      Og_precedence.Ck_record_field
      ppf
      m_e;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let printer_explicit_line_body pp_connectors pp_points ctx ppf = function
  | {
      Mdl_implementation_explicit_ast.explicit_line_name = l_o;
      Mdl_implementation_explicit_ast.explicit_line_connectors = c;
      Mdl_implementation_explicit_ast.explicit_line_font = e;
      Mdl_implementation_explicit_ast.explicit_line_labels = l_o0;
      Mdl_implementation_explicit_ast.explicit_line_points = p_o;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_implementation_explicit_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>explicit_line_name =";
    Og_printer.printer_Option printer_line_name
      Og_precedence.Ck_record_field
      ppf
      l_o;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_line_connectors =";
    pp_connectors Og_precedence.Ck_record_field ppf c;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_line_font =";
    printer_explicit_font Og_precedence.Ck_record_field ppf e;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_line_labels =";
    Og_printer.printer_Option printer_labels
      Og_precedence.Ck_record_field
      ppf
      l_o0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>explicit_line_points =";
    Og_printer.printer_Option pp_points Og_precedence.Ck_record_field ppf p_o;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let rec printer_explicit_lines ctx ppf = function
  | e_l -> Og_printer.printer_List printer_explicit_line ctx ppf e_l

and printer_explicit_line ctx ppf = function
  | Mdl_implementation_explicit_ast.Explicit_line_connection e_e_e ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_implementation_explicit_ast.Explicit_line_connection";
    printer_explicit_line_body
      printer_explicit_connection_connectors
      printer_explicit_connection_points
      Og_precedence.Ck_argument
      ppf
      e_e_e;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_implementation_explicit_ast.Explicit_line_directed e_e_e ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_implementation_explicit_ast.Explicit_line_directed";
    printer_explicit_line_body
      printer_explicit_directed_connectors
      printer_explicit_directed_points
      Og_precedence.Ck_argument
      ppf
      e_e_e;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let printer_explicit_line_model ctx ppf = function
  | e_e -> printer_explicit_model printer_explicit_line ctx ppf e_e
;;

(* Defining top printers. *)

let print_explicit_block_name ppf =
  printer_explicit_block_name Og_precedence.Ck_toplevel ppf

and print_explicit_model_version ppf =
  printer_explicit_model_version Og_precedence.Ck_toplevel ppf

and print_explicit_matlab_function_script ppf =
  printer_explicit_matlab_function_script Og_precedence.Ck_toplevel ppf
;;

let print_explicit_block_graphical ppf =
  printer_explicit_block_graphical Og_precedence.Ck_toplevel ppf
;;

let print_explicit_block_optional_graphical ppf =
  printer_explicit_block_optional_graphical Og_precedence.Ck_toplevel ppf
;;

let print_explicit_binding_table ppf =
  printer_explicit_binding_table Og_precedence.Ck_toplevel ppf
;;

let print_explicit_block_parameters ppf =
  printer_explicit_block_parameters Og_precedence.Ck_toplevel ppf
;;

let print_explicit_block_all_bindings ppf =
  printer_explicit_block_all_bindings Og_precedence.Ck_toplevel ppf
;;

let print_explicit_annotation ppf =
  printer_explicit_annotation Og_precedence.Ck_toplevel ppf

and print_explicit_annotations ppf =
  printer_explicit_annotations Og_precedence.Ck_toplevel ppf
;;

let print_explicit_simple_block_activation ppf =
  printer_explicit_simple_block_activation Og_precedence.Ck_toplevel ppf

and print_simple_block_activation ppf =
  printer_simple_block_activation Og_precedence.Ck_toplevel ppf
;;

let print_explicit_simple_block_desc pp_ty ppf =
  printer_explicit_simple_block_desc pp_ty Og_precedence.Ck_toplevel ppf
;;

let print_explicit_action_type ppf =
  printer_explicit_action_type Og_precedence.Ck_toplevel ppf

and print_explicit_trigger_type ppf =
  printer_explicit_trigger_type Og_precedence.Ck_toplevel ppf
;;

let print_explicit_matlab_function_data_desc ppf =
  printer_explicit_matlab_function_data_desc Og_precedence.Ck_toplevel ppf
;;

let print_explicit_matlab_function_parameter_data_desc ppf =
  printer_explicit_matlab_function_parameter_data_desc
    Og_precedence.Ck_toplevel
    ppf
;;

let print_explicit_matlab_function_arguments ppf =
  printer_explicit_matlab_function_arguments Og_precedence.Ck_toplevel ppf

and print_explicit_matlab_function_argument ppf =
  printer_explicit_matlab_function_argument Og_precedence.Ck_toplevel ppf
;;

let print_explicit_matlab_function_returns ppf =
  printer_explicit_matlab_function_returns Og_precedence.Ck_toplevel ppf

and print_explicit_matlab_function_return ppf =
  printer_explicit_matlab_function_return Og_precedence.Ck_toplevel ppf
;;

let print_explicit_s_function_type ppf =
  printer_explicit_s_function_type Og_precedence.Ck_toplevel ppf

and print_explicit_matlab_function_desc ppf =
  printer_explicit_matlab_function_desc Og_precedence.Ck_toplevel ppf
;;

let print_explicit_block pp_line ppf =
  printer_explicit_block pp_line Og_precedence.Ck_toplevel ppf

and print_explicit_block_sid ppf =
  printer_explicit_block_sid Og_precedence.Ck_toplevel ppf

and print_explicit_block_desc pp_line ppf =
  printer_explicit_block_desc pp_line Og_precedence.Ck_toplevel ppf

and print_explicit_block_sub_system_desc pp_line ppf =
  printer_explicit_block_sub_system_desc pp_line
    Og_precedence.Ck_toplevel
    ppf

and print_explicit_sub_system_activation pp_line ppf =
  printer_explicit_sub_system_activation pp_line
    Og_precedence.Ck_toplevel
    ppf

and print_sub_system_activation pp_line ppf =
  printer_sub_system_activation pp_line Og_precedence.Ck_toplevel ppf

and print_explicit_block_body ppf =
  printer_explicit_block_body Og_precedence.Ck_toplevel ppf

and print_explicit_system pp_line ppf =
  printer_explicit_system pp_line Og_precedence.Ck_toplevel ppf

and print_explicit_blocks pp_line ppf =
  printer_explicit_blocks pp_line Og_precedence.Ck_toplevel ppf

and print_explicit_system_connectors ppf =
  printer_explicit_system_connectors Og_precedence.Ck_toplevel ppf

and print_explicit_system_connector ppf =
  printer_explicit_system_connector Og_precedence.Ck_toplevel ppf
;;

let print_explicit_model pp_line ppf =
  printer_explicit_model pp_line Og_precedence.Ck_toplevel ppf

and print_explicit_model_matdata ppf =
  printer_explicit_model_matdata Og_precedence.Ck_toplevel ppf

and print_explicit_matdata_section_item ppf =
  printer_explicit_matdata_section_item Og_precedence.Ck_toplevel ppf

and print_explicit_model_matdatas ppf =
  printer_explicit_model_matdatas Og_precedence.Ck_toplevel ppf

and print_explicit_model_body pp_line ppf =
  printer_explicit_model_body pp_line Og_precedence.Ck_toplevel ppf

and print_explicit_model_workspace ppf =
  printer_explicit_model_workspace Og_precedence.Ck_toplevel ppf

and print_explicit_model_configuration ppf =
  printer_explicit_model_configuration Og_precedence.Ck_toplevel ppf
;;

let print_explicit_connector_port pp_port_type ppf =
  printer_explicit_connector_port pp_port_type Og_precedence.Ck_toplevel ppf
;;

let print_explicit_directed_connector_port ppf =
  printer_explicit_directed_connector_port Og_precedence.Ck_toplevel ppf
;;

let print_explicit_connection_connector_port ppf =
  printer_explicit_connection_connector_port Og_precedence.Ck_toplevel ppf

and print_explicit_connection_connector_desc ppf =
  printer_explicit_connection_connector_desc Og_precedence.Ck_toplevel ppf

and print_connection_port_value ppf =
  printer_connection_port_value Og_precedence.Ck_toplevel ppf
;;

let print_explicit_relative_points ppf =
  printer_explicit_relative_points Og_precedence.Ck_toplevel ppf
;;

let print_explicit_absolute_point ppf =
  printer_explicit_absolute_point Og_precedence.Ck_toplevel ppf
;;

let print_explicit_directed_points ppf =
  printer_explicit_directed_points Og_precedence.Ck_toplevel ppf

and print_explicit_connection_points ppf =
  printer_explicit_connection_points Og_precedence.Ck_toplevel ppf
;;

let print_explicit_connection_connector ppf =
  printer_explicit_connection_connector Og_precedence.Ck_toplevel ppf

and print_explicit_connection_branches ppf =
  printer_explicit_connection_branches Og_precedence.Ck_toplevel ppf

and print_explicit_connection_branch ppf =
  printer_explicit_connection_branch Og_precedence.Ck_toplevel ppf

and print_explicit_connection_branch_child ppf =
  printer_explicit_connection_branch_child Og_precedence.Ck_toplevel ppf
;;

let print_explicit_connection_connectors ppf =
  printer_explicit_connection_connectors Og_precedence.Ck_toplevel ppf
;;

let print_explicit_directed_connectors ppf =
  printer_explicit_directed_connectors Og_precedence.Ck_toplevel ppf
;;

let print_explicit_line_body pp_connectors pp_points ppf =
  printer_explicit_line_body pp_connectors pp_points
    Og_precedence.Ck_toplevel
    ppf
;;

let print_explicit_lines ppf =
  printer_explicit_lines Og_precedence.Ck_toplevel ppf

and print_explicit_line ppf =
  printer_explicit_line Og_precedence.Ck_toplevel ppf
;;

let print_explicit_line_model ppf =
  printer_explicit_line_model Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.5+dev0 generated code. *)
