(***********************************************************************)
(*                                                                     *)
(*                               Simport                               *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2010-2019,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* $Id: mdl_implementation_to_explicit_ast.mli,v 1.1 2019-05-10 14:04:56 jpc Exp $ *)

(** From deep syntax to completely explicit inherited tree:
   - defaults sections are incorporated into values,
   - no more default sections in the resulting trees: all fields are explicit
     and checked with respect to various type constraints or range constraints.
*)

val implementation_to_explicit_line_ast :
  Mdl_interface_explicit_ast.explicit_interfaces ->
  Mdl_deep_ast.deep_implementation ->
  Mdl_explicit_ast.explicit_line_simulink_file
;;

(** {6 Access to fields of explicit blocks} *)

val get_explicit_block_graphical :
  'a Mdl_implementation_explicit_ast.explicit_block ->
  Mdl_implementation_explicit_ast.explicit_block_graphical
;;

val get_explicit_block_ports_description :
  'a Mdl_implementation_explicit_ast.explicit_block ->
  Mdl_basics_explicit_ast.explicit_ports_description
;;

(*
val read_simulink_implementation_marshaled_file : Path.file_name ->
  Mdl_explicit_ast.explicit_simulink_file
;;

val write_simulink_implementation_marshaled_file : Path.file_name ->
  Mdl_explicit_ast.explicit_simulink_file -> unit
;;
(** Reading/writing Simulink (pre)compiled implementation file. *)
*)

(*
 Local Variables:
  compile-command: "cd ../../..; make"
  End:
*)
