(***********************************************************************)
(*                                                                     *)
(*                               Simport                               *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2010-2019,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* $Id: mdl_interface_explicit_ast.mli,v 1.1 2019-05-10 14:04:56 jpc Exp $ *)

open Mdl_basics_explicit_ast;;

(** Explicit interface definitions. *)

type explicit_interface_block_desc =
  | Ebi_primitive
  | Ebi_sub_system
  | Ebi_s_function
;;

type explicit_interface_block_parameters_table =
  (Ident.ident,
   Mdl_deep_ast.deep_interface_block_parameter_type) Hash_table.t
;;

type explicit_interface_block = {
  ebi_desc : explicit_interface_block_desc;
  ebi_ports_description : explicit_ports_description;
  ebi_parameters : explicit_interface_block_parameters_table;
}
;;

type explicit_interface_block_table =
  (explicit_block_type, explicit_interface_block) Hash_table.t
;;

type explicit_interface = {
  ei_version : Simport_configuration.interface_version;
  ei_ident : Ident.ident;
  ei_source : Path.file_name;
  ei_table : explicit_interface_block_table;
}
;;

type explicit_interfaces = explicit_interface list
;;

(*
 Local Variables:
  compile-command: "cd ../../..; make"
  End:
*)
