(***********************************************************************)
(*                                                                     *)
(*                               Simport                               *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2010-2019,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.5+dev0 generated code. *)

open Mdl_basics_explicit_ast_print;;

let printer_explicit_interface_block_desc _ctx ppf = function
  | Mdl_interface_explicit_ast.Ebi_primitive ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_interface_explicit_ast.Ebi_primitive"
  | Mdl_interface_explicit_ast.Ebi_sub_system ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_interface_explicit_ast.Ebi_sub_system"
  | Mdl_interface_explicit_ast.Ebi_s_function ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Mdl_interface_explicit_ast.Ebi_s_function"
;;

let printer_explicit_interface_block_parameters_table ctx ppf = function
  | i_i_m_d_h_t ->
    Hash_table_print.printer_t
      Ident_print.printer_ident
      Mdl_deep_ast_print.printer_deep_interface_block_parameter_type
      ctx
      ppf
      i_i_m_d_h_t
;;

let printer_explicit_interface_block ctx ppf = function
  | {
      Mdl_interface_explicit_ast.ebi_desc = e;
      Mdl_interface_explicit_ast.ebi_ports_description = e0;
      Mdl_interface_explicit_ast.ebi_parameters = e1;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_interface_explicit_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>ebi_desc =";
    printer_explicit_interface_block_desc Og_precedence.Ck_record_field ppf e;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>ebi_ports_description =";
    printer_explicit_ports_description Og_precedence.Ck_record_field ppf e0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>ebi_parameters =";
    printer_explicit_interface_block_parameters_table
      Og_precedence.Ck_record_field
      ppf
      e1;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let printer_explicit_interface_block_table ctx ppf = function
  | e_e_h_t ->
    Hash_table_print.printer_t
      printer_explicit_block_type
      printer_explicit_interface_block
      ctx
      ppf
      e_e_h_t
;;

let printer_explicit_interface ctx ppf = function
  | {
      Mdl_interface_explicit_ast.ei_version = s_i;
      Mdl_interface_explicit_ast.ei_ident = i_i;
      Mdl_interface_explicit_ast.ei_source = p_f;
      Mdl_interface_explicit_ast.ei_table = e;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_interface_explicit_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>ei_version =";
    Simport_configuration_print.printer_interface_version
      Og_precedence.Ck_record_field
      ppf
      s_i;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>ei_ident =";
    Ident_print.printer_ident Og_precedence.Ck_record_field ppf i_i;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>ei_source =";
    Path_print.printer_file_name Og_precedence.Ck_record_field ppf p_f;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>ei_table =";
    printer_explicit_interface_block_table
      Og_precedence.Ck_record_field
      ppf
      e;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let printer_explicit_interfaces ctx ppf = function
  | e_l -> Og_printer.printer_List printer_explicit_interface ctx ppf e_l
;;

(* Defining top printers. *)

let print_explicit_interface_block_desc ppf =
  printer_explicit_interface_block_desc Og_precedence.Ck_toplevel ppf
;;

let print_explicit_interface_block_parameters_table ppf =
  printer_explicit_interface_block_parameters_table
    Og_precedence.Ck_toplevel
    ppf
;;

let print_explicit_interface_block ppf =
  printer_explicit_interface_block Og_precedence.Ck_toplevel ppf
;;

let print_explicit_interface_block_table ppf =
  printer_explicit_interface_block_table Og_precedence.Ck_toplevel ppf
;;

let print_explicit_interface ppf =
  printer_explicit_interface Og_precedence.Ck_toplevel ppf
;;

let print_explicit_interfaces ppf =
  printer_explicit_interfaces Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.5+dev0 generated code. *)
