(***********************************************************************)
(*                                                                     *)
(*                               Simport                               *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2010-2019,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* $Id: mdl_interface_to_explicit_ast.mli,v 1.1 2019-05-10 14:04:56 jpc Exp $ *)

val read_simulink_interface_marshaled_file :
  Path.explicit_file_name ->
  Mdl_interface_explicit_ast.explicit_interface
;;

val write_simulink_interface_marshaled_file :
  Path.explicit_file_name ->
  Mdl_interface_explicit_ast.explicit_interface -> unit
(** Reading/writing SIMULINK compiled interface file. *)
;;

val load_simulink_interface_source_file :
  Path.explicit_file_name ->
  Mdl_interface_explicit_ast.explicit_interface
;;

val load_simulink_interface :
  Ident.ident -> Mdl_interface_explicit_ast.explicit_interface
;;

val load_simulink_interfaces : unit ->
  Mdl_interface_explicit_ast.explicit_interfaces
;;

val interface_to_explicit_ast :
  Mdl_deep_ast.deep_interface ->
  'a Mdl_explicit_ast.explicit_simulink_file
;;

(*
 Local Variables:
  compile-command: "cd ../../..; make"
  End:
*)
