(***********************************************************************)
(*                                                                     *)
(*                               Simport                               *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2010-2019,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.5+dev0 generated code. *)

let rec printer_explicit_stateflow_section ctx ppf = function
  | Mdl_stateflow_explicit_ast.Explicit_stateflow_section e ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Mdl_stateflow_explicit_ast.Explicit_stateflow_section";
    printer_explicit_stateflow_section_items Og_precedence.Ck_argument ppf e;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_explicit_stateflow_section_items ctx ppf = function
  | e_l ->
    Og_printer.printer_List printer_explicit_stateflow_section_item
      ctx
      ppf
      e_l

and printer_explicit_stateflow_section_item ctx ppf = function
  | m_d ->
    Mdl_stateflow_deep_ast_print.printer_deep_stateflow_section_item
      ctx
      ppf
      m_d
;;

(* Defining top printers. *)

let print_explicit_stateflow_section ppf =
  printer_explicit_stateflow_section Og_precedence.Ck_toplevel ppf

and print_explicit_stateflow_section_items ppf =
  printer_explicit_stateflow_section_items Og_precedence.Ck_toplevel ppf

and print_explicit_stateflow_section_item ppf =
  printer_explicit_stateflow_section_item Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.5+dev0 generated code. *)
