(***********************************************************************)
(*                                                                     *)
(*                               Simport                               *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2010-2019,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* $Id: mdl_stateflow_to_explicit_ast.ml,v 1.1 2019-05-10 14:04:56 jpc Exp $ *)

(* From deep syntax to explicit syntax for stateflow. *)

open Mdl_stateflow_deep_ast;;
open Mdl_stateflow_explicit_ast;;

(* For the time being, just do nothing! *)
let explicit_stateflow_section_item deep_stateflow_item =
  deep_stateflow_item
;;

let explicit_stateflow_section = function
  | Deep_stateflow_section deep_stateflow_section_items ->
    Explicit_stateflow_section
      (List.rev_map explicit_stateflow_section_item deep_stateflow_section_items)
;;

(*
let deep_stateflow_machine _stateflow_items = failwith "not yet"
;;

let deep_stateflow_target _stateflow_items = failwith "not yet"
;;

let deep_stateflow_chart _stateflow_items = failwith "not yet"
;;

let deep_stateflow_event _stateflow_items = failwith "not yet"
;;

let deep_stateflow_state _stateflow_items = failwith "not yet"
;;

let deep_stateflow_junction _stateflow_items = failwith "not yet"
;;

let deep_stateflow_transition _stateflow_items = failwith "not yet"
;;

let deep_stateflow_data _stateflow_items = failwith "not yet"
;;

let deep_stateflow_instance _stateflow_items = failwith "not yet"
;;

let deep_stateflow_section_item = function
  | Mdl_ast.Stateflow_machine stateflow_items -> deep_stateflow_machine stateflow_items
  | Stateflow_target stateflow_items -> deep_stateflow_target stateflow_items
  | Stateflow_chart stateflow_items -> deep_stateflow_chart stateflow_items
  | Stateflow_event stateflow_items -> deep_stateflow_event stateflow_items
  | Stateflow_state stateflow_items -> deep_stateflow_state stateflow_items
  | Stateflow_junction stateflow_items -> deep_stateflow_junction stateflow_items
  | Stateflow_transition stateflow_items -> deep_stateflow_transition stateflow_items
  | Stateflow_data stateflow_items -> deep_stateflow_data stateflow_items
  | Stateflow_instance stateflow_items -> deep_stateflow_instance stateflow_items
;;

let deep_stateflow_section stateflow_section =
  List.rev_map deep_stateflow_section_item stateflow_section
;;
*)

(*
type stateflow_section = stateflow_section_items

and stateflow_section_items =  stateflow_section_item list
and stateflow_section_item =
  | Stateflow_machine of stateflow_items
  | Stateflow_target of stateflow_items
  | Stateflow_chart of stateflow_items
  | Stateflow_event of stateflow_items
  | Stateflow_state of stateflow_items
  | Stateflow_junction of stateflow_items
  | Stateflow_transition of stateflow_items
  | Stateflow_data of stateflow_items
  | Stateflow_instance of stateflow_items

and stateflow_items = stateflow_item list
and stateflow_item =
  | Stateflow_trigger of ident
  | Stateflow_chart_ref of natural
  | Stateflow_machine_ref of simple_value
  | Stateflow_type of ident
  | Stateflow_name of string
  | Stateflow_id of natural
  | Stateflow_eml of stateflow_items
  | Stateflow_binding of binding
;;
*)

(*
 Local Variables:
  compile-command: "cd ../../..; make"
  End:
*)
