(***********************************************************************)
(*                                                                     *)
(*                               Simport                               *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2010-2019,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* $Id: mdl_to_explicit_ast.mli,v 1.1 2019-05-10 14:04:56 jpc Exp $ *)

(* From deep syntax to completely explicit inherited tree:
   - defaults sections are incorporated into values,
   - no more default sections in the resulting trees: all fields are explicit
     and checked with respect to various type or range constraints.
*)

val treat_simulink_ast :
  Mdl_ast.simulink_file ->
  Mdl_explicit_ast.explicit_line_simulink_file
;;

val read_mdl_file :
  Path.explicit_file_name ->
  Mdl_explicit_ast.explicit_line_simulink_file
;;

(*
 Local Variables:
  compile-command: "cd ../../..; make"
  End:
*)
