(***********************************************************************)
(*                                                                     *)
(*                               Simport                               *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2010-2019,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* $Id: mdl_rename.mli,v 1.1 2019-05-10 14:04:59 jpc Exp $ *)

(** {3 From models with action links to models with rename links} *)

(** From explicit action link model to explicit rename link models:
  activation is translated to event generator blocks and event links. *)

(** Translate action models to an explicit_model with rename links.
*)

val matlab_function_name_ident : Ident.ident;;
val matlab_function_script_ident : Ident.ident;;
val block_input_offsets_ident : Ident.ident;;
val block_parameter_offsets_ident : Ident.ident;;
val block_argument_sizes_ident : Ident.ident;;
val block_return_sizes_ident : Ident.ident;;

val rename_model :
  Mdl_action_ast.action_model ->
  Mdl_rename_ast.rename_model
;;

(*
 Local Variables:
  compile-command: "cd ../../..; make"
  End:
*)
