(***********************************************************************)
(*                                                                     *)
(*                               Simport                               *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2010-2019,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.5+dev0 generated code. *)

let printer_natural ctx ppf = function
  | u_t -> Unatural_print.printer_t ctx ppf u_t
;;

let printer_explicit_block pp_a ctx ppf = function
  | a_m_e ->
    Mdl_implementation_explicit_ast_print.printer_explicit_block pp_a
      ctx
      ppf
      a_m_e

and printer_explicit_system pp_a ctx ppf = function
  | a_m_e ->
    Mdl_implementation_explicit_ast_print.printer_explicit_system pp_a
      ctx
      ppf
      a_m_e

and printer_explicit_model pp_a ctx ppf = function
  | a_m_e ->
    Mdl_implementation_explicit_ast_print.printer_explicit_model pp_a
      ctx
      ppf
      a_m_e

and printer_explicit_simulink_file pp_a ctx ppf = function
  | a_m_e ->
    Mdl_explicit_ast_print.printer_explicit_simulink_file pp_a ctx ppf a_m_e
;;

let printer_action_link_connectors pp_a ctx ppf = function
  | a_m_a ->
    Mdl_action_ast_print.printer_action_link_connectors pp_a ctx ppf a_m_a

and printer_action_directed_connectors ctx ppf = function
  | m_a ->
    Mdl_action_ast_print.printer_action_directed_connectors ctx ppf m_a

and printer_action_event_connectors ctx ppf = function
  | m_a -> Mdl_action_ast_print.printer_action_event_connectors ctx ppf m_a
;;

let printer_poly_rename_link pp_link ctx ppf = function
  | l_m_p ->
    Mdl_action_ast_print.printer_poly_action_link pp_link ctx ppf l_m_p
;;

let printer_connection_port_info ctx ppf = function
  | {
      Mdl_rename_ast.connector_block_nin = n;
      Mdl_rename_ast.connector_block_nout = n0;
      Mdl_rename_ast.connection_port_value = m_c;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Mdl_rename_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>connector_block_nin =";
    printer_natural Og_precedence.Ck_record_field ppf n;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>connector_block_nout =";
    printer_natural Og_precedence.Ck_record_field ppf n0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>connection_port_value =";
    Mdl_implementation_explicit_ast_print.printer_connection_port_value
      Og_precedence.Ck_record_field
      ppf
      m_c;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let printer_rename_connection_connector_desc ctx ppf = function
  | Mdl_rename_ast.Rename_left_connector c ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_rename_ast.Rename_left_connector";
    printer_connection_port_info Og_precedence.Ck_argument ppf c;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_rename_ast.Rename_right_connector c ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_rename_ast.Rename_right_connector";
    printer_connection_port_info Og_precedence.Ck_argument ppf c;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let printer_rename_directed_connector ctx ppf = function
  | m_a -> Mdl_action_ast_print.printer_action_directed_connector ctx ppf m_a

and printer_rename_connection_connector ctx ppf = function
  | r_m_a ->
    Mdl_action_ast_print.printer_action_connector_port
      printer_rename_connection_connector_desc
      ctx
      ppf
      r_m_a
;;

let printer_rename_connection_connectors ctx ppf = function
  | r_a ->
    printer_action_link_connectors printer_rename_connection_connector_desc
      ctx
      ppf
      r_a
;;

let printer_rename_directed_connectors ctx ppf = function
  | m_a ->
    Mdl_action_ast_print.printer_action_directed_connectors ctx ppf m_a

and printer_rename_event_connectors ctx ppf = function
  | m_a -> Mdl_action_ast_print.printer_action_event_connectors ctx ppf m_a
;;

let printer_rename_link_desc ctx ppf = function
  | Mdl_rename_ast.Rename_directed_link r ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_rename_ast.Rename_directed_link";
    printer_rename_directed_connectors Og_precedence.Ck_argument ppf r;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_rename_ast.Rename_event_link r ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_rename_ast.Rename_event_link";
    printer_rename_event_connectors Og_precedence.Ck_argument ppf r;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Mdl_rename_ast.Rename_connection_link r ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Mdl_rename_ast.Rename_connection_link";
    printer_rename_connection_connectors Og_precedence.Ck_argument ppf r;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let rec printer_rename_links ctx ppf = function
  | r_l -> Og_printer.printer_List printer_rename_link ctx ppf r_l

and printer_rename_link ctx ppf = function
  | r_p -> printer_poly_rename_link printer_rename_link_desc ctx ppf r_p
;;

let printer_rename_block ctx ppf = function
  | r_e -> printer_explicit_block printer_rename_link ctx ppf r_e

and printer_rename_system ctx ppf = function
  | r_e -> printer_explicit_system printer_rename_link ctx ppf r_e

and printer_rename_model ctx ppf = function
  | r_e -> printer_explicit_model printer_rename_link ctx ppf r_e

and printer_rename_simulink_file ctx ppf = function
  | r_e -> printer_explicit_simulink_file printer_rename_link ctx ppf r_e
;;

(* Defining top printers. *)

let print_natural ppf = printer_natural Og_precedence.Ck_toplevel ppf
;;

let print_explicit_block pp_a ppf =
  printer_explicit_block pp_a Og_precedence.Ck_toplevel ppf

and print_explicit_system pp_a ppf =
  printer_explicit_system pp_a Og_precedence.Ck_toplevel ppf

and print_explicit_model pp_a ppf =
  printer_explicit_model pp_a Og_precedence.Ck_toplevel ppf

and print_explicit_simulink_file pp_a ppf =
  printer_explicit_simulink_file pp_a Og_precedence.Ck_toplevel ppf
;;

let print_action_link_connectors pp_a ppf =
  printer_action_link_connectors pp_a Og_precedence.Ck_toplevel ppf

and print_action_directed_connectors ppf =
  printer_action_directed_connectors Og_precedence.Ck_toplevel ppf

and print_action_event_connectors ppf =
  printer_action_event_connectors Og_precedence.Ck_toplevel ppf
;;

let print_poly_rename_link pp_link ppf =
  printer_poly_rename_link pp_link Og_precedence.Ck_toplevel ppf
;;

let print_connection_port_info ppf =
  printer_connection_port_info Og_precedence.Ck_toplevel ppf
;;

let print_rename_connection_connector_desc ppf =
  printer_rename_connection_connector_desc Og_precedence.Ck_toplevel ppf
;;

let print_rename_directed_connector ppf =
  printer_rename_directed_connector Og_precedence.Ck_toplevel ppf

and print_rename_connection_connector ppf =
  printer_rename_connection_connector Og_precedence.Ck_toplevel ppf
;;

let print_rename_connection_connectors ppf =
  printer_rename_connection_connectors Og_precedence.Ck_toplevel ppf
;;

let print_rename_directed_connectors ppf =
  printer_rename_directed_connectors Og_precedence.Ck_toplevel ppf

and print_rename_event_connectors ppf =
  printer_rename_event_connectors Og_precedence.Ck_toplevel ppf
;;

let print_rename_link_desc ppf =
  printer_rename_link_desc Og_precedence.Ck_toplevel ppf
;;

let print_rename_links ppf =
  printer_rename_links Og_precedence.Ck_toplevel ppf

and print_rename_link ppf = printer_rename_link Og_precedence.Ck_toplevel ppf
;;

let print_rename_block ppf =
  printer_rename_block Og_precedence.Ck_toplevel ppf

and print_rename_system ppf =
  printer_rename_system Og_precedence.Ck_toplevel ppf

and print_rename_model ppf =
  printer_rename_model Og_precedence.Ck_toplevel ppf

and print_rename_simulink_file ppf =
  printer_rename_simulink_file Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.5+dev0 generated code. *)
