(***********************************************************************)
(*                                                                     *)
(*                               Simport                               *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2010-2019,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* $Id: mdl_split.mli,v 1.1 2019-05-10 14:04:01 jpc Exp $ *)

(** {3 From Simulink lines to Scicos links: first step} *)

(** Removing Simulink line branches by adding (fake) Simulink split blocks. *)

(** From explicit syntax with Simulink-style lines to
   splitting blocks with Scicos-style links. *)

(** Translate all the lines of an explicit_model. *)
val split_model :
  Mdl_implementation_explicit_ast.explicit_line_model ->
  Mdl_split_ast.split_model
;;

(*
 Local Variables:
  compile-command: "cd ../../..; make"
  End:
*)
