(***********************************************************************)
(*                                                                     *)
(*                               Simport                               *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2010-2019,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* $Id: mdl_to_split_ast.ml,v 1.1 2019-05-10 14:04:01 jpc Exp $ *)

open Mdl_explicit_ast;;

(** From explicit syntax to split syntax tree. *)
let pass = function
  | Mdl_explicit_ast.Explicit_interface _ as intf -> intf
  | Mdl_explicit_ast.Explicit_model explicit_model ->
    Explicit_model (
      Mdl_split.split_model explicit_model)
  | Mdl_explicit_ast.Explicit_library explicit_model ->
    Explicit_library (
      Mdl_split.split_model explicit_model)
;;

let treat_simulink_ast ast =
  let east = Mdl_to_explicit_ast.treat_simulink_ast ast in
  pass east
;;

let read_mdl_file explicit_fname =
  let east = Mdl_to_explicit_ast.read_mdl_file explicit_fname in
  pass east
;;

(*
 Local Variables:
  compile-command: "cd ../../..; make"
  End:
*)
