(***********************************************************************)
(*                                                                     *)
(*                               Simport                               *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2010-2019,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* $Id: concat_list.mli,v 1.1 2019-05-10 14:04:02 jpc Exp $ *)

type 'a clist = private
   | List of 'a list
   | Concat of 'a clist * 'a clist
;;

val concat : 'a clist -> 'a clist -> 'a clist;;
val list : 'a list -> 'a clist;;

val cons : 'a -> 'a clist -> 'a clist;;
val cons_list : 'a list -> 'a clist -> 'a clist;;

val length : 'a clist -> int;;

val list_of_clist : 'a clist -> 'a list
;;

val clist_of_lists : 'a list list -> 'a clist
;;

val iter : ('a -> unit) -> 'a clist -> unit
;;

val map :  ('a -> 'b) -> 'a clist -> 'b clist
;;


(*
 Local Variables:
  compile-command: "cd ../../..; make"
  End:
*)
