(***********************************************************************)
(*                                                                     *)
(*                               Simport                               *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2010-2019,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* $Id: genr_block.mli,v 1.1 2019-05-10 14:04:02 jpc Exp $ *)

open Mdl_basics_explicit_ast
open Genr_block_types
;;

val init : Simport_configuration.target_modeler -> unit;;

val add_translator :
  Simport_configuration.target_modeler ->
  explicit_block_type -> block_translator -> unit
;;

val find_translator : explicit_block_type -> block_translator;;

val translation_error : string -> 'a;;

val print_block_identity : Format.formatter -> genr_info -> unit;;

val block_identity : genr_info -> string;;

(*
 Local Variables:
  compile-command: "cd ../../..; make"
  End:
*)
