(***********************************************************************)
(*                                                                     *)
(*                               Simport                               *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2010-2019,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.5+dev0 generated code. *)

open Mdl_basics_explicit_ast_print;;

open Mdl_implementation_explicit_ast_print;;

open Instructions_print;;

let printer_natural ctx ppf = function
  | a_n -> Ast_types_print.printer_natural ctx ppf a_n
;;

let printer_pmio_port_side _ctx ppf = function
  | Genr_block_types.Pmio_port_left ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Genr_block_types.Pmio_port_left"
  | Genr_block_types.Pmio_port_right ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Genr_block_types.Pmio_port_right"
;;

let printer_pmio_port_sides ctx ppf = function
  | p_o_a ->
    Og_printer.printer_Array
      (Og_printer.printer_Option printer_pmio_port_side)
      ctx
      ppf
      p_o_a
;;

let printer_system_io_descriptor ctx ppf = function
  | {
      Genr_block_types.system_pmio_port_sides = p;
      Genr_block_types.system_inport_number = n;
      Genr_block_types.system_outport_number = n0;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Genr_block_types.@,";
    Format.fprintf ppf "%,@[<hv 2>system_pmio_port_sides =";
    printer_pmio_port_sides Og_precedence.Ck_record_field ppf p;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>system_inport_number =";
    printer_natural Og_precedence.Ck_record_field ppf n;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>system_outport_number =";
    printer_natural Og_precedence.Ck_record_field ppf n0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let printer_genr_info ctx ppf = function
  | {
      Genr_block_types.block_arguments = e;
      Genr_block_types.block_bindings = e0;
      Genr_block_types.block_inport_names = e_e_h_t;
      Genr_block_types.block_ports = e1;
      Genr_block_types.block_ports_description = e2;
      Genr_block_types.block_parent_system_io_descriptor = s;
      Genr_block_types.block_port_activation_needed = b;
      Genr_block_types.block_explicit_type = e3;
      Genr_block_types.block_explicit_name = m_e;
      Genr_block_types.block_explicit_instance_data = e_o;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Genr_block_types.@,";
    Format.fprintf ppf "%,@[<hv 2>block_arguments =";
    printer_explicit_binding_table Og_precedence.Ck_record_field ppf e;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>block_bindings =";
    printer_explicit_binding_table Og_precedence.Ck_record_field ppf e0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>block_inport_names =";
    Hash_table_print.printer_t
      printer_explicit_port_number
      printer_explicit_line_name
      Og_precedence.Ck_record_field
      ppf
      e_e_h_t;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>block_ports =";
    printer_explicit_block_ports Og_precedence.Ck_record_field ppf e1;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>block_ports_description =";
    printer_explicit_ports_description Og_precedence.Ck_record_field ppf e2;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>block_parent_system_io_descriptor =";
    printer_system_io_descriptor Og_precedence.Ck_record_field ppf s;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>block_port_activation_needed =";
    Og_printer.printer_Bool Og_precedence.Ck_record_field ppf b;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>block_explicit_type =";
    printer_explicit_block_type Og_precedence.Ck_record_field ppf e3;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>block_explicit_name =";
    Mdl_basics_explicit_ast_print.printer_explicit_block_name
      Og_precedence.Ck_record_field
      ppf
      m_e;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>block_explicit_instance_data =";
    Og_printer.printer_Option printer_explicit_binding_table
      Og_precedence.Ck_record_field
      ppf
      e_o;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let printer_block_translator ctx ppf = function
  | f_h_f_g_c ->
    Og_printer.printer_Fun
      printer_host_block_ident
      (Og_printer.printer_Fun printer_genr_info printer_code)
      ctx
      ppf
      f_h_f_g_c
;;

(* Defining top printers. *)

let print_natural ppf = printer_natural Og_precedence.Ck_toplevel ppf
;;

let print_pmio_port_side ppf =
  printer_pmio_port_side Og_precedence.Ck_toplevel ppf
;;

let print_pmio_port_sides ppf =
  printer_pmio_port_sides Og_precedence.Ck_toplevel ppf
;;

let print_system_io_descriptor ppf =
  printer_system_io_descriptor Og_precedence.Ck_toplevel ppf
;;

let print_genr_info ppf = printer_genr_info Og_precedence.Ck_toplevel ppf
;;

let print_block_translator ppf =
  printer_block_translator Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.5+dev0 generated code. *)
