(***********************************************************************)
(*                                                                     *)
(*                               Simport                               *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2010-2019,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.5+dev0 generated code. *)

let printer_natural ctx ppf = function
  | a_n -> Ast_types_print.printer_natural ctx ppf a_n
;;

let printer_mdl_text ctx ppf = function
  | a_m -> Ast_types_print.printer_mdl_text ctx ppf a_m
;;

let printer_diagram_name ctx ppf = function
  | a_m -> Ast_types_print.printer_mdl_name ctx ppf a_m
;;

let printer_host_id ctx ppf = function
  | s -> Og_printer.printer_String ctx ppf s
;;

let printer_host_ident ctx ppf = function
  | Instructions.Hi h ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Hi";
    printer_host_id Og_precedence.Ck_argument ppf h;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let printer_host_block_ident ctx ppf = function
  | Instructions.Hbi h ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Hbi";
    printer_host_id Og_precedence.Ck_argument ppf h;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let printer_host_block_tag_ident ctx ppf = function
  | Instructions.Hbti s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Hbti";
    Og_printer.printer_String Og_precedence.Ck_argument ppf s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let printer_host_diagram_ident ctx ppf = function
  | Instructions.Hdi h ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Hdi";
    printer_host_id Og_precedence.Ck_argument ppf h;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let printer_host_model_ident ctx ppf = function
  | Instructions.Hmi h ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Hmi";
    printer_host_id Og_precedence.Ck_argument ppf h;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let printer_host_function_ident ctx ppf = function
  | Instructions.Hfi h ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Hfi";
    printer_host_id Og_precedence.Ck_argument ppf h;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let printer_host_string ctx ppf = function
  | Instructions.Host_string s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Host_string";
    Og_printer.printer_String Og_precedence.Ck_argument ppf s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let printer_modeler_font_size ctx ppf = function
  | Instructions.Sfs m ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Sfs";
    printer_mdl_text Og_precedence.Ck_argument ppf m;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let printer_modeler_font_value ctx ppf = function
  | Instructions.Sfv n ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Sfv";
    printer_natural Og_precedence.Ck_argument ppf n;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let printer_modeler_color ctx ppf = function
  | Instructions.Sc m_r ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Sc";
    Mdl_basics_deep_ast_print.printer_rgb_color
      Og_precedence.Ck_argument
      ppf
      m_r;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let printer_modeler_block_type ctx ppf = function
  | Instructions.Sbt s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Sbt";
    Og_printer.printer_String Og_precedence.Ck_argument ppf s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let printer_modeler_ident ctx ppf = function
  | Instructions.Si s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Si";
    Og_printer.printer_String Og_precedence.Ck_argument ppf s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let printer_matlab_script ctx ppf = function
  | Instructions.Matlab_script m ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Matlab_script";
    printer_mdl_text Og_precedence.Ck_argument ppf m;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let printer_code_value ctx ppf = function
  | m_e -> Mdl_basics_explicit_ast_print.printer_explicit_value ctx ppf m_e
;;

let rec printer_modeler_block_parameter_bindings ctx ppf = function
  | m_u_t ->
    Ulist1_print.printer_t printer_modeler_block_parameter_binding
      ctx
      ppf
      m_u_t

and printer_modeler_block_parameter_binding ctx ppf = function
  | m_b_i ->
    Binding_print.printer_ident_binding printer_modeler_block_parameter_value
      ctx
      ppf
      m_b_i

and printer_modeler_block_parameter_value ctx ppf = function
  | Instructions.Parameter_value c ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Parameter_value";
    printer_code_value Og_precedence.Ck_argument ppf c;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Instructions.Parameter_struct c_l_b_i_u_t ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Parameter_struct";
    Ulist1_print.printer_t
      (Binding_print.printer_ident_binding
         (Og_printer.printer_List printer_code_value))
      Og_precedence.Ck_argument
      ppf
      c_l_b_i_u_t;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let printer_evaluation_mode ctx ppf = function
  | m_d ->
    Mdl_basics_deep_ast_print.printer_deep_mask_parameter_evaluation
      ctx
      ppf
      m_d
;;

let printer_enable_mode ctx ppf = function
  | m_d ->
    Mdl_basics_deep_ast_print.printer_deep_mask_parameter_enable ctx ppf m_d
;;

let printer_visible_mode ctx ppf = function
  | m_d ->
    Mdl_basics_deep_ast_print.printer_deep_mask_parameter_visible ctx ppf m_d
;;

let printer_mask ctx ppf = function
  | m_e -> Mdl_basics_explicit_ast_print.printer_explicit_mask ctx ppf m_e
;;

let printer_mask_parameter ctx ppf = function
  | m_e ->
    Mdl_basics_explicit_ast_print.printer_explicit_mask_parameter ctx ppf m_e
;;

let printer_mask_parameter_value ctx ppf = function
  | m_e ->
    Mdl_basics_explicit_ast_print.printer_explicit_mask_parameter_value
      ctx
      ppf
      m_e
;;

let printer_context ctx ppf = function
  | Instructions.Context_code m ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Context_code";
    printer_matlab_script Og_precedence.Ck_argument ppf m;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Instructions.Context_bindings m ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Context_bindings";
    printer_modeler_block_parameter_bindings Og_precedence.Ck_argument ppf m;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Instructions.Context_commented m ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Context_commented";
    printer_modeler_block_parameter_bindings Og_precedence.Ck_argument ppf m;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let printer_workspace ctx ppf = function
  | m_e ->
    Mdl_implementation_explicit_ast_print.printer_explicit_model_workspace
      ctx
      ppf
      m_e
;;

let printer_directed_connector_src ctx ppf = function
  | Instructions.Dcs (h, m_r) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Dcs";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_host_block_tag_ident Og_precedence.Ck_tuple_item ppf h;
    Format.fprintf ppf "%,,@ ";
    Mdl_rename_ast_print.printer_rename_directed_connector
      Og_precedence.Ck_tuple_item
      ppf
      m_r;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_directed_connector_dst ctx ppf = function
  | Instructions.Dcd (h, m_r) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Dcd";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_host_block_tag_ident Og_precedence.Ck_tuple_item ppf h;
    Format.fprintf ppf "%,,@ ";
    Mdl_rename_ast_print.printer_rename_directed_connector
      Og_precedence.Ck_tuple_item
      ppf
      m_r;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let printer_connection_connector_src ctx ppf = function
  | Instructions.Ccs (h, m_r) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Ccs";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_host_block_tag_ident Og_precedence.Ck_tuple_item ppf h;
    Format.fprintf ppf "%,,@ ";
    Mdl_rename_ast_print.printer_rename_connection_connector
      Og_precedence.Ck_tuple_item
      ppf
      m_r;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_connection_connector_dst ctx ppf = function
  | Instructions.Ccd (h, m_r) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Ccd";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_host_block_tag_ident Og_precedence.Ck_tuple_item ppf h;
    Format.fprintf ppf "%,,@ ";
    Mdl_rename_ast_print.printer_rename_connection_connector
      Og_precedence.Ck_tuple_item
      ppf
      m_r;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let printer_modeler_point ctx ppf = function
  | { Instructions.sp_x = f; Instructions.sp_y = f0; } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Instructions.@,";
    Format.fprintf ppf "%,@[<hv 2>sp_x =";
    Og_printer.printer_Float Og_precedence.Ck_record_field ppf f;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>sp_y =";
    Og_printer.printer_Float Og_precedence.Ck_record_field ppf f0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let printer_modeler_size ctx ppf = function
  | { Instructions.ss_w = f; Instructions.ss_h = f0; } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Instructions.@,";
    Format.fprintf ppf "%,@[<hv 2>ss_w =";
    Og_printer.printer_Float Og_precedence.Ck_record_field ppf f;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>ss_h =";
    Og_printer.printer_Float Og_precedence.Ck_record_field ppf f0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let printer_modeler_position ctx ppf = function
  | {
      Instructions.sp_xmin = f;
      Instructions.sp_xmax = f0;
      Instructions.sp_ymin = f1;
      Instructions.sp_ymax = f2;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Instructions.@,";
    Format.fprintf ppf "%,@[<hv 2>sp_xmin =";
    Og_printer.printer_Float Og_precedence.Ck_record_field ppf f;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>sp_xmax =";
    Og_printer.printer_Float Og_precedence.Ck_record_field ppf f0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>sp_ymin =";
    Og_printer.printer_Float Og_precedence.Ck_record_field ppf f1;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>sp_ymax =";
    Og_printer.printer_Float Og_precedence.Ck_record_field ppf f2;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let printer_modeler_simulation_parameters ctx ppf = function
  | {
      Instructions.ssp_abs_tol = c;
      Instructions.ssp_rel_tol = c0;
      Instructions.ssp_tim_tol = c1;
      Instructions.ssp_delta_t = c2;
      Instructions.ssp_rt_scale = c3;
      Instructions.ssp_solver = c4;
      Instructions.ssp_max_step = c5;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Instructions.@,";
    Format.fprintf ppf "%,@[<hv 2>ssp_abs_tol =";
    printer_code_value Og_precedence.Ck_record_field ppf c;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>ssp_rel_tol =";
    printer_code_value Og_precedence.Ck_record_field ppf c0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>ssp_tim_tol =";
    printer_code_value Og_precedence.Ck_record_field ppf c1;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>ssp_delta_t =";
    printer_code_value Og_precedence.Ck_record_field ppf c2;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>ssp_rt_scale =";
    printer_code_value Og_precedence.Ck_record_field ppf c3;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>ssp_solver =";
    printer_code_value Og_precedence.Ck_record_field ppf c4;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>ssp_max_step =";
    printer_code_value Og_precedence.Ck_record_field ppf c5;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let rec printer_code ctx ppf = function
  | i_c_c ->
    Concat_list_print.printer_clist printer_instruction ctx ppf i_c_c

and printer_instruction ctx ppf = function
  | Instructions.Add_block (h, h0, h1, m_b) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Add_block";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_host_diagram_ident Og_precedence.Ck_tuple_item ppf h;
    Format.fprintf ppf "%,,@ ";
    printer_host_block_tag_ident Og_precedence.Ck_tuple_item ppf h0;
    Format.fprintf ppf "%,,@ ";
    printer_host_block_ident Og_precedence.Ck_tuple_item ppf h1;
    Format.fprintf ppf "%,,@ ";
    Mdl_ast_print.printer_block_name Og_precedence.Ck_tuple_item ppf m_b;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Instructions.Add_connection_link (h, c, c0, m_l) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Add_connection_link";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_host_diagram_ident Og_precedence.Ck_tuple_item ppf h;
    Format.fprintf ppf "%,,@ ";
    printer_connection_connector_src Og_precedence.Ck_tuple_item ppf c;
    Format.fprintf ppf "%,,@ ";
    printer_connection_connector_dst Og_precedence.Ck_tuple_item ppf c0;
    Format.fprintf ppf "%,,@ ";
    Og_printer.printer_List printer_modeler_point
      Og_precedence.Ck_tuple_item
      ppf
      m_l;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Instructions.Add_directed_link (h, d, d0, m_l) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Add_directed_link";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_host_diagram_ident Og_precedence.Ck_tuple_item ppf h;
    Format.fprintf ppf "%,,@ ";
    printer_directed_connector_src Og_precedence.Ck_tuple_item ppf d;
    Format.fprintf ppf "%,,@ ";
    printer_directed_connector_dst Og_precedence.Ck_tuple_item ppf d0;
    Format.fprintf ppf "%,,@ ";
    Og_printer.printer_List printer_modeler_point
      Og_precedence.Ck_tuple_item
      ppf
      m_l;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Instructions.Add_event_link (h, d, d0, m_l) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Add_event_link";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_host_diagram_ident Og_precedence.Ck_tuple_item ppf h;
    Format.fprintf ppf "%,,@ ";
    printer_directed_connector_src Og_precedence.Ck_tuple_item ppf d;
    Format.fprintf ppf "%,,@ ";
    printer_directed_connector_dst Og_precedence.Ck_tuple_item ppf d0;
    Format.fprintf ppf "%,,@ ";
    Og_printer.printer_List printer_modeler_point
      Og_precedence.Ck_tuple_item
      ppf
      m_l;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Instructions.Define_function (h, h0, h_l, c) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Define_function";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_host_diagram_ident Og_precedence.Ck_tuple_item ppf h;
    Format.fprintf ppf "%,,@ ";
    printer_host_function_ident Og_precedence.Ck_tuple_item ppf h0;
    Format.fprintf ppf "%,,@ ";
    Og_printer.printer_List printer_host_ident
      Og_precedence.Ck_tuple_item
      ppf
      h_l;
    Format.fprintf ppf "%,,@ ";
    printer_code Og_precedence.Ck_tuple_item ppf c;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Instructions.Evaluate_model (h, h0) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Evaluate_model";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_host_model_ident Og_precedence.Ck_tuple_item ppf h;
    Format.fprintf ppf "%,,@ ";
    printer_host_diagram_ident Og_precedence.Ck_tuple_item ppf h0;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Instructions.Fill_super_block (h, h0) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Fill_super_block";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_host_block_ident Og_precedence.Ck_tuple_item ppf h;
    Format.fprintf ppf "%,,@ ";
    printer_host_diagram_ident Og_precedence.Ck_tuple_item ppf h0;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Instructions.Instantiate_block (h, m) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Instantiate_block";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_host_block_ident Og_precedence.Ck_tuple_item ppf h;
    Format.fprintf ppf "%,,@ ";
    printer_modeler_block_type Og_precedence.Ck_tuple_item ppf m;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Instructions.Instantiate_super_block h ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Instantiate_super_block";
    printer_host_block_ident Og_precedence.Ck_argument ppf h;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Instructions.Instantiate_diagram h ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Instantiate_diagram";
    printer_host_diagram_ident Og_precedence.Ck_argument ppf h;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Instructions.Mask_block (h, c, m) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Mask_block";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_host_block_ident Og_precedence.Ck_tuple_item ppf h;
    Format.fprintf ppf "%,,@ ";
    printer_context Og_precedence.Ck_tuple_item ppf c;
    Format.fprintf ppf "%,,@ ";
    printer_mask Og_precedence.Ck_tuple_item ppf m;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Instructions.Set_block_bg_color (h, m) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Set_block_bg_color";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_host_block_ident Og_precedence.Ck_tuple_item ppf h;
    Format.fprintf ppf "%,,@ ";
    printer_modeler_color Og_precedence.Ck_tuple_item ppf m;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Instructions.Set_block_fg_color (h, m) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Set_block_fg_color";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_host_block_ident Og_precedence.Ck_tuple_item ppf h;
    Format.fprintf ppf "%,,@ ";
    printer_modeler_color Og_precedence.Ck_tuple_item ppf m;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Instructions.Set_block_evtnin (h, n) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Set_block_evtnin";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_host_block_ident Og_precedence.Ck_tuple_item ppf h;
    Format.fprintf ppf "%,,@ ";
    printer_natural Og_precedence.Ck_tuple_item ppf n;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Instructions.Set_block_evtnout (h, n) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Set_block_evtnout";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_host_block_ident Og_precedence.Ck_tuple_item ppf h;
    Format.fprintf ppf "%,,@ ";
    printer_natural Og_precedence.Ck_tuple_item ppf n;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Instructions.Set_block_flip (h, b) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Set_block_flip";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_host_block_ident Og_precedence.Ck_tuple_item ppf h;
    Format.fprintf ppf "%,,@ ";
    Og_printer.printer_Bool Og_precedence.Ck_tuple_item ppf b;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Instructions.Set_block_icon (h, m) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Set_block_icon";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_host_block_ident Og_precedence.Ck_tuple_item ppf h;
    Format.fprintf ppf "%,,@ ";
    printer_matlab_script Og_precedence.Ck_tuple_item ppf m;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Instructions.Set_block_icon_text (h, m) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Set_block_icon_text";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_host_block_ident Og_precedence.Ck_tuple_item ppf h;
    Format.fprintf ppf "%,,@ ";
    printer_mdl_text Og_precedence.Ck_tuple_item ppf m;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Instructions.Set_block_ident (h, m_b) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Set_block_ident";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_host_block_ident Og_precedence.Ck_tuple_item ppf h;
    Format.fprintf ppf "%,,@ ";
    Mdl_ast_print.printer_block_name Og_precedence.Ck_tuple_item ppf m_b;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Instructions.Set_block_mask (h, m) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Set_block_mask";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_host_block_ident Og_precedence.Ck_tuple_item ppf h;
    Format.fprintf ppf "%,,@ ";
    printer_mask Og_precedence.Ck_tuple_item ppf m;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Instructions.Set_block_nin (h, n) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Set_block_nin";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_host_block_ident Og_precedence.Ck_tuple_item ppf h;
    Format.fprintf ppf "%,,@ ";
    printer_natural Og_precedence.Ck_tuple_item ppf n;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Instructions.Set_block_nout (h, n) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Set_block_nout";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_host_block_ident Og_precedence.Ck_tuple_item ppf h;
    Format.fprintf ppf "%,,@ ";
    printer_natural Og_precedence.Ck_tuple_item ppf n;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Instructions.Set_block_origin (h, m) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Set_block_origin";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_host_block_ident Og_precedence.Ck_tuple_item ppf h;
    Format.fprintf ppf "%,,@ ";
    printer_modeler_point Og_precedence.Ck_tuple_item ppf m;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Instructions.Set_block_parameters (h, m) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Set_block_parameters";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_host_block_ident Og_precedence.Ck_tuple_item ppf h;
    Format.fprintf ppf "%,,@ ";
    printer_modeler_block_parameter_bindings
      Og_precedence.Ck_tuple_item
      ppf
      m;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Instructions.Set_block_size (h, m) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Set_block_size";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_host_block_ident Og_precedence.Ck_tuple_item ppf h;
    Format.fprintf ppf "%,,@ ";
    printer_modeler_size Og_precedence.Ck_tuple_item ppf m;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Instructions.Set_block_theta (h, f) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Set_block_theta";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_host_block_ident Og_precedence.Ck_tuple_item ppf h;
    Format.fprintf ppf "%,,@ ";
    Og_printer.printer_Float Og_precedence.Ck_tuple_item ppf f;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Instructions.Set_diagram_3d (h, b) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Set_diagram_3d";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_host_diagram_ident Og_precedence.Ck_tuple_item ppf h;
    Format.fprintf ppf "%,,@ ";
    Og_printer.printer_Bool Og_precedence.Ck_tuple_item ppf b;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Instructions.Set_diagram_bg_color (h, m) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Set_diagram_bg_color";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_host_diagram_ident Og_precedence.Ck_tuple_item ppf h;
    Format.fprintf ppf "%,,@ ";
    printer_modeler_color Og_precedence.Ck_tuple_item ppf m;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Instructions.Set_diagram_context (h, c) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Set_diagram_context";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_host_diagram_ident Og_precedence.Ck_tuple_item ppf h;
    Format.fprintf ppf "%,,@ ";
    printer_context Og_precedence.Ck_tuple_item ppf c;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Instructions.Set_diagram_position (h, m) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Set_diagram_position";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_host_diagram_ident Og_precedence.Ck_tuple_item ppf h;
    Format.fprintf ppf "%,,@ ";
    printer_modeler_position Og_precedence.Ck_tuple_item ppf m;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Instructions.Set_diagram_name (h, d) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Set_diagram_name";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_host_diagram_ident Og_precedence.Ck_tuple_item ppf h;
    Format.fprintf ppf "%,,@ ";
    printer_diagram_name Og_precedence.Ck_tuple_item ppf d;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Instructions.Set_diagram_zoom (h, f) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Set_diagram_zoom";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_host_diagram_ident Og_precedence.Ck_tuple_item ppf h;
    Format.fprintf ppf "%,,@ ";
    Og_printer.printer_Float Og_precedence.Ck_tuple_item ppf f;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Instructions.Set_function_call (h, h0, h_l) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Set_function_call";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_host_diagram_ident Og_precedence.Ck_tuple_item ppf h;
    Format.fprintf ppf "%,,@ ";
    printer_host_function_ident Og_precedence.Ck_tuple_item ppf h0;
    Format.fprintf ppf "%,,@ ";
    Og_printer.printer_List printer_host_ident
      Og_precedence.Ck_tuple_item
      ppf
      h_l;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Instructions.Set_model_close_fcn (h, m) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Set_model_close_fcn";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_host_model_ident Og_precedence.Ck_tuple_item ppf h;
    Format.fprintf ppf "%,,@ ";
    printer_matlab_script Og_precedence.Ck_tuple_item ppf m;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Instructions.Set_model_final_simulation_time (h, c) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Instructions.Set_model_final_simulation_time";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_host_model_ident Og_precedence.Ck_tuple_item ppf h;
    Format.fprintf ppf "%,,@ ";
    printer_code_value Og_precedence.Ck_tuple_item ppf c;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Instructions.Set_model_init_fcn (h, m) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Set_model_init_fcn";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_host_model_ident Og_precedence.Ck_tuple_item ppf h;
    Format.fprintf ppf "%,,@ ";
    printer_matlab_script Og_precedence.Ck_tuple_item ppf m;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Instructions.Set_model_initial_simulation_time (h, c) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Instructions.Set_model_initial_simulation_time";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_host_model_ident Og_precedence.Ck_tuple_item ppf h;
    Format.fprintf ppf "%,,@ ";
    printer_code_value Og_precedence.Ck_tuple_item ppf c;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Instructions.Set_model_postload_fcn (h, m) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Set_model_postload_fcn";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_host_model_ident Og_precedence.Ck_tuple_item ppf h;
    Format.fprintf ppf "%,,@ ";
    printer_matlab_script Og_precedence.Ck_tuple_item ppf m;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Instructions.Set_model_postlude (h, m) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Set_model_postlude";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_host_model_ident Og_precedence.Ck_tuple_item ppf h;
    Format.fprintf ppf "%,,@ ";
    printer_matlab_script Og_precedence.Ck_tuple_item ppf m;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Instructions.Set_model_postsave_fcn (h, m) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Set_model_postsave_fcn";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_host_model_ident Og_precedence.Ck_tuple_item ppf h;
    Format.fprintf ppf "%,,@ ";
    printer_matlab_script Og_precedence.Ck_tuple_item ppf m;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Instructions.Set_model_preload_fcn (h, m) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Set_model_preload_fcn";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_host_model_ident Og_precedence.Ck_tuple_item ppf h;
    Format.fprintf ppf "%,,@ ";
    printer_matlab_script Og_precedence.Ck_tuple_item ppf m;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Instructions.Set_model_prelude (h, m) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Set_model_prelude";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_host_model_ident Og_precedence.Ck_tuple_item ppf h;
    Format.fprintf ppf "%,,@ ";
    printer_matlab_script Og_precedence.Ck_tuple_item ppf m;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Instructions.Set_model_presave_fcn (h, m) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Set_model_presave_fcn";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_host_model_ident Og_precedence.Ck_tuple_item ppf h;
    Format.fprintf ppf "%,,@ ";
    printer_matlab_script Og_precedence.Ck_tuple_item ppf m;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Instructions.Set_model_start_fcn (h, m) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Set_model_start_fcn";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_host_model_ident Og_precedence.Ck_tuple_item ppf h;
    Format.fprintf ppf "%,,@ ";
    printer_matlab_script Og_precedence.Ck_tuple_item ppf m;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Instructions.Set_model_stop_fcn (h, m) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Set_model_stop_fcn";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_host_model_ident Og_precedence.Ck_tuple_item ppf h;
    Format.fprintf ppf "%,,@ ";
    printer_matlab_script Og_precedence.Ck_tuple_item ppf m;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Instructions.Set_model_workspace (h, w) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Set_model_workspace";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_host_model_ident Og_precedence.Ck_tuple_item ppf h;
    Format.fprintf ppf "%,,@ ";
    printer_workspace Og_precedence.Ck_tuple_item ppf w;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Instructions.Set_model_solver_parameters (h, m) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Set_model_solver_parameters";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_host_model_ident Og_precedence.Ck_tuple_item ppf h;
    Format.fprintf ppf "%,,@ ";
    printer_modeler_simulation_parameters Og_precedence.Ck_tuple_item ppf m;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Instructions.Set_super_block_atomic_property (h, b) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf
      "%,@[<hv 2>Instructions.Set_super_block_atomic_property";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_host_block_ident Og_precedence.Ck_tuple_item ppf h;
    Format.fprintf ppf "%,,@ ";
    Og_printer.printer_Bool Og_precedence.Ck_tuple_item ppf b;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Instructions.Set_target_modeler s_t ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Set_target_modeler";
    Simport_configuration_print.printer_target_modeler
      Og_precedence.Ck_argument
      ppf
      s_t;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Instructions.Comment s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Instructions.Comment";
    Og_printer.printer_String Og_precedence.Ck_argument ppf s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let printer_t ctx ppf = function | i -> printer_instruction ctx ppf i
;;

(* Defining top printers. *)

let print_natural ppf = printer_natural Og_precedence.Ck_toplevel ppf
;;

let print_mdl_text ppf = printer_mdl_text Og_precedence.Ck_toplevel ppf
;;

let print_diagram_name ppf =
  printer_diagram_name Og_precedence.Ck_toplevel ppf
;;

let print_host_id ppf = printer_host_id Og_precedence.Ck_toplevel ppf
;;

let print_host_ident ppf = printer_host_ident Og_precedence.Ck_toplevel ppf
;;

let print_host_block_ident ppf =
  printer_host_block_ident Og_precedence.Ck_toplevel ppf
;;

let print_host_block_tag_ident ppf =
  printer_host_block_tag_ident Og_precedence.Ck_toplevel ppf
;;

let print_host_diagram_ident ppf =
  printer_host_diagram_ident Og_precedence.Ck_toplevel ppf
;;

let print_host_model_ident ppf =
  printer_host_model_ident Og_precedence.Ck_toplevel ppf
;;

let print_host_function_ident ppf =
  printer_host_function_ident Og_precedence.Ck_toplevel ppf
;;

let print_host_string ppf = printer_host_string Og_precedence.Ck_toplevel ppf
;;

let print_modeler_font_size ppf =
  printer_modeler_font_size Og_precedence.Ck_toplevel ppf
;;

let print_modeler_font_value ppf =
  printer_modeler_font_value Og_precedence.Ck_toplevel ppf
;;

let print_modeler_color ppf =
  printer_modeler_color Og_precedence.Ck_toplevel ppf
;;

let print_modeler_block_type ppf =
  printer_modeler_block_type Og_precedence.Ck_toplevel ppf
;;

let print_modeler_ident ppf =
  printer_modeler_ident Og_precedence.Ck_toplevel ppf
;;

let print_matlab_script ppf =
  printer_matlab_script Og_precedence.Ck_toplevel ppf
;;

let print_code_value ppf = printer_code_value Og_precedence.Ck_toplevel ppf
;;

let print_modeler_block_parameter_bindings ppf =
  printer_modeler_block_parameter_bindings Og_precedence.Ck_toplevel ppf

and print_modeler_block_parameter_binding ppf =
  printer_modeler_block_parameter_binding Og_precedence.Ck_toplevel ppf

and print_modeler_block_parameter_value ppf =
  printer_modeler_block_parameter_value Og_precedence.Ck_toplevel ppf
;;

let print_evaluation_mode ppf =
  printer_evaluation_mode Og_precedence.Ck_toplevel ppf
;;

let print_enable_mode ppf = printer_enable_mode Og_precedence.Ck_toplevel ppf
;;

let print_visible_mode ppf =
  printer_visible_mode Og_precedence.Ck_toplevel ppf
;;

let print_mask ppf = printer_mask Og_precedence.Ck_toplevel ppf
;;

let print_mask_parameter ppf =
  printer_mask_parameter Og_precedence.Ck_toplevel ppf
;;

let print_mask_parameter_value ppf =
  printer_mask_parameter_value Og_precedence.Ck_toplevel ppf
;;

let print_context ppf = printer_context Og_precedence.Ck_toplevel ppf
;;

let print_workspace ppf = printer_workspace Og_precedence.Ck_toplevel ppf
;;

let print_directed_connector_src ppf =
  printer_directed_connector_src Og_precedence.Ck_toplevel ppf

and print_directed_connector_dst ppf =
  printer_directed_connector_dst Og_precedence.Ck_toplevel ppf
;;

let print_connection_connector_src ppf =
  printer_connection_connector_src Og_precedence.Ck_toplevel ppf

and print_connection_connector_dst ppf =
  printer_connection_connector_dst Og_precedence.Ck_toplevel ppf
;;

let print_modeler_point ppf =
  printer_modeler_point Og_precedence.Ck_toplevel ppf
;;

let print_modeler_size ppf =
  printer_modeler_size Og_precedence.Ck_toplevel ppf
;;

let print_modeler_position ppf =
  printer_modeler_position Og_precedence.Ck_toplevel ppf
;;

let print_modeler_simulation_parameters ppf =
  printer_modeler_simulation_parameters Og_precedence.Ck_toplevel ppf
;;

let print_code ppf = printer_code Og_precedence.Ck_toplevel ppf

and print_instruction ppf = printer_instruction Og_precedence.Ck_toplevel ppf
;;

let print_t ppf = printer_t Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.5+dev0 generated code. *)
