(***********************************************************************)
(*                                                                     *)
(*                               Simport                               *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2010-2019,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* $Id: mdl_to_code.ml,v 1.1 2019-05-10 14:04:02 jpc Exp $ *)

(** From explicit syntax to split syntax tree. *)
open Mdl_explicit_ast;;

let pass east =
  match east with
  | Explicit_model explicit_model
  | Explicit_library explicit_model ->
    Model_to_code.compile_model explicit_model
  | Explicit_interface _explicit_interface_table ->
    Concat_list.list []
;;

let treat_simulink_ast ast =
  let east = Mdl_to_rename_ast.treat_simulink_ast ast in
  pass east
;;

let read_mdl_file explicit_fname =
  let east = Mdl_to_rename_ast.read_mdl_file explicit_fname in
  pass east
;;

(*
 Local Variables:
  compile-command: "cd ../../..; make"
  End:
*)
