(***********************************************************************)
(*                                                                     *)
(*                               Simport                               *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2010-2019,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* $Id: mdl_parse_error.mli,v 1.1 2019-05-10 14:04:02 jpc Exp $ *)

type reason = string;;

type error =
  | Wrong_integer of string * reason
  | Not_an_integer of string * reason
  | Not_a_boolean of string * reason
  | Duplicated_defaults_section of string
  | Unknown_connection_type of string
  | Unknown_line_type of string
  | Unknown_alignment of string
  | Unknown_array_type of string
  | Unknown_block_type of string
  | Unknown_block_sf_block_type of string
  | Unknown_workspace_data_source_type of string
  | Unknown_port_kind of string
  | Invalid_string_specification of string * string
  | Invalid_tag_ident of string
  | Wrong_connection_port of string
  | Parsing_error
;;

val report_error : Format.formatter -> error -> unit;;

exception Error of Location.t * error;;

val parsing_error : Location.t -> error -> 'a;;

(*
 Local Variables:
  compile-command: "cd ../../..; make"
  End:
*)
