type token =
  | IDENT of (string)
  | BLOCKTYPENAME of (Mdl_block_types.block_type)
  | VENDOR of (Mdl_ast.vendor_ident)
  | FLOAT of (string)
  | INT of (string)
  | STRING of (string)
  | BOOL of (string)
  | OPEN_PAREN
  | CLOSE_PAREN
  | OPEN_BRACKET
  | CLOSE_BRACKET
  | OPEN_BRACE
  | CLOSE_BRACE
  | COMMA
  | COLON
  | DOT
  | SEMICOLON
  | TILDA
  | EOF
  | ANNOTATION
  | ANNOTATIONDEFAULTS
  | ARRAY
  | AUTOSIZE
  | BACKGROUNDCOLOR
  | BLOCK
  | BLOCKDEFAULTS
  | BLOCKINTERFACEPARAMETERS
  | BLOCKINTERFACES
  | BLOCKMIRROR
  | BLOCKPARAMETERDEFAULTS
  | BLOCKROTATION
  | BLOCKTYPE
  | BRANCH
  | CLICKFCN
  | CONFIGSET
  | CONNECTTYPE
  | CUSTOMPROPERTY
  | DATARECORD
  | DATATYPE
  | DIMENSION
  | DOLLAR_BACKUPCLASS
  | DOLLAR_CLASSNAME
  | DOLLAR_OBJECTID
  | DOLLAR_PROPNAME
  | DROPSHADOW
  | DSTBLOCK
  | DSTPORT
  | ENABLEPORT
  | ENUMSTRPAIRS
  | FONTANGLE
  | FONTNAME
  | FONTSIZE
  | FONTWEIGHT
  | FOREGROUNDCOLOR
  | GRAPHICALINTERFACE
  | HIDEAUTOMATICNAME
  | HORIZONTALALIGNMENT
  | INPORT
  | INTERFACENAME
  | INTERPRETER
  | LABELS
  | LENABLE
  | LIBRARY
  | LIFACTION
  | LINE
  | LINEDEFAULTS
  | LINETYPE
  | LIST
  | LISTTYPE
  | LOCATION
  | MASKCALLBACKSTRING
  | MASKCAPABILITIES
  | MASKDEFAULTS
  | MASKDESCRIPTION
  | MASKDISPLAY
  | MASKDISPLAYSTRING
  | MASKENABLESTRING
  | MASKHELP
  | MASKICONFRAME
  | MASKICONOPAQUE
  | MASKICONROTATE
  | MASKICONUNITS
  | MASKINITIALIZATION
  | MASKPARAMETERDEFAULTS
  | MASKPORTROTATE
  | MASKPROMPTSTRING
  | MASKRUNINITFORICONREDRAW
  | MASKSELFMODIFIABLE
  | MASKSTYLESTRING
  | MASKTABNAMESTRING
  | MASKTOOLTIPSTRING
  | MASKTUNABLEVALUESTRING
  | MASKTYPE
  | MASKVALUESTRING
  | MASKVARALIASSTRING
  | MASKVARIABLES
  | MASKVISIBILITYSTRING
  | MATDATA
  | MATSTRUCT
  | MODEL
  | NAME
  | NAMEPLACEMENT
  | NUMRECORDS
  | NUMROOTINPORTS
  | NUMROOTOUTPORTS
  | NUMROOTTRIGPORTS
  | OBJECT
  | ORIENTATION
  | OUTPORT
  | POINTS
  | PORT
  | PORTNUMBER
  | PORTS
  | POSITION
  | PROPNAME
  | SAVEDCHARACTERENCODING
  | SFBLOCKTYPE
  | SHARP
  | SHOWNAME
  | SID
  | SOURCEBLOCK
  | SOURCETYPE
  | SRCBLOCK
  | SRCPORT
  | STATEFLOW
  | STR
  | SYSTEM
  | TAG
  | TEXMODE
  | TEXT
  | TREATASATOMICUNIT
  | TRIGPORT
  | TYPE
  | DATA
  | USEDISPLAYTEXTASCLICKCALLBACK
  | VALUE
  | VERSION
  | VERTICALALIGNMENT
  | WORDWRAP
  | WSDATASOURCE
  | WSMATFILENAME
  | WSMATLABCODE
  | WSMCODE
  | WSMDLFILEDATA
  | WSSOURCEFILENAME
  | ZORDER
  | LARRAY
  | LCHART
  | LDATA
  | LDST
  | LEML
  | LEVENT
  | LEXECUTIONORDER
  | LFIRSTDATA
  | LFIRSTEVENT
  | LFIRSTINDEX
  | LFIRSTJUNCTION
  | LFIRSTTRANSITION
  | LFIRSTTARGET
  | LID
  | LINTERSECTION
  | LINSTANCE
  | LJUNCTION
  | LLABELSTRING
  | LLINKNODE
  | LTREENODE
  | LMACHINE
  | LCHARTFILENUMBER
  | LNAME
  | LPROPS
  | LPLANTMODELINGINFO
  | LSCOPE
  | LSIZE
  | LSCRIPT
  | LSRC
  | LSSIDNUMBER
  | LSTATE
  | LTARGET
  | LTRANSITION
  | LTRIGGER
  | LTYPE

val mdl_file :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Mdl_parsing_ast.simulink_file_contents
val position_entry :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Mdl_ast.position
val location_entry :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Mdl_ast.position
val simple_value_entry :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Mdl_ast.simple_value
val slx_model_value_entry :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Mdl_ast.model_value
val block_type_value_entry :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Mdl_block_types.block_type
val array_type_entry :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Mdl_ast.array_type
val line_type_entry :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Mdl_ast.line_type
val connection_type_entry :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Mdl_ast.connection_type
val naturals_entry :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Unatural.t list
val natural_vector_entry :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Unatural.t list
val horizontal_alignment_entry :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Mdl_ast.horizontal_alignment
val vertical_alignment_entry :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Mdl_ast.vertical_alignment
val integer_matrix_entry :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Mdl_ast.integer_matrix
val block_sid_value_entry :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Mdl_ast.block_sid
val slx_port_connector_entry :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Mdl_ast.block_sid * Mdl_ast.port_value
val vendor_configuration_longident_entry :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Mdl_ast.vendor_ident * Mdl_ast.configuration_longident
val workspace_data_source_type_entry :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Mdl_ast.workspace_data_source_type
val custom_property_type_entry :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Mdl_ast.custom_property_type
val intersection_entry :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Mdl_ast.stateflow_numbers
