(***********************************************************************)
(*                                                                     *)
(*                               Simport                               *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2010-2019,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* $Id: main.ml,v 1.1 2019-05-10 14:04:02 jpc Exp $ *)

let treat_file ppf fname =
  let efname = Path.find fname in
  let get_token = Mdl_to_tokens.read_mdl_file efname in
  let rec loop i =
    let lexem = get_token () in
    Format.fprintf ppf "lexem %d : %a@."
      i Mdl_lex_pprint.print_lexem lexem;
    loop (i + 1) in
  try loop 1 with
  | End_of_file -> ()
;;

let main ppf = Main_gen.do_phase "lex" (treat_file ppf);;

main Format.std_formatter;;

(*
 Local Variables:
  compile-command: "make"
  End:
*)
