(***********************************************************************)
(*                                                                     *)
(*                               Simport                               *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2010-2019,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* $Id: main.ml,v 1.1 2019-05-10 14:04:02 jpc Exp $ *)

let treat_file ppf fname =
  let efname = Path.find fname in
  let ast = Mdl_to_ast.read_mdl_file efname in
  Format.fprintf ppf "%a@." Mdl_ast_print.print_simulink_file ast
;;

let main ppf = Main_gen.do_phase "lex" (treat_file ppf);;

main Format.std_formatter;;

(*
 Local Variables:
  compile-command: "make"
  End:
*)
