#!/bin/sh -e

#######################################################################
#                                                                     #
#                           Simport                                   #
#                                                                     #
#          Clement Franchini, INRIA Rocquencourt                      #
#                                                                     #
#  Copyright 2013-2015,                                               #
#  Institut National de Recherche en Informatique et en Automatique.  #
#  All rights reserved.                                               #
#                                                                     #
#  This file is distributed under the terms of the BSD License.       #
#                                                                     #
#######################################################################

# $Id: generate_htmldoc.sh,v 1.1 2019-05-10 14:04:02 jpc Exp $

DUMPFILE=/tmp/dump
if [ -z "$HTMLDIR" ]
then
    HTMLDIR=autodoc/html
fi

if [ -z "$CAML_INCLUDES" ]
then
    echo "generate_htmldoc.sh: environment variable \
\"CAML_INCLUDES\" must be set" >&2
    false
fi

dirs="$CAML_INCLUDES"

# exclude_flags=""
# if [ -n "$EXCLUDED_DIRS" ]
# then
#     for dir in $EXCLUDED_DIRS;
#     do
#         exclude_flags="$exclude_flags -not -path */$dir/*"
#     done
# fi

rm -f $DUMPFILE
for file in \
    $(find . -type f -name '*.cmi' \
    -not -path '*/library-to-install/*' \
    -not -path '*/internal_libs/*');
do
    if [ -r $DUMPFILE ]
    then
        arg="-load $DUMPFILE"
    else
        arg=
    fi
    ml=${file%.*}.ml
    mli=${ml}i
    if [ -f $mli ]
    then
        docfile=$mli
    else
        docfile=$ml
    fi
    echo "generating doc of $docfile"
    ocamldoc $dirs $arg -sort -dump $DUMPFILE $docfile ||
    exit 1
done

echo "merging doc"
mkdir -p $HTMLDIR
rm -Rf $HTMLDIR/*
ocamldoc -load $DUMPFILE -html -d $HTMLDIR
rm -f $DUMPFILE
