(***********************************************************************)
(*                                                                     *)
(*                               Simport                               *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2010-2019,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* $Id: mbd_ast.mli,v 1.1 2019-05-10 13:58:20 jpc Exp $ *)

type operator_name = string;;
type label_name = string;;
type parameter_name = string;;
type variable_name = string;;

type expression =
   | E_number of string
   | E_string of string
   | E_variable of variable_name
   | E_uparameter_paren of expression
   | E_uparameter_bracket of expression
   | E_uparameter
   | E_parameter of parameter_name
   | E_unary_op of operator_name * expression
   | E_binary_op of operator_name * expression * expression
   | E_apply of expression * expression list
   | E_record_access of expression * label_name
   | E_paren of expression
;;

(*
 Local Variables:
  compile-command: "cd ../..; make"
  End:
*)
