(***********************************************************************)
(*                                                                     *)
(*                               Simport                               *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2010-2019,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* $Id: mbd_deep_ast.mli,v 1.1 2019-05-10 13:58:20 jpc Exp $ *)

type parameter = int
;;

type expression =
   | D_number of string
   | D_string of string
   | D_variable of Mbd_predef.global
   | D_uparameter_paren of expression
   | D_uparameter_bracket of expression
   | D_parameter of parameter

   | D_unary_op of Mbd_predef.unary_op * expression
   | D_binary_op of Mbd_predef.binary_op * expression * expression

   | D_unary_prim of Mbd_predef.unary_prim * expression
   | D_binary_prim of Mbd_predef.binary_prim * expression * expression

   | D_apply of expression * expression list
   | D_record_access of expression * Mbd_ast.label_name
   | D_paren of expression
;;

(*
 Local Variables:
  compile-command: "cd ../..; make"
  End:
*)
