(***********************************************************************)
(*                                                                     *)
(*                               Simport                               *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2010-2019,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* $Id: mbd_predefined.mli,v 1.1 2019-05-10 13:58:20 jpc Exp $ *)

val unary_op_of_string : Mbd_ast.operator_name -> Mbd_predef.unary_op
;;
val string_of_unary_op : Mbd_predef.unary_op -> Mbd_ast.operator_name
;;

val unary_prim_of_string : Mbd_ast.operator_name -> Mbd_predef.unary_prim
;;
val string_of_unary_prim : Mbd_predef.unary_prim -> Mbd_ast.operator_name
;;

val binary_op_of_string : Mbd_ast.operator_name -> Mbd_predef.binary_op
;;
val string_of_binary_op : Mbd_predef.binary_op -> Mbd_ast.operator_name
;;

val binary_prim_of_string : Mbd_ast.operator_name -> Mbd_predef.binary_prim
;;
val string_of_binary_prim : Mbd_predef.binary_prim -> Mbd_ast.operator_name
;;

val global_of_string : Mbd_ast.variable_name -> Mbd_predef.global;;

val string_of_global : Mbd_predef.global -> string;;

(*
 Local Variables:
  compile-command: "cd ../..; make"
  End:
*)
