(***********************************************************************)
(*                                                                     *)
(*                               Simport                               *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2010-2019,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* $Id: mbd_to_target.mli,v 1.1 2019-05-10 13:58:20 jpc Exp $ *)

(** The procedures to translate Simulink embedded expressions to Scicos expressions. *)

val print : Format.formatter -> Path.explicit_file_name -> unit
(** Reads a Simulink embedded expression file, translates it to the target
  language, and prints the translation onto the formatter argument. *)
;;

val translate_string : string -> string
(** Reads a string that contains a Simulink embedded expression and
    returns its translation to the target_language as a string. *)
;;

(*
 Local Variables:
  compile-command: "cd ../..; make"
  End:
*)
