(***********************************************************************)
(*                                                                     *)
(*                               Simport                               *)
(*                                                                     *)
(*                   Pierre Weis, Clément Franchini                    *)
(*                   INRIA Rocquencourt                                *)
(*                                                                     *)
(*  Copyright 2013-2019,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* $Id: slx_to_xml_deep_ast.ml,v 1.1 2019-05-10 14:00:16 jpc Exp $ *)

let read_xml_file efname =
  let xml_model = Slx_to_xml_ast.read_xml_file efname in
  Say.debug (Printf.sprintf "slx: parsing phase done");
  Xml_ast_to_xml_deep_ast.xml_ast_to_xml_deep_ast xml_model
;;

let read_slx_file efname =
  let xml_document = Slx_to_xml_ast.read_slx_file efname in
  Say.debug (Printf.sprintf "slx: parsing phase done");
  Xml_ast_to_xml_deep_ast.xml_ast_to_xml_deep_ast xml_document
;;

(*
 Local Variables:
  compile-command: "cd ../../..; make"
 End:
*)
