(***********************************************************************)
(*                                                                     *)
(*                               Simport                               *)
(*                                                                     *)
(*                   Pierre Weis, Clément Franchini                    *)
(*                   INRIA Rocquencourt                                *)
(*                                                                     *)
(*  Copyright 2013-2019,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.5+dev0 generated code. *)

let printer_text ctx ppf = function
  | s -> Og_printer.printer_String ctx ppf s
;;

let printer_encoding ctx ppf = function
  | s -> Og_printer.printer_String ctx ppf s
;;

let printer_attribute_name ctx ppf = function
  | s -> Og_printer.printer_String ctx ppf s

and printer_element_name ctx ppf = function
  | s -> Og_printer.printer_String ctx ppf s
;;

let printer_char_data ctx ppf = function | t -> printer_text ctx ppf t

and printer_attribute_value ctx ppf = function
  | s -> Og_printer.printer_String ctx ppf s
;;

let rec printer_deep_attribute ctx ppf = function
  | { Xml_deep_ast.da_name = a; Xml_deep_ast.da_value = a0; } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Xml_deep_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>da_name =";
    printer_attribute_name Og_precedence.Ck_record_field ppf a;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>da_value =";
    printer_attribute_value Og_precedence.Ck_record_field ppf a0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"

and printer_deep_attributes ctx ppf = function
  | d_l -> Og_printer.printer_List printer_deep_attribute ctx ppf d_l
;;

let rec printer_deep_child ctx ppf = function
  | c_d_i_s ->
    Intercal_print.printer_sum printer_char_data printer_deep_element
      ctx
      ppf
      c_d_i_s

and printer_deep_children ctx ppf = function
  | d_l -> Og_printer.printer_List printer_deep_child ctx ppf d_l

and printer_deep_element ctx ppf = function
  | {
      Xml_deep_ast.de_name = e;
      Xml_deep_ast.de_attributes = d;
      Xml_deep_ast.de_children = d0;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Xml_deep_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>de_name =";
    printer_element_name Og_precedence.Ck_record_field ppf e;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>de_attributes =";
    printer_deep_attributes Og_precedence.Ck_record_field ppf d;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>de_children =";
    printer_deep_children Og_precedence.Ck_record_field ppf d0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let printer_deep_document ctx ppf = function
  | { Xml_deep_ast.deep_prolog = e_o; Xml_deep_ast.deep_element = d; } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Xml_deep_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>deep_prolog =";
    Og_printer.printer_Option printer_encoding
      Og_precedence.Ck_record_field
      ppf
      e_o;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_element =";
    printer_deep_element Og_precedence.Ck_record_field ppf d;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let printer_deep_annex_name ctx ppf = function
  | Xml_deep_ast.Deep_block_diagram_defaults ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Xml_deep_ast.Deep_block_diagram_defaults"
  | Xml_deep_ast.Deep_config_set_info ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Xml_deep_ast.Deep_config_set_info"
  | Xml_deep_ast.Deep_graphical_interface ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Xml_deep_ast.Deep_graphical_interface"
  | Xml_deep_ast.Deep_stateflow ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Xml_deep_ast.Deep_stateflow"
  | Xml_deep_ast.Deep_annex_file_name p_f ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_deep_ast.Deep_annex_file_name";
    Path_print.printer_file_name Og_precedence.Ck_argument ppf p_f;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let printer_deep_annex ctx ppf = function
  | (d, d0) ->
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ "
      else
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_tuple_item then
      Format.fprintf ppf "%,@[<hv 2>(@,";
    Format.fprintf ppf "%,@[<hv 0>";
    printer_deep_annex_name Og_precedence.Ck_tuple_item ppf d;
    Format.fprintf ppf "%,,@ ";
    printer_deep_document Og_precedence.Ck_tuple_item ppf d0;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
      else
    if ctx = Og_precedence.Ck_tuple_item then
      Format.fprintf ppf "%,@;<0 -2>)@]"
;;

let printer_deep_annexes ctx ppf = function
  | d_l -> Og_printer.printer_List printer_deep_annex ctx ppf d_l
;;

let printer_xml_deep_model ctx ppf = function
  | {
      Xml_deep_ast.deep_model_ident = m_m;
      Xml_deep_ast.deep_blockdiagram = d;
      Xml_deep_ast.deep_annexes = d0;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Xml_deep_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>deep_model_ident =";
    Mdl_ast_print.printer_model_ident Og_precedence.Ck_record_field ppf m_m;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_blockdiagram =";
    printer_deep_document Og_precedence.Ck_record_field ppf d;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>deep_annexes =";
    printer_deep_annexes Og_precedence.Ck_record_field ppf d0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

(* Defining top printers. *)

let print_text ppf = printer_text Og_precedence.Ck_toplevel ppf
;;

let print_encoding ppf = printer_encoding Og_precedence.Ck_toplevel ppf
;;

let print_attribute_name ppf =
  printer_attribute_name Og_precedence.Ck_toplevel ppf

and print_element_name ppf =
  printer_element_name Og_precedence.Ck_toplevel ppf
;;

let print_char_data ppf = printer_char_data Og_precedence.Ck_toplevel ppf

and print_attribute_value ppf =
  printer_attribute_value Og_precedence.Ck_toplevel ppf
;;

let print_deep_attribute ppf =
  printer_deep_attribute Og_precedence.Ck_toplevel ppf

and print_deep_attributes ppf =
  printer_deep_attributes Og_precedence.Ck_toplevel ppf
;;

let print_deep_child ppf = printer_deep_child Og_precedence.Ck_toplevel ppf

and print_deep_children ppf =
  printer_deep_children Og_precedence.Ck_toplevel ppf

and print_deep_element ppf =
  printer_deep_element Og_precedence.Ck_toplevel ppf
;;

let print_deep_document ppf =
  printer_deep_document Og_precedence.Ck_toplevel ppf
;;

let print_deep_annex_name ppf =
  printer_deep_annex_name Og_precedence.Ck_toplevel ppf
;;

let print_deep_annex ppf = printer_deep_annex Og_precedence.Ck_toplevel ppf
;;

let print_deep_annexes ppf =
  printer_deep_annexes Og_precedence.Ck_toplevel ppf
;;

let print_xml_deep_model ppf =
  printer_xml_deep_model Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.5+dev0 generated code. *)
