(***********************************************************************)
(*                                                                     *)
(*                         The CamlZip library                         *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2001 Institut National de Recherche en Informatique et   *)
(*  en Automatique.  All rights reserved.  This file is distributed    *)
(*  under the terms of the GNU Library General Public License, with    *)
(*  the special exception on linking described in file LICENSE.        *)
(*                                                                     *)
(***********************************************************************)

(* $Id: zip_lib_string.ml,v 1.1 2019-05-10 14:00:17 jpc Exp $ *)

(* Module [Zip_lib_string]: external (non deprecated) primitives for
  strings. *)

external set : string -> int -> char -> unit = "%string_safe_set";;

external create : int -> string = "caml_create_string";;

external blit :
  string -> int -> string -> int -> int -> unit =
  "caml_blit_string"
(*
  [@@noalloc]
  Old version was  "noalloc"
  New version is [@@noalloc]
We do not mention it for sake of portability with older versions of OCaml.
*)
;;

let input ic (s : string) i n =
  Pervasives.input ic (Obj.magic s) i n
;;
let really_input ic (s : string) i n =
  Pervasives.really_input ic (Obj.magic s) i n
;;

let output oc (s : string) i n =
  Pervasives.output oc (Obj.magic s) i n
;;
