(***********************************************************************)
(*                                                                     *)
(*                              OCamlGen                               *)
(*                                                                     *)
(*                       OCaml module Generator                        *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 1997-2018 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Clement Franchini <Clement.Franchini@inria.fr>                     *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.0+dev0 generated code. *)

let printer_xml_position ctx ppf = function
  | {
      Lexing.pos_fname = s;
      Lexing.pos_lnum = i;
      Lexing.pos_bol = i0;
      Lexing.pos_cnum = i1;
    } ->
    ignore ctx; Format.fprintf ppf "%,@[<hv 2><record>@,";
    Format.fprintf ppf "%,@[<hv 2><pos_fname>@,";
    Og_printer_xml.printer_xml_String Og_precedence.Ck_record_field ppf s;
    Format.fprintf ppf "%,@;<0 -2></pos_fname>@]"; Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><pos_lnum>@,";
    Og_printer_xml.printer_xml_Int Og_precedence.Ck_record_field ppf i;
    Format.fprintf ppf "%,@;<0 -2></pos_lnum>@]"; Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><pos_bol>@,";
    Og_printer_xml.printer_xml_Int Og_precedence.Ck_record_field ppf i0;
    Format.fprintf ppf "%,@;<0 -2></pos_bol>@]"; Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><pos_cnum>@,";
    Og_printer_xml.printer_xml_Int Og_precedence.Ck_record_field ppf i1;
    Format.fprintf ppf "%,@;<0 -2></pos_cnum>@]";
    Format.fprintf ppf "%,@;<0 -2></record>@]"
;;

let rec printer_xml_lexbuf ctx ppf = function
  | {
      Lexing.refill_buff = f_l_u;
      Lexing.lex_buffer = b;
      Lexing.lex_buffer_len = i;
      Lexing.lex_abs_pos = i0;
      Lexing.lex_start_pos = i1;
      Lexing.lex_curr_pos = i2;
      Lexing.lex_last_pos = i3;
      Lexing.lex_last_action = i4;
      Lexing.lex_eof_reached = b0;
      Lexing.lex_mem = i_a;
      Lexing.lex_start_p = p;
      Lexing.lex_curr_p = p0;
    } ->
    ignore ctx; Format.fprintf ppf "%,@[<hv 2><record>@,";
    Format.fprintf ppf "%,@[<hv 2><refill_buff>@,";
    Og_printer_xml.printer_xml_Fun
      printer_xml_lexbuf
      Og_printer_xml.printer_xml_Unit
      Og_precedence.Ck_record_field
      ppf
      f_l_u;
    Format.fprintf ppf "%,@;<0 -2></refill_buff>@]";
    Format.fprintf ppf "%,@,"; Format.fprintf ppf "%,@[<hv 2><lex_buffer>@,";
    Og_printer_xml.printer_xml_Bytes Og_precedence.Ck_record_field ppf b;
    Format.fprintf ppf "%,@;<0 -2></lex_buffer>@]";
    Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><lex_buffer_len>@,";
    Og_printer_xml.printer_xml_Int Og_precedence.Ck_record_field ppf i;
    Format.fprintf ppf "%,@;<0 -2></lex_buffer_len>@]";
    Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><lex_abs_pos>@,";
    Og_printer_xml.printer_xml_Int Og_precedence.Ck_record_field ppf i0;
    Format.fprintf ppf "%,@;<0 -2></lex_abs_pos>@]";
    Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><lex_start_pos>@,";
    Og_printer_xml.printer_xml_Int Og_precedence.Ck_record_field ppf i1;
    Format.fprintf ppf "%,@;<0 -2></lex_start_pos>@]";
    Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><lex_curr_pos>@,";
    Og_printer_xml.printer_xml_Int Og_precedence.Ck_record_field ppf i2;
    Format.fprintf ppf "%,@;<0 -2></lex_curr_pos>@]";
    Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><lex_last_pos>@,";
    Og_printer_xml.printer_xml_Int Og_precedence.Ck_record_field ppf i3;
    Format.fprintf ppf "%,@;<0 -2></lex_last_pos>@]";
    Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><lex_last_action>@,";
    Og_printer_xml.printer_xml_Int Og_precedence.Ck_record_field ppf i4;
    Format.fprintf ppf "%,@;<0 -2></lex_last_action>@]";
    Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><lex_eof_reached>@,";
    Og_printer_xml.printer_xml_Bool Og_precedence.Ck_record_field ppf b0;
    Format.fprintf ppf "%,@;<0 -2></lex_eof_reached>@]";
    Format.fprintf ppf "%,@,"; Format.fprintf ppf "%,@[<hv 2><lex_mem>@,";
    Og_printer_xml.printer_xml_Array Og_printer_xml.printer_xml_Int
      Og_precedence.Ck_record_field
      ppf
      i_a;
    Format.fprintf ppf "%,@;<0 -2></lex_mem>@]"; Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><lex_start_p>@,";
    printer_xml_position Og_precedence.Ck_record_field ppf p;
    Format.fprintf ppf "%,@;<0 -2></lex_start_p>@]";
    Format.fprintf ppf "%,@,"; Format.fprintf ppf "%,@[<hv 2><lex_curr_p>@,";
    printer_xml_position Og_precedence.Ck_record_field ppf p0;
    Format.fprintf ppf "%,@;<0 -2></lex_curr_p>@]";
    Format.fprintf ppf "%,@;<0 -2></record>@]"
;;

let printer_xml_lex_tables ctx ppf = function
  | {
      Lexing.lex_base = s;
      Lexing.lex_backtrk = s0;
      Lexing.lex_default = s1;
      Lexing.lex_trans = s2;
      Lexing.lex_check = s3;
      Lexing.lex_base_code = s4;
      Lexing.lex_backtrk_code = s5;
      Lexing.lex_default_code = s6;
      Lexing.lex_trans_code = s7;
      Lexing.lex_check_code = s8;
      Lexing.lex_code = s9;
    } ->
    ignore ctx; Format.fprintf ppf "%,@[<hv 2><record>@,";
    Format.fprintf ppf "%,@[<hv 2><lex_base>@,";
    Og_printer_xml.printer_xml_String Og_precedence.Ck_record_field ppf s;
    Format.fprintf ppf "%,@;<0 -2></lex_base>@]"; Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><lex_backtrk>@,";
    Og_printer_xml.printer_xml_String Og_precedence.Ck_record_field ppf s0;
    Format.fprintf ppf "%,@;<0 -2></lex_backtrk>@]";
    Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><lex_default>@,";
    Og_printer_xml.printer_xml_String Og_precedence.Ck_record_field ppf s1;
    Format.fprintf ppf "%,@;<0 -2></lex_default>@]";
    Format.fprintf ppf "%,@,"; Format.fprintf ppf "%,@[<hv 2><lex_trans>@,";
    Og_printer_xml.printer_xml_String Og_precedence.Ck_record_field ppf s2;
    Format.fprintf ppf "%,@;<0 -2></lex_trans>@]"; Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><lex_check>@,";
    Og_printer_xml.printer_xml_String Og_precedence.Ck_record_field ppf s3;
    Format.fprintf ppf "%,@;<0 -2></lex_check>@]"; Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><lex_base_code>@,";
    Og_printer_xml.printer_xml_String Og_precedence.Ck_record_field ppf s4;
    Format.fprintf ppf "%,@;<0 -2></lex_base_code>@]";
    Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><lex_backtrk_code>@,";
    Og_printer_xml.printer_xml_String Og_precedence.Ck_record_field ppf s5;
    Format.fprintf ppf "%,@;<0 -2></lex_backtrk_code>@]";
    Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><lex_default_code>@,";
    Og_printer_xml.printer_xml_String Og_precedence.Ck_record_field ppf s6;
    Format.fprintf ppf "%,@;<0 -2></lex_default_code>@]";
    Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><lex_trans_code>@,";
    Og_printer_xml.printer_xml_String Og_precedence.Ck_record_field ppf s7;
    Format.fprintf ppf "%,@;<0 -2></lex_trans_code>@]";
    Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><lex_check_code>@,";
    Og_printer_xml.printer_xml_String Og_precedence.Ck_record_field ppf s8;
    Format.fprintf ppf "%,@;<0 -2></lex_check_code>@]";
    Format.fprintf ppf "%,@,"; Format.fprintf ppf "%,@[<hv 2><lex_code>@,";
    Og_printer_xml.printer_xml_String Og_precedence.Ck_record_field ppf s9;
    Format.fprintf ppf "%,@;<0 -2></lex_code>@]";
    Format.fprintf ppf "%,@;<0 -2></record>@]"
;;

(* Defining top printers. *)

let print_xml_position ppf =
  printer_xml_position Og_precedence.Ck_toplevel ppf
;;

let print_xml_lexbuf ppf = printer_xml_lexbuf Og_precedence.Ck_toplevel ppf
;;

let print_xml_lex_tables ppf =
  printer_xml_lex_tables Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.0+dev0 generated code. *)
