(***********************************************************************)
(*                                                                     *)
(*                          Ocaml-xml Library                          *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2013-2018,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* $Id: uarray.ml,v 1.1 2019-05-10 14:00:49 jpc Exp $ *)

let fold_map f env a =
  let env, l = Ulist.fold_map f env (Array.to_list a) in
  env, Array.of_list l
;;

let split a =
  let len = Array.length a in
  Array.init len (fun i -> fst a.(i)),
  Array.init len (fun i -> snd a.(i))
;;

let combine a1 a2 =
  let len1 = Array.length a1 in
  let len2 = Array.length a2 in
  if len1 <> len2 then
    invalid_arg "Uarray.combine: arrays of different lengths";
  Array.init len1 (fun i -> a1.(i), a2.(i))
;;

(*
 Local Variables:
  compile-command: "cd ../..; make"
  End:
*)
