(***********************************************************************)
(*                                                                     *)
(*                          Ocaml-xml Library                          *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2013-2018,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* $Id: ulist.ml,v 1.1 2019-05-10 14:00:49 jpc Exp $ *)

type 'a t = 'a list;;

let rev_flat_map_end f l raccu =
  List.fold_left
     (fun accu l -> List.rev_append (f l) accu)
     raccu
    l
;;

let rev_flat_map f l = rev_flat_map_end f l [];;

let flat_map f l = List.rev (rev_flat_map f l);;

let fold_map f env l =
  let env, l =
    List.fold_left
      (fun (env, accu) x ->
       let env, x = f env x in
       env, x :: accu)
      (env, []) l in
  env, List.rev l
;;

let rev_fold_flat_map_end f env l raccu =
  List.fold_left
    (fun (env, raccu) x ->
     let env, lres = f env x in
     env, List.rev_append lres raccu)
    (env, raccu) l
;;

let rev_fold_flat_map f env l = rev_fold_flat_map_end f env l [];;

let fold_flat_map f env l =
  let env, l = rev_fold_flat_map f env l in
  env, List.rev l
;;

(*

let map_fold_flat f env l more =
  let env, l, more =
    List.fold_left
      (fun (env, accu, more_accu) x ->
       let env, (x, more) = f env x in
       env, x :: accu, List.rev_append more more_accu)
      (env, [], more) l in
  env, (List.rev l, List.rev more)
;;

let array_fold_map f (env, v) =
  let env, l = fold_map f (env, Array.to_list v) in
  env, Array.of_list l
;;

*)

(*
 Local Variables:
  compile-command: "cd ../..; make"
  End:
*)
