(***********************************************************************)
(*                                                                     *)
(*                          Ocaml-xml Library                          *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2013-2018,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* $Id: umarshal.ml,v 1.1 2019-05-10 14:00:49 jpc Exp $ *)

(** Additional functions for module Marshal. *)

(** Reading/Writing files with marshalled values. *)
let of_to_file () =
  (fun fname ->
    Path.with_explicit_in_file_bin fname
      (fun ic -> Marshal.from_channel ic)),
  (fun fname ast ->
    Path.with_explicit_out_file_bin fname
      (fun oc -> Marshal.to_channel oc ast []))
;;

let read_write_file = of_to_file;;

(*
 Local Variables:
  compile-command: "cd ../..; make"
  End:
*)
