(***********************************************************************)
(*                                                                     *)
(*                          Ocaml-xml Library                          *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2013-2018,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* $Id: unatural_types.ml,v 1.1 2019-05-10 14:00:49 jpc Exp $ *)

(* The private type of natural numbers. *)

let natural_failwith fun_name msg =
  failwith (Printf.sprintf "Unatural.%s: %s" fun_name msg)
;;

type natural = int;;

let to_natural i =
  if i < 0 then natural_failwith "of_int" "negative argument" else i
;;

external of_natural : natural -> int = "%identity";;

(*
 Local Variables:
  compile-command: "cd ../..; make"
  End:
*)
