(***********************************************************************)
(*                                                                     *)
(*                          Ocaml-xml Library                          *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2013-2018,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* $Id: xml.ml,v 1.1 2019-05-10 14:02:41 jpc Exp $ *)

let read_xml_file = Xml_to_ast.read_xml_file;;

(* module EntityName = Xml_expand.EntityName;; *)
(* module Env = Xml_env.Expand_env;; *)

type raw_document = Xml_ast.raw_document;;
type document = Xml_expand.document;;

let of_document = Xml_expand.of_document;;
let to_document = Xml_expand.to_document;;

let raw_parse = read_xml_file;;

let expand = to_document;;

let parse fname =
  let raw_document = raw_parse fname in
  to_document raw_document
;;

let print_raw_document = Xml_ast_print.print_raw_document;;
let print_document ppf document =
  let raw_document = of_document document in
  print_raw_document ppf raw_document
;;

(*

 Local Variables:
  compile-command: "cd ../..; make"
  End:

*)
