(***********************************************************************)
(*                                                                     *)
(*                          Ocaml-xml Library                          *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2013-2018,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* $Id: xml_parser_error.mli,v 1.1 2019-05-10 14:00:50 jpc Exp $ *)

type error =
   | Invalid_xml_name of string
   | Invalid_closing_tag of Xml_basics_ast.tag_name * Xml_basics_ast.tag_name
   | Invalid_att_type of Xml_basics_ast.nm_token
   | Invalid_content_spec of Xml_basics_ast.nm_token
   | Invalid_entity_value of Xml_basics_ast.att_value * string
(** The various errors when parsing. *)
;;

exception Error of error * Lexing.position * Lexing.position;;

(** {6 Explaining parsing errors} *)

val report_error : Format.formatter -> error -> unit;;

(*
 Local Variables:
  compile-command: "cd ../../..; make"
 End:
*)
