(***********************************************************************)
(*                                                                     *)
(*                          Ocaml-xml Library                          *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2013-2018,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* $Id: xml_say.ml,v 1.1 2019-05-10 14:00:17 jpc Exp $ *)

type message = string
;;

let fdebug f =
  if Xml_configuration.get_debug () then
    Format.fprintf Format.err_formatter
      "%s debug: %a@."
      (Xml_configuration.get_library_name ())
      (fun ppf () -> f ppf) ()
;;

let debug s = fdebug (fun ppf -> Format.fprintf ppf "%s" s);;

let warning s =
  if Xml_configuration.get_warnings () then
  prerr_endline (
    Printf.sprintf "%s warning: %s"
      (Xml_configuration.get_library_name ()) s
  )
;;

let fatal_error s =
  raise (Xml_configuration.Error (Xml_configuration.Fatal_error s))
;;

(*
 Local Variables:
  compile-command: "cd ../..; make"
  End:
*)
