(***********************************************************************)
(*                                                                     *)
(*                           ScicosLab                                 *)
(*                                                                     *)
(*          Pierre Weis, INRIA Rocquencourt                            *)
(*                                                                     *)
(*  Copyright 2010-2013,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* $Id: uname_pprint.mli,v 1.1 2019-05-10 14:00:49 jpc Exp $ *)

val pprint_t : Format.formatter -> Uname.t -> unit
(** [pprint_t ppf uname] prints into [ppf] the identifier part of unique name
  [uname]. *)
;;

val pprint_full_t : Format.formatter -> Uname.t -> unit
(** [pprint_full_t ppf uname] prints into [ppf] the unique name [uname].
  In the output, the identifier part and id parts of [uname] are separated
  with a ['_'] character. *)
;;

(*
 Local Variables:
  compile-command: "cd ../..; make"
  End:
*)
