(***********************************************************************)
(*                                                                     *)
(*                          Ocaml-xml Library                          *)
(*                                                                     *)
(*                   Pierre Weis, INRIA Rocquencourt                   *)
(*                                                                     *)
(*  Copyright 2013-2018,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* $Id: xml_configuration.mli,v 1.1 2019-05-10 14:00:17 jpc Exp $ *)

type error =
   | Fatal_error of string
;;

exception Error of error;;

val report_error : Format.formatter -> error -> unit
;;

val print_version : Ocamlxml_configuration.version -> unit;;

val set_verbose : unit -> unit;;
val get_verbose : unit -> bool;;

val set_debug : unit -> unit;;
val get_debug : unit -> bool;;

val set_no_warnings : unit -> unit;;
val get_no_warnings : unit -> bool;;

val set_warnings : unit -> unit;;
val get_warnings : unit -> bool;;

val set_parsing_debug : unit -> unit;;

val get_library_name : unit -> string;;
val get_library_version : unit -> Ocamlxml_configuration.version;;

(*
 Local Variables:
  compile-command: "cd ../..; make"
  End:
*)
