(***********************************************************************)
(*                                                                     *)
(*                              OCamlGen                               *)
(*                                                                     *)
(*                       OCaml module Generator                        *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 1997-2018 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Clement Franchini <Clement.Franchini@inria.fr>                     *)
(*                                                                     *)
(***********************************************************************)

(* $Id: lazy_print_xml.ml,v 1.1 2019-05-10 14:02:41 jpc Exp $ *)

let printer_xml_t px_a ctx ppf a =
  let px_a ctx ppf a =
    if Lazy.is_val a then
      px_a ctx ppf (Lazy.force a)
    else
      Og_printer_xml.printer_xml_Lazy ctx ppf () in
  ignore ctx; Format.fprintf ppf "%,@[<hv 2><constructor>@,";
  Format.fprintf ppf "%,@[<hv 2><lident>@,"; Format.fprintf ppf "%,lazy";
  Format.fprintf ppf "%,@;<0 -2></lident>@]"; Format.fprintf ppf "%,@,";
  px_a Og_precedence.Ck_argument ppf a;
  Format.fprintf ppf "%,@;<0 -2></constructor>@]"
;;

let print_xml_t pp_a =
  printer_xml_t pp_a Og_precedence.Ck_toplevel
;;
