(***********************************************************************)
(*                                                                     *)
(*                              OCamlGen                               *)
(*                                                                     *)
(*                       OCaml module Generator                        *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 1997-2018 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Clement Franchini <Clement.Franchini@inria.fr>                     *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 3.7+dev0 generated code. *)

let printer_enclosing_mode _ctx ppf = function
  | Og_precedence.Em_do_close ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field then
      Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Em_do_close"
  | Og_precedence.Em_tuple ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field then
      Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Em_tuple"
  | Og_precedence.Em_application ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field then
      Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Em_application"
  | Og_precedence.Em_do_not_close ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field then
      Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Em_do_not_close"
;;

let printer_context_kind _ctx ppf = function
  | Og_precedence.Ck_toplevel ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field then
      Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Og_precedence.Ck_toplevel"
  | Og_precedence.Ck_record_field ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field then
      Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Og_precedence.Ck_record_field"
  | Og_precedence.Ck_tuple_item ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field then
      Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Og_precedence.Ck_tuple_item"
  | Og_precedence.Ck_argument ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field then
      Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Og_precedence.Ck_argument"
;;

(* Defining top printers. *)

let print_enclosing_mode ppf = function
  | e -> printer_enclosing_mode Og_precedence.Ck_toplevel ppf e
;;

let print_context_kind ppf = function
  | c -> printer_context_kind Og_precedence.Ck_toplevel ppf c
;;

(* End of OCamlGen, 3.7+dev0 generated code. *)
