(* Beginning of OCamlGen, 4.5+dev0 generated code. *)

open Xml_basics_ast_print;;

let printer_space ctx ppf = function
  | s -> Og_printer.printer_String ctx ppf s
;;

let printer_comment ctx ppf = function
  | s -> Og_printer.printer_String ctx ppf s
;;

let printer_system_literal ctx ppf = function
  | s -> Og_printer.printer_String ctx ppf s
;;

let printer_pubid_literal ctx ppf = function
  | s -> Og_printer.printer_String ctx ppf s
;;

let printer_cdata ctx ppf = function
  | s -> Og_printer.printer_String ctx ppf s
;;

let printer_version_number ctx ppf = function
  | s -> Og_printer.printer_String ctx ppf s
;;

let printer_encoding_name ctx ppf = function
  | s -> Og_printer.printer_String ctx ppf s
;;

let printer_list2 pp_a ctx ppf = function
  | (a, a_u_t) ->
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ "
      else
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_tuple_item then
      Format.fprintf ppf "%,@[<hv 2>(@,";
    Format.fprintf ppf "%,@[<hv 0>"; pp_a Og_precedence.Ck_tuple_item ppf a;
    Format.fprintf ppf "%,,@ ";
    Ulist1_print.printer_t pp_a Og_precedence.Ck_tuple_item ppf a_u_t;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
      else
    if ctx = Og_precedence.Ck_tuple_item then
      Format.fprintf ppf "%,@;<0 -2>)@]"
;;

let rec printer_raw_document ctx ppf = function
  | { Xml_ast.prolog = p; Xml_ast.element = e; Xml_ast.misc_star = m; } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Xml_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>prolog =";
    printer_prolog Og_precedence.Ck_record_field ppf p;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>element =";
    printer_element Og_precedence.Ck_record_field ppf e;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>misc_star =";
    printer_misc_star Og_precedence.Ck_record_field ppf m;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"

and printer_prolog ctx ppf = function
  | {
      Xml_ast.xml_decl = x_o;
      Xml_ast.xml_misc_star = m;
      Xml_ast.xml_doc_type_decl = d_o;
      Xml_ast.xml_misc_star_trailing = m0;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Xml_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>xml_decl =";
    Og_printer.printer_Option printer_xml_decl
      Og_precedence.Ck_record_field
      ppf
      x_o;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>xml_misc_star =";
    printer_misc_star Og_precedence.Ck_record_field ppf m;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>xml_doc_type_decl =";
    Og_printer.printer_Option printer_doc_type_decl
      Og_precedence.Ck_record_field
      ppf
      d_o;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>xml_misc_star_trailing =";
    printer_misc_star Og_precedence.Ck_record_field ppf m0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"

and printer_xml_decl ctx ppf = function
  | {
      Xml_ast.xml_version_info = v;
      Xml_ast.xml_encoding_decl = e_o;
      Xml_ast.xml_standalone_decl = s_o;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Xml_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>xml_version_info =";
    printer_version_number Og_precedence.Ck_record_field ppf v;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>xml_encoding_decl =";
    Og_printer.printer_Option printer_encoding_name
      Og_precedence.Ck_record_field
      ppf
      e_o;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>xml_standalone_decl =";
    Og_printer.printer_Option printer_standalone_decl
      Og_precedence.Ck_record_field
      ppf
      s_o;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"

and printer_standalone_decl _ctx ppf = function
  | Xml_ast.Standalone ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Xml_ast.Standalone"
  | Xml_ast.Not_standalone ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Xml_ast.Not_standalone"

and printer_element ctx ppf = function
  | Xml_ast.Empty_element_tag t ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_ast.Empty_element_tag";
    printer_tag Og_precedence.Ck_argument ppf t; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Xml_ast.Content_element_tag (t, e) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_ast.Content_element_tag";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_tag Og_precedence.Ck_tuple_item ppf t;
    Format.fprintf ppf "%,,@ ";
    printer_element_content Og_precedence.Ck_tuple_item ppf e;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_tag ctx ppf = function
  | { Xml_ast.tag_name = t; Xml_ast.tag_attributes = t_l; } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Xml_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>tag_name =";
    printer_tag_name Og_precedence.Ck_record_field ppf t;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>tag_attributes =";
    Og_printer.printer_List printer_tag_attribute
      Og_precedence.Ck_record_field
      ppf
      t_l;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"

and printer_tag_attribute ctx ppf = function
  | { Xml_ast.tag_attribute_name = t; Xml_ast.tag_attribute_value = a; } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Xml_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>tag_attribute_name =";
    printer_tag_attribute_name Og_precedence.Ck_record_field ppf t;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>tag_attribute_value =";
    printer_att_value Og_precedence.Ck_record_field ppf a;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"

and printer_char_data ctx ppf = function
  | Xml_ast.Char_data c ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_ast.Char_data";
    printer_char_data_text Og_precedence.Ck_argument ppf c;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_element_content ctx ppf = function
  | Xml_ast.Element_content c_t_i_t ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_ast.Element_content";
    Intercal_print.printer_t printer_char_data printer_tag_child
      Og_precedence.Ck_argument
      ppf
      c_t_i_t;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_tag_child ctx ppf = function
  | Xml_ast.Child_element e ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_ast.Child_element";
    printer_element Og_precedence.Ck_argument ppf e;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Xml_ast.Child_cd_sect c ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_ast.Child_cd_sect";
    printer_cdata Og_precedence.Ck_argument ppf c; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Xml_ast.Child_pi p ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_ast.Child_pi";
    printer_pi Og_precedence.Ck_argument ppf p; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Xml_ast.Child_comment c ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_ast.Child_comment";
    printer_comment Og_precedence.Ck_argument ppf c;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Xml_ast.Child_reference r ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_ast.Child_reference";
    printer_reference Og_precedence.Ck_argument ppf r;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_misc_star ctx ppf = function
  | m_l -> Og_printer.printer_List printer_misc ctx ppf m_l

and printer_misc ctx ppf = function
  | Xml_ast.Misc_comment c ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_ast.Misc_comment";
    printer_comment Og_precedence.Ck_argument ppf c;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Xml_ast.Misc_pi p ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_ast.Misc_pi";
    printer_pi Og_precedence.Ck_argument ppf p; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Xml_ast.Misc_space s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_ast.Misc_space";
    printer_space Og_precedence.Ck_argument ppf s; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_pi ctx ppf = function
  | { Xml_ast.pi_target = p; Xml_ast.pi_instructions = x_p; } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Xml_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>pi_target =";
    printer_pi_target Og_precedence.Ck_record_field ppf p;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>pi_instructions =";
    Xml_basics_ast_print.printer_pi_instructions
      Og_precedence.Ck_record_field
      ppf
      x_p;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"

and printer_doc_type_decl ctx ppf = function
  | {
      Xml_ast.doctype_name = t;
      Xml_ast.external_id = e_o;
      Xml_ast.int_subset = i_o;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Xml_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>doctype_name =";
    printer_tag_name Og_precedence.Ck_record_field ppf t;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>external_id =";
    Og_printer.printer_Option printer_external_id
      Og_precedence.Ck_record_field
      ppf
      e_o;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>int_subset =";
    Og_printer.printer_Option printer_int_subset
      Og_precedence.Ck_record_field
      ppf
      i_o;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"

and printer_external_id ctx ppf = function
  | Xml_ast.System s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_ast.System";
    printer_system_literal Og_precedence.Ck_argument ppf s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Xml_ast.Public (p, s) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_ast.Public";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_pubid_literal Og_precedence.Ck_tuple_item ppf p;
    Format.fprintf ppf "%,,@ ";
    printer_system_literal Og_precedence.Ck_tuple_item ppf s;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_public_id ctx ppf = function
  | p -> printer_pubid_literal ctx ppf p

and printer_int_subset ctx ppf = function
  | i_l -> Og_printer.printer_List printer_int_subset_elem ctx ppf i_l

and printer_int_subset_elem ctx ppf = function
  | Xml_ast.Markup_decl m ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_ast.Markup_decl";
    printer_markup_decl Og_precedence.Ck_argument ppf m;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Xml_ast.Sep_decl s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_ast.Sep_decl";
    printer_sep_decl Og_precedence.Ck_argument ppf s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_sep_decl ctx ppf = function
  | Xml_ast.Pe_reference_decl e ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_ast.Pe_reference_decl";
    printer_entity_name Og_precedence.Ck_argument ppf e;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Xml_ast.Space_decl s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_ast.Space_decl";
    printer_space Og_precedence.Ck_argument ppf s; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_notation_id ctx ppf = function
  | Xml_ast.External_id e ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_ast.External_id";
    printer_external_id Og_precedence.Ck_argument ppf e;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Xml_ast.Public_id p ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_ast.Public_id";
    printer_public_id Og_precedence.Ck_argument ppf p;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_markup_decl ctx ppf = function
  | Xml_ast.Element_decl (t, c) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_ast.Element_decl";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_tag_name Og_precedence.Ck_tuple_item ppf t;
    Format.fprintf ppf "%,,@ ";
    printer_content_spec Og_precedence.Ck_tuple_item ppf c;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Xml_ast.Attlist_decl (t, a_l) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_ast.Attlist_decl";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_tag_attribute_name Og_precedence.Ck_tuple_item ppf t;
    Format.fprintf ppf "%,,@ ";
    Og_printer.printer_List printer_att_def
      Og_precedence.Ck_tuple_item
      ppf
      a_l;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Xml_ast.Entity_decl e ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_ast.Entity_decl";
    printer_entity_decl Og_precedence.Ck_argument ppf e;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Xml_ast.Notation_decl (n, n0) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_ast.Notation_decl";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_notation_name Og_precedence.Ck_tuple_item ppf n;
    Format.fprintf ppf "%,,@ ";
    printer_notation_id Og_precedence.Ck_tuple_item ppf n0;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Xml_ast.Pi_decl p ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_ast.Pi_decl";
    printer_pi Og_precedence.Ck_argument ppf p; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Xml_ast.Comment_decl c ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_ast.Comment_decl";
    printer_comment Og_precedence.Ck_argument ppf c;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_att_def ctx ppf = function
  | {
      Xml_ast.att_def_name = t;
      Xml_ast.att_def_type = a;
      Xml_ast.att_def_default = a0;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Xml_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>att_def_name =";
    printer_tag_attribute_name Og_precedence.Ck_record_field ppf t;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>att_def_type =";
    printer_att_type Og_precedence.Ck_record_field ppf a;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>att_def_default =";
    printer_att_default Og_precedence.Ck_record_field ppf a0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"

and printer_att_type ctx ppf = function
  | Xml_ast.String_type ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Xml_ast.String_type"
  | Xml_ast.Tokenized_type t ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_ast.Tokenized_type";
    printer_tokenized_type Og_precedence.Ck_argument ppf t;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Xml_ast.Enumerated_type e ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_ast.Enumerated_type";
    printer_enumerated_type Og_precedence.Ck_argument ppf e;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_tokenized_type _ctx ppf = function
  | Xml_ast.Id_type ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Xml_ast.Id_type"
  | Xml_ast.Idref_type ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Xml_ast.Idref_type"
  | Xml_ast.Idrefs_type ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Xml_ast.Idrefs_type"
  | Xml_ast.Entity_type ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Xml_ast.Entity_type"
  | Xml_ast.Entities_type ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Xml_ast.Entities_type"
  | Xml_ast.Nmtoken_type ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Xml_ast.Nmtoken_type"
  | Xml_ast.Nmtokens_type ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Xml_ast.Nmtokens_type"

and printer_enumerated_type ctx ppf = function
  | Xml_ast.Notation_type n_u_t ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_ast.Notation_type";
    Ulist1_print.printer_t printer_notation_name
      Og_precedence.Ck_argument
      ppf
      n_u_t;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Xml_ast.Enumeration_type x_n_u_t ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_ast.Enumeration_type";
    Ulist1_print.printer_t Xml_basics_ast_print.printer_nm_token
      Og_precedence.Ck_argument
      ppf
      x_n_u_t;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_att_default ctx ppf = function
  | Xml_ast.Required ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Xml_ast.Required"
  | Xml_ast.Implied ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Xml_ast.Implied"
  | Xml_ast.Att_value x_a ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_ast.Att_value";
    Xml_basics_ast_print.printer_att_value Og_precedence.Ck_argument ppf x_a;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Xml_ast.Fixed_att_value x_a ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_ast.Fixed_att_value";
    Xml_basics_ast_print.printer_att_value Og_precedence.Ck_argument ppf x_a;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_entity_decl ctx ppf = function
  | Xml_ast.Ge_decl (e, g) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_ast.Ge_decl";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_entity_name Og_precedence.Ck_tuple_item ppf e;
    Format.fprintf ppf "%,,@ ";
    printer_gentity_def Og_precedence.Ck_tuple_item ppf g;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Xml_ast.Pe_decl (e, p) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_ast.Pe_decl";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_entity_name Og_precedence.Ck_tuple_item ppf e;
    Format.fprintf ppf "%,,@ ";
    printer_pentity_def Og_precedence.Ck_tuple_item ppf p;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_gentity_def ctx ppf = function
  | Xml_ast.Gentity_value x_e ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_ast.Gentity_value";
    Xml_basics_ast_print.printer_entity_value
      Og_precedence.Ck_argument
      ppf
      x_e;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Xml_ast.Gentity_external_id (e, n_o) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_ast.Gentity_external_id";
    Format.fprintf ppf "%, (@,"; Format.fprintf ppf "%,@[<hv 0>";
    printer_external_id Og_precedence.Ck_tuple_item ppf e;
    Format.fprintf ppf "%,,@ ";
    Og_printer.printer_Option printer_ndata_decl
      Og_precedence.Ck_tuple_item
      ppf
      n_o;
    Format.fprintf ppf "%,@]"; Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_ndata_decl ctx ppf = function
  | n -> printer_notation_name ctx ppf n

and printer_pentity_def ctx ppf = function
  | Xml_ast.Pentity_value e ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_ast.Pentity_value";
    printer_entity_value Og_precedence.Ck_argument ppf e;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Xml_ast.Pentity_external_id e ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_ast.Pentity_external_id";
    printer_external_id Og_precedence.Ck_argument ppf e;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_content_spec ctx ppf = function
  | Xml_ast.Content_spec_empty ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Xml_ast.Content_spec_empty"
  | Xml_ast.Content_spec_any ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Xml_ast.Content_spec_any"
  | Xml_ast.Content_spec_mixed c ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_ast.Content_spec_mixed";
    printer_content_spec_mixed Og_precedence.Ck_argument ppf c;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Xml_ast.Content_spec_children c ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_ast.Content_spec_children";
    printer_content_spec_children Og_precedence.Ck_argument ppf c;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_content_particle_choice ctx ppf = function
  | (c, c_l) ->
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ "
      else
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_tuple_item then
      Format.fprintf ppf "%,@[<hv 2>(@,";
    Format.fprintf ppf "%,@[<hv 0>";
    printer_content_spec_mod Og_precedence.Ck_tuple_item ppf c;
    Format.fprintf ppf "%,,@ ";
    printer_list2 printer_content_spec_particle
      Og_precedence.Ck_tuple_item
      ppf
      c_l;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
      else
    if ctx = Og_precedence.Ck_tuple_item then
      Format.fprintf ppf "%,@;<0 -2>)@]"

and printer_content_particle_seq ctx ppf = function
  | (c, c_u_t) ->
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ "
      else
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_tuple_item then
      Format.fprintf ppf "%,@[<hv 2>(@,";
    Format.fprintf ppf "%,@[<hv 0>";
    printer_content_spec_mod Og_precedence.Ck_tuple_item ppf c;
    Format.fprintf ppf "%,,@ ";
    Ulist1_print.printer_t printer_content_spec_particle
      Og_precedence.Ck_tuple_item
      ppf
      c_u_t;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
      else
    if ctx = Og_precedence.Ck_tuple_item then
      Format.fprintf ppf "%,@;<0 -2>)@]"

and printer_content_particle_name ctx ppf = function
  | (c, t) ->
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ "
      else
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_tuple_item then
      Format.fprintf ppf "%,@[<hv 2>(@,";
    Format.fprintf ppf "%,@[<hv 0>";
    printer_content_spec_mod Og_precedence.Ck_tuple_item ppf c;
    Format.fprintf ppf "%,,@ ";
    printer_tag_name Og_precedence.Ck_tuple_item ppf t;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
      else
    if ctx = Og_precedence.Ck_tuple_item then
      Format.fprintf ppf "%,@;<0 -2>)@]"

and printer_content_spec_children ctx ppf = function
  | Xml_ast.Content_spec_choice c ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_ast.Content_spec_choice";
    printer_content_particle_choice Og_precedence.Ck_argument ppf c;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Xml_ast.Content_spec_seq c ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_ast.Content_spec_seq";
    printer_content_particle_seq Og_precedence.Ck_argument ppf c;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_content_spec_particle ctx ppf = function
  | Xml_ast.Content_particle_name c ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_ast.Content_particle_name";
    printer_content_particle_name Og_precedence.Ck_argument ppf c;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Xml_ast.Content_particle_choice c ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_ast.Content_particle_choice";
    printer_content_particle_choice Og_precedence.Ck_argument ppf c;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Xml_ast.Content_particle_seq c ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_ast.Content_particle_seq";
    printer_content_particle_seq Og_precedence.Ck_argument ppf c;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_content_spec_mixed ctx ppf = function
  | Xml_ast.PCData ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Xml_ast.PCData"
  | Xml_ast.PCData_empty ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Xml_ast.PCData_empty"
  | Xml_ast.PCData_alternatives t_l ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_ast.PCData_alternatives";
    Og_printer.printer_List printer_tag_name
      Og_precedence.Ck_argument
      ppf
      t_l;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_content_spec_mod _ctx ppf = function
  | Xml_ast.None_mod ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Xml_ast.None_mod"
  | Xml_ast.Opt_mod ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Xml_ast.Opt_mod"
  | Xml_ast.Star_mod ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Xml_ast.Star_mod"
  | Xml_ast.Plus_mod ->
    if _ctx = Og_precedence.Ck_argument ||
       _ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Xml_ast.Plus_mod"

and printer_raw_ext_subset ctx ppf = function
  | (t_o, e) ->
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ "
      else
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_tuple_item then
      Format.fprintf ppf "%,@[<hv 2>(@,";
    Format.fprintf ppf "%,@[<hv 0>";
    Og_printer.printer_Option printer_text_decl
      Og_precedence.Ck_tuple_item
      ppf
      t_o;
    Format.fprintf ppf "%,,@ ";
    printer_ext_subset_decl Og_precedence.Ck_tuple_item ppf e;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
      else
    if ctx = Og_precedence.Ck_tuple_item then
      Format.fprintf ppf "%,@;<0 -2>)@]"

and printer_ext_subset_decl ctx ppf = function
  | e_l -> Og_printer.printer_List printer_ext_subset_decl_elem ctx ppf e_l

and printer_ext_subset_decl_elem ctx ppf = function
  | Xml_ast.Ext_markup_decl m ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_ast.Ext_markup_decl";
    printer_markup_decl Og_precedence.Ck_argument ppf m;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Xml_ast.Ext_conditional_sect c ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_ast.Ext_conditional_sect";
    printer_conditional_sect Og_precedence.Ck_argument ppf c;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Xml_ast.Ext_sep_decl s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_ast.Ext_sep_decl";
    printer_sep_decl Og_precedence.Ck_argument ppf s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_text_decl ctx ppf = function
  | { Xml_ast.text_version_info = v_o; Xml_ast.text_encoding_decl = e; } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Xml_ast.@,";
    Format.fprintf ppf "%,@[<hv 2>text_version_info =";
    Og_printer.printer_Option printer_version_number
      Og_precedence.Ck_record_field
      ppf
      v_o;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>text_encoding_decl =";
    printer_encoding_name Og_precedence.Ck_record_field ppf e;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"

and printer_conditional_sect ctx ppf = function
  | Xml_ast.Include_sect e ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_ast.Include_sect";
    printer_ext_subset_decl Og_precedence.Ck_argument ppf e;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Xml_ast.Ignore_sect i ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_ast.Ignore_sect";
    printer_ignore_text Og_precedence.Ck_argument ppf i;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_ignore_text ctx ppf = function
  | s -> Og_printer.printer_String ctx ppf s
;;

(* Defining top printers. *)

let print_space ppf = printer_space Og_precedence.Ck_toplevel ppf
;;

let print_comment ppf = printer_comment Og_precedence.Ck_toplevel ppf
;;

let print_system_literal ppf =
  printer_system_literal Og_precedence.Ck_toplevel ppf
;;

let print_pubid_literal ppf =
  printer_pubid_literal Og_precedence.Ck_toplevel ppf
;;

let print_cdata ppf = printer_cdata Og_precedence.Ck_toplevel ppf
;;

let print_version_number ppf =
  printer_version_number Og_precedence.Ck_toplevel ppf
;;

let print_encoding_name ppf =
  printer_encoding_name Og_precedence.Ck_toplevel ppf
;;

let print_list2 pp_a ppf = printer_list2 pp_a Og_precedence.Ck_toplevel ppf
;;

let print_raw_document ppf =
  printer_raw_document Og_precedence.Ck_toplevel ppf

and print_prolog ppf = printer_prolog Og_precedence.Ck_toplevel ppf

and print_xml_decl ppf = printer_xml_decl Og_precedence.Ck_toplevel ppf

and print_standalone_decl ppf =
  printer_standalone_decl Og_precedence.Ck_toplevel ppf

and print_element ppf = printer_element Og_precedence.Ck_toplevel ppf

and print_tag ppf = printer_tag Og_precedence.Ck_toplevel ppf

and print_tag_attribute ppf =
  printer_tag_attribute Og_precedence.Ck_toplevel ppf

and print_char_data ppf = printer_char_data Og_precedence.Ck_toplevel ppf

and print_element_content ppf =
  printer_element_content Og_precedence.Ck_toplevel ppf

and print_tag_child ppf = printer_tag_child Og_precedence.Ck_toplevel ppf

and print_misc_star ppf = printer_misc_star Og_precedence.Ck_toplevel ppf

and print_misc ppf = printer_misc Og_precedence.Ck_toplevel ppf

and print_pi ppf = printer_pi Og_precedence.Ck_toplevel ppf

and print_doc_type_decl ppf =
  printer_doc_type_decl Og_precedence.Ck_toplevel ppf

and print_external_id ppf = printer_external_id Og_precedence.Ck_toplevel ppf

and print_public_id ppf = printer_public_id Og_precedence.Ck_toplevel ppf

and print_int_subset ppf = printer_int_subset Og_precedence.Ck_toplevel ppf

and print_int_subset_elem ppf =
  printer_int_subset_elem Og_precedence.Ck_toplevel ppf

and print_sep_decl ppf = printer_sep_decl Og_precedence.Ck_toplevel ppf

and print_notation_id ppf = printer_notation_id Og_precedence.Ck_toplevel ppf

and print_markup_decl ppf = printer_markup_decl Og_precedence.Ck_toplevel ppf

and print_att_def ppf = printer_att_def Og_precedence.Ck_toplevel ppf

and print_att_type ppf = printer_att_type Og_precedence.Ck_toplevel ppf

and print_tokenized_type ppf =
  printer_tokenized_type Og_precedence.Ck_toplevel ppf

and print_enumerated_type ppf =
  printer_enumerated_type Og_precedence.Ck_toplevel ppf

and print_att_default ppf = printer_att_default Og_precedence.Ck_toplevel ppf

and print_entity_decl ppf = printer_entity_decl Og_precedence.Ck_toplevel ppf

and print_gentity_def ppf = printer_gentity_def Og_precedence.Ck_toplevel ppf

and print_ndata_decl ppf = printer_ndata_decl Og_precedence.Ck_toplevel ppf

and print_pentity_def ppf = printer_pentity_def Og_precedence.Ck_toplevel ppf

and print_content_spec ppf =
  printer_content_spec Og_precedence.Ck_toplevel ppf

and print_content_particle_choice ppf =
  printer_content_particle_choice Og_precedence.Ck_toplevel ppf

and print_content_particle_seq ppf =
  printer_content_particle_seq Og_precedence.Ck_toplevel ppf

and print_content_particle_name ppf =
  printer_content_particle_name Og_precedence.Ck_toplevel ppf

and print_content_spec_children ppf =
  printer_content_spec_children Og_precedence.Ck_toplevel ppf

and print_content_spec_particle ppf =
  printer_content_spec_particle Og_precedence.Ck_toplevel ppf

and print_content_spec_mixed ppf =
  printer_content_spec_mixed Og_precedence.Ck_toplevel ppf

and print_content_spec_mod ppf =
  printer_content_spec_mod Og_precedence.Ck_toplevel ppf

and print_raw_ext_subset ppf =
  printer_raw_ext_subset Og_precedence.Ck_toplevel ppf

and print_ext_subset_decl ppf =
  printer_ext_subset_decl Og_precedence.Ck_toplevel ppf

and print_ext_subset_decl_elem ppf =
  printer_ext_subset_decl_elem Og_precedence.Ck_toplevel ppf

and print_text_decl ppf = printer_text_decl Og_precedence.Ck_toplevel ppf

and print_conditional_sect ppf =
  printer_conditional_sect Og_precedence.Ck_toplevel ppf

and print_ignore_text ppf = printer_ignore_text Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.5+dev0 generated code. *)
