(* Beginning of OCamlGen, 4.4+dev0 generated code. *)

let printer_text ctx ppf = function
  | s -> Og_printer.printer_String ctx ppf s
;;

let printer_char_data_text ctx ppf = function | t -> printer_text ctx ppf t
;;

let printer_nm_token ctx ppf = function
  | s -> Og_printer.printer_String ctx ppf s
;;

let printer_xml_name ctx ppf = function
  | x -> (fun n -> printer_nm_token ctx ppf n) (Xml_basics_ast.of_xml_name x)
;;

let printer_pi_target ctx ppf = function
  | p ->
    (fun x -> printer_xml_name ctx ppf x) (Xml_basics_ast.of_pi_target p)
;;

let printer_pi_instructions ctx ppf = function | t -> printer_text ctx ppf t
;;

let printer_tag_name ctx ppf = function | x -> printer_xml_name ctx ppf x
;;

let printer_tag_attribute_name ctx ppf = function
  | x -> printer_xml_name ctx ppf x
;;

let printer_entity_name ctx ppf = function | x -> printer_xml_name ctx ppf x
;;

let printer_notation_name ctx ppf = function
  | x -> printer_xml_name ctx ppf x
;;

let printer_att_value_text ctx ppf = function | t -> printer_text ctx ppf t
;;

let printer_entity_value_text ctx ppf = function
  | t -> printer_text ctx ppf t
;;

let printer_reference ctx ppf = function
  | Xml_basics_ast.Char_ref i ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_basics_ast.Char_ref";
    Og_printer.printer_Int32 Og_precedence.Ck_argument ppf i;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Xml_basics_ast.Entity_ref e ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_basics_ast.Entity_ref";
    printer_entity_name Og_precedence.Ck_argument ppf e;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let rec printer_att_value ctx ppf = function
  | a_l -> Og_printer.printer_List printer_att_value_elem ctx ppf a_l

and printer_att_value_elem ctx ppf = function
  | Xml_basics_ast.Att_value_text a ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_basics_ast.Att_value_text";
    printer_att_value_text Og_precedence.Ck_argument ppf a;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Xml_basics_ast.Att_value_reference r ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_basics_ast.Att_value_reference";
    printer_reference Og_precedence.Ck_argument ppf r;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let rec printer_entity_value ctx ppf = function
  | e_l -> Og_printer.printer_List printer_entity_value_elem ctx ppf e_l

and printer_entity_value_elem ctx ppf = function
  | Xml_basics_ast.Entity_value_text e ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_basics_ast.Entity_value_text";
    printer_entity_value_text Og_precedence.Ck_argument ppf e;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Xml_basics_ast.Entity_value_reference r ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_basics_ast.Entity_value_reference";
    printer_reference Og_precedence.Ck_argument ppf r;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Xml_basics_ast.Entity_value_pe_reference e ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Xml_basics_ast.Entity_value_pe_reference";
    printer_entity_name Og_precedence.Ck_argument ppf e;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

(* Defining top printers. *)

let print_text ppf = printer_text Og_precedence.Ck_toplevel ppf
;;

let print_char_data_text ppf =
  printer_char_data_text Og_precedence.Ck_toplevel ppf
;;

let print_nm_token ppf = printer_nm_token Og_precedence.Ck_toplevel ppf
;;

let print_xml_name ppf = printer_xml_name Og_precedence.Ck_toplevel ppf
;;

let print_pi_target ppf = printer_pi_target Og_precedence.Ck_toplevel ppf
;;

let print_pi_instructions ppf =
  printer_pi_instructions Og_precedence.Ck_toplevel ppf
;;

let print_tag_name ppf = printer_tag_name Og_precedence.Ck_toplevel ppf
;;

let print_tag_attribute_name ppf =
  printer_tag_attribute_name Og_precedence.Ck_toplevel ppf
;;

let print_entity_name ppf = printer_entity_name Og_precedence.Ck_toplevel ppf
;;

let print_notation_name ppf =
  printer_notation_name Og_precedence.Ck_toplevel ppf
;;

let print_att_value_text ppf =
  printer_att_value_text Og_precedence.Ck_toplevel ppf
;;

let print_entity_value_text ppf =
  printer_entity_value_text Og_precedence.Ck_toplevel ppf
;;

let print_reference ppf = printer_reference Og_precedence.Ck_toplevel ppf
;;

let print_att_value ppf = printer_att_value Og_precedence.Ck_toplevel ppf

and print_att_value_elem ppf =
  printer_att_value_elem Og_precedence.Ck_toplevel ppf
;;

let print_entity_value ppf =
  printer_entity_value Og_precedence.Ck_toplevel ppf

and print_entity_value_elem ppf =
  printer_entity_value_elem Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.4+dev0 generated code. *)
