(***********************************************************************)
(*                                                                     *)
(*                               Simport                               *)
(*                                                                     *)
(*                   Pierre Weis, Clément Franchini                    *)
(*                   INRIA Rocquencourt                                *)
(*                                                                     *)
(*  Copyright 2013-2019,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* $Id: slx_to_xml_ast.mli,v 1.1 2019-05-10 14:00:17 jpc Exp $ *)

type annex_name =
  | Block_diagram_defaults
  | Config_set_info
  | Graphical_interface
  | Stateflow
  | Annex_file_name of Path.file_name
;;

type annexes = (annex_name * Xml.document) list;;

type xml_model = {
  model_ident : Mdl_ast.model_ident;
  blockdiagram : Xml.document;
  annexes : annexes;
}
(** The XML model with its associated model name: the source of any
  translating function from XML block diagrams without specified model name
  to MDL file with model name. *)
;;

val read_xml_file : Path.explicit_file_name -> xml_model;;

val read_slx_file : Path.explicit_file_name -> xml_model;;

(*
 Local Variables:
  compile-command: "cd ../../..; make"
 End:
*)
