(***********************************************************************)
(*                                                                     *)
(*                               Simport                               *)
(*                                                                     *)
(*                   Pierre Weis, Clément Franchini                    *)
(*                   INRIA Rocquencourt                                *)
(*                                                                     *)
(*  Copyright 2013-2019,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* $Id: slx_to_mdl_ast.mli,v 1.1 2019-05-10 14:00:17 jpc Exp $ *)

val read_xml_file : Path.explicit_file_name -> Mdl_ast.simulink_file
(** Read a XML file that is supposed to contain a Simulink model and returns
  the MDL AST of its model. *)
;;

val read_slx_file : Path.explicit_file_name -> Mdl_ast.simulink_file
(** Read a SLX file and returns the MDL AST of its Simulink model. *)
;;

(*
 Local Variables:
  compile-command: "cd ../../..; make"
 End:
*)
