(***********************************************************************)
(*                                                                     *)
(*                               Simport                               *)
(*                                                                     *)
(*                   Pierre Weis, Clément Franchini                    *)
(*                   INRIA Rocquencourt                                *)
(*                                                                     *)
(*  Copyright 2013-2019,                                               *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  This file is distributed under the terms of the BSD License.       *)
(*                                                                     *)
(***********************************************************************)

(* $Id: xml_translating_basics.mli,v 1.1 2019-05-10 14:00:17 jpc Exp $ *)

type module_name = string;;

type property_conversion_mode =
  | Mode_ignore
  (* | Mode_force *)
  | Mode_property
;;

val not_yet : module_name -> string -> 'a;;

val fatal_error : module_name -> string -> 'a;;

val warning : module_name -> string -> unit;;

val not_yet_warning : module_name -> string -> unit;;

val fdebug : module_name -> (Format.formatter -> unit) -> unit;;

val model_value_of_optional_classified :
  Xml_explicit_ast.parameter_class option -> string -> Mdl_ast.model_value
;;

val simple_value_of_natural : Unatural.t -> Mdl_ast.simple_value;;

val model_value_of_simple_value : Mdl_ast.simple_value -> Mdl_ast.model_value;;

val model_value_of_natural : Unatural.t -> Mdl_ast.model_value;;

val model_value_of_text : string -> Mdl_ast.model_value;;

val model_value_of_block_ssid : Mdl_ast.block_sid -> Mdl_ast.model_value;;

val binding :
  property_conversion_mode ->
  Xml_explicit_ast.explicit_document_value Binding.ident_binding ->
  Mdl_ast.binding
;;

val bindings :
  property_conversion_mode ->
  Xml_explicit_ast.explicit_document_value Binding.ident_binding list ->
  Mdl_ast.binding list
;;

(*
 Local Variables:
  compile-command: "cd ../../..; make"
 End:
*)
