#ifndef SLICOT_H
#define SLICOT_H

#include "nsp/object.h" 
#include "nsp/blas.h" 
#include "nsp/lapack-c.h" 
#include "nsp/matutil.h"
#include "nsp/sciio.h" 
#include "../libcalelm/calpack.h"

#define U_fp void *
#define S_fp void *
#define L_fp void *

#define d_imag(x) ((x)->i)
#define d_lg10(x) log10(*(x))
#define i_dnnt(x) ((int) ((x) >=0 ? floor((x) + .5) : -floor(.5 - (x)) ))
#define d_cnjg(R, Z) (R)->r = (Z)->r; (R)->i = - (Z)->i;

extern double nsp_slicot_ab13ad (char *dico, char *equil, int *n, int *m, int *p, double *alpha, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, int *ns, double *hsv, double *dwork, int *ldwork, int *info, long int dico_len, long int equil_len);
extern double nsp_slicot_ab13ax (char *dico, int *n, int *m, int *p, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *hsv, double *dwork, int *ldwork, int *info, long int dico_len);
extern double nsp_slicot_ab13ax (char *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, double *, int *, int *, long int);
extern double nsp_slicot_ab13bd (char *dico, char *jobn, int *n, int *m, int *p, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, int *nq, double *tol, double *dwork, int *ldwork, int *iwarn, int *info, long int dico_len, long int jobn_len);
extern double nsp_slicot_ab13cd (int *n, int *m, int *np, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, double *tol, int *iwork, double *dwork, int *ldwork, doubleC * cwork, int *lcwork, int *bwork, int *info);
extern double nsp_slicot_ab13dx (char *, char *, char *, int *, int *, int *, double *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *, double *, int *, doubleC *, int *, int *, long int, long int, long int);
extern double nsp_slicot_ab13dx (char *dico, char *jobe, char *jobd, int *n, int *m, int *p, double *omega, double *a, int *lda, double *e, int *lde, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, int *iwork, double *dwork, int *ldwork, doubleC * cwork, int *lcwork, int *info, long int dico_len, long int jobe_len, long int jobd_len);
extern double nsp_slicot_ma02id (char *, char *, int *, double *, int *, double *, int *, double *, long int, long int);
extern double nsp_slicot_ma02id (char *typ, char *norm, int *n, double *a, int *lda, double *qg, int *ldqg, double *dwork, long int typ_len, long int norm_len);
extern double nsp_slicot_ma02jd (int *ltran1, int *ltran2, int *n, double *q1, int *ldq1, double *q2, int *ldq2, double *res, int *ldres);
extern double nsp_slicot_mb03my (int *, double *, int *);
extern double nsp_slicot_mb03my (int *nx, double *x, int *incx);
extern double nsp_slicot_mb03ny (int *, double *, double *, int *, double *, double *, int *, doubleC *, int *, int *);
extern double nsp_slicot_mb03ny (int *n, double *omega, double *a, int *lda, double *s, double *dwork, int *ldwork, doubleC * cwork, int *lcwork, int *info);
extern int nsp_slicot_ab01md (char *jobz, int *n, double *a, int *lda, double *b, int *ncont, double *z__, int *ldz, double *tau, double *tol, double *dwork, int *ldwork, int *info, long int jobz_len);
extern int nsp_slicot_ab01nd (char *, int *, int *, double *, int *, double *, int *, int *, int *, int *, double *, int *, double *, double *, int *, double *, int *, int *, long int);
extern int nsp_slicot_ab01nd (char *jobz, int *n, int *m, double *a, int *lda, double *b, int *ldb, int *ncont, int *indcon, int *nblk, double *z__, int *ldz, double *tau, double *tol, int *iwork, double *dwork, int *ldwork, int *info, long int jobz_len);

extern int nsp_slicot_ab01od (char *stages, char *jobu, char *jobv, int *n, int *m, double *a, int *lda, double *b, int *ldb,
			      double *u, int *ldu, double *v, int *ldv, int *ncont, int *indcon, int *kstair, double *tol, int *iwork, double *dwork, int *ldwork, int *info, long int stages_len, long int jobu_len, long int jobv_len);

extern int nsp_slicot_ab04md (char *, int *, int *, int *, double *, double *, double *, int *, double *, int *, double *, int *, double *, int *, int *, double *, int *, int *, long int);
extern int nsp_slicot_ab04md (char *type__, int *n, int *m, int *p, double *alpha, double *beta, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, int *iwork, double *dwork, int *ldwork, int *info, long int type_len);
extern int nsp_slicot_ab05md (char *uplo, char *over, int *n1, int *m1, int *p1, int *n2, int *p2, double *a1, int *lda1, double *b1, int *ldb1, double *c1, int *ldc1, double *d1, int *ldd1, double *a2, int *lda2, double *b2, int *ldb2, double *c2, int *ldc2, double *d2, int *ldd2, int *n, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, double *dwork, int *ldwork, int *info, long int uplo_len, long int over_len);
extern int nsp_slicot_ab05nd (char *over, int *n1, int *m1, int *p1, int *n2, double *alpha, double *a1, int *lda1, double *b1, int *ldb1, double *c1, int *ldc1, double *d1, int *ldd1, double *a2, int *lda2, double *b2, int *ldb2, double *c2, int *ldc2, double *d2, int *ldd2, int *n, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, int *iwork, double *dwork, int *ldwork, int *info, long int over_len);
extern int nsp_slicot_ab05od (char *over, int *n1, int *m1, int *p1, int *n2, int *m2, double *alpha, double *a1, int *lda1, double *b1, int *ldb1, double *c1, int *ldc1, double *d1, int *ldd1, double *a2, int *lda2, double *b2, int *ldb2, double *c2, int *ldc2, double *d2, int *ldd2, int *n, int *m, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, int *info, long int over_len);
extern int nsp_slicot_ab05pd (char *, int *, int *, int *, int *, double *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *, long int);
extern int nsp_slicot_ab05pd (char *over, int *n1, int *m, int *p, int *n2, double *alpha, double *a1, int *lda1, double *b1, int *ldb1, double *c1, int *ldc1, double *d1, int *ldd1, double *a2, int *lda2, double *b2, int *ldb2, double *c2, int *ldc2, double *d2, int *ldd2, int *n, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, int *info, long int over_len);
extern int nsp_slicot_ab05qd (char *, int *, int *, int *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *, long int);
extern int nsp_slicot_ab05qd (char *over, int *n1, int *m1, int *p1, int *n2, int *m2, int *p2, double *a1, int *lda1, double *b1, int *ldb1, double *c1, int *ldc1, double *d1, int *ldd1, double *a2, int *lda2, double *b2, int *ldb2, double *c2, int *ldc2, double *d2, int *ldd2, int *n, int *m, int *p, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, int *info, long int over_len);
extern int nsp_slicot_ab05rd (char *fbtype, char *jobd, int *n, int *m, int *p, int *mv, int *pz, double *alpha, double *beta, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, double *f, int *ldf, double *k, int *ldk, double *g, int *ldg, double *h__, int *ldh, double *rcond, double *bc, int *ldbc, double *cc, int *ldcc, double *dc, int *lddc, int *iwork, double *dwork, int *ldwork, int *info, long int fbtype_len, long int jobd_len);
extern int nsp_slicot_ab05sd (char *, char *, int *, int *, int *, double *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *, long int, long int);
extern int nsp_slicot_ab05sd (char *fbtype, char *jobd, int *n, int *m, int *p, double *alpha, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, double *f, int *ldf, double *rcond, int *iwork, double *dwork, int *ldwork, int *info, long int fbtype_len, long int jobd_len);
extern int nsp_slicot_ab07md (char *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *, long int);
extern int nsp_slicot_ab07md (char *jobd, int *n, int *m, int *p, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, int *info, long int jobd_len);
extern int nsp_slicot_ab07nd (int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *);
extern int nsp_slicot_ab07nd (int *n, int *m, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, double *rcond, int *iwork, double *dwork, int *ldwork, int *info);
extern int nsp_slicot_ab08md (char *equil, int *n, int *m, int *p, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, int *rank, double *tol, int *iwork, double *dwork, int *ldwork, int *info, long int equil_len);
extern int nsp_slicot_ab08md (char *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *, double *, int *, double *, int *, int *, long int);
extern int nsp_slicot_ab08mz (char *equil, int *n, int *m, int *p, doubleC * a, int *lda, doubleC * b, int *ldb, doubleC * c__, int *ldc, doubleC * d__, int *ldd, int *rank, double *tol, int *iwork, double *dwork, doubleC * zwork, int *lzwork, int *info, long int equil_len);
extern int nsp_slicot_ab08nd (char *equil, int *n, int *m, int *p, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, int *nu, int *rank, int *dinfz, int *nkror, int *nkrol, int *infz, int *kronr, int *kronl, double *af, int *ldaf, double *bf, int *ldbf, double *tol, int *iwork, double *dwork, int *ldwork, int *info, long int equil_len);
extern int nsp_slicot_ab08nx (int *, int *, int *, int *, int *, double *, double *, int *, int *, int *, int *, int *, int *, int *, double *, int *, double *, int *, int *);
extern int nsp_slicot_ab08nx (int *n, int *m, int *p, int *ro, int *sigma, double *svlmax, double *abcd, int *ldabcd, int *ninfz, int *infz, int *kronl, int *mu, int *nu, int *nkrol, double *tol, int *iwork, double *dwork, int *ldwork, int *info);
extern int nsp_slicot_ab08nz (char *equil, int *n, int *m, int *p, doubleC * a, int *lda, doubleC * b, int *ldb, doubleC * c__, int *ldc, doubleC * d__, int *ldd, int *nu, int *rank, int *dinfz, int *nkror, int *nkrol, int *infz, int *kronr, int *kronl, doubleC * af, int *ldaf, doubleC * bf, int *ldbf, double *tol, int *iwork, double *dwork, doubleC * zwork, int *lzwork, int *info, long int equil_len);
extern int nsp_slicot_ab09ad (char *, char *, char *, char *, int *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, double *, int *, double *, int *, int *, int *, long int, long int, long int, long int);
extern int nsp_slicot_ab09ad (char *dico, char *job, char *equil, char *ordsel, int *n, int *m, int *p, int *nr, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *hsv, double *tol, int *iwork, double *dwork, int *ldwork, int *iwarn, int *info, long int dico_len, long int job_len, long int equil_len, long int ordsel_len);
extern int nsp_slicot_ab09ax (char *, char *, char *, int *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, double *, int *, double *, int *, double *, int *, double *, int *, int *, int *, long int, long int, long int);
extern int nsp_slicot_ab09ax (char *dico, char *job, char *ordsel, int *n, int *m, int *p, int *nr, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *hsv, double *t, int *ldt, double *ti, int *ldti, double *tol, int *iwork, double *dwork, int *ldwork, int *iwarn, int *info, long int dico_len, long int job_len, long int ordsel_len);
extern int nsp_slicot_ab09bd (char *, char *, char *, char *, int *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, double *, double *, int *, double *, int *, int *, int *, long int, long int, long int, long int);
extern int nsp_slicot_ab09bd (char *dico, char *job, char *equil, char *ordsel, int *n, int *m, int *p, int *nr, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, double *hsv, double *tol1, double *tol2, int *iwork, double *dwork, int *ldwork, int *iwarn, int *info, long int dico_len, long int job_len, long int equil_len, long int ordsel_len);
extern int nsp_slicot_ab09bx (char *, char *, char *, int *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, double *, int *, double *, int *, double *, double *, int *, double *, int *, int *, int *, long int, long int, long int);
extern int nsp_slicot_ab09bx (char *dico, char *job, char *ordsel, int *n, int *m, int *p, int *nr, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, double *hsv, double *t, int *ldt, double *ti, int *ldti, double *tol1, double *tol2, int *iwork, double *dwork, int *ldwork, int *iwarn, int *info, long int dico_len, long int job_len, long int ordsel_len);
extern int nsp_slicot_ab09cd (char *dico, char *equil, char *ordsel, int *n, int *m, int *p, int *nr, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, double *hsv, double *tol1, double *tol2, int *iwork, double *dwork, int *ldwork, int *iwarn, int *info, long int dico_len, long int equil_len, long int ordsel_len);
extern int nsp_slicot_ab09cx (char *, char *, int *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, double *, double *, int *, double *, int *, int *, int *, long int, long int);
extern int nsp_slicot_ab09cx (char *dico, char *ordsel, int *n, int *m, int *p, int *nr, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, double *hsv, double *tol1, double *tol2, int *iwork, double *dwork, int *ldwork, int *iwarn, int *info, long int dico_len, long int ordsel_len);
extern int nsp_slicot_ab09dd (char *dico, int *n, int *m, int *p, int *nr, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, double *rcond, int *iwork, double *dwork, int *info, long int dico_len);
extern int nsp_slicot_ab09dd (char *, int *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, long int);
extern int nsp_slicot_ab09ed (char *dico, char *equil, char *ordsel, int *n, int *m, int *p, int *nr, double *alpha, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, int *ns, double *hsv, double *tol1, double *tol2, int *iwork, double *dwork, int *ldwork, int *iwarn, int *info, long int dico_len, long int equil_len, long int ordsel_len);
extern int nsp_slicot_ab09fd (char *dico, char *jobcf, char *fact, char *jobmr, char *equil, char *ordsel, int *n, int *m, int *p, int *nr, double *alpha, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, int *nq, double *hsv, double *tol1, double *tol2, int *iwork, double *dwork, int *ldwork, int *iwarn, int *info, long int dico_len, long int jobcf_len, long int fact_len, long int jobmr_len, long int equil_len, long int ordsel_len);
extern int nsp_slicot_ab09gd (char *dico, char *jobcf, char *fact, char *jobmr, char *equil, char *ordsel, int *n, int *m, int *p, int *nr, double *alpha, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, int *nq, double *hsv, double *tol1, double *tol2, double *tol3, int *iwork, double *dwork, int *ldwork, int *iwarn, int *info, long int dico_len, long int jobcf_len, long int fact_len, long int jobmr_len, long int equil_len, long int ordsel_len);
extern int nsp_slicot_ab09hd (char *dico, char *job, char *equil, char *ordsel, int *n, int *m, int *p, int *nr, double *alpha, double *beta, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, int *ns, double *hsv, double *tol1, double *tol2, int *iwork, double *dwork, int *ldwork, int *bwork, int *iwarn, int *info, long int dico_len, long int job_len, long int equil_len, long int ordsel_len);
extern int nsp_slicot_ab09hx (char *dico, char *job, char *ordsel, int *n, int *m, int *p, int *nr, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, double *hsv, double *t, int *ldt, double *ti, int *ldti, double *tol1, double *tol2, int *iwork, double *dwork, int *ldwork, int *bwork, int *iwarn, int *info, long int dico_len, long int job_len, long int ordsel_len);
extern int nsp_slicot_ab09hy (int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, double *, double *, int *, double *, int *, int *, double *, int *, int *, int *);
extern int nsp_slicot_ab09hy (int *n, int *m, int *p, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, double *scalec, double *scaleo, double *s, int *lds, double *r__, int *ldr, int *iwork, double *dwork, int *ldwork, int *bwork, int *info);
extern int nsp_slicot_ab09id (char *dico, char *jobc, char *jobo, char *job, char *weight, char *equil, char *ordsel, int *n, int *m, int *p, int *nv, int *pv, int *nw, int *mw, int *nr, double *alpha, double *alphac, double *alphao, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, double *av, int *ldav, double *bv, int *ldbv, double *cv, int *ldcv, double *dv, int *lddv, double *aw, int *ldaw, double *bw, int *ldbw, double *cw, int *ldcw, double *dw, int *lddw, int *ns, double *hsv, double *tol1, double *tol2, int *iwork, double *dwork, int *ldwork, int *iwarn, int *info, long int dico_len, long int jobc_len, long int jobo_len, long int job_len, long int weight_len, long int equil_len, long int ordsel_len);
extern int nsp_slicot_ab09ix (char *, char *, char *, char *, int *, int *, int *, int *, double *, double *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *, double *, double *, double *, int *, double *, int *, int *, int *, long int, long int, long int, long int);
extern int nsp_slicot_ab09ix (char *dico, char *job, char *fact, char *ordsel, int *n, int *m, int *p, int *nr, double *scalec, double *scaleo, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, double *ti, int *ldti, double *t, int *ldt, int *nminr, double *hsv, double *tol1, double *tol2, int *iwork, double *dwork, int *ldwork, int *iwarn, int *info, long int dico_len, long int job_len, long int fact_len, long int ordsel_len);
extern int nsp_slicot_ab09iy (char *, char *, char *, char *, int *, int *, int *, int *, int *, int *, int *, double *, double *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, double *, double *, int *, double *, int *, double *, int *, int *, long int, long int, long int, long int);
extern int nsp_slicot_ab09iy (char *dico, char *jobc, char *jobo, char *weight, int *n, int *m, int *p, int *nv, int *pv, int *nw, int *mw, double *alphac, double *alphao, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *av, int *ldav, double *bv, int *ldbv, double *cv, int *ldcv, double *dv, int *lddv, double *aw, int *ldaw, double *bw, int *ldbw, double *cw, int *ldcw, double *dw, int *lddw, double *scalec, double *scaleo, double *s, int *lds, double *r__, int *ldr, double *dwork, int *ldwork, int *info, long int dico_len, long int jobc_len, long int jobo_len, long int weight_len);
extern int nsp_slicot_ab09jd (char *jobv, char *jobw, char *jobinv, char *dico, char *equil, char *ordsel, int *n, int *nv, int *nw, int *m, int *p, int *nr, double *alpha, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, double *av, int *ldav, double *bv, int *ldbv, double *cv, int *ldcv, double *dv, int *lddv, double *aw, int *ldaw, double *bw, int *ldbw, double *cw, int *ldcw, double *dw, int *lddw, int *ns, double *hsv, double *tol1, double *tol2, int *iwork, double *dwork, int *ldwork, int *iwarn, int *info, long int jobv_len, long int jobw_len, long int jobinv_len, long int dico_len, long int equil_len, long int ordsel_len);
extern int nsp_slicot_ab09jv (char *, char *, char *, char *, int *, int *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *, double *, int *, int *, long int, long int, long int, long int);
extern int nsp_slicot_ab09jv (char *job, char *dico, char *jobev, char *stbchk, int *n, int *m, int *p, int *nv, int *pv, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, double *av, int *ldav, double *ev, int *ldev, double *bv, int *ldbv, double *cv, int *ldcv, double *dv, int *lddv, int *iwork, double *dwork, int *ldwork, int *info, long int job_len, long int dico_len, long int jobev_len, long int stbchk_len);
extern int nsp_slicot_ab09jw (char *, char *, char *, char *, int *, int *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *, double *, int *, int *, long int, long int, long int, long int);
extern int nsp_slicot_ab09jw (char *job, char *dico, char *jobew, char *stbchk, int *n, int *m, int *p, int *nw, int *mw, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, double *aw, int *ldaw, double *ew, int *ldew, double *bw, int *ldbw, double *cw, int *ldcw, double *dw, int *lddw, int *iwork, double *dwork, int *ldwork, int *info, long int job_len, long int dico_len, long int jobew_len, long int stbchk_len);
extern int nsp_slicot_ab09jx (char *, char *, char *, int *, double *, double *, double *, double *, double *, int *, long int, long int, long int);
extern int nsp_slicot_ab09jx (char *dico, char *stdom, char *evtype, int *n, double *alpha, double *er, double *ei, double *ed, double *tolinf, int *info, long int dico_len, long int stdom_len, long int evtype_len);
extern int nsp_slicot_ab09kd (char *job, char *dico, char *weight, char *equil, char *ordsel, int *n, int *nv, int *nw, int *m, int *p, int *nr, double *alpha, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, double *av, int *ldav, double *bv, int *ldbv, double *cv, int *ldcv, double *dv, int *lddv, double *aw, int *ldaw, double *bw, int *ldbw, double *cw, int *ldcw, double *dw, int *lddw, int *ns, double *hsv, double *tol1, double *tol2, int *iwork, double *dwork, int *ldwork, int *iwarn, int *info, long int job_len, long int dico_len, long int weight_len, long int equil_len, long int ordsel_len);
extern int nsp_slicot_ab09kx (char *, char *, char *, int *, int *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *, int *, long int, long int, long int);
extern int nsp_slicot_ab09kx (char *job, char *dico, char *weight, int *n, int *nv, int *nw, int *m, int *p, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, double *av, int *ldav, double *bv, int *ldbv, double *cv, int *ldcv, double *dv, int *lddv, double *aw, int *ldaw, double *bw, int *ldbw, double *cw, int *ldcw, double *dw, int *lddw, double *dwork, int *ldwork, int *iwarn, int *info, long int job_len, long int dico_len, long int weight_len);
extern int nsp_slicot_ab09md (char *dico, char *job, char *equil, char *ordsel, int *n, int *m, int *p, int *nr, double *alpha, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, int *ns, double *hsv, double *tol, int *iwork, double *dwork, int *ldwork, int *iwarn, int *info, long int dico_len, long int job_len, long int equil_len, long int ordsel_len);
extern int nsp_slicot_ab09nd (char *dico, char *job, char *equil, char *ordsel, int *n, int *m, int *p, int *nr, double *alpha, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, int *ns, double *hsv, double *tol1, double *tol2, int *iwork, double *dwork, int *ldwork, int *iwarn, int *info, long int dico_len, long int job_len, long int equil_len, long int ordsel_len);
extern int nsp_slicot_ab13dd (char *dico, char *jobe, char *equil, char *jobd, int *n, int *m, int *p, double *fpeak, double *a, int *lda, double *e, int *lde, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, double *gpeak, double *tol, int *iwork, double *dwork, int *ldwork, doubleC * cwork, int *lcwork, int *info, long int dico_len, long int jobe_len, long int equil_len, long int jobd_len);
extern int nsp_slicot_ab13ed (int *n, double *a, int *lda, double *low, double *high, double *tol, double *dwork, int *ldwork, int *info);
extern int nsp_slicot_ab13fd (int *n, double *a, int *lda, double *beta, double *omega, double *tol, double *dwork, int *ldwork, doubleC * cwork, int *lcwork, int *info);
extern int nsp_slicot_ab13md (char *fact, int *n, doubleC * z__, int *ldz, int *m, int *nblock, int *itype, double *x, double *bound, double *d__, double *g, int *iwork, double *dwork, int *ldwork, doubleC * zwork, int *lzwork, int *info, long int fact_len);
extern int nsp_slicot_ab13md (char *, int *, doubleC *, int *, int *, int *, int *, double *, double *, double *, double *, int *, double *, int *, doubleC *, int *, int *, long int);
extern int nsp_slicot_ab8nxz (int *, int *, int *, int *, int *, double *, doubleC *, int *, int *, int *, int *, int *, int *, int *, double *, int *, double *, doubleC *, int *, int *);
extern int nsp_slicot_ab8nxz (int *n, int *m, int *p, int *ro, int *sigma, double *svlmax, doubleC * abcd, int *ldabcd, int *ninfz, int *infz, int *kronl, int *mu, int *nu, int *nkrol, double *tol, int *iwork, double *dwork, doubleC * zwork, int *lzwork, int *info);
extern int nsp_slicot_ag07bd (char *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *, long int);
extern int nsp_slicot_ag07bd (char *jobe, int *n, int *m, double *a, int *lda, double *e, int *lde, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, double *ai, int *ldai, double *ei, int *ldei, double *bi, int *ldbi, double *ci, int *ldci, double *di, int *lddi, int *info, long int jobe_len);
extern int nsp_slicot_ag08bd (char *equil, int *l, int *n, int *m, int *p, double *a, int *lda, double *e, int *lde, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, int *nfz, int *nrank, int *niz, int *dinfz, int *nkror, int *ninfe, int *nkrol, int *infz, int *kronr, int *infe, int *kronl, double *tol, int *iwork, double *dwork, int *ldwork, int *info, long int equil_len);
extern int nsp_slicot_ag08by (int *first, int *n, int *m, int *p, double *svlmax, double *abcd, int *ldabcd, double *e, int *lde, int *nr, int *pr, int *ninfz, int *dinfz, int *nkronl, int *infz, int *kronl, double *tol, int *iwork, double *dwork, int *ldwork, int *info);
extern int nsp_slicot_ag08by (int *, int *, int *, int *, double *, double *, int *, double *, int *, int *, int *, int *, int *, int *, int *, int *, double *, int *, double *, int *, int *);
extern int nsp_slicot_ag08bz (char *equil, int *l, int *n, int *m, int *p, doubleC * a, int *lda, doubleC * e, int *lde, doubleC * b, int *ldb, doubleC * c__, int *ldc, doubleC * d__, int *ldd, int *nfz, int *nrank, int *niz, int *dinfz, int *nkror, int *ninfe, int *nkrol, int *infz, int *kronr, int *infe, int *kronl, double *tol, int *iwork, double *dwork, doubleC * zwork, int *lzwork, int *info, long int equil_len);
extern int nsp_slicot_ag8byz (int *first, int *n, int *m, int *p, double *svlmax, doubleC * abcd, int *ldabcd, doubleC * e, int *lde, int *nr, int *pr, int *ninfz, int *dinfz, int *nkronl, int *infz, int *kronl, double *tol, int *iwork, double *dwork, doubleC * zwork, int *lzwork, int *info);
extern int nsp_slicot_ag8byz (int *, int *, int *, int *, double *, doubleC *, int *, doubleC *, int *, int *, int *, int *, int *, int *, int *, int *, double *, int *, double *, doubleC *, int *, int *);
extern int nsp_slicot_bb01ad (char *def, int *nr, double *dpar, int *ipar, int *bpar, char *chpar, int *vec, int *n, int *m, int *p, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *g, int *ldg, double *q, int *ldq, double *x, int *ldx, double *dwork, int *ldwork, int *info, long int def_len, long int chpar_len);
extern int nsp_slicot_bb02ad (char *def, int *nr, double *dpar, int *ipar, int *bpar, char *chpar, int *vec, int *n, int *m, int *p, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *q, int *ldq, double *r__, int *ldr, double *s, int *lds, double *x, int *ldx, double *dwork, int *ldwork, int *info, long int def_len, long int chpar_len);
extern int nsp_slicot_bb03ad (char *def, int *nr, double *dpar, int *ipar, int *vec, int *n, int *m, double *e, int *lde, double *a, int *lda, double *y, int *ldy, double *b, int *ldb, double *x, int *ldx, double *u, int *ldu, char *note, double *dwork, int *ldwork, int *info, long int def_len, long int note_len);
extern int nsp_slicot_bb04ad (char *def, int *nr, double *dpar, int *ipar, int *vec, int *n, int *m, double *e, int *lde, double *a, int *lda, double *y, int *ldy, double *b, int *ldb, double *x, int *ldx, double *u, int *ldu, char *note, double *dwork, int *ldwork, int *info, long int def_len, long int note_len);
extern int nsp_slicot_bd01ad (char *def, int *nr, double *dpar, int *ipar, int *vec, int *n, int *m, int *p, double *e, int *lde, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, char *note, double *dwork, int *ldwork, int *info, long int def_len, long int note_len);
extern int nsp_slicot_bd02ad (char *def, int *nr, double *dpar, int *ipar, int *vec, int *n, int *m, int *p, double *e, int *lde, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, char *note, double *dwork, int *ldwork, int *info, long int def_len, long int note_len);
extern int nsp_slicot_de01od (char *conv, int *n, double *a, double *b, int *info, long int conv_len);
extern int nsp_slicot_de01pd (char *conv, char *wght, int *n, double *a, double *b, double *w, int *info, long int conv_len, long int wght_len);
extern int nsp_slicot_delctg ();
extern int nsp_slicot_delctg (double *par1, double *par2, double *par3);
extern int nsp_slicot_df01md (char *sico, int *n, double *dt, double *a, double *dwork, int *info, long int sico_len);
extern int nsp_slicot_dg01md (char *indi, int *n, double *xr, double *xi, int *info, long int indi_len);
extern int nsp_slicot_dg01md (char *, int *, double *, double *, int *, long int);
extern int nsp_slicot_dg01nd (char *indi, int *n, double *xr, double *xi, int *info, long int indi_len);
extern int nsp_slicot_dg01nd (char *, int *, double *, double *, int *, long int);
extern int nsp_slicot_dg01ny (char *indi, int *n, double *xr, double *xi, long int indi_len);
extern int nsp_slicot_dg01ny (char *, int *, double *, double *, long int);
extern int nsp_slicot_dg01od (char *, char *, int *, double *, double *, int *, long int, long int);
extern int nsp_slicot_dg01od (char *scr, char *wght, int *n, double *a, double *w, int *info, long int scr_len, long int wght_len);
extern int nsp_slicot_dggbal (char *, int *, double *, int *, double *, int *, int *, int *, double *, double *, double *, int *, long int);
extern int nsp_slicot_dgges (char *, char *, char *, L_fp, int *, double *, int *, double *, int *, int *, double *, double *, double *, double *, int *, double *, int *, double *, int *, int *, int *, long int, long int, long int);
extern int nsp_slicot_dggev (char *, char *, int *, double *, int *, double *, int *, double *, double *, double *, double *, int *, double *, int *, double *, int *, int *, long int, long int);
extern int nsp_slicot_dhgeqz (char *, char *, char *, int *, int *, int *, double *, int *, double *, int *, double *, double *, double *, double *, int *, double *, int *, double *, int *, int *, long int, long int, long int);
extern int nsp_slicot_dhseqr (char *, char *, int *, int *, int *, double *, int *, double *, double *, double *, int *, double *, int *, int *, long int, long int);
extern int nsp_slicot_dk01md (char *type__, int *n, double *a, int *info, long int type_len);
extern int nsp_slicot_fb01qd (char *jobk, char *multbq, int *n, int *m, int *p, double *s, int *lds, double *a, int *lda, double *b, int *ldb, double *q, int *ldq, double *c__, int *ldc, double *r__, int *ldr, double *k, int *ldk, double *tol, int *iwork, double *dwork, int *ldwork, int *info, long int jobk_len, long int multbq_len);
extern int nsp_slicot_fb01rd (char *jobk, char *multbq, int *n, int *m, int *p, double *s, int *lds, double *a, int *lda, double *b, int *ldb, double *q, int *ldq, double *c__, int *ldc, double *r__, int *ldr, double *k, int *ldk, double *tol, int *iwork, double *dwork, int *ldwork, int *info, long int jobk_len, long int multbq_len);
extern int nsp_slicot_fb01sd (char *jobx, char *multab, char *multrc, int *n, int *m, int *p, double *sinv, int *ldsinv, double *ainv, int *ldainv, double *b, int *ldb, double *rinv, int *ldrinv, double *c__, int *ldc, double *qinv, int *ldqinv, double *x, double *rinvy, double *z__, double *e, double *tol, int *iwork, double *dwork, int *ldwork, int *info, long int jobx_len, long int multab_len, long int multrc_len);
extern int nsp_slicot_fb01td (char *jobx, char *multrc, int *n, int *m, int *p, double *sinv, int *ldsinv, double *ainv, int *ldainv, double *ainvb, int *ldainb, double *rinv, int *ldrinv, double *c__, int *ldc, double *qinv, int *ldqinv, double *x, double *rinvy, double *z__, double *e, double *tol, int *iwork, double *dwork, int *ldwork, int *info, long int jobx_len, long int multrc_len);
extern int nsp_slicot_fb01vd (int *n, int *m, int *l, double *p, int *ldp, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *q, int *ldq, double *r__, int *ldr, double *k, int *ldk, double *tol, int *iwork, double *dwork, int *ldwork, int *info);
extern int nsp_slicot_fd01ad (char *jp, int *l, double *lambda, double *xin, double *yin, double *efor, double *xf, double *epsbck, double *cteta, double *steta, double *yq, double *epos, double *eout, double *salph, int *iwarn, int *info, long int jp_len);
extern int nsp_slicot_ib01ad (char *, char *, char *, char *, char *, char *, int *, int *, int *, int *, double *, int *, double *, int *, int *, double *, int *, double *, double *, double *, int *, double *, int *, int *, int *, long int, long int, long int, long int, long int, long int);
extern int nsp_slicot_ib01ad (char *meth, char *alg, char *jobd, char *batch, char *conct, char *ctrl, int *nobr, int *m, int *l, int *nsmp, double *u, int *ldu, double *y, int *ldy, int *n, double *r__, int *ldr, double *sv, double *rcond, double *tol, int *iwork, double *dwork, int *ldwork, int *iwarn, int *info, long int meth_len, long int alg_len, long int jobd_len, long int batch_len, long int conct_len, long int ctrl_len);
extern int nsp_slicot_ib01bd (char *, char *, char *, int *, int *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *, int *, int *, long int, long int, long int);
extern int nsp_slicot_ib01bd (char *meth, char *job, char *jobck, int *nobr, int *n, int *m, int *l, int *nsmpl, double *r__, int *ldr, double *a, int *lda, double *c__, int *ldc, double *b, int *ldb, double *d__, int *ldd, double *q, int *ldq, double *ry, int *ldry, double *s, int *lds, double *k, int *ldk, double *tol, int *iwork, double *dwork, int *ldwork, int *bwork, int *iwarn, int *info, long int meth_len, long int job_len, long int jobck_len);
extern int nsp_slicot_ib01cd (char *, char *, char *, int *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, double *, int *, double *, int *, double *, int *, int *, int *, long int, long int, long int);
extern int nsp_slicot_ib01cd (char *jobx0, char *comuse, char *job, int *n, int *m, int *l, int *nsmp, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, double *u, int *ldu, double *y, int *ldy, double *x0, double *v, int *ldv, double *tol, int *iwork, double *dwork, int *ldwork, int *iwarn, int *info, long int jobx0_len, long int comuse_len, long int job_len);
extern int nsp_slicot_ib01md (char *, char *, char *, char *, int *, int *, int *, int *, double *, int *, double *, int *, double *, int *, int *, double *, int *, int *, int *, long int, long int, long int, long int);
extern int nsp_slicot_ib01md (char *meth, char *alg, char *batch, char *conct, int *nobr, int *m, int *l, int *nsmp, double *u, int *ldu, double *y, int *ldy, double *r__, int *ldr, int *iwork, double *dwork, int *ldwork, int *iwarn, int *info, long int meth_len, long int alg_len, long int batch_len, long int conct_len);
extern int nsp_slicot_ib01my (char *, char *, char *, int *, int *, int *, int *, double *, int *, double *, int *, double *, int *, int *, double *, int *, int *, int *, long int, long int, long int);
extern int nsp_slicot_ib01my (char *meth, char *batch, char *conct, int *nobr, int *m, int *l, int *nsmp, double *u, int *ldu, double *y, int *ldy, double *r__, int *ldr, int *iwork, double *dwork, int *ldwork, int *iwarn, int *info, long int meth_len, long int batch_len, long int conct_len);
extern int nsp_slicot_ib01nd (char *, char *, int *, int *, int *, double *, int *, double *, double *, int *, double *, int *, int *, int *, long int, long int);
extern int nsp_slicot_ib01nd (char *meth, char *jobd, int *nobr, int *m, int *l, double *r__, int *ldr, double *sv, double *tol, int *iwork, double *dwork, int *ldwork, int *iwarn, int *info, long int meth_len, long int jobd_len);
extern int nsp_slicot_ib01od (char *ctrl, int *nobr, int *l, double *sv, int *n, double *tol, int *iwarn, int *info, long int ctrl_len);
extern int nsp_slicot_ib01od (char *, int *, int *, double *, int *, double *, int *, int *, long int);
extern int nsp_slicot_ib01oy (int *, int *, int *, double *, int *);
extern int nsp_slicot_ib01oy (int *ns, int *nmax, int *n, double *sv, int *info);
extern int nsp_slicot_ib01pd (char *, char *, char *, int *, int *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *, int *, long int, long int, long int);
extern int nsp_slicot_ib01pd (char *meth, char *job, char *jobcv, int *nobr, int *n, int *m, int *l, int *nsmpl, double *r__, int *ldr, double *a, int *lda, double *c__, int *ldc, double *b, int *ldb, double *d__, int *ldd, double *q, int *ldq, double *ry, int *ldry, double *s, int *lds, double *o, int *ldo, double *tol, int *iwork, double *dwork, int *ldwork, int *iwarn, int *info, long int meth_len, long int job_len, long int jobcv_len);
extern int nsp_slicot_ib01px (char *, int *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, double *, int *, double *, int *, double *, int *, double *, int *, int *, int *, long int);
extern int nsp_slicot_ib01px (char *job, int *nobr, int *n, int *m, int *l, double *uf, int *lduf, double *un, int *ldun, double *ul, int *ldul, double *pgal, int *ldpgal, double *k, int *ldk, double *r__, int *ldr, double *x, double *b, int *ldb, double *d__, int *ldd, double *tol, int *iwork, double *dwork, int *ldwork, int *iwarn, int *info, long int job_len);
extern int nsp_slicot_ib01py (char *, char *, int *, int *, int *, int *, int *, double *, int *, double *, int *, double *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *, int *, long int, long int);
extern int nsp_slicot_ib01py (char *meth, char *job, int *nobr, int *n, int *m, int *l, int *rankr1, double *ul, int *ldul, double *r1, int *ldr1, double *tau1, double *pgal, int *ldpgal, double *k, int *ldk, double *r__, int *ldr, double *h__, int *ldh, double *b, int *ldb, double *d__, int *ldd, double *tol, int *iwork, double *dwork, int *ldwork, int *iwarn, int *info, long int meth_len, long int job_len);
extern int nsp_slicot_ib01qd (char *, char *, int *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, double *, int *, double *, int *, double *, int *, double *, int *, int *, int *, long int, long int);
extern int nsp_slicot_ib01qd (char *jobx0, char *job, int *n, int *m, int *l, int *nsmp, double *a, int *lda, double *c__, int *ldc, double *u, int *ldu, double *y, int *ldy, double *x0, double *b, int *ldb, double *d__, int *ldd, double *tol, int *iwork, double *dwork, int *ldwork, int *iwarn, int *info, long int jobx0_len, long int job_len);
extern int nsp_slicot_ib01rd (char *, int *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, double *, int *, double *, int *, int *, int *, long int);
extern int nsp_slicot_ib01rd (char *job, int *n, int *m, int *l, int *nsmp, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, double *u, int *ldu, double *y, int *ldy, double *x0, double *tol, int *iwork, double *dwork, int *ldwork, int *iwarn, int *info, long int job_len);
extern int nsp_slicot_ib03ad (char *init, char *alg, char *stor, int *nobr, int *m, int *l, int *nsmp, int *n, int *nn, int *itmax1, int *itmax2, int *nprint, double *u, int *ldu, double *y, int *ldy, double *x, int *lx, double *tol1, double *tol2, int *iwork, double *dwork, int *ldwork, int *iwarn, int *info, long int init_len, long int alg_len, long int stor_len);
extern int nsp_slicot_ib03bd (char *init, int *nobr, int *m, int *l, int *nsmp, int *n, int *nn, int *itmax1, int *itmax2, int *nprint, double *u, int *ldu, double *y, int *ldy, double *x, int *lx, double *tol1, double *tol2, int *iwork, double *dwork, int *ldwork, int *iwarn, int *info, long int init_len);
extern int nsp_slicot_idamax (int *, double *, int *);
extern int nsp_slicot_ilaenv (int *, char *, char *, int *, int *, int *, int *, long int, long int);
extern int nsp_slicot_izamax (int *, doubleC *, int *);
extern int nsp_slicot_lfdum (double *x, double *y);
extern int nsp_slicot_ma01ad (double *, double *, double *, double *);
extern int nsp_slicot_ma01ad (double *xr, double *xi, double *yr, double *yi);
extern int nsp_slicot_ma02ad (char *, int *, int *, double *, int *, double *, int *, long int);
extern int nsp_slicot_ma02ad (char *job, int *m, int *n, double *a, int *lda, double *b, int *ldb, long int job_len);
extern int nsp_slicot_ma02bd (char *, int *, int *, double *, int *, long int);
extern int nsp_slicot_ma02bd (char *side, int *m, int *n, double *a, int *lda, long int side_len);
extern int nsp_slicot_ma02bz (char *, int *, int *, doubleC *, int *, long int);
extern int nsp_slicot_ma02bz (char *side, int *m, int *n, doubleC * a, int *lda, long int side_len);
extern int nsp_slicot_ma02cd (int *, int *, int *, double *, int *);
extern int nsp_slicot_ma02cd (int *n, int *kl, int *ku, double *a, int *lda);
extern int nsp_slicot_ma02cz (int *, int *, int *, doubleC *, int *);
extern int nsp_slicot_ma02cz (int *n, int *kl, int *ku, doubleC * a, int *lda);
extern int nsp_slicot_ma02dd (char *, char *, int *, double *, int *, double *, long int, long int);
extern int nsp_slicot_ma02dd (char *job, char *uplo, int *n, double *a, int *lda, double *ap, long int job_len, long int uplo_len);
extern int nsp_slicot_ma02ed (char *, int *, double *, int *, long int);
extern int nsp_slicot_ma02ed (char *uplo, int *n, double *a, int *lda, long int uplo_len);
extern int nsp_slicot_ma02fd (double *, double *, double *, double *, int *);
extern int nsp_slicot_ma02fd (double *x1, double *x2, double *c__, double *s, int *info);
extern int nsp_slicot_ma02gd (int *, double *, int *, int *, int *, int *, int *);
extern int nsp_slicot_ma02gd (int *n, double *a, int *lda, int *k1, int *k2, int *ipiv, int *incx);
extern int nsp_slicot_ma02hd (char *job, int *m, int *n, double *diag, double *a, int *lda, long int job_len);
extern int nsp_slicot_mb01md (char *, int *, double *, double *, int *, double *, int *, double *, double *, int *, long int);
extern int nsp_slicot_mb01md (char *uplo, int *n, double *alpha, double *a, int *lda, double *x, int *incx, double *beta, double *y, int *incy, long int uplo_len);
extern int nsp_slicot_mb01nd (char *, int *, double *, double *, int *, double *, int *, double *, int *, long int);
extern int nsp_slicot_mb01nd (char *uplo, int *n, double *alpha, double *x, int *incx, double *y, int *incy, double *a, int *lda, long int uplo_len);
extern int nsp_slicot_mb01pd (char *scun, char *type__, int *m, int *n, int *kl, int *ku, double *anrm, int *nbl, int *nrows, double *a, int *lda, int *info, long int scun_len, long int type_len);
extern int nsp_slicot_mb01qd (char *type__, int *m, int *n, int *kl, int *ku, double *cfrom, double *cto, int *nbl, int *nrows, double *a, int *lda, int *info, long int type_len);
extern int nsp_slicot_mb01rd (char *uplo, char *trans, int *m, int *n, double *alpha, double *beta, double *r__, int *ldr, double *a, int *lda, double *x, int *ldx, double *dwork, int *ldwork, int *info, long int uplo_len, long int trans_len);
extern int nsp_slicot_mb01ru (char *uplo, char *trans, int *m, int *n, double *alpha, double *beta, double *r__, int *ldr, double *a, int *lda, double *x, int *ldx, double *dwork, int *ldwork, int *info, long int uplo_len, long int trans_len);
extern int nsp_slicot_mb01rw (char *uplo, char *trans, int *m, int *n, double *a, int *lda, double *z__, int *ldz, double *dwork, int *info, long int uplo_len, long int trans_len);
extern int nsp_slicot_mb01rx (char *side, char *uplo, char *trans, int *m, int *n, double *alpha, double *beta, double *r__, int *ldr, double *a, int *lda, double *b, int *ldb, int *info, long int side_len, long int uplo_len, long int trans_len);
extern int nsp_slicot_mb01ry (char *side, char *uplo, char *trans, int *m, double *alpha, double *beta, double *r__, int *ldr, double *h__, int *ldh, double *b, int *ldb, double *dwork, int *info, long int side_len, long int uplo_len, long int trans_len);
extern int nsp_slicot_mb01sd (char *jobs, int *m, int *n, double *a, int *lda, double *r__, double *c__, long int jobs_len);
extern int nsp_slicot_mb01td (int *n, double *a, int *lda, double *b, int *ldb, double *dwork, int *info);
extern int nsp_slicot_mb01ud (char *side, char *trans, int *m, int *n, double *alpha, double *h__, int *ldh, double *a, int *lda, double *b, int *ldb, int *info, long int side_len, long int trans_len);
extern int nsp_slicot_mb01uw (char *side, char *trans, int *m, int *n, double *alpha, double *h__, int *ldh, double *a, int *lda, double *dwork, int *ldwork, int *info, long int side_len, long int trans_len);
extern int nsp_slicot_mb01ux (char *side, char *uplo, char *trans, int *m, int *n, double *alpha, double *t, int *ldt, double *a, int *lda, double *dwork, int *ldwork, int *info, long int side_len, long int uplo_len, long int trans_len);
extern int nsp_slicot_mb01vd (char *trana, char *tranb, int *ma, int *na, int *mb, int *nb, double *alpha, double *beta, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, int *mc, int *nc, int *info, long int trana_len, long int tranb_len);
extern int nsp_slicot_mb01wd (char *dico, char *uplo, char *trans, char *hess, int *n, double *alpha, double *beta, double *r__, int *ldr, double *a, int *lda, double *t, int *ldt, int *info, long int dico_len, long int uplo_len, long int trans_len, long int hess_len);
extern int nsp_slicot_mb01xd (char *uplo, int *n, double *a, int *lda, int *info, long int uplo_len);
extern int nsp_slicot_mb01xy (char *uplo, int *n, double *a, int *lda, int *info, long int uplo_len);
extern int nsp_slicot_mb01yd (char *uplo, char *trans, int *n, int *k, int *l, double *alpha, double *beta, double *a, int *lda, double *c__, int *ldc, int *info, long int uplo_len, long int trans_len);
extern int nsp_slicot_mb01zd (char *side, char *uplo, char *transt, char *diag, int *m, int *n, int *l, double *alpha, double *t, int *ldt, double *h__, int *ldh, int *info, long int side_len, long int uplo_len, long int transt_len, long int diag_len);
extern int nsp_slicot_mb02cd (char *job, char *typet, int *k, int *n, double *t, int *ldt, double *g, int *ldg, double *r__, int *ldr, double *l, int *ldl, double *cs, int *lcs, double *dwork, int *ldwork, int *info, long int job_len, long int typet_len);
extern int nsp_slicot_mb02cu (char *typeg, int *k, int *p, int *q, int *nb, double *a1, int *lda1, double *a2, int *lda2, double *b, int *ldb, int *rnk, int *ipvt, double *cs, double *tol, double *dwork, int *ldwork, int *info, long int typeg_len);
extern int nsp_slicot_mb02cv (char *typeg, char *strucg, int *k, int *n, int *p, int *q, int *nb, int *rnk, double *a1, int *lda1, double *a2, int *lda2, double *b, int *ldb, double *f1, int *ldf1, double *f2, int *ldf2, double *g, int *ldg, double *cs, double *dwork, int *ldwork, int *info, long int typeg_len, long int strucg_len);
extern int nsp_slicot_mb02cx (char *typet, int *p, int *q, int *k, double *a, int *lda, double *b, int *ldb, double *cs, int *lcs, double *dwork, int *ldwork, int *info, long int typet_len);
extern int nsp_slicot_mb02cy (char *typet, char *strucg, int *p, int *q, int *n, int *k, double *a, int *lda, double *b, int *ldb, double *h__, int *ldh, double *cs, int *lcs, double *dwork, int *ldwork, int *info, long int typet_len, long int strucg_len);
extern int nsp_slicot_mb02dd (char *job, char *typet, int *k, int *m, int *n, double *ta, int *ldta, double *t, int *ldt, double *g, int *ldg, double *r__, int *ldr, double *l, int *ldl, double *cs, int *lcs, double *dwork, int *ldwork, int *info, long int job_len, long int typet_len);
extern int nsp_slicot_mb02ed (char *typet, int *k, int *n, int *nrhs, double *t, int *ldt, double *b, int *ldb, double *dwork, int *ldwork, int *info, long int typet_len);
extern int nsp_slicot_mb02fd (char *typet, int *k, int *n, int *p, int *s, double *t, int *ldt, double *r__, int *ldr, double *dwork, int *ldwork, int *info, long int typet_len);
extern int nsp_slicot_mb02gd (char *typet, char *triu, int *k, int *n, int *nl, int *p, int *s, double *t, int *ldt, double *rb, int *ldrb, double *dwork, int *ldwork, int *info, long int typet_len, long int triu_len);
extern int nsp_slicot_mb02hd (char *triu, int *k, int *l, int *m, int *ml, int *n, int *nu, int *p, int *s, double *tc, int *ldtc, double *tr, int *ldtr, double *rb, int *ldrb, double *dwork, int *ldwork, int *info, long int triu_len);
extern int nsp_slicot_mb02id (char *job, int *k, int *l, int *m, int *n, int *rb, int *rc, double *tc, int *ldtc, double *tr, int *ldtr, double *b, int *ldb, double *c__, int *ldc, double *dwork, int *ldwork, int *info, long int job_len);
extern int nsp_slicot_mb02jd (char *job, int *k, int *l, int *m, int *n, int *p, int *s, double *tc, int *ldtc, double *tr, int *ldtr, double *q, int *ldq, double *r__, int *ldr, double *dwork, int *ldwork, int *info, long int job_len);
extern int nsp_slicot_mb02jx (char *job, int *k, int *l, int *m, int *n, double *tc, int *ldtc, double *tr, int *ldtr, int *rnk, double *q, int *ldq, double *r__, int *ldr, int *jpvt, double *tol1, double *tol2, double *dwork, int *ldwork, int *info, long int job_len);
extern int nsp_slicot_mb02kd (char *, char *, int *, int *, int *, int *, int *, double *, double *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *, long int, long int);
extern int nsp_slicot_mb02kd (char *ldblk, char *trans, int *k, int *l, int *m, int *n, int *r__, double *alpha, double *beta, double *tc, int *ldtc, double *tr, int *ldtr, double *b, int *ldb, double *c__, int *ldc, double *dwork, int *ldwork, int *info, long int ldblk_len, long int trans_len);
extern int nsp_slicot_mb02md (char *job, int *m, int *n, int *l, int *rank, double *c__, int *ldc, double *s, double *x, int *ldx, double *tol, int *iwork, double *dwork, int *ldwork, int *iwarn, int *info, long int job_len);
extern int nsp_slicot_mb02nd (int *m, int *n, int *l, int *rank, double *theta, double *c__, int *ldc, double *x, int *ldx, double *q, int *inul, double *tol, double *reltol, int *iwork, double *dwork, int *ldwork, int *bwork, int *iwarn, int *info);
extern int nsp_slicot_mb02ny (int *, int *, int *, int *, int *, int *, double *, double *, double *, int *, double *, int *, double *);
extern int nsp_slicot_mb02ny (int *updatu, int *updatv, int *m, int *n, int *i__, int *k, double *q, double *e, double *u, int *ldu, double *v, int *ldv, double *dwork);
extern int nsp_slicot_mb02od (char *, char *, char *, char *, char *, int *, int *, double *, double *, int *, double *, int *, double *, double *, int *, double *, int *, long int, long int, long int, long int, long int);
extern int nsp_slicot_mb02od (char *side, char *uplo, char *trans, char *diag, char *norm, int *m, int *n, double *alpha, double *a, int *lda, double *b, int *ldb, double *rcond, double *tol, int *iwork, double *dwork, int *info, long int side_len, long int uplo_len, long int trans_len, long int diag_len, long int norm_len);
extern int nsp_slicot_mb02pd (char *, char *, int *, int *, double *, int *, double *, int *, int *, char *, double *, double *, double *, int *, double *, int *, double *, double *, double *, int *, double *, int *, long int, long int, long int);
extern int nsp_slicot_mb02pd (char *fact, char *trans, int *n, int *nrhs, double *a, int *lda, double *af, int *ldaf, int *ipiv, char *equed, double *r__, double *c__, double *b, int *ldb, double *x, int *ldx, double *rcond, double *ferr, double *berr, int *iwork, double *dwork, int *info, long int fact_len, long int trans_len, long int equed_len);
extern int nsp_slicot_mb02qd (char *, char *, int *, int *, int *, double *, double *, double *, int *, double *, int *, double *, int *, int *, double *, double *, int *, int *, long int, long int);
extern int nsp_slicot_mb02qd (char *job, char *iniper, int *m, int *n, int *nrhs, double *rcond, double *svlmax, double *a, int *lda, double *b, int *ldb, double *y, int *jpvt, int *rank, double *sval, double *dwork, int *ldwork, int *info, long int job_len, long int iniper_len);
extern int nsp_slicot_mb02qy (int *, int *, int *, int *, double *, int *, int *, double *, int *, double *, double *, int *, int *);
extern int nsp_slicot_mb02qy (int *m, int *n, int *nrhs, int *rank, double *a, int *lda, int *jpvt, double *b, int *ldb, double *tau, double *dwork, int *ldwork, int *info);
extern int nsp_slicot_mb02rd (char *, int *, int *, double *, int *, int *, double *, int *, int *, long int);
extern int nsp_slicot_mb02rd (char *trans, int *n, int *nrhs, double *h__, int *ldh, int *ipiv, double *b, int *ldb, int *info, long int trans_len);
extern int nsp_slicot_mb02rz (char *, int *, int *, doubleC *, int *, int *, doubleC *, int *, int *, long int);
extern int nsp_slicot_mb02rz (char *trans, int *n, int *nrhs, doubleC * h__, int *ldh, int *ipiv, doubleC * b, int *ldb, int *info, long int trans_len);
extern int nsp_slicot_mb02sd (int *, double *, int *, int *, int *);
extern int nsp_slicot_mb02sd (int *n, double *h__, int *ldh, int *ipiv, int *info);
extern int nsp_slicot_mb02sz (int *, doubleC *, int *, int *, int *);
extern int nsp_slicot_mb02sz (int *n, doubleC * h__, int *ldh, int *ipiv, int *info);
extern int nsp_slicot_mb02td (char *norm, int *n, double *hnorm, double *h__, int *ldh, int *ipiv, double *rcond, int *iwork, double *dwork, int *info, long int norm_len);
extern int nsp_slicot_mb02tz (char *, int *, double *, doubleC *, int *, int *, double *, double *, doubleC *, int *, long int);
extern int nsp_slicot_mb02tz (char *norm, int *n, double *hnorm, doubleC * h__, int *ldh, int *ipiv, double *rcond, double *dwork, doubleC * zwork, int *info, long int norm_len);
extern int nsp_slicot_mb02ud (char *, char *, char *, char *, int *, int *, double *, double *, int *, double *, int *, double *, int *, double *, double *, int *, double *, int *, double *, int *, int *, long int, long int, long int, long int);
extern int nsp_slicot_mb02ud (char *fact, char *side, char *trans, char *jobp, int *m, int *n, double *alpha, double *rcond, int *rank, double *r__, int *ldr, double *q, int *ldq, double *sv, double *b, int *ldb, double *rp, int *ldrp, double *dwork, int *ldwork, int *info, long int fact_len, long int side_len, long int trans_len, long int jobp_len);
extern int nsp_slicot_mb02uu (int *, double *, int *, double *, int *, int *, double *);
extern int nsp_slicot_mb02uu (int *n, double *a, int *lda, double *rhs, int *ipiv, int *jpiv, double *scale);
extern int nsp_slicot_mb02uv (int *, double *, int *, int *, int *, int *);
extern int nsp_slicot_mb02uv (int *n, double *a, int *lda, int *ipiv, int *jpiv, int *info);
extern int nsp_slicot_mb02vd (char *, int *, int *, double *, int *, int *, double *, int *, int *, long int);
extern int nsp_slicot_mb02vd (char *trans, int *m, int *n, double *a, int *lda, int *ipiv, double *b, int *ldb, int *info, long int trans_len);
extern int nsp_slicot_mb02wd (char *form, S_fp f, int *n, int *ipar, int *lipar, double *dpar, int *ldpar, int *itmax, double *a, int *lda, double *b, int *incb, double *x, int *incx, double *tol, double *dwork, int *ldwork, int *iwarn, int *info, long int form_len);
extern int nsp_slicot_mb02wd (char *, U_fp, int *, int *, int *, double *, int *, int *, double *, int *, double *, int *, double *, int *, double *, double *, int *, int *, int *, long int);
extern int nsp_slicot_mb02xd (char *, char *, char *, U_fp, int *, int *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *, long int, long int, long int);
extern int nsp_slicot_mb02xd (char *form, char *stor, char *uplo, S_fp f, int *m, int *n, int *nrhs, int *ipar, int *lipar, double *dpar, int *ldpar, double *a, int *lda, double *b, int *ldb, double *ata, int *ldata, double *dwork, int *ldwork, int *info, long int form_len, long int stor_len, long int uplo_len);
extern int nsp_slicot_mb02yd (char *cond, int *n, double *r__, int *ldr, int *ipvt, double *diag, double *qtb, int *rank, double *x, double *tol, double *dwork, int *ldwork, int *info, long int cond_len);
extern int nsp_slicot_mb02yd (char *, int *, double *, int *, int *, double *, double *, int *, double *, double *, double *, int *, int *, long int);
extern int nsp_slicot_mb03md (int *, int *, double *, double *, double *, double *, double *, double *, double *, double *, int *, int *);
extern int nsp_slicot_mb03md (int *n, int *l, double *theta, double *q, double *e, double *q2, double *e2, double *pivmin, double *tol, double *reltol, int *iwarn, int *info);
extern int nsp_slicot_mb03nd (int *, double *, double *, double *, double *, int *);
extern int nsp_slicot_mb03nd (int *n, double *theta, double *q2, double *e2, double *pivmin, int *info);
extern int nsp_slicot_mb03od (char *, int *, int *, double *, int *, int *, double *, double *, double *, int *, double *, double *, int *, int *, long int);
extern int nsp_slicot_mb03od (char *jobqr, int *m, int *n, double *a, int *lda, int *jpvt, double *rcond, double *svlmax, double *tau, int *rank, double *sval, double *dwork, int *ldwork, int *info, long int jobqr_len);
extern int nsp_slicot_mb03oy (int *, int *, double *, int *, double *, double *, int *, double *, int *, double *, double *, int *);
extern int nsp_slicot_mb03oy (int *m, int *n, double *a, int *lda, double *rcond, double *svlmax, int *rank, double *sval, int *jpvt, double *tau, double *dwork, int *info);
extern int nsp_slicot_mb03pd (char *jobrq, int *m, int *n, double *a, int *lda, int *jpvt, double *rcond, double *svlmax, double *tau, int *rank, double *sval, double *dwork, int *info, long int jobrq_len);
extern int nsp_slicot_mb03py (int *, int *, double *, int *, double *, double *, int *, double *, int *, double *, double *, int *);
extern int nsp_slicot_mb03py (int *m, int *n, double *a, int *lda, double *rcond, double *svlmax, int *rank, double *sval, int *jpvt, double *tau, double *dwork, int *info);
extern int nsp_slicot_mb03qd (char *, char *, char *, int *, int *, int *, double *, double *, int *, double *, int *, int *, double *, int *, long int, long int, long int);
extern int nsp_slicot_mb03qd (char *dico, char *stdom, char *jobu, int *n, int *nlow, int *nsup, double *alpha, double *a, int *lda, double *u, int *ldu, int *ndim, double *dwork, int *info, long int dico_len, long int stdom_len, long int jobu_len);
extern int nsp_slicot_mb03qx (int *, double *, int *, double *, double *, int *);
extern int nsp_slicot_mb03qx (int *n, double *t, int *ldt, double *wr, double *wi, int *info);
extern int nsp_slicot_mb03qy (int *, int *, double *, int *, double *, int *, double *, double *, int *);
extern int nsp_slicot_mb03qy (int *n, int *l, double *a, int *lda, double *u, int *ldu, double *e1, double *e2, int *info);
extern int nsp_slicot_mb03rd (char *jobx, char *sort, int *n, double *pmax, double *a, int *lda, double *x, int *ldx, int *nblcks, int *blsize, double *wr, double *wi, double *tol, double *dwork, int *info, long int jobx_len, long int sort_len);
extern int nsp_slicot_mb03rx (char *, int *, int *, int *, double *, int *, double *, int *, double *, double *, double *, long int);
extern int nsp_slicot_mb03rx (char *jobv, int *n, int *kl, int *ku, double *a, int *lda, double *x, int *ldx, double *wr, double *wi, double *dwork, long int jobv_len);
extern int nsp_slicot_mb03ry (int *, int *, double *, double *, int *, double *, int *, double *, int *, int *);
extern int nsp_slicot_mb03ry (int *m, int *n, double *pmax, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, int *info);
extern int nsp_slicot_mb03sd (char *jobscl, int *n, double *a, int *lda, double *qg, int *ldqg, double *wr, double *wi, double *dwork, int *ldwork, int *info, long int jobscl_len);
extern int nsp_slicot_mb03td (char *, char *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, double *, int *, double *, int *, int *, long int, long int);
extern int nsp_slicot_mb03td (char *typ, char *compu, int *select, int *lower, int *n, double *a, int *lda, double *g, int *ldg, double *u1, int *ldu1, double *u2, int *ldu2, double *wr, double *wi, int *m, double *dwork, int *ldwork, int *info, long int typ_len, long int compu_len);
extern int nsp_slicot_mb03ts (int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *, int *, int *, double *, int *);
extern int nsp_slicot_mb03ts (int *isham, int *wantu, int *n, double *a, int *lda, double *g, int *ldg, double *u1, int *ldu1, double *u2, int *ldu2, int *j1, int *n1, int *n2, double *dwork, int *info);
extern int nsp_slicot_mb03ud (char *, char *, int *, double *, int *, double *, int *, double *, double *, int *, int *, long int, long int);
extern int nsp_slicot_mb03ud (char *jobq, char *jobp, int *n, double *a, int *lda, double *q, int *ldq, double *sv, double *dwork, int *ldwork, int *info, long int jobq_len, long int jobp_len);
extern int nsp_slicot_mb03vd (int *n, int *p, int *ilo, int *ihi, double *a, int *lda1, int *lda2, double *tau, int *ldtau, double *dwork, int *info);
extern int nsp_slicot_mb03vy (int *n, int *p, int *ilo, int *ihi, double *a, int *lda1, int *lda2, double *tau, int *ldtau, double *dwork, int *ldwork, int *info);
extern int nsp_slicot_mb03wa (int *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *);
extern int nsp_slicot_mb03wa (int *wantq, int *wantz, int *n1, int *n2, double *a, int *lda, double *b, int *ldb, double *q, int *ldq, double *z__, int *ldz, int *info);
extern int nsp_slicot_mb03wd (char *job, char *compz, int *n, int *p, int *ilo, int *ihi, int *iloz, int *ihiz, double *h__, int *ldh1, int *ldh2, double *z__, int *ldz1, int *ldz2, double *wr, double *wi, double *dwork, int *ldwork, int *info, long int job_len, long int compz_len);
extern int nsp_slicot_mb03wx (int *n, int *p, double *t, int *ldt1, int *ldt2, double *wr, double *wi, int *info);
extern int nsp_slicot_mb03xd (char *balanc, char *job, char *jobu, char *jobv, int *n, double *a, int *lda, double *qg, int *ldqg, double *t, int *ldt, double *u1, int *ldu1, double *u2, int *ldu2, double *v1, int *ldv1, double *v2, int *ldv2, double *wr, double *wi, int *ilo, double *scale, double *dwork, int *ldwork, int *info, long int balanc_len, long int job_len, long int jobu_len, long int jobv_len);
extern int nsp_slicot_mb03xd (char *, char *, char *, char *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, double *, int *, double *, double *, int *, int *, long int, long int, long int, long int);
extern int nsp_slicot_mb03xp (char *, char *, char *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, double *, double *, double *, int *, int *, long int, long int, long int);
extern int nsp_slicot_mb03xp (char *job, char *compq, char *compz, int *n, int *ilo, int *ihi, double *a, int *lda, double *b, int *ldb, double *q, int *ldq, double *z__, int *ldz, double *alphar, double *alphai, double *beta, double *dwork, int *ldwork, int *info, long int job_len, long int compq_len, long int compz_len);
extern int nsp_slicot_mb03xu (int *, int *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, double *, double *, double *, double *);
extern int nsp_slicot_mb03xu (int *ltra, int *ltrb, int *n, int *k, int *nb, double *a, int *lda, double *b, int *ldb, double *g, int *ldg, double *q, int *ldq, double *xa, int *ldxa, double *xb, int *ldxb, double *xg, int *ldxg, double *xq, int *ldxq, double *ya, int *ldya, double *yb, int *ldyb, double *yg, int *ldyg, double *yq, int *ldyq, double *csl, double *csr, double *taul, double *taur, double *dwork);
extern int nsp_slicot_mb03ya (int *, int *, int *, int *, int *, int *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *);
extern int nsp_slicot_mb03ya (int *wantt, int *wantq, int *wantz, int *n, int *ilo, int *ihi, int *iloq, int *ihiq, int *pos, double *a, int *lda, double *b, int *ldb, double *q, int *ldq, double *z__, int *ldz, int *info);
extern int nsp_slicot_mb03yd (int *, int *, int *, int *, int *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, double *, double *, double *, int *, int *);
extern int nsp_slicot_mb03yd (int *wantt, int *wantq, int *wantz, int *n, int *ilo, int *ihi, int *iloq, int *ihiq, double *a, int *lda, double *b, int *ldb, double *q, int *ldq, double *z__, int *ldz, double *alphar, double *alphai, double *beta, double *dwork, int *ldwork, int *info);
extern int nsp_slicot_mb03yt (double *a, int *lda, double *b, int *ldb, double *alphar, double *alphai, double *beta, double *csl, double *snl, double *csr, double *snr);
extern int nsp_slicot_mb03yt (double *, int *, double *, int *, double *, double *, double *, double *, double *, double *, double *);
extern int nsp_slicot_mb03za (char *, char *, char *, char *, char *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, double *, int *, double *, int *, int *, long int, long int, long int, long int, long int);
extern int nsp_slicot_mb03za (char *compc, char *compu, char *compv, char *compw, char *which, int *select, int *n, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *u1, int *ldu1, double *u2, int *ldu2, double *v1, int *ldv1, double *v2, int *ldv2, double *w, int *ldw, double *wr, double *wi, int *m, double *dwork, int *ldwork, int *info, long int compc_len, long int compu_len, long int compv_len, long int compw_len, long int which_len);
extern int nsp_slicot_mb03zd (char *which, char *meth, char *stab, char *balanc, char *ortbal, int *select, int *n, int *mm, int *ilo, double *scale, double *s, int *lds, double *t, int *ldt, double *g, int *ldg, double *u1, int *ldu1, double *u2, int *ldu2, double *v1, int *ldv1, double *v2, int *ldv2, int *m, double *wr, double *wi, double *us, int *ldus, double *uu, int *lduu, int *lwork, int *iwork, double *dwork, int *ldwork, int *info, long int which_len, long int meth_len, long int stab_len, long int balanc_len, long int ortbal_len);
extern int nsp_slicot_mb04dd (char *, int *, double *, int *, double *, int *, int *, double *, int *, long int);
extern int nsp_slicot_mb04dd (char *job, int *n, double *a, int *lda, double *qg, int *ldqg, int *ilo, double *scale, int *info, long int job_len);
extern int nsp_slicot_mb04di (char *, char *, int *, int *, double *, int *, double *, int *, double *, int *, int *, long int, long int);
extern int nsp_slicot_mb04di (char *job, char *sgn, int *n, int *ilo, double *scale, int *m, double *v1, int *ldv1, double *v2, int *ldv2, int *info, long int job_len, long int sgn_len);
extern int nsp_slicot_mb04ds (char *job, int *n, double *a, int *lda, double *qg, int *ldqg, int *ilo, double *scale, int *info, long int job_len);
extern int nsp_slicot_mb04dy (char *jobscl, int *n, double *a, int *lda, double *qg, int *ldqg, double *d__, double *dwork, int *info, long int jobscl_len);
extern int nsp_slicot_mb04gd (int *, int *, double *, int *, int *, double *, double *, int *);
extern int nsp_slicot_mb04gd (int *m, int *n, double *a, int *lda, int *jpvt, double *tau, double *dwork, int *info);
extern int nsp_slicot_mb04id (int *, int *, int *, int *, double *, int *, double *, int *, double *, double *, int *, int *);
extern int nsp_slicot_mb04id (int *n, int *m, int *p, int *l, double *a, int *lda, double *b, int *ldb, double *tau, double *dwork, int *ldwork, int *info);
extern int nsp_slicot_mb04iy (char *, char *, int *, int *, int *, int *, double *, int *, double *, double *, int *, double *, int *, int *, long int, long int);
extern int nsp_slicot_mb04iy (char *side, char *trans, int *n, int *m, int *k, int *p, double *a, int *lda, double *tau, double *c__, int *ldc, double *dwork, int *ldwork, int *info, long int side_len, long int trans_len);
extern int nsp_slicot_mb04iz (int *n, int *m, int *p, int *l, doubleC * a, int *lda, doubleC * b, int *ldb, doubleC * tau, doubleC * zwork, int *lzwork, int *info);
extern int nsp_slicot_mb04jd (int *, int *, int *, int *, double *, int *, double *, int *, double *, double *, int *, int *);
extern int nsp_slicot_mb04jd (int *n, int *m, int *p, int *l, double *a, int *lda, double *b, int *ldb, double *tau, double *dwork, int *ldwork, int *info);
extern int nsp_slicot_mb04kd (char *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, double *, long int);
extern int nsp_slicot_mb04kd (char *uplo, int *n, int *m, int *p, double *r__, int *ldr, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *tau, double *dwork, long int uplo_len);
extern int nsp_slicot_mb04ld (char *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, double *, long int);
extern int nsp_slicot_mb04ld (char *uplo, int *n, int *m, int *p, double *l, int *ldl, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *tau, double *dwork, long int uplo_len);
extern int nsp_slicot_mb04md (int *, double *, double *, int *, double *, int *);
extern int nsp_slicot_mb04md (int *n, double *maxred, double *a, int *lda, double *scale, int *info);
extern int nsp_slicot_mb04nd (char *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, double *, long int);
extern int nsp_slicot_mb04nd (char *uplo, int *n, int *m, int *p, double *r__, int *ldr, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *tau, double *dwork, long int uplo_len);
extern int nsp_slicot_mb04ny (int *, int *, double *, int *, double *, double *, int *, double *, int *, double *);
extern int nsp_slicot_mb04ny (int *m, int *n, double *v, int *incv, double *tau, double *a, int *lda, double *b, int *ldb, double *dwork);
extern int nsp_slicot_mb04od (char *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, double *, long int);
extern int nsp_slicot_mb04od (char *uplo, int *n, int *m, int *p, double *r__, int *ldr, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *tau, double *dwork, long int uplo_len);
extern int nsp_slicot_mb04ow (int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *);
extern int nsp_slicot_mb04ow (int *m, int *n, int *p, double *a, int *lda, double *t, int *ldt, double *x, int *incx, double *b, int *ldb, double *c__, int *ldc, double *d__, int *incd);
extern int nsp_slicot_mb04ox (int *, double *, int *, double *, int *);
extern int nsp_slicot_mb04ox (int *n, double *a, int *lda, double *x, int *incx);
extern int nsp_slicot_mb04oy (int *, int *, double *, double *, double *, int *, double *, int *, double *);
extern int nsp_slicot_mb04oy (int *m, int *n, double *v, double *tau, double *a, int *lda, double *b, int *ldb, double *dwork);
extern int nsp_slicot_mb04pa (int *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, double *, double *);
extern int nsp_slicot_mb04pa (int *lham, int *n, int *k, int *nb, double *a, int *lda, double *qg, int *ldqg, double *xa, int *ldxa, double *xg, int *ldxg, double *xq, int *ldxq, double *ya, int *ldya, double *cs, double *tau, double *dwork);
extern int nsp_slicot_mb04pb (int *n, int *ilo, double *a, int *lda, double *qg, int *ldqg, double *cs, double *tau, double *dwork, int *ldwork, int *info);
extern int nsp_slicot_mb04pu (int *, int *, double *, int *, double *, int *, double *, double *, double *, int *, int *);
extern int nsp_slicot_mb04pu (int *n, int *ilo, double *a, int *lda, double *qg, int *ldqg, double *cs, double *tau, double *dwork, int *ldwork, int *info);
extern int nsp_slicot_mb04py (char *, int *, int *, double *, double *, double *, int *, double *, long int);
extern int nsp_slicot_mb04py (char *side, int *m, int *n, double *v, double *tau, double *c__, int *ldc, double *dwork, long int side_len);
extern int nsp_slicot_mb04qb (char *, char *, char *, char *, char *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, double *, double *, int *, int *, long int, long int, long int, long int, long int);
extern int nsp_slicot_mb04qb (char *tranc, char *trand, char *tranq, char *storev, char *storew, int *m, int *n, int *k, double *v, int *ldv, double *w, int *ldw, double *c__, int *ldc, double *d__, int *ldd, double *cs, double *tau, double *dwork, int *ldwork, int *info, long int tranc_len, long int trand_len, long int tranq_len, long int storev_len, long int storew_len);
extern int nsp_slicot_mb04qc (char *, char *, char *, char *, char *, char *, char *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, long int, long int, long int, long int, long int, long int, long int);
extern int nsp_slicot_mb04qc (char *struct__, char *trana, char *tranb, char *tranq, char *direct, char *storev, char *storew, int *m, int *n, int *k, double *v, int *ldv, double *w, int *ldw, double *rs, int *ldrs, double *t, int *ldt, double *a, int *lda, double *b, int *ldb, double *dwork, long int struct_len, long int trana_len, long int tranb_len, long int tranq_len, long int direct_len, long int storev_len, long int storew_len);
extern int nsp_slicot_mb04qf (char *, char *, char *, int *, int *, double *, int *, double *, int *, double *, double *, double *, int *, double *, int *, double *, long int, long int, long int);
extern int nsp_slicot_mb04qf (char *direct, char *storev, char *storew, int *n, int *k, double *v, int *ldv, double *w, int *ldw, double *cs, double *tau, double *rs, int *ldrs, double *t, int *ldt, double *dwork, long int direct_len, long int storev_len, long int storew_len);
extern int nsp_slicot_mb04qu (char *, char *, char *, char *, char *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, double *, double *, int *, int *, long int, long int, long int, long int, long int);
extern int nsp_slicot_mb04qu (char *tranc, char *trand, char *tranq, char *storev, char *storew, int *m, int *n, int *k, double *v, int *ldv, double *w, int *ldw, double *c__, int *ldc, double *d__, int *ldd, double *cs, double *tau, double *dwork, int *ldwork, int *info, long int tranc_len, long int trand_len, long int tranq_len, long int storev_len, long int storew_len);
extern int nsp_slicot_mb04tb (char *, char *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, double *, double *, double *, double *, int *, int *, long int, long int);
extern int nsp_slicot_mb04tb (char *trana, char *tranb, int *n, int *ilo, double *a, int *lda, double *b, int *ldb, double *g, int *ldg, double *q, int *ldq, double *csl, double *csr, double *taul, double *taur, double *dwork, int *ldwork, int *info, long int trana_len, long int tranb_len);
extern int nsp_slicot_mb04ts (char *, char *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, double *, double *, double *, double *, int *, int *, long int, long int);
extern int nsp_slicot_mb04ts (char *trana, char *tranb, int *n, int *ilo, double *a, int *lda, double *b, int *ldb, double *g, int *ldg, double *q, int *ldq, double *csl, double *csr, double *taul, double *taur, double *dwork, int *ldwork, int *info, long int trana_len, long int tranb_len);
extern int nsp_slicot_mb04tt (int *, int *, int *, int *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *, int *, double *, int *);
extern int nsp_slicot_mb04tt (int *updatq, int *updatz, int *m, int *n, int *ifira, int *ifica, int *nca, double *a, int *lda, double *e, int *lde, double *q, int *ldq, double *z__, int *ldz, int *istair, int *rank, double *tol, int *iwork);
extern int nsp_slicot_mb04tu (int *, double *, int *, double *, int *, double *, double *);
extern int nsp_slicot_mb04tu (int *n, double *x, int *incx, double *y, int *incy, double *c__, double *s);
extern int nsp_slicot_mb04tv (int *, int *, int *, int *, int *, int *, double *, int *, double *, int *, double *, int *);
extern int nsp_slicot_mb04tv (int *updatz, int *n, int *nra, int *nca, int *ifira, int *ifica, double *a, int *lda, double *e, int *lde, double *z__, int *ldz);
extern int nsp_slicot_mb04tw (int *, int *, int *, int *, int *, int *, int *, int *, double *, int *, double *, int *, double *, int *);
extern int nsp_slicot_mb04tw (int *updatq, int *m, int *n, int *nre, int *nce, int *ifire, int *ifice, int *ifica, double *a, int *lda, double *e, int *lde, double *q, int *ldq);
extern int nsp_slicot_mb04tx (int *updatq, int *updatz, int *m, int *n, int *nblcks, int *inuk, int *imuk, double *a, int *lda, double *e, int *lde, double *q, int *ldq, double *z__, int *ldz, int *mnei);
extern int nsp_slicot_mb04ty (int *, int *, int *, int *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *);
extern int nsp_slicot_mb04ty (int *updatq, int *updatz, int *m, int *n, int *nblcks, int *inuk, int *imuk, double *a, int *lda, double *e, int *lde, double *q, int *ldq, double *z__, int *ldz, int *info);
extern int nsp_slicot_mb04ud (char *, char *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *, int *, double *, double *, int *, long int, long int);
extern int nsp_slicot_mb04ud (char *jobq, char *jobz, int *m, int *n, double *a, int *lda, double *e, int *lde, double *q, int *ldq, double *z__, int *ldz, int *ranke, int *istair, double *tol, double *dwork, int *info, long int jobq_len, long int jobz_len);
extern int nsp_slicot_mb04vd (char *, char *, char *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *, int *, int *, int *, int *, int *, int *, double *, int *, int *, long int, long int, long int);
extern int nsp_slicot_mb04vd (char *mode, char *jobq, char *jobz, int *m, int *n, int *ranke, double *a, int *lda, double *e, int *lde, double *q, int *ldq, double *z__, int *ldz, int *istair, int *nblcks, int *nblcki, int *imuk, int *inuk, int *imuk0, int *mnei, double *tol, int *iwork, int *info, long int mode_len, long int jobq_len, long int jobz_len);
extern int nsp_slicot_mb04vx (int *, int *, int *, int *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *);
extern int nsp_slicot_mb04vx (int *updatq, int *updatz, int *m, int *n, int *nblcks, int *inuk, int *imuk, double *a, int *lda, double *e, int *lde, double *q, int *ldq, double *z__, int *ldz, int *mnei);
extern int nsp_slicot_mb04wd (char *, char *, int *, int *, int *, double *, int *, double *, int *, double *, double *, double *, int *, int *, long int, long int);
extern int nsp_slicot_mb04wd (char *tranq1, char *tranq2, int *m, int *n, int *k, double *q1, int *ldq1, double *q2, int *ldq2, double *cs, double *tau, double *dwork, int *ldwork, int *info, long int tranq1_len, long int tranq2_len);
extern int nsp_slicot_mb04wp (int *n, int *ilo, double *u1, int *ldu1, double *u2, int *ldu2, double *cs, double *tau, double *dwork, int *ldwork, int *info);
extern int nsp_slicot_mb04wr (char *job, char *trans, int *n, int *ilo, double *q1, int *ldq1, double *q2, int *ldq2, double *cs, double *tau, double *dwork, int *ldwork, int *info, long int job_len, long int trans_len);
extern int nsp_slicot_mb04wu (char *, char *, int *, int *, int *, double *, int *, double *, int *, double *, double *, double *, int *, int *, long int, long int);
extern int nsp_slicot_mb04wu (char *tranq1, char *tranq2, int *m, int *n, int *k, double *q1, int *ldq1, double *q2, int *ldq2, double *cs, double *tau, double *dwork, int *ldwork, int *info, long int tranq1_len, long int tranq2_len);
extern int nsp_slicot_mb04xd (char *jobu, char *jobv, int *m, int *n, int *rank, double *theta, double *a, int *lda, double *u, int *ldu, double *v, int *ldv, double *q, int *inul, double *tol, double *reltol, double *dwork, int *ldwork, int *iwarn, int *info, long int jobu_len, long int jobv_len);
extern int nsp_slicot_mb04xy (char *, char *, int *, int *, double *, int *, double *, double *, double *, int *, double *, int *, int *, int *, long int, long int);
extern int nsp_slicot_mb04xy (char *jobu, char *jobv, int *m, int *n, double *x, int *ldx, double *taup, double *tauq, double *u, int *ldu, double *v, int *ldv, int *inul, int *info, long int jobu_len, long int jobv_len);
extern int nsp_slicot_mb04yd (char *, char *, int *, int *, int *, double *, double *, double *, double *, int *, double *, int *, int *, double *, double *, double *, int *, int *, int *, long int, long int);
extern int nsp_slicot_mb04yd (char *jobu, char *jobv, int *m, int *n, int *rank, double *theta, double *q, double *e, double *u, int *ldu, double *v, int *ldv, int *inul, double *tol, double *reltol, double *dwork, int *ldwork, int *iwarn, int *info, long int jobu_len, long int jobv_len);
extern int nsp_slicot_mb04yw (int *, int *, int *, int *, int *, int *, int *, double *, double *, double *, double *, int *, double *, int *, double *);
extern int nsp_slicot_mb04yw (int *qrit, int *updatu, int *updatv, int *m, int *n, int *l, int *k, double *shift, double *d__, double *e, double *u, int *ldu, double *v, int *ldv, double *dwork);
extern int nsp_slicot_mb04zd (char *compu, int *n, double *a, int *lda, double *qg, int *ldqg, double *u, int *ldu, double *dwork, int *info, long int compu_len);
extern int nsp_slicot_mb04zd (char *, int *, double *, int *, double *, int *, double *, int *, double *, int *, long int);
extern int nsp_slicot_mb05md (char *balanc, int *n, double *delta, double *a, int *lda, double *v, int *ldv, double *y, int *ldy, double *valr, double *vali, int *iwork, double *dwork, int *ldwork, int *info, long int balanc_len);
extern int nsp_slicot_mb05my (char *balanc, int *n, double *a, int *lda, double *wr, double *wi, double *r__, int *ldr, double *q, int *ldq, double *dwork, int *ldwork, int *info, long int balanc_len);
extern int nsp_slicot_mb05my (char *, int *, double *, int *, double *, double *, double *, int *, double *, int *, double *, int *, int *, long int);
extern int nsp_slicot_mb05nd (int *n, double *delta, double *a, int *lda, double *ex, int *ldex, double *exint, int *ldexin, double *tol, int *iwork, double *dwork, int *ldwork, int *info);
extern int nsp_slicot_mb05od (char *balanc, int *n, int *ndiag, double *delta, double *a, int *lda, int *mdig, int *idig, int *iwork, double *dwork, int *ldwork, int *iwarn, int *info, long int balanc_len);
extern int nsp_slicot_mb05oy (char *, int *, int *, int *, double *, int *, double *, int *, long int);
extern int nsp_slicot_mb05oy (char *job, int *n, int *low, int *igh, double *a, int *lda, double *scale, int *info, long int job_len);
extern int nsp_slicot_mb3oyz (int *, int *, doubleC *, int *, double *, double *, int *, double *, int *, doubleC *, double *, doubleC *, int *);
extern int nsp_slicot_mb3oyz (int *m, int *n, doubleC * a, int *lda, double *rcond, double *svlmax, int *rank, double *sval, int *jpvt, doubleC * tau, double *dwork, doubleC * zwork, int *info);
extern int nsp_slicot_mb3pyz (int *, int *, doubleC *, int *, double *, double *, int *, double *, int *, doubleC *, double *, doubleC *, int *);
extern int nsp_slicot_mb3pyz (int *m, int *n, doubleC * a, int *lda, double *rcond, double *svlmax, int *rank, double *sval, int *jpvt, doubleC * tau, double *dwork, doubleC * zwork, int *info);
extern int nsp_slicot_mc01md (int *dp, double *alpha, int *k, double *p, double *q, int *info);
extern int nsp_slicot_mc01nd (int *dp, double *xr, double *xi, double *p, double *vr, double *vi, int *info);
extern int nsp_slicot_mc01od (int *k, double *rez, double *imz, double *rep, double *imp, double *dwork, int *info);
extern int nsp_slicot_mc01pd (int *, double *, double *, double *, double *, int *);
extern int nsp_slicot_mc01pd (int *k, double *rez, double *imz, double *p, double *dwork, int *info);
extern int nsp_slicot_mc01py (int *, double *, double *, double *, double *, int *);
extern int nsp_slicot_mc01py (int *k, double *rez, double *imz, double *p, double *dwork, int *info);
extern int nsp_slicot_mc01qd (int *da, int *db, double *a, double *b, double *rq, int *iwarn, int *info);
extern int nsp_slicot_mc01rd (int *dp1, int *dp2, int *dp3, double *alpha, double *p1, double *p2, double *p3, int *info);
extern int nsp_slicot_mc01sd (int *dp, double *p, int *s, int *t, double *mant, int *e, int *iwork, int *info);
extern int nsp_slicot_mc01sw (double *a, int *b, double *m, int *e);
extern int nsp_slicot_mc01sw (double *, int *, double *, int *);
extern int nsp_slicot_mc01sx (int *, int *, int *, double *);
extern int nsp_slicot_mc01sx (int *lb, int *ub, int *e, double *mant);
extern int nsp_slicot_mc01sy (double *, int *, int *, double *, int *);
extern int nsp_slicot_mc01sy (double *m, int *e, int *b, double *a, int *ovflow);
extern int nsp_slicot_mc01td (char *dico, int *dp, double *p, int *stable, int *nz, double *dwork, int *iwarn, int *info, long int dico_len);
extern int nsp_slicot_mc01vd (double *a, double *b, double *c__, double *z1re, double *z1im, double *z2re, double *z2im, int *info);
extern int nsp_slicot_mc01wd (int *dp, double *p, double *u1, double *u2, double *q, int *info);
extern int nsp_slicot_mc03md (int *rp1, int *cp1, int *cp2, int *dp1, int *dp2, int *dp3, double *alpha, double *p1, int *ldp11, int *ldp12, double *p2, int *ldp21, int *ldp22, double *p3, int *ldp31, int *ldp32, double *dwork, int *info);
extern int nsp_slicot_mc03nd (int *mp, int *np, int *dp, double *p, int *ldp1, int *ldp2, int *dk, int *gam, double *nullsp, int *ldnull, double *ker, int *ldker1, int *ldker2, double *tol, int *iwork, double *dwork, int *ldwork, int *info);
extern int nsp_slicot_mc03nx (int *, int *, int *, double *, int *, int *, double *, int *, double *, int *);
extern int nsp_slicot_mc03nx (int *mp, int *np, int *dp, double *p, int *ldp1, int *ldp2, double *a, int *lda, double *e, int *lde);
extern int nsp_slicot_mc03ny (int *, int *, int *, double *, int *, double *, int *, int *, int *, double *, int *, int *);
extern int nsp_slicot_mc03ny (int *nblcks, int *nra, int *nca, double *a, int *lda, double *e, int *lde, int *imuk, int *inuk, double *veps, int *ldveps, int *info);
extern int nsp_slicot_md03ad (char *, char *, char *, char *, U_fp, U_fp, int *, int *, int *, int *, int *, int *, double *, int *, double *, int *, double *, int *, int *, double *, double *, double *, int *, int *, int *, long int, long int, long int, long int);
extern int nsp_slicot_md03ad (char *xinit, char *alg, char *stor, char *uplo, S_fp fcn, U_fp jpj, int *m, int *n, int *itmax, int *nprint, int *ipar, int *lipar, double *dpar1, int *ldpar1, double *dpar2, int *ldpar2, double *x, int *nfev, int *njev, double *tol, double *cgtol, double *dwork, int *ldwork, int *iwarn, int *info, long int xinit_len, long int alg_len, long int stor_len, long int uplo_len);
extern int nsp_slicot_md03ba ();
extern int nsp_slicot_md03ba (int *n, int *ipar, int *lipar, double *fnorm, double *j, int *ldj, double *e, double *jnorms, double *gnorm, int *ipvt, double *dwork, int *ldwork, int *info);
extern int nsp_slicot_md03bb ();
extern int nsp_slicot_md03bb (char *cond, int *n, int *ipar, int *lipar, double *r__, int *ldr, int *ipvt, double *diag, double *qtb, double *delta, double *par, int *ranks, double *x, double *rx, double *tol, double *dwork, int *ldwork, int *info, long int cond_len);
extern int nsp_slicot_md03bd (char *, char *, char *, U_fp, U_fp, U_fp, int *, int *, int *, double *, int *, int *, int *, double *, int *, double *, int *, double *, double *, int *, int *, double *, double *, double *, double *, int *, double *, int *, int *, int *, long int, long int, long int);
extern int nsp_slicot_md03bd (char *xinit, char *scale, char *cond, S_fp fcn, S_fp qrfact, S_fp lmparm, int *m, int *n, int *itmax, double *factor, int *nprint, int *ipar, int *lipar, double *dpar1, int *ldpar1, double *dpar2, int *ldpar2, double *x, double *diag, int *nfev, int *njev, double *ftol, double *xtol, double *gtol, double *tol, int *iwork, double *dwork, int *ldwork, int *iwarn, int *info, long int xinit_len, long int scale_len, long int cond_len);
extern int nsp_slicot_md03bf (int *iflag, int *m, int *n, int *ipar, int *lipar, double *dpar1, int *ldpar1, double *dpar2, int *ldpar2, double *x, int *nfevl, double *e, double *j, int *ldj, double *dwork, int *ldwork, int *info);
extern int nsp_slicot_md03bx (int *, int *, double *, double *, int *, double *, double *, double *, int *, double *, int *, int *);
extern int nsp_slicot_md03bx (int *m, int *n, double *fnorm, double *j, int *ldj, double *e, double *jnorms, double *gnorm, int *ipvt, double *dwork, int *ldwork, int *info);
extern int nsp_slicot_md03by (char *cond, int *n, double *r__, int *ldr, int *ipvt, double *diag, double *qtb, double *delta, double *par, int *rank, double *x, double *rx, double *tol, double *dwork, int *ldwork, int *info, long int cond_len);
extern int nsp_slicot_md03by (char *, int *, double *, int *, int *, double *, double *, double *, double *, int *, double *, double *, double *, double *, int *, int *, long int);
extern int nsp_slicot_nf01ad (int *, int *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *);
extern int nsp_slicot_nf01ad (int *nsmp, int *m, int *l, int *ipar, int *lipar, double *x, int *lx, double *u, int *ldu, double *y, int *ldy, double *dwork, int *ldwork, int *info);
extern int nsp_slicot_nf01ay (int *, int *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *);
extern int nsp_slicot_nf01ay (int *nsmp, int *nz, int *l, int *ipar, int *lipar, double *wb, int *lwb, double *z__, int *ldz, double *y, int *ldy, double *dwork, int *ldwork, int *info);
extern int nsp_slicot_nf01ba ();
extern int nsp_slicot_nf01ba (int *iflag, int *nsmp, int *n, int *ipar, int *lipar, double *z__, int *ldz, double *y, int *ldy, double *x, int *nfevl, double *e, double *j, int *ldj, double *jte, double *dwork, int *ldwork, int *info);
extern int nsp_slicot_nf01bb ();
extern int nsp_slicot_nf01bb (int *iflag, int *nfun, int *lx, int *ipar, int *lipar, double *u, int *ldu, double *y, int *ldy, double *x, int *nfevl, double *e, double *j, int *ldj, double *jte, double *dwork, int *ldwork, int *info);
extern int nsp_slicot_nf01bd (char *cjte, int *nsmp, int *m, int *l, int *ipar, int *lipar, double *x, int *lx, double *u, int *ldu, double *e, double *j, int *ldj, double *jte, double *dwork, int *ldwork, int *info, long int cjte_len);
extern int nsp_slicot_nf01bd (char *, int *, int *, int *, int *, int *, double *, int *, double *, int *, double *, double *, int *, double *, double *, int *, int *, long int);
extern int nsp_slicot_nf01be ();
extern int nsp_slicot_nf01be (int *iflag, int *nsmp, int *n, int *ipar, int *lipar, double *z__, int *ldz, double *y, int *ldy, double *x, int *nfevl, double *e, double *j, int *ldj, double *dwork, int *ldwork, int *info);
extern int nsp_slicot_nf01bf ();
extern int nsp_slicot_nf01bf (int *iflag, int *nfun, int *lx, int *ipar, int *lipar, double *u, int *ldu, double *y, int *ldy, double *x, int *nfevl, double *e, double *j, int *ldj, double *dwork, int *ldwork, int *info);
extern int nsp_slicot_nf01bp ();
extern int nsp_slicot_nf01bp (char *cond, int *n, int *ipar, int *lipar, double *r__, int *ldr, int *ipvt, double *diag, double *qtb, double *delta, double *par, int *ranks, double *x, double *rx, double *tol, double *dwork, int *ldwork, int *info, long int cond_len);
extern int nsp_slicot_nf01bq (char *cond, int *n, int *ipar, int *lipar, double *r__, int *ldr, int *ipvt, double *diag, double *qtb, int *ranks, double *x, double *tol, double *dwork, int *ldwork, int *info, long int cond_len);
extern int nsp_slicot_nf01bq (char *, int *, int *, int *, double *, int *, int *, double *, double *, int *, double *, double *, double *, int *, int *, long int);
extern int nsp_slicot_nf01br (char *, char *, char *, int *, int *, int *, double *, int *, double *, double *, int *, double *, int *, double *, double *, int *, int *, long int, long int, long int);
extern int nsp_slicot_nf01br (char *cond, char *uplo, char *trans, int *n, int *ipar, int *lipar, double *r__, int *ldr, double *sdiag, double *s, int *lds, double *b, int *ranks, double *tol, double *dwork, int *ldwork, int *info, long int cond_len, long int uplo_len, long int trans_len);
extern int nsp_slicot_nf01bs ();
extern int nsp_slicot_nf01bs (int *n, int *ipar, int *lipar, double *fnorm, double *j, int *ldj, double *e, double *jnorms, double *gnorm, int *ipvt, double *dwork, int *ldwork, int *info);
extern int nsp_slicot_nf01bu ();
extern int nsp_slicot_nf01bu (char *stor, char *uplo, int *n, int *ipar, int *lipar, double *dpar, int *ldpar, double *j, int *ldj, double *jtj, int *ldjtj, double *dwork, int *ldwork, int *info, long int stor_len, long int uplo_len);
extern int nsp_slicot_nf01bv ();
extern int nsp_slicot_nf01bv (char *, char *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *, long int, long int);
extern int nsp_slicot_nf01bv (char *stor, char *uplo, int *n, int *ipar, int *lipar, double *dpar, int *ldpar, double *j, int *ldj, double *jtj, int *ldjtj, double *dwork, int *ldwork, int *info, long int stor_len, long int uplo_len);
extern int nsp_slicot_nf01bw ();
extern int nsp_slicot_nf01bw (int *n, int *ipar, int *lipar, double *dpar, int *ldpar, double *j, int *ldj, double *x, int *incx, double *dwork, int *ldwork, int *info);
extern int nsp_slicot_nf01bx ();
extern int nsp_slicot_nf01bx (int *n, int *ipar, int *lipar, double *dpar, int *ldpar, double *j, int *ldj, double *x, int *incx, double *dwork, int *ldwork, int *info);
extern int nsp_slicot_nf01by (char *cjte, int *nsmp, int *nz, int *l, int *ipar, int *lipar, double *wb, int *lwb, double *z__, int *ldz, double *e, double *j, int *ldj, double *jte, double *dwork, int *ldwork, int *info, long int cjte_len);
extern int nsp_slicot_nf01by (char *, int *, int *, int *, int *, int *, double *, int *, double *, int *, double *, double *, int *, double *, double *, int *, int *, long int);
extern int nsp_slicot_sb01bd (char *dico, int *n, int *m, int *np, double *alpha, double *a, int *lda, double *b, int *ldb, double *wr, double *wi, int *nfp, int *nap, int *nup, double *f, int *ldf, double *z__, int *ldz, double *tol, double *dwork, int *ldwork, int *iwarn, int *info, long int dico_len);
extern int nsp_slicot_sb01bx (int *, int *, double *, double *, double *, double *, double *, double *);
extern int nsp_slicot_sb01bx (int *reig, int *n, double *xr, double *xi, double *wr, double *wi, double *s, double *p);
extern int nsp_slicot_sb01by (int *, int *, double *, double *, double *, double *, double *, double *, double *, int *);
extern int nsp_slicot_sb01by (int *n, int *m, double *s, double *p, double *a, double *b, double *f, double *tol, double *dwork, int *info);
extern int nsp_slicot_sb01dd (int *n, int *m, int *indcon, double *a, int *lda, double *b, int *ldb, int *nblk, double *wr, double *wi, double *z__, int *ldz, double *y, int *count, double *g, int *ldg, double *tol, int *iwork, double *dwork, int *ldwork, int *info);
extern int nsp_slicot_sb01fy (int *discr, int *n, int *m, double *a, int *lda, double *b, int *ldb, double *f, int *ldf, double *v, int *ldv, int *info);
extern int nsp_slicot_sb01fy (int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *);
extern int nsp_slicot_sb01md (int *ncont, int *n, double *a, int *lda, double *b, double *wr, double *wi, double *z__, int *ldz, double *g, double *dwork, int *info);
extern int nsp_slicot_sb02cx ();
extern int nsp_slicot_sb02cx (double *reig, double *ieig);
extern int nsp_slicot_sb02md (char *, char *, char *, char *, char *, int *, double *, int *, double *, int *, double *, int *, double *, double *, double *, double *, int *, double *, int *, int *, double *, int *, int *, int *, long int, long int, long int, long int, long int);
extern int nsp_slicot_sb02md (char *dico, char *hinv, char *uplo, char *scal, char *sort, int *n, double *a, int *lda, double *g, int *ldg, double *q, int *ldq, double *rcond, double *wr, double *wi, double *s, int *lds, double *u, int *ldu, int *iwork, double *dwork, int *ldwork, int *bwork, int *info, long int dico_len, long int hinv_len, long int uplo_len, long int scal_len, long int sort_len);
extern int nsp_slicot_sb02mr ();
extern int nsp_slicot_sb02mr (double *reig, double *ieig);
extern int nsp_slicot_sb02ms ();
extern int nsp_slicot_sb02ms (double *reig, double *ieig);
extern int nsp_slicot_sb02mt (char *, char *, char *, char *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *, int *, double *, int *, int *, double *, int *, int *, long int, long int, long int, long int);
extern int nsp_slicot_sb02mt (char *jobg, char *jobl, char *fact, char *uplo, int *n, int *m, double *a, int *lda, double *b, int *ldb, double *q, int *ldq, double *r__, int *ldr, double *l, int *ldl, int *ipiv, int *oufact, double *g, int *ldg, int *iwork, double *dwork, int *ldwork, int *info, long int jobg_len, long int jobl_len, long int fact_len, long int uplo_len);
extern int nsp_slicot_sb02mu (char *, char *, char *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *, double *, int *, int *, long int, long int, long int);
extern int nsp_slicot_sb02mu (char *dico, char *hinv, char *uplo, int *n, double *a, int *lda, double *g, int *ldg, double *q, int *ldq, double *s, int *lds, int *iwork, double *dwork, int *ldwork, int *info, long int dico_len, long int hinv_len, long int uplo_len);
extern int nsp_slicot_sb02mv ();
extern int nsp_slicot_sb02mv (double *reig, double *ieig);
extern int nsp_slicot_sb02mw ();
extern int nsp_slicot_sb02mw (double *reig, double *ieig);
extern int nsp_slicot_sb02nd (char *, char *, char *, char *, int *, int *, int *, double *, int *, double *, int *, double *, int *, int *, double *, int *, double *, int *, double *, double *, int *, int *, int *, double *, int *, int *, long int, long int, long int, long int);
extern int nsp_slicot_sb02nd (char *dico, char *fact, char *uplo, char *jobl, int *n, int *m, int *p, double *a, int *lda, double *b, int *ldb, double *r__, int *ldr, int *ipiv, double *l, int *ldl, double *x, int *ldx, double *rnorm, double *f, int *ldf, int *oufact, int *iwork, double *dwork, int *ldwork, int *info, long int dico_len, long int fact_len, long int uplo_len, long int jobl_len);
extern int nsp_slicot_sb02od (char *, char *, char *, char *, char *, char *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, double *, int *, double *, double *, double *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *, int *, long int, long int, long int, long int, long int, long int);
extern int nsp_slicot_sb02od (char *dico, char *jobb, char *fact, char *uplo, char *jobl, char *sort, int *n, int *m, int *p, double *a, int *lda, double *b, int *ldb, double *q, int *ldq, double *r__, int *ldr, double *l, int *ldl, double *rcond, double *x, int *ldx, double *alfar, double *alfai, double *beta, double *s, int *lds, double *t, int *ldt, double *u, int *ldu, double *tol, int *iwork, double *dwork, int *ldwork, int *bwork, int *info, long int dico_len, long int jobb_len, long int fact_len, long int uplo_len, long int jobl_len, long int sort_len);
extern int nsp_slicot_sb02ou ();
extern int nsp_slicot_sb02ou (double *alphar, double *alphai, double *beta);
extern int nsp_slicot_sb02ov ();
extern int nsp_slicot_sb02ov (double *alphar, double *alphai, double *beta);
extern int nsp_slicot_sb02ow ();
extern int nsp_slicot_sb02ow (double *alphar, double *alphai, double *beta);
extern int nsp_slicot_sb02ox (double *alphar, double *alphai, double *beta);
extern int nsp_slicot_sb02oy (char *, char *, char *, char *, char *, char *, char *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *, long int, long int, long int, long int, long int, long int, long int);
extern int nsp_slicot_sb02oy (char *type__, char *dico, char *jobb, char *fact, char *uplo, char *jobl, char *jobe, int *n, int *m, int *p, double *a, int *lda, double *b, int *ldb, double *q, int *ldq, double *r__, int *ldr, double *l, int *ldl, double *e, int *lde, double *af, int *ldaf, double *bf, int *ldbf, double *tol, int *iwork, double *dwork, int *ldwork, int *info, long int type_len, long int dico_len, long int jobb_len, long int fact_len, long int uplo_len, long int jobl_len, long int jobe_len);
extern int nsp_slicot_sb02pd (char *job, char *trana, char *uplo, int *n, double *a, int *lda, double *g, int *ldg, double *q, int *ldq, double *x, int *ldx, double *rcond, double *ferr, double *wr, double *wi, int *iwork, double *dwork, int *ldwork, int *info, long int job_len, long int trana_len, long int uplo_len);
extern int nsp_slicot_sb02qd (char *, char *, char *, char *, char *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, double *, double *, int *, double *, int *, int *, long int, long int, long int, long int, long int);
extern int nsp_slicot_sb02qd (char *job, char *fact, char *trana, char *uplo, char *lyapun, int *n, double *a, int *lda, double *t, int *ldt, double *u, int *ldu, double *g, int *ldg, double *q, int *ldq, double *x, int *ldx, double *sep, double *rcond, double *ferr, int *iwork, double *dwork, int *ldwork, int *info, long int job_len, long int fact_len, long int trana_len, long int uplo_len, long int lyapun_len);
extern int nsp_slicot_sb02rd (char *, char *, char *, char *, char *, char *, char *, char *, char *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, double *, double *, double *, double *, double *, int *, int *, double *, int *, int *, int *, long int, long int, long int, long int, long int, long int, long int, long int, long int);
extern int nsp_slicot_sb02rd (char *job, char *dico, char *hinv, char *trana, char *uplo, char *scal, char *sort, char *fact, char *lyapun, int *n, double *a, int *lda, double *t, int *ldt, double *v, int *ldv, double *g, int *ldg, double *q, int *ldq, double *x, int *ldx, double *sep, double *rcond, double *ferr, double *wr, double *wi, double *s, int *lds, int *iwork, double *dwork, int *ldwork, int *bwork, int *info, long int job_len, long int dico_len, long int hinv_len, long int trana_len, long int uplo_len, long int scal_len, long int sort_len, long int fact_len, long int lyapun_len);
extern int nsp_slicot_sb02ru (char *, char *, char *, char *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *, double *, int *, int *, long int, long int, long int, long int);
extern int nsp_slicot_sb02ru (char *dico, char *hinv, char *trana, char *uplo, int *n, double *a, int *lda, double *g, int *ldg, double *q, int *ldq, double *s, int *lds, int *iwork, double *dwork, int *ldwork, int *info, long int dico_len, long int hinv_len, long int trana_len, long int uplo_len);
extern int nsp_slicot_sb02sd (char *, char *, char *, char *, char *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, double *, double *, int *, double *, int *, int *, long int, long int, long int, long int, long int);
extern int nsp_slicot_sb02sd (char *job, char *fact, char *trana, char *uplo, char *lyapun, int *n, double *a, int *lda, double *t, int *ldt, double *u, int *ldu, double *g, int *ldg, double *q, int *ldq, double *x, int *ldx, double *sepd, double *rcond, double *ferr, int *iwork, double *dwork, int *ldwork, int *info, long int job_len, long int fact_len, long int trana_len, long int uplo_len, long int lyapun_len);
extern int nsp_slicot_sb03md (char *dico, char *job, char *fact, char *trana, int *n, double *a, int *lda, double *u, int *ldu, double *c__, int *ldc, double *scale, double *sep, double *ferr, double *wr, double *wi, int *iwork, double *dwork, int *ldwork, int *info, long int dico_len, long int job_len, long int fact_len, long int trana_len);
extern int nsp_slicot_sb03mu (int *ltranl, int *ltranr, int *isgn, int *n1, int *n2, double *tl, int *ldtl, double *tr, int *ldtr, double *b, int *ldb, double *scale, double *x, int *ldx, double *xnorm, int *info);
extern int nsp_slicot_sb03mv (int *, int *, double *, int *, double *, int *, double *, double *, int *, double *, int *);
extern int nsp_slicot_sb03mv (int *ltran, int *lupper, double *t, int *ldt, double *b, int *ldb, double *scale, double *x, int *ldx, double *xnorm, int *info);
extern int nsp_slicot_sb03mw (int *, int *, double *, int *, double *, int *, double *, double *, int *, double *, int *);
extern int nsp_slicot_sb03mw (int *ltran, int *lupper, double *t, int *ldt, double *b, int *ldb, double *scale, double *x, int *ldx, double *xnorm, int *info);
extern int nsp_slicot_sb03mx (char *, int *, double *, int *, double *, int *, double *, double *, int *, long int);
extern int nsp_slicot_sb03mx (char *trana, int *n, double *a, int *lda, double *c__, int *ldc, double *scale, double *dwork, int *info, long int trana_len);
extern int nsp_slicot_sb03my (char *, int *, double *, int *, double *, int *, double *, int *, long int);
extern int nsp_slicot_sb03my (char *trana, int *n, double *a, int *lda, double *c__, int *ldc, double *scale, int *info, long int trana_len);
extern int nsp_slicot_sb03od (char *, char *, char *, int *, int *, double *, int *, double *, int *, double *, int *, double *, double *, double *, double *, int *, int *, long int, long int, long int);
extern int nsp_slicot_sb03od (char *dico, char *fact, char *trans, int *n, int *m, double *a, int *lda, double *q, int *ldq, double *b, int *ldb, double *scale, double *wr, double *wi, double *dwork, int *ldwork, int *info, long int dico_len, long int fact_len, long int trans_len);
extern int nsp_slicot_sb03or (int *discr, int *ltrans, int *n, int *m, double *s, int *lds, double *a, int *lda, double *c__, int *ldc, double *scale, int *info);
extern int nsp_slicot_sb03or (int *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *);
extern int nsp_slicot_sb03ot (int *discr, int *ltrans, int *n, double *s, int *lds, double *r__, int *ldr, double *scale, double *dwork, int *info);
extern int nsp_slicot_sb03ot (int *, int *, int *, double *, int *, double *, int *, double *, double *, int *);
extern int nsp_slicot_sb03ou (int *discr, int *ltrans, int *n, int *m, double *a, int *lda, double *b, int *ldb, double *tau, double *u, int *ldu, double *scale, double *dwork, int *ldwork, int *info);
extern int nsp_slicot_sb03ou (int *, int *, int *, int *, double *, int *, double *, int *, double *, double *, int *, double *, double *, int *, int *);
extern int nsp_slicot_sb03ov (double *a, double *b, double *c__, double *s);
extern int nsp_slicot_sb03ov (double *, double *, double *, double *);
extern int nsp_slicot_sb03oy (int *discr, int *ltrans, int *isgn, double *s, int *lds, double *r__, int *ldr, double *a, int *lda, double *scale, int *info);
extern int nsp_slicot_sb03oy (int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *);
extern int nsp_slicot_sb03pd (char *job, char *fact, char *trana, int *n, double *a, int *lda, double *u, int *ldu, double *c__, int *ldc, double *scale, double *sepd, double *ferr, double *wr, double *wi, int *iwork, double *dwork, int *ldwork, int *info, long int job_len, long int fact_len, long int trana_len);
extern int nsp_slicot_sb03qd (char *, char *, char *, char *, char *, int *, double *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, double *, double *, int *, double *, int *, int *, long int, long int, long int, long int, long int);
extern int nsp_slicot_sb03qd (char *job, char *fact, char *trana, char *uplo, char *lyapun, int *n, double *scale, double *a, int *lda, double *t, int *ldt, double *u, int *ldu, double *c__, int *ldc, double *x, int *ldx, double *sep, double *rcond, double *ferr, int *iwork, double *dwork, int *ldwork, int *info, long int job_len, long int fact_len, long int trana_len, long int uplo_len, long int lyapun_len);
extern int nsp_slicot_sb03qx (char *, char *, char *, int *, double *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *, long int, long int, long int);
extern int nsp_slicot_sb03qx (char *trana, char *uplo, char *lyapun, int *n, double *xanorm, double *t, int *ldt, double *u, int *ldu, double *r__, int *ldr, double *ferr, int *iwork, double *dwork, int *ldwork, int *info, long int trana_len, long int uplo_len, long int lyapun_len);
extern int nsp_slicot_sb03qy (char *, char *, char *, int *, double *, int *, double *, int *, double *, int *, double *, double *, int *, double *, int *, int *, long int, long int, long int);
extern int nsp_slicot_sb03qy (char *job, char *trana, char *lyapun, int *n, double *t, int *ldt, double *u, int *ldu, double *x, int *ldx, double *sep, double *thnorm, int *iwork, double *dwork, int *ldwork, int *info, long int job_len, long int trana_len, long int lyapun_len);
extern int nsp_slicot_sb03rd (char *job, char *fact, char *trana, int *n, double *a, int *lda, double *u, int *ldu, double *c__, int *ldc, double *scale, double *sep, double *ferr, double *wr, double *wi, int *iwork, double *dwork, int *ldwork, int *info, long int job_len, long int fact_len, long int trana_len);
extern int nsp_slicot_sb03sd (char *, char *, char *, char *, char *, int *, double *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, double *, double *, int *, double *, int *, int *, long int, long int, long int, long int, long int);
extern int nsp_slicot_sb03sd (char *job, char *fact, char *trana, char *uplo, char *lyapun, int *n, double *scale, double *a, int *lda, double *t, int *ldt, double *u, int *ldu, double *c__, int *ldc, double *x, int *ldx, double *sepd, double *rcond, double *ferr, int *iwork, double *dwork, int *ldwork, int *info, long int job_len, long int fact_len, long int trana_len, long int uplo_len, long int lyapun_len);
extern int nsp_slicot_sb03sx (char *, char *, char *, int *, double *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *, long int, long int, long int);
extern int nsp_slicot_sb03sx (char *trana, char *uplo, char *lyapun, int *n, double *xanorm, double *t, int *ldt, double *u, int *ldu, double *r__, int *ldr, double *ferr, int *iwork, double *dwork, int *ldwork, int *info, long int trana_len, long int uplo_len, long int lyapun_len);
extern int nsp_slicot_sb03sy (char *, char *, char *, int *, double *, int *, double *, int *, double *, int *, double *, double *, int *, double *, int *, int *, long int, long int, long int);
extern int nsp_slicot_sb03sy (char *job, char *trana, char *lyapun, int *n, double *t, int *ldt, double *u, int *ldu, double *xa, int *ldxa, double *sepd, double *thnorm, int *iwork, double *dwork, int *ldwork, int *info, long int job_len, long int trana_len, long int lyapun_len);
extern int nsp_slicot_sb03td (char *job, char *fact, char *trana, char *uplo, char *lyapun, int *n, double *scale, double *a, int *lda, double *t, int *ldt, double *u, int *ldu, double *c__, int *ldc, double *x, int *ldx, double *sep, double *rcond, double *ferr, double *wr, double *wi, int *iwork, double *dwork, int *ldwork, int *info, long int job_len, long int fact_len, long int trana_len, long int uplo_len, long int lyapun_len);
extern int nsp_slicot_sb03ud (char *job, char *fact, char *trana, char *uplo, char *lyapun, int *n, double *scale, double *a, int *lda, double *t, int *ldt, double *u, int *ldu, double *c__, int *ldc, double *x, int *ldx, double *sepd, double *rcond, double *ferr, double *wr, double *wi, int *iwork, double *dwork, int *ldwork, int *info, long int job_len, long int fact_len, long int trana_len, long int uplo_len, long int lyapun_len);
extern int nsp_slicot_sb04md (int *n, int *m, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *z__, int *ldz, int *iwork, double *dwork, int *ldwork, int *info);
extern int nsp_slicot_sb04mr (int *, double *, int *, int *);
extern int nsp_slicot_sb04mr (int *m, double *d__, int *ipr, int *info);
extern int nsp_slicot_sb04mu (int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *);
extern int nsp_slicot_sb04mu (int *n, int *m, int *ind, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ipr, int *info);
extern int nsp_slicot_sb04mw (int *, double *, int *, int *);
extern int nsp_slicot_sb04mw (int *m, double *d__, int *ipr, int *info);
extern int nsp_slicot_sb04my (int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *);
extern int nsp_slicot_sb04my (int *n, int *m, int *ind, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ipr, int *info);
extern int nsp_slicot_sb04nd (char *abschu, char *ula, char *ulb, int *n, int *m, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *tol, int *iwork, double *dwork, int *ldwork, int *info, long int abschu_len, long int ula_len, long int ulb_len);
extern int nsp_slicot_sb04nv (char *abschr, char *ul, int *n, int *m, double *c__, int *ldc, int *indx, double *ab, int *ldab, double *d__, long int abschr_len, long int ul_len);
extern int nsp_slicot_sb04nv (char *, char *, int *, int *, double *, int *, int *, double *, int *, double *, long int, long int);
extern int nsp_slicot_sb04nw (char *abschr, char *ul, int *n, int *m, double *c__, int *ldc, int *indx, double *ab, int *ldab, double *d__, long int abschr_len, long int ul_len);
extern int nsp_slicot_sb04nw (char *, char *, int *, int *, double *, int *, int *, double *, int *, double *, long int, long int);
extern int nsp_slicot_sb04nx (char *, char *, int *, double *, int *, double *, double *, double *, double *, double *, double *, int *, double *, int *, int *, long int, long int);
extern int nsp_slicot_sb04nx (char *rc, char *ul, int *m, double *a, int *lda, double *lambd1, double *lambd2, double *lambd3, double *lambd4, double *d__, double *tol, int *iwork, double *dwork, int *lddwor, int *info, long int rc_len, long int ul_len);
extern int nsp_slicot_sb04ny (char *, char *, int *, double *, int *, double *, double *, double *, int *, double *, int *, int *, long int, long int);
extern int nsp_slicot_sb04ny (char *rc, char *ul, int *m, double *a, int *lda, double *lambda, double *d__, double *tol, int *iwork, double *dwork, int *lddwor, int *info, long int rc_len, long int ul_len);
extern int nsp_slicot_sb04od (char *reduce, char *trans, char *jobd, int *m, int *n, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, double *e, int *lde, double *f, int *ldf, double *scale, double *dif, double *p, int *ldp, double *q, int *ldq, double *u, int *ldu, double *v, int *ldv, int *iwork, double *dwork, int *ldwork, int *info, long int reduce_len, long int trans_len, long int jobd_len);
extern int nsp_slicot_sb04ow (int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *);
extern int nsp_slicot_sb04ow (int *m, int *n, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, double *e, int *lde, double *f, int *ldf, double *scale, int *iwork, int *info);
extern int nsp_slicot_sb04pd (char *dico, char *facta, char *factb, char *trana, char *tranb, int *isgn, int *m, int *n, double *a, int *lda, double *u, int *ldu, double *b, int *ldb, double *v, int *ldv, double *c__, int *ldc, double *scale, double *dwork, int *ldwork, int *info, long int dico_len, long int facta_len, long int factb_len, long int trana_len, long int tranb_len);
extern int nsp_slicot_sb04px (int *, int *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, double *, int *, double *, int *);
extern int nsp_slicot_sb04px (int *ltranl, int *ltranr, int *isgn, int *n1, int *n2, double *tl, int *ldtl, double *tr, int *ldtr, double *b, int *ldb, double *scale, double *x, int *ldx, double *xnorm, int *info);
extern int nsp_slicot_sb04py (char *, char *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, double *, int *, long int, long int);
extern int nsp_slicot_sb04py (char *trana, char *tranb, int *isgn, int *m, int *n, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *scale, double *dwork, int *info, long int trana_len, long int tranb_len);
extern int nsp_slicot_sb04qd (int *n, int *m, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *z__, int *ldz, int *iwork, double *dwork, int *ldwork, int *info);
extern int nsp_slicot_sb04qr (int *, double *, int *, int *);
extern int nsp_slicot_sb04qr (int *m, double *d__, int *ipr, int *info);
extern int nsp_slicot_sb04qu (int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *);
extern int nsp_slicot_sb04qu (int *n, int *m, int *ind, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ipr, int *info);
extern int nsp_slicot_sb04qy (int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *);
extern int nsp_slicot_sb04qy (int *n, int *m, int *ind, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ipr, int *info);
extern int nsp_slicot_sb04rd (char *abschu, char *ula, char *ulb, int *n, int *m, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *tol, int *iwork, double *dwork, int *ldwork, int *info, long int abschu_len, long int ula_len, long int ulb_len);
extern int nsp_slicot_sb04rv (char *abschr, char *ul, int *n, int *m, double *c__, int *ldc, int *indx, double *ab, int *ldab, double *ba, int *ldba, double *d__, double *dwork, long int abschr_len, long int ul_len);
extern int nsp_slicot_sb04rv (char *, char *, int *, int *, double *, int *, int *, double *, int *, double *, int *, double *, double *, long int, long int);
extern int nsp_slicot_sb04rw (char *abschr, char *ul, int *n, int *m, double *c__, int *ldc, int *indx, double *ab, int *ldab, double *ba, int *ldba, double *d__, double *dwork, long int abschr_len, long int ul_len);
extern int nsp_slicot_sb04rw (char *, char *, int *, int *, double *, int *, int *, double *, int *, double *, int *, double *, double *, long int, long int);
extern int nsp_slicot_sb04rx (char *, char *, int *, double *, int *, double *, double *, double *, double *, double *, double *, int *, double *, int *, int *, long int, long int);
extern int nsp_slicot_sb04rx (char *rc, char *ul, int *m, double *a, int *lda, double *lambd1, double *lambd2, double *lambd3, double *lambd4, double *d__, double *tol, int *iwork, double *dwork, int *lddwor, int *info, long int rc_len, long int ul_len);
extern int nsp_slicot_sb04ry (char *, char *, int *, double *, int *, double *, double *, double *, int *, double *, int *, int *, long int, long int);
extern int nsp_slicot_sb04ry (char *rc, char *ul, int *m, double *a, int *lda, double *lambda, double *d__, double *tol, int *iwork, double *dwork, int *lddwor, int *info, long int rc_len, long int ul_len);
extern int nsp_slicot_sb06nd (int *n, int *m, int *kmax, double *a, int *lda, double *b, int *ldb, int *kstair, double *u, int *ldu, double *f, int *ldf, double *dwork, int *info);
extern int nsp_slicot_sb08cd (char *dico, int *n, int *m, int *p, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, int *nq, int *nr, double *br, int *ldbr, double *dr, int *lddr, double *tol, double *dwork, int *ldwork, int *iwarn, int *info, long int dico_len);
extern int nsp_slicot_sb08cd (char *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *, int *, double *, int *, double *, int *, double *, double *, int *, int *, int *, long int);
extern int nsp_slicot_sb08dd (char *dico, int *n, int *m, int *p, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, int *nq, int *nr, double *cr, int *ldcr, double *dr, int *lddr, double *tol, double *dwork, int *ldwork, int *iwarn, int *info, long int dico_len);
extern int nsp_slicot_sb08dd (char *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *, int *, double *, int *, double *, int *, double *, double *, int *, int *, int *, long int);
extern int nsp_slicot_sb08ed (char *dico, int *n, int *m, int *p, double *alpha, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, int *nq, int *nr, double *br, int *ldbr, double *dr, int *lddr, double *tol, double *dwork, int *ldwork, int *iwarn, int *info, long int dico_len);
extern int nsp_slicot_sb08ed (char *, int *, int *, int *, double *, double *, int *, double *, int *, double *, int *, double *, int *, int *, int *, double *, int *, double *, int *, double *, double *, int *, int *, int *, long int);
extern int nsp_slicot_sb08fd (char *dico, int *n, int *m, int *p, double *alpha, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, int *nq, int *nr, double *cr, int *ldcr, double *dr, int *lddr, double *tol, double *dwork, int *ldwork, int *iwarn, int *info, long int dico_len);
extern int nsp_slicot_sb08fd (char *, int *, int *, int *, double *, double *, int *, double *, int *, double *, int *, double *, int *, int *, int *, double *, int *, double *, int *, double *, double *, int *, int *, int *, long int);
extern int nsp_slicot_sb08gd (int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *, double *, int *);
extern int nsp_slicot_sb08gd (int *n, int *m, int *p, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, double *br, int *ldbr, double *dr, int *lddr, int *iwork, double *dwork, int *info);
extern int nsp_slicot_sb08hd (int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *, double *, int *);
extern int nsp_slicot_sb08hd (int *n, int *m, int *p, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, double *cr, int *ldcr, double *dr, int *lddr, int *iwork, double *dwork, int *info);
extern int nsp_slicot_sb08md (char *acona, int *da, double *a, double *res, double *e, double *dwork, int *ldwork, int *info, long int acona_len);
extern int nsp_slicot_sb08my (int *da, double *a, double *b, double *epsb);
extern int nsp_slicot_sb08my (int *, double *, double *, double *);
extern int nsp_slicot_sb08nd (char *acona, int *da, double *a, double *res, double *e, double *dwork, int *ldwork, int *info, long int acona_len);
extern int nsp_slicot_sb08ny (int *da, double *a, double *b, double *epsb);
extern int nsp_slicot_sb08ny (int *, double *, double *, double *);
extern int nsp_slicot_sb09md (int *n, int *nc, int *nb, double *h1, int *ldh1, double *h2, int *ldh2, double *ss, int *ldss, double *se, int *ldse, double *pre, int *ldpre, double *tol, int *info);
extern int nsp_slicot_sb10ad (int *job, int *n, int *m, int *np, int *ncon, int *nmeas, double *gamma, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, double *ak, int *ldak, double *bk, int *ldbk, double *ck, int *ldck, double *dk, int *lddk, double *ac, int *ldac, double *bc, int *ldbc, double *cc, int *ldcc, double *dc, int *lddc, double *rcond, double *gtol, double *actol, int *iwork, int *liwork, double *dwork, int *ldwork, int *bwork, int *lbwork, int *info);
extern int nsp_slicot_sb10dd (int *n, int *m, int *np, int *ncon, int *nmeas, double *gamma, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, double *ak, int *ldak, double *bk, int *ldbk, double *ck, int *ldck, double *dk, int *lddk, double *x, int *ldx, double *z__, int *ldz, double *rcond, double *tol, int *iwork, double *dwork, int *ldwork, int *bwork, int *info);
extern int nsp_slicot_sb10ed (int *n, int *m, int *np, int *ncon, int *nmeas, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, double *ak, int *ldak, double *bk, int *ldbk, double *ck, int *ldck, double *dk, int *lddk, double *rcond, double *tol, int *iwork, double *dwork, int *ldwork, int *bwork, int *info);
extern int nsp_slicot_sb10fd (int *n, int *m, int *np, int *ncon, int *nmeas, double *gamma, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, double *ak, int *ldak, double *bk, int *ldbk, double *ck, int *ldck, double *dk, int *lddk, double *rcond, double *tol, int *iwork, double *dwork, int *ldwork, int *bwork, int *info);
extern int nsp_slicot_sb10hd (int *n, int *m, int *np, int *ncon, int *nmeas, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, double *ak, int *ldak, double *bk, int *ldbk, double *ck, int *ldck, double *dk, int *lddk, double *rcond, double *tol, int *iwork, double *dwork, int *ldwork, int *bwork, int *info);
extern int nsp_slicot_sb10id (int *n, int *m, int *np, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, double *factor, int *nk, double *ak, int *ldak, double *bk, int *ldbk, double *ck, int *ldck, double *dk, int *lddk, double *rcond, int *iwork, double *dwork, int *ldwork, int *bwork, int *info);
extern int nsp_slicot_sb10jd (int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *, double *, int *, int *);
extern int nsp_slicot_sb10jd (int *n, int *m, int *np, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, double *e, int *lde, int *nsys, double *dwork, int *ldwork, int *info);
extern int nsp_slicot_sb10kd (int *n, int *m, int *np, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *factor, double *ak, int *ldak, double *bk, int *ldbk, double *ck, int *ldck, double *dk, int *lddk, double *rcond, int *iwork, double *dwork, int *ldwork, int *bwork, int *info);
extern int nsp_slicot_sb10ld (int *, int *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *, double *, int *, int *);
extern int nsp_slicot_sb10ld (int *n, int *m, int *np, int *ncon, int *nmeas, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, double *ak, int *ldak, double *bk, int *ldbk, double *ck, int *ldck, double *dk, int *lddk, double *ac, int *ldac, double *bc, int *ldbc, double *cc, int *ldcc, double *dc, int *lddc, int *iwork, double *dwork, int *ldwork, int *info);
extern int nsp_slicot_sb10md (int *nc, int *mp, int *lendat, int *f, int *ord, int *mnb, int *nblock, int *itype, double *qutol, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, double *omega, int *totord, double *ad, int *ldad, double *bd, int *ldbd, double *cd, int *ldcd, double *dd, int *lddd, double *mju, int *iwork, int *liwork, double *dwork, int *ldwork, doubleC * zwork, int *lzwork, int *info);
extern int nsp_slicot_sb10pd (int *, int *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, double *, double *, int *, int *);
extern int nsp_slicot_sb10pd (int *n, int *m, int *np, int *ncon, int *nmeas, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, double *tu, int *ldtu, double *ty, int *ldty, double *rcond, double *tol, double *dwork, int *ldwork, int *info);
extern int nsp_slicot_sb10qd (int *, int *, int *, int *, int *, double *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *, int *);
extern int nsp_slicot_sb10qd (int *n, int *m, int *np, int *ncon, int *nmeas, double *gamma, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, double *f, int *ldf, double *h__, int *ldh, double *x, int *ldx, double *y, int *ldy, double *xycond, int *iwork, double *dwork, int *ldwork, int *bwork, int *info);
extern int nsp_slicot_sb10rd (int *, int *, int *, int *, int *, double *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *, double *, int *, int *);
extern int nsp_slicot_sb10rd (int *n, int *m, int *np, int *ncon, int *nmeas, double *gamma, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, double *f, int *ldf, double *h__, int *ldh, double *tu, int *ldtu, double *ty, int *ldty, double *x, int *ldx, double *y, int *ldy, double *ak, int *ldak, double *bk, int *ldbk, double *ck, int *ldck, double *dk, int *lddk, int *iwork, double *dwork, int *ldwork, int *info);
extern int nsp_slicot_sb10sd (int *, int *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, double *, int *, double *, int *, int *, int *);
extern int nsp_slicot_sb10sd (int *n, int *m, int *np, int *ncon, int *nmeas, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, double *ak, int *ldak, double *bk, int *ldbk, double *ck, int *ldck, double *dk, int *lddk, double *x, int *ldx, double *y, int *ldy, double *rcond, double *tol, int *iwork, double *dwork, int *ldwork, int *bwork, int *info);
extern int nsp_slicot_sb10td (int *, int *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, double *, int *, double *, int *, int *);
extern int nsp_slicot_sb10td (int *n, int *m, int *np, int *ncon, int *nmeas, double *d__, int *ldd, double *tu, int *ldtu, double *ty, int *ldty, double *ak, int *ldak, double *bk, int *ldbk, double *ck, int *ldck, double *dk, int *lddk, double *rcond, double *tol, int *iwork, double *dwork, int *ldwork, int *info);
extern int nsp_slicot_sb10ud (int *, int *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, double *, double *, int *, int *);
extern int nsp_slicot_sb10ud (int *n, int *m, int *np, int *ncon, int *nmeas, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, double *tu, int *ldtu, double *ty, int *ldty, double *rcond, double *tol, double *dwork, int *ldwork, int *info);
extern int nsp_slicot_sb10vd (int *, int *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *, int *);
extern int nsp_slicot_sb10vd (int *n, int *m, int *np, int *ncon, int *nmeas, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *f, int *ldf, double *h__, int *ldh, double *x, int *ldx, double *y, int *ldy, double *xycond, int *iwork, double *dwork, int *ldwork, int *bwork, int *info);
extern int nsp_slicot_sb10wd (int *, int *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *);
extern int nsp_slicot_sb10wd (int *n, int *m, int *np, int *ncon, int *nmeas, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, double *f, int *ldf, double *h__, int *ldh, double *tu, int *ldtu, double *ty, int *ldty, double *ak, int *ldak, double *bk, int *ldbk, double *ck, int *ldck, double *dk, int *lddk, int *info);
extern int nsp_slicot_sb10yd (int *discfl, int *flag__, int *lendat, double *rfrdat, double *ifrdat, double *omega, int *n, double *a, int *lda, double *b, double *c__, double *d__, double *tol, int *iwork, double *dwork, int *ldwork, doubleC * zwork, int *lzwork, int *info);
extern int nsp_slicot_sb10yd (int *, int *, int *, double *, double *, double *, int *, double *, int *, double *, double *, double *, double *, int *, double *, int *, doubleC *, int *, int *);
extern int nsp_slicot_sb10zd (int *n, int *m, int *np, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, double *factor, double *ak, int *ldak, double *bk, int *ldbk, double *ck, int *ldck, double *dk, int *lddk, double *rcond, double *tol, int *iwork, double *dwork, int *ldwork, int *bwork, int *info);
extern int nsp_slicot_sb10zp (int *discfl, int *n, double *a, int *lda, double *b, double *c__, double *d__, int *iwork, double *dwork, int *ldwork, int *info);
extern int nsp_slicot_sb10zp (int *, int *, double *, int *, double *, double *, double *, int *, double *, int *, int *);
extern int nsp_slicot_sb16ad (char *dico, char *jobc, char *jobo, char *jobmr, char *weight, char *equil, char *ordsel, int *n, int *m, int *p, int *nc, int *ncr, double *alpha, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, double *ac, int *ldac, double *bc, int *ldbc, double *cc, int *ldcc, double *dc, int *lddc, int *ncs, double *hsvc, double *tol1, double *tol2, int *iwork, double *dwork, int *ldwork, int *iwarn, int *info, long int dico_len, long int jobc_len, long int jobo_len, long int jobmr_len, long int weight_len, long int equil_len, long int ordsel_len);
extern int nsp_slicot_sb16ay (char *, char *, char *, char *, int *, int *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, double *, double *, int *, double *, int *, int *, double *, int *, int *, long int, long int, long int, long int);
extern int nsp_slicot_sb16ay (char *dico, char *jobc, char *jobo, char *weight, int *n, int *m, int *p, int *nc, int *ncs, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, double *ac, int *ldac, double *bc, int *ldbc, double *cc, int *ldcc, double *dc, int *lddc, double *scalec, double *scaleo, double *s, int *lds, double *r__, int *ldr, int *iwork, double *dwork, int *ldwork, int *info, long int dico_len, long int jobc_len, long int jobo_len, long int weight_len);
extern int nsp_slicot_sb16bd (char *dico, char *jobd, char *jobmr, char *jobcf, char *equil, char *ordsel, int *n, int *m, int *p, int *ncr, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, double *f, int *ldf, double *g, int *ldg, double *dc, int *lddc, double *hsv, double *tol1, double *tol2, int *iwork, double *dwork, int *ldwork, int *iwarn, int *info, long int dico_len, long int jobd_len, long int jobmr_len, long int jobcf_len, long int equil_len, long int ordsel_len);
extern int nsp_slicot_sb16cd (char *dico, char *jobd, char *jobmr, char *jobcf, char *ordsel, int *n, int *m, int *p, int *ncr, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, double *f, int *ldf, double *g, int *ldg, double *hsv, double *tol, int *iwork, double *dwork, int *ldwork, int *iwarn, int *info, long int dico_len, long int jobd_len, long int jobmr_len, long int jobcf_len, long int ordsel_len);
extern int nsp_slicot_sb16cy (char *, char *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, double *, double *, int *, double *, int *, double *, int *, int *, long int, long int);
extern int nsp_slicot_sb16cy (char *dico, char *jobcf, int *n, int *m, int *p, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *f, int *ldf, double *g, int *ldg, double *scalec, double *scaleo, double *s, int *lds, double *r__, int *ldr, double *dwork, int *ldwork, int *info, long int dico_len, long int jobcf_len);

extern int nsp_slicot_select (const double *par1,const double *par2);
extern int nsp_slicot_sg02ad (char *dico, char *jobb, char *fact, char *uplo, char *jobl, char *scal, char *sort, char *acc, int *n, int *m, int *p, double *a, int *lda, double *e, int *lde, double *b, int *ldb, double *q, int *ldq, double *r__, int *ldr, double *l, int *ldl, double *rcondu, double *x, int *ldx, double *alfar, double *alfai, double *beta, double *s, int *lds, double *t, int *ldt, double *u, int *ldu, double *tol, int *iwork, double *dwork, int *ldwork, int *bwork, int *iwarn, int *info, long int dico_len, long int jobb_len, long int fact_len, long int uplo_len, long int jobl_len, long int scal_len, long int sort_len, long int acc_len);
extern int nsp_slicot_sg03ad (char *dico, char *job, char *fact, char *trans, char *uplo, int *n, double *a, int *lda, double *e, int *lde, double *q, int *ldq, double *z__, int *ldz, double *x, int *ldx, double *scale, double *sep, double *ferr, double *alphar, double *alphai, double *beta, int *iwork, double *dwork, int *ldwork, int *info, long int dico_len, long int job_len, long int fact_len, long int trans_len, long int uplo_len);
extern int nsp_slicot_sg03ax (char *, int *, double *, int *, double *, int *, double *, int *, double *, int *, long int);
extern int nsp_slicot_sg03ax (char *trans, int *n, double *a, int *lda, double *e, int *lde, double *x, int *ldx, double *scale, int *info, long int trans_len);
extern int nsp_slicot_sg03ay (char *, int *, double *, int *, double *, int *, double *, int *, double *, int *, long int);
extern int nsp_slicot_sg03ay (char *trans, int *n, double *a, int *lda, double *e, int *lde, double *x, int *ldx, double *scale, int *info, long int trans_len);
extern int nsp_slicot_sg03bd (char *dico, char *fact, char *trans, int *n, int *m, double *a, int *lda, double *e, int *lde, double *q, int *ldq, double *z__, int *ldz, double *b, int *ldb, double *scale, double *alphar, double *alphai, double *beta, double *dwork, int *ldwork, int *info, long int dico_len, long int fact_len, long int trans_len);
extern int nsp_slicot_sg03bu (char *trans, int *n, double *a, int *lda, double *e, int *lde, double *b, int *ldb, double *scale, double *dwork, int *info, long int trans_len);
extern int nsp_slicot_sg03bv (char *, int *, double *, int *, double *, int *, double *, int *, double *, double *, int *, long int);
extern int nsp_slicot_sg03bv (char *trans, int *n, double *a, int *lda, double *e, int *lde, double *b, int *ldb, double *scale, double *dwork, int *info, long int trans_len);
extern int nsp_slicot_sg03bw (char *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, long int);
extern int nsp_slicot_sg03bw (char *trans, int *m, int *n, double *a, int *lda, double *c__, int *ldc, double *e, int *lde, double *d__, int *ldd, double *x, int *ldx, double *scale, int *info, long int trans_len);
extern int nsp_slicot_sg03bx (char *, char *, double *, int *, double *, int *, double *, int *, double *, int *, double *, double *, int *, double *, int *, int *, long int, long int);
extern int nsp_slicot_sg03bx (char *dico, char *trans, double *a, int *lda, double *e, int *lde, double *b, int *ldb, double *u, int *ldu, double *scale, double *m1, int *ldm1, double *m2, int *ldm2, int *info, long int dico_len, long int trans_len);
extern int nsp_slicot_sg03by (double *, double *, double *, double *, double *, double *, double *, double *, double *);
extern int nsp_slicot_sg03by (double *xr, double *xi, double *yr, double *yi, double *cr, double *ci, double *sr, double *si, double *z__);
extern int nsp_slicot_tb01id (char *, int *, int *, int *, double *, double *, int *, double *, int *, double *, int *, double *, int *, long int);
extern int nsp_slicot_tb01id (char *job, int *n, int *m, int *p, double *maxred, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *scale, int *info, long int job_len);
extern int nsp_slicot_tb01iz (char *, int *, int *, int *, double *, doubleC *, int *, doubleC *, int *, doubleC *, int *, double *, int *, long int);
extern int nsp_slicot_tb01iz (char *job, int *n, int *m, int *p, double *maxred, doubleC * a, int *lda, doubleC * b, int *ldb, doubleC * c__, int *ldc, double *scale, int *info, long int job_len);
extern int nsp_slicot_tb01kd (char *, char *, char *, int *, int *, int *, double *, double *, int *, double *, int *, double *, int *, int *, double *, int *, double *, double *, double *, int *, int *, long int, long int, long int);
extern int nsp_slicot_tb01kd (char *dico, char *stdom, char *joba, int *n, int *m, int *p, double *alpha, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, int *ndim, double *u, int *ldu, double *wr, double *wi, double *dwork, int *ldwork, int *info, long int dico_len, long int stdom_len, long int joba_len);
extern int nsp_slicot_tb01ld (char *, char *, char *, int *, int *, int *, double *, double *, int *, double *, int *, double *, int *, int *, double *, int *, double *, double *, double *, int *, int *, long int, long int, long int);
extern int nsp_slicot_tb01ld (char *dico, char *stdom, char *joba, int *n, int *m, int *p, double *alpha, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, int *ndim, double *u, int *ldu, double *wr, double *wi, double *dwork, int *ldwork, int *info, long int dico_len, long int stdom_len, long int joba_len);
extern int nsp_slicot_tb01md (char *jobu, char *uplo, int *n, int *m, double *a, int *lda, double *b, int *ldb, double *u, int *ldu, double *dwork, int *info, long int jobu_len, long int uplo_len);
extern int nsp_slicot_tb01nd (char *jobu, char *uplo, int *n, int *p, double *a, int *lda, double *c__, int *ldc, double *u, int *ldu, double *dwork, int *info, long int jobu_len, long int uplo_len);
extern int nsp_slicot_tb01pd (char *, char *, int *, int *, int *, double *, int *, double *, int *, double *, int *, int *, double *, int *, double *, int *, int *, long int, long int);
extern int nsp_slicot_tb01pd (char *job, char *equil, int *n, int *m, int *p, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, int *nr, double *tol, int *iwork, double *dwork, int *ldwork, int *info, long int job_len, long int equil_len);
extern int nsp_slicot_tb01td (int *n, int *m, int *p, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, int *low, int *igh, double *scstat, double *scin, double *scout, double *dwork, int *info);
extern int nsp_slicot_tb01ty (int *, int *, int *, int *, int *, double *, double *, int *, double *);
extern int nsp_slicot_tb01ty (int *mode, int *ioff, int *joff, int *nrow, int *ncol, double *size, double *x, int *ldx, double *bvect);
extern int nsp_slicot_tb01ud (char *, int *, int *, int *, double *, int *, double *, int *, double *, int *, int *, int *, int *, double *, int *, double *, double *, int *, double *, int *, int *, long int);
extern int nsp_slicot_tb01ud (char *jobz, int *n, int *m, int *p, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, int *ncont, int *indcon, int *nblk, double *z__, int *ldz, double *tau, double *tol, int *iwork, double *dwork, int *ldwork, int *info, long int jobz_len);
extern int nsp_slicot_tb01vd (char *apply, int *n, int *m, int *l, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, double *x0, double *theta, int *ltheta, double *dwork, int *ldwork, int *info, long int apply_len);
extern int nsp_slicot_tb01vd (char *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, double *, int *, double *, int *, int *, long int);
extern int nsp_slicot_tb01vy (char *apply, int *n, int *m, int *l, double *theta, int *ltheta, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, double *x0, double *dwork, int *ldwork, int *info, long int apply_len);
extern int nsp_slicot_tb01vy (char *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, double *, int *, int *, long int);
extern int nsp_slicot_tb01wd (int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, double *, double *, int *, int *);
extern int nsp_slicot_tb01wd (int *n, int *m, int *p, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *u, int *ldu, double *wr, double *wi, double *dwork, int *ldwork, int *info);
extern int nsp_slicot_tb01xd (char *, int *, int *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *, long int);
extern int nsp_slicot_tb01xd (char *jobd, int *n, int *m, int *p, int *kl, int *ku, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, int *info, long int jobd_len);
extern int nsp_slicot_tb01xz (char *, int *, int *, int *, int *, int *, doubleC *, int *, doubleC *, int *, doubleC *, int *, doubleC *, int *, int *, long int);
extern int nsp_slicot_tb01xz (char *jobd, int *n, int *m, int *p, int *kl, int *ku, doubleC * a, int *lda, doubleC * b, int *ldb, doubleC * c__, int *ldc, doubleC * d__, int *ldd, int *info, long int jobd_len);
extern int nsp_slicot_tb01yd (int *, int *, int *, double *, int *, double *, int *, double *, int *, int *);
extern int nsp_slicot_tb01yd (int *n, int *m, int *p, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, int *info);
extern int nsp_slicot_tb01zd (char *, int *, int *, double *, int *, double *, double *, int *, int *, double *, int *, double *, double *, double *, int *, int *, long int);
extern int nsp_slicot_tb01zd (char *jobz, int *n, int *p, double *a, int *lda, double *b, double *c__, int *ldc, int *ncont, double *z__, int *ldz, double *tau, double *tol, double *dwork, int *ldwork, int *info, long int jobz_len);
extern int nsp_slicot_tb03ad (char *, char *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *, int *, double *, int *, int *, double *, int *, int *, double *, int *, int *, double *, int *, double *, int *, int *, long int, long int);
extern int nsp_slicot_tb03ad (char *leri, char *equil, int *n, int *m, int *p, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, int *nr, int *index, double *pcoeff, int *ldpco1, int *ldpco2, double *qcoeff, int *ldqco1, int *ldqco2, double *vcoeff, int *ldvco1, int *ldvco2, double *tol, int *iwork, double *dwork, int *ldwork, int *info, long int leri_len, long int equil_len);
extern int nsp_slicot_tb03ay (int *, double *, int *, int *, int *, double *, int *, int *, double *, int *, int *, int *);
extern int nsp_slicot_tb03ay (int *nr, double *a, int *lda, int *indblk, int *nblk, double *vcoeff, int *ldvco1, int *ldvco2, double *pcoeff, int *ldpco1, int *ldpco2, int *info);
extern int nsp_slicot_tb04ad (char *rowcol, int *n, int *m, int *p, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, int *nr, int *index, double *dcoeff, int *lddcoe, double *ucoeff, int *lduco1, int *lduco2, double *tol1, double *tol2, int *iwork, double *dwork, int *ldwork, int *info, long int rowcol_len);
extern int nsp_slicot_tb04ay (int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *, int *, double *, int *, double *, int *, int *, double *, int *, double *, double *, double *, int *, double *, int *, int *);
extern int nsp_slicot_tb04ay (int *n, int *mwork, int *pwork, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, int *ncont, int *indexd, double *dcoeff, int *lddcoe, double *ucoeff, int *lduco1, int *lduco2, double *at, int *n1, double *tau, double *tol1, double *tol2, int *iwork, double *dwork, int *ldwork, int *info);
extern int nsp_slicot_tb04bd (char *jobd, char *order, char *equil, int *n, int *m, int *p, int *md, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, int *ign, int *ldign, int *igd, int *ldigd, double *gn, double *gd, double *tol, int *iwork, double *dwork, int *ldwork, int *info, long int jobd_len, long int order_len, long int equil_len);
extern int nsp_slicot_tb04bv (char *order, int *p, int *m, int *md, int *ign, int *ldign, int *igd, int *ldigd, double *gn, double *gd, double *d__, int *ldd, double *tol, int *info, long int order_len);
extern int nsp_slicot_tb04bw (char *order, int *p, int *m, int *md, int *ign, int *ldign, int *igd, int *ldigd, double *gn, double *gd, double *d__, int *ldd, int *info, long int order_len);
extern int nsp_slicot_tb04bx (int *, int *, double *, int *, double *, double *, double *, double *, double *, double *, double *, double *, int *);
extern int nsp_slicot_tb04bx (int *ip, int *iz, double *a, int *lda, double *b, double *c__, double *d__, double *pr, double *pi, double *zr, double *zi, double *gain, int *iwork);
extern int nsp_slicot_tb04cd (char *jobd, char *equil, int *n, int *m, int *p, int *npz, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, int *nz, int *ldnz, int *np, int *ldnp, double *zerosr, double *zerosi, double *polesr, double *polesi, double *gains, int *ldgain, double *tol, int *iwork, double *dwork, int *ldwork, int *info, long int jobd_len, long int equil_len);
extern int nsp_slicot_tb05ad (char *baleig, char *inita, int *n, int *m, int *p, doubleC * freq, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *rcond, doubleC * g, int *ldg, double *evre, double *evim, doubleC * hinvb, int *ldhinv, int *iwork, double *dwork, int *ldwork, doubleC * zwork, int *lzwork, int *info, long int baleig_len, long int inita_len);
extern int nsp_slicot_tb05ad (char *, char *, int *, int *, int *, doubleC *, double *, int *, double *, int *, double *, int *, double *, doubleC *, int *, double *, double *, doubleC *, int *, int *, double *, int *, doubleC *, int *, int *, long int, long int);
extern int nsp_slicot_tc01od (char *, int *, int *, int *, double *, int *, int *, double *, int *, int *, int *, long int);
extern int nsp_slicot_tc01od (char *leri, int *m, int *p, int *indlim, double *pcoeff, int *ldpco1, int *ldpco2, double *qcoeff, int *ldqco1, int *ldqco2, int *info, long int leri_len);
extern int nsp_slicot_tc04ad (char *leri, int *m, int *p, int *index, double *pcoeff, int *ldpco1, int *ldpco2, double *qcoeff, int *ldqco1, int *ldqco2, int *n, double *rcond, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, int *iwork, double *dwork, int *ldwork, int *info, long int leri_len);
extern int nsp_slicot_tc05ad (char *leri, int *m, int *p, doubleC * sval, int *index, double *pcoeff, int *ldpco1, int *ldpco2, double *qcoeff, int *ldqco1, int *ldqco2, double *rcond, doubleC * cfreqr, int *ldcfre, int *iwork, double *dwork, doubleC * zwork, int *info, long int leri_len);
extern int nsp_slicot_td03ad (char *rowcol, char *leri, char *equil, int *m, int *p, int *indexd, double *dcoeff, int *lddcoe, double *ucoeff, int *lduco1, int *lduco2, int *nr, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, int *indexp, double *pcoeff, int *ldpco1, int *ldpco2, double *qcoeff, int *ldqco1, int *ldqco2, double *vcoeff, int *ldvco1, int *ldvco2, double *tol, int *iwork, double *dwork, int *ldwork, int *info, long int rowcol_len, long int leri_len, long int equil_len);
extern int nsp_slicot_td03ay (int *, int *, int *, double *, int *, double *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *);
extern int nsp_slicot_td03ay (int *mwork, int *pwork, int *index, double *dcoeff, int *lddcoe, double *ucoeff, int *lduco1, int *lduco2, int *n, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, int *info);
extern int nsp_slicot_td04ad (char *, int *, int *, int *, double *, int *, double *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *, long int);
extern int nsp_slicot_td04ad (char *rowcol, int *m, int *p, int *index, double *dcoeff, int *lddcoe, double *ucoeff, int *lduco1, int *lduco2, int *nr, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, double *tol, int *iwork, double *dwork, int *ldwork, int *info, long int rowcol_len);
extern int nsp_slicot_td05ad (char *unitf, char *output, int *np1, int *mp1, double *w, double *a, double *b, double *valr, double *vali, int *info, long int unitf_len, long int output_len);
extern int nsp_slicot_tf01md (int *n, int *m, int *p, int *ny, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, double *u, int *ldu, double *x, double *y, int *ldy, double *dwork, int *info);
extern int nsp_slicot_tf01mx (int *, int *, int *, int *, double *, int *, double *, int *, double *, double *, int *, double *, int *, int *);
extern int nsp_slicot_tf01mx (int *n, int *m, int *p, int *ny, double *s, int *lds, double *u, int *ldu, double *x, double *y, int *ldy, double *dwork, int *ldwork, int *info);
extern int nsp_slicot_tf01my (int *n, int *m, int *p, int *ny, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, double *u, int *ldu, double *x, double *y, int *ldy, double *dwork, int *ldwork, int *info);
extern int nsp_slicot_tf01nd (char *uplo, int *n, int *m, int *p, int *ny, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *d__, int *ldd, double *u, int *ldu, double *x, double *y, int *ldy, double *dwork, int *info, long int uplo_len);
extern int nsp_slicot_tf01od (int *nh1, int *nh2, int *nr, int *nc, double *h__, int *ldh, double *t, int *ldt, int *info);
extern int nsp_slicot_tf01pd (int *nh1, int *nh2, int *nr, int *nc, double *h__, int *ldh, double *t, int *ldt, int *info);
extern int nsp_slicot_tf01qd (int *nc, int *nb, int *n, int *iord, double *ar, double *ma, double *h__, int *ldh, int *info);
extern int nsp_slicot_tf01rd (int *na, int *nb, int *nc, int *n, double *a, int *lda, double *b, int *ldb, double *c__, int *ldc, double *h__, int *ldh, double *dwork, int *ldwork, int *info);
extern int nsp_slicot_tg01ad (char *, int *, int *, int *, int *, double *, double *, int *, double *, int *, double *, int *, double *, int *, double *, double *, double *, int *, long int);
extern int nsp_slicot_tg01ad (char *job, int *l, int *n, int *m, int *p, double *thresh, double *a, int *lda, double *e, int *lde, double *b, int *ldb, double *c__, int *ldc, double *lscale, double *rscale, double *dwork, int *info, long int job_len);
extern int nsp_slicot_tg01az (char *, int *, int *, int *, int *, double *, doubleC *, int *, doubleC *, int *, doubleC *, int *, doubleC *, int *, double *, double *, double *, int *, long int);
extern int nsp_slicot_tg01az (char *job, int *l, int *n, int *m, int *p, double *thresh, doubleC * a, int *lda, doubleC * e, int *lde, doubleC * b, int *ldb, doubleC * c__, int *ldc, double *lscale, double *rscale, double *dwork, int *info, long int job_len);
extern int nsp_slicot_tg01bd (char *, char *, char *, int *, int *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *, long int, long int, long int);
extern int nsp_slicot_tg01bd (char *jobe, char *compq, char *compz, int *n, int *m, int *p, int *ilo, int *ihi, double *a, int *lda, double *e, int *lde, double *b, int *ldb, double *c__, int *ldc, double *q, int *ldq, double *z__, int *ldz, double *dwork, int *ldwork, int *info, long int jobe_len, long int compq_len, long int compz_len);
extern int nsp_slicot_tg01cd (char *compq, int *l, int *n, int *m, double *a, int *lda, double *e, int *lde, double *b, int *ldb, double *q, int *ldq, double *dwork, int *ldwork, int *info, long int compq_len);
extern int nsp_slicot_tg01dd (char *compz, int *l, int *n, int *p, double *a, int *lda, double *e, int *lde, double *c__, int *ldc, double *z__, int *ldz, double *dwork, int *ldwork, int *info, long int compz_len);
extern int nsp_slicot_tg01ed (char *joba, int *l, int *n, int *m, int *p, double *a, int *lda, double *e, int *lde, double *b, int *ldb, double *c__, int *ldc, double *q, int *ldq, double *z__, int *ldz, int *ranke, int *rnka22, double *tol, double *dwork, int *ldwork, int *info, long int joba_len);
extern int nsp_slicot_tg01fd (char *, char *, char *, int *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *, int *, double *, int *, double *, int *, int *, long int, long int, long int);
extern int nsp_slicot_tg01fd (char *compq, char *compz, char *joba, int *l, int *n, int *m, int *p, double *a, int *lda, double *e, int *lde, double *b, int *ldb, double *c__, int *ldc, double *q, int *ldq, double *z__, int *ldz, int *ranke, int *rnka22, double *tol, int *iwork, double *dwork, int *ldwork, int *info, long int compq_len, long int compz_len, long int joba_len);
extern int nsp_slicot_tg01fz (char *, char *, char *, int *, int *, int *, int *, doubleC *, int *, doubleC *, int *, doubleC *, int *, doubleC *, int *, doubleC *, int *, doubleC *, int *, int *, int *, double *, int *, double *, doubleC *, int *, int *, long int, long int, long int);
extern int nsp_slicot_tg01fz (char *compq, char *compz, char *joba, int *l, int *n, int *m, int *p, doubleC * a, int *lda, doubleC * e, int *lde, doubleC * b, int *ldb, doubleC * c__, int *ldc, doubleC * q, int *ldq, doubleC * z__, int *ldz, int *ranke, int *rnka22, double *tol, int *iwork, double *dwork, doubleC * zwork, int *lzwork, int *info, long int compq_len, long int compz_len, long int joba_len);
extern int nsp_slicot_tg01hd (char *jobcon, char *compq, char *compz, int *n, int *m, int *p, double *a, int *lda, double *e, int *lde, double *b, int *ldb, double *c__, int *ldc, double *q, int *ldq, double *z__, int *ldz, int *ncont, int *niucon, int *nrblck, int *rtau, double *tol, int *iwork, double *dwork, int *info, long int jobcon_len, long int compq_len, long int compz_len);
extern int nsp_slicot_tg01hx (char *, char *, int *, int *, int *, int *, int *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, double *, int *, int *, int *, int *, double *, int *, double *, int *, long int, long int);
extern int nsp_slicot_tg01hx (char *compq, char *compz, int *l, int *n, int *m, int *p, int *n1, int *lbe, double *a, int *lda, double *e, int *lde, double *b, int *ldb, double *c__, int *ldc, double *q, int *ldq, double *z__, int *ldz, int *nr, int *nrblck, int *rtau, double *tol, int *iwork, double *dwork, int *info, long int compq_len, long int compz_len);
extern int nsp_slicot_tg01id (char *jobobs, char *compq, char *compz, int *n, int *m, int *p, double *a, int *lda, double *e, int *lde, double *b, int *ldb, double *c__, int *ldc, double *q, int *ldq, double *z__, int *ldz, int *nobsv, int *niuobs, int *nlblck, int *ctau, double *tol, int *iwork, double *dwork, int *info, long int jobobs_len, long int compq_len, long int compz_len);
extern int nsp_slicot_tg01jd (char *job, char *systyp, char *equil, int *n, int *m, int *p, double *a, int *lda, double *e, int *lde, double *b, int *ldb, double *c__, int *ldc, int *nr, int *infred, double *tol, int *iwork, double *dwork, int *ldwork, int *info, long int job_len, long int systyp_len, long int equil_len);
extern int nsp_slicot_tg01wd (int *n, int *m, int *p, double *a, int *lda, double *e, int *lde, double *b, int *ldb, double *c__, int *ldc, double *q, int *ldq, double *z__, int *ldz, double *alphar, double *alphai, double *beta, double *dwork, int *ldwork, int *info);
extern int nsp_slicot_ud01bd (int *mp, int *np, int *dp, int *nin, double *p, int *ldp1, int *ldp2, int *info);
extern int nsp_slicot_ud01cd (int *mp, int *np, int *dp, int *nin, double *p, int *ldp1, int *ldp2, int *info);
extern int nsp_slicot_ud01dd (int *m, int *n, int *nin, double *a, int *lda, int *info);
extern int nsp_slicot_ud01md (int *m, int *n, int *l, int *nout, double *a, int *lda, char *text, int *info, long int text_len);
extern int nsp_slicot_ud01mz (int *m, int *n, int *l, int *nout, doubleC * a, int *lda, char *text, int *info, long int text_len);
extern int nsp_slicot_ud01nd (int *mp, int *np, int *dp, int *l, int *nout, double *p, int *ldp1, int *ldp2, char *text, int *info, long int text_len);
extern int nsp_slicot_ue01md (int *, char *, char *, int *, int *, int *, long int, long int);
extern int nsp_slicot_ue01md (int *ispec, char *name__, char *opts, int *n1, int *n2, int *n3, long int name_len, long int opts_len);

#endif
